/*eslint-disable */
import UIComponent from '../core/UIComponent'
import React from 'react'

import Constants from '../utils/Constants'
import UIUtils from '../utils/UIUtils'
import FlexDataGridEvent from '../flexgrid/events/FlexDataGridEvent'
/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

/**
 * A DatePicker that which can be used within the filtering/binding infrastructure.
 * @class DatePicker
 * @constructor
 * @namespace flexiciousNmsp
 * 
 */
let datePickerIndex = 0;
export default class DatePicker extends UIComponent {
    constructor(tag) {
        super();
        //this.outsideIcon =  Constants.IMAGE_PATH+'/date_picker.png'; 
        this.dateFormatString = flexiciousNmsp.Constants.DEFAULT_DATE_FORMAT;
        this.selectedDate = null;
        this.checkChange = this.checkChange.bind(this);
    }
    componentDidMountCustom() {
        if (this._focusPending) {
            this._focusPending = false;
            const input = UIUtils.findFirstElementByTagName(this.domElement, "input");
            if (input) {
                input.focus();
            }
        }

    }

    getClassNames() {
        return ["DatePicker", "UIComponent"];
    }

    setValue(val) {
        if (val != null) {
            this.selectedDate = val;
        }

    }

    getValue() {
        return this.selectedDate;
    }

    getSelectedDate() {
        return this.getValue();
    }

    setSelectedDate(val) {
        this.selectedDate = val;
    }

    // owns(elem) {
    //     if (UIUtils.adapter.isDatePickerElement(elem)) {

    //         return true;
    //     }
    //     return flexiciousNmsp.UIComponent.prototype.owns.apply(this, [elem]) || UIUtils.adapter.isDatePickerElement(elem);
    // }

    checkChange(evt, newDate) {
        if (this.selectedDate != newDate) {
            this.selectedDate = newDate
            this.dispatchEvent(new flexiciousNmsp.FlexDataGridEvent(Constants.EVENT_CHANGE));
            this.dispatchEvent(new flexiciousNmsp.FlexDataGridEvent(Constants.EVENT_VALUE_COMMIT));
        }
    }

    /**
     * Sets the focus on the textbox
     **/
    focus() {
        if (this.domElement) {
            const input = UIUtils.findFirstElementByTagName(this.domElement, "input");
            if (input) {
                input.focus();
            }
        } else {
            this._focusPending = true;
        }

    }

    kill() {
        flexiciousNmsp.UIComponent.prototype.kill.apply(this);
        if (this.changeTimer) {
            this.changeTimer.kill();
        }
    }

    render() {
        return <div ref="pickerbar" style={this.propertyBag.style} className={"flexDataGridCell editor"} key={'datePickerIndex' + datePickerIndex++} >
            {UIUtils.adapter.createDateTimePicker(this.dateFormatString, this.selectedDate, Constants.DATE_PICKER_END_DATE, "pickerEndDate", this.checkChange)}
        </div>;
    }
}
flexiciousNmsp.DatePicker = DatePicker;