/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

 import UIComponent from '../core/UIComponent'

import Constants from '../utils/Constants'
import UIUtils from '../utils/UIUtils' 

/**
 * A Label that which can be used within the filtering/binding infrastructure.
 * @class Label
 * @constructor
 * @namespace flexiciousNmsp
 * 
 */
export default class Label extends UIComponent {
    constructor(props) {
        super(props, "label");
        this._text = "";
    }

    componentDidMountCustom() {
        this.detachClass(UIUtils.doLower(this.typeName));
        this.attachClass("flexiciousLabel"); //Bootstrap messes with this.
    }
    getClassNames() {
        return ["Label", "UIComponent"];
    }

    /**
     * Generic function that returns the value of a IFilterControl
     */
    clear() {
        this.setText("");
    }

    /**
     * Generic function that returns the value of a IFilterControl
     */
    getValue() {
        return this.getText();
    }

    /**
     * Generic function that sets the value of a IFilterControl
     * @param val
     */
    setValue(val) {
        this.setText(val);
    }
}

flexiciousNmsp.Label = Label; //add to name space
Label.prototype.typeName = Label.typeName = 'Label';//for quick inspection
