/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */
import React from 'react';
import ReactDOM from 'react-dom';
/**
 * This class is the base class for all Flexicious classes. It defines the basis for the
 * Object oriented design, by implementing the "implementsOrExtends" function, which is a
 * replacement for the "is" keyword from other OO languages.
 * @namespace flexiciousNmsp
 * @class TypedObject
 * @name TypedObject
 */
export default class ReactDataGridCellContainer extends React.Component {
    constructor(props) {
        super();
        this.component = props.component;
    }
    shouldComponentUpdate(nextProps, nextState){
        
        if (this.component.shouldComponentUpdateCustom) {
            return this.component.shouldComponentUpdateCustom(nextProps, nextState);
        }
        return !ReactDataGridCellContainer.isScrolling;
    }
    componentDidMount() {
        const domElement = ReactDOM.findDOMNode(this);
        this.component.reactComponent = this;
        this.component.setDomElement(domElement);
        if (this.component.componentDidMountCustom) {
            this.component.componentDidMountCustom();
        }
    }
    componentWillUnmount() {
        //this.component.kill();
        if (this.component.componentWillUnmountCustom) {
            this.component.componentWillUnmountCustom();
        }
        this.component.setDomElement(null);
        this.component.reactComponent = null;
        this.component = null;
    }
    componentWillMount() {
        this.component.validateNow();
    }
    componentWillUpdate() {
        this.component.validateNowIfValid();
    }
    render() {
        const component = this.component;

        let allChildren = null;

        if (component.tagName == "img" || component.tagName == "input" ) {
            //console.log(component.propertyBag.src + component.propertyBag.style.left);
        } else {
            allChildren = component.children.concat(component.props.children || []);
            allChildren = allChildren.map((child, idx) => {
                if (typeof child["implementsOrExtends"] == "function") {
                    //child.key = idx;
                    return child.render();
                } else {
                    return child;
                }
            });

        }
        this.reactElement = React.createElement(component.tagName, component.propertyBag, allChildren && allChildren.length == 1 ? allChildren[0] : allChildren);
        return this.reactElement;
    }
}

ReactDataGridCellContainer.prototype.typeName = ReactDataGridCellContainer.typeName = "ReactDataGridCellContainer";//for quick inspection
flexiciousNmsp.ReactDataGridCellContainer = ReactDataGridCellContainer;

