/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

import Constants from '../../utils/Constants'
import UIUtils from '../../utils/UIUtils' 
import FlexDataGridExpandCollapseCell from './FlexDataGridExpandCollapseCell'
/**
 * @inheritDoc
 * @constructor
 * @class FlexDataGridExpandCollapseHeaderCell
 * @namespace flexiciousNmsp
 */
export default class FlexDataGridExpandCollapseHeaderCell extends FlexDataGridExpandCollapseCell {
    /**
     *
     * @return {Array}
     */
    getClassNames() {
        return ["FlexDataGridExpandCollapseHeaderCell", "FlexDataGridExpandCollapseCell", "FlexDataGridCell", "UIComponent", "IFlexDataGridCell"];
    }

    /**
     *
     * @return {Boolean}
     */
    getDrawTopBorder() {
        //if we're at a nested level, grid does not draw horizontal lines,
        //and there is no filter row, we draw a line above us to seperate ourselves from the data item above.
        flexiciousNmsp.FlexDataGridExpandCollapseCell.prototype.getDrawTopBorder.apply(this, [])
            || ((this.rowInfo.getIsHeaderRow() && this.level.getNestDepth() > 1 && !this.level.grid.getStyle("horizontalGridLines")
                && (this.level.getFilterRowHeight() == 0))
                || (this.rowInfo.getIsFilterRow() && this.level.getNestDepth() > 1 && !this.level.grid.getStyle("horizontalGridLines")));
    }
}

flexiciousNmsp.FlexDataGridExpandCollapseHeaderCell = FlexDataGridExpandCollapseHeaderCell; //add to name space 
FlexDataGridExpandCollapseHeaderCell.prototype.typeName = FlexDataGridExpandCollapseHeaderCell.typeName = 'FlexDataGridExpandCollapseHeaderCell';//for quick inspection