/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

import Constants from '../../utils/Constants'
import UIUtils from '../../utils/UIUtils' 
import UIComponent from '../../core/UIComponent'

/**
 * @inheritDoc
 * @constructor
 * @class FlexDataGridHeaderSeperator
 * @namespace flexiciousNmsp
 * 
 */
export default class FlexDataGridHeaderSeperator extends UIComponent {
    constructor() {
        super();
        /**
         * @property resizing
         * @default false
         * @type {Boolean}
         */
        this.resizing = false;
        /**
         * @property headerColors
         * @default null
         * @type {Array}
         */

        this.headerColors = null;


    }
    getClassNames() {
        return ["FlexDataGridHeaderSeperator", "UIComponent", "IFixedWidth"];
    }
    componentWillMount() {
        super.componentWillMount();
        this.setColorFromGrid();
    }
    componentWillUpdate() {
        super.componentWillUpdate();
        this.setColorFromGrid();
    }
    setColorFromGrid() {

        let color = 0;
        const fdg = this.parent && this.parent.implementsOrExtends("FlexDataGrid") ? this.parent : null;
        if (fdg) {
            color = fdg.getStyle("columnMoveResizeSeparatorColor");
        }
        this.setStyleAttribute("backgroundColor", UIUtils.decimalToColor(color));
    }
}

flexiciousNmsp.FlexDataGridHeaderSeperator = FlexDataGridHeaderSeperator; //add to name space
FlexDataGridHeaderSeperator.prototype.typeName = FlexDataGridHeaderSeperator.typeName = 'FlexDataGridHeaderSeperator';//for quick inspection