/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

import Constants from '../../utils/Constants'
import UIUtils from '../../utils/UIUtils' 
import FlexDataGridCell from './FlexDataGridCell'

/**
 * @inheritDoc
 * @constructor
 * @class FlexDataGridLevelRendererCell
 * @namespace flexiciousNmsp
 * 
 */
export default class FlexDataGridLevelRendererCell extends FlexDataGridCell {
    getClassNames() {
        return ["FlexDataGridLevelRendererCell", "FlexDataGridCell", "UIComponent", "IFixedWidth", "IFlexDataGridCell"];
    }

    /**
     *
     * @return {String}
     */
    getBackgroundColors() {

        //if(currentBackgroundColors)return currentBackgroundColors;
        const fromGrid = flexiciousNmsp.CellUtils.getBackgroundColorFromGrid(this);
        if (fromGrid != null) return fromGrid;
        return this.getStyleValue("rendererColors");

    }

    /**
     *
     * @return {String}
     */
    getTextColors() {

        const fromGrid = flexiciousNmsp.CellUtils.getTextColorFromGrid(this);
        if (fromGrid != null) return fromGrid;
        if (this.currentTextColors) return this.currentTextColors;
        return this.getStyle("color");

    }

    /**
     *
     * @return {String}
     */
    getRolloverColor() {

        return this.getStyleValue("rendererRollOverColors");

    }

    /**
     * Refreshing the contents of this cell.
     */
    refreshCell() {

        flexiciousNmsp.FlexDataGridCell.prototype.refreshCell.apply(this, []);
        if (this.getRenderer().typeName) {
            this.getRenderer().setData(this.rowInfo.getData());
        }
    }

    /**
     *
     * @return {String}
     */
    getPrefix() {
        return "renderer";
    }

    /**
     *
     * @return {Boolean}
     */
    getDrawTopBorder() {
        return this.getStyleValue("rendererDrawTopBorder")
    }
}

flexiciousNmsp.FlexDataGridLevelRendererCell = FlexDataGridLevelRendererCell; //add to name space
FlexDataGridLevelRendererCell.prototype.typeName = FlexDataGridLevelRendererCell.typeName = 'FlexDataGridLevelRendererCell';//for quick inspection