/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

const uiUtil = flexiciousNmsp.UIUtils;
const flxConstants = flexiciousNmsp.Constants;
import BaseEvent from './BaseEvent'

/**
 * Event fired when the filter, page or sort state of the grid changes.
 * @constructor
 * @class FilterPageSortChangeEvent
 * @namespace flexiciousNmsp
 * 
 */
export default class FilterPageSortChangeEvent extends BaseEvent {
    constructor(type, filter, bubbles, cancelable) {

        super(type, bubbles, cancelable);
        /**
         *  The filter that is associated with this event.
         * @property  filter
         * @type  Filter
         * @default null
         */
        this.filter = null;
        /**
         * The original event that triggered the
         * filter event
         * @property  triggerEvent
         * @type  Event
         * @default null
         */
        this.triggerEvent = null;
        /**
         * Whether it was a filter,page or sort that caused this change.
         * @property  cause
         * @type  String
         * @default null
         */
        this.cause = null;
        this.filter = filter;
    }

    getClassNames() {
        return ["FilterPageSortChangeEvent", "Event"];
    }

    /**
     *
     * @return {flexiciousNmsp.FilterPageSortChangeEvent}
     */
    clone() {

        return new flexiciousNmsp.FilterPageSortChangeEvent
            (this.type
            , this.filter
            , this.bubbles
            , this.cancelable
            );

    }
}

flexiciousNmsp.FilterPageSortChangeEvent = FilterPageSortChangeEvent; //add to name space
FilterPageSortChangeEvent.prototype.typeName = FilterPageSortChangeEvent.typeName = 'FilterPageSortChangeEvent';//for quick inspection
FilterPageSortChangeEvent.FILTER_PAGE_SORT_CHANGE = "filterPageSortChange";
FilterPageSortChangeEvent.FILTER_CHANGE = "filterChange";
FilterPageSortChangeEvent.PAGE_CHANGE = "pageChange";
FilterPageSortChangeEvent.SORT_CHANGE = "sortChange";
FilterPageSortChangeEvent.DESTROY = "destroy";