/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

import UIComponent from '../../core/UIComponent'
import FlexDataGridEvent from './FlexDataGridEvent'
/**
 * A utility event that holds a data object
 * @constructor
 * @class FlexDataGridItemEditEvent
 * @namespace flexiciousNmsp
 */
export default class FlexDataGridItemEditEvent extends FlexDataGridEvent {
    constructor(type, grid, level, column, cell, item, triggerEvent, bubbles, cancelable) {
        super(type, grid, level, column, cell, item, triggerEvent, bubbles, cancelable);
        if (typeof grid === "undefined") {
            grid = null;
        }
        if (typeof level === "undefined") {
            level = null;
        }
        /**
         * This event is dispatched in relation to edit related events. It contains the reference to the item editor.
         * @property itemEditor
         * @type UIComponent
         * @default null
         */
        this.itemEditor = null;
        /**
         * Populated for ITEM_EDIT_VALUE_COMMIT. Contains the value being committed.
         * @type {Object}
         * @property  newValue
         * @default null
         */

        this.newValue = null;
    }

    getClassNames() { //for support of "is" keyword
        return ["FlexDataGridEvent", this.typeName];
    }
}

flexiciousNmsp.FlexDataGridItemEditEvent = FlexDataGridItemEditEvent; //add to name space
FlexDataGridItemEditEvent.prototype.typeName = FlexDataGridItemEditEvent.typeName = "FlexDataGridItemEditEvent";//for quick inspection