/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */
 
import FilterPageSortChangeEvent from './FilterPageSortChangeEvent'
import BaseEvent from './BaseEvent'
/**
 * Event fired when the filter, page or sort state of the grid changes.
 * @constructor
 * @class PrintExportDataRequestEvent
 * @namespace flexiciousNmsp
 * @param type
 * @param filter
 * @param [bubbles]
 * @param [cancelable]
 */
export default class PrintExportDataRequestEvent extends BaseEvent {
    constructor(type, filter, bubbles, cancelable) {

        super(type, bubbles, cancelable);
        this.filter = filter;
    }

    getClassNames() {
        return ["PrintExportDataRequestEvent", "FilterPageSortChangeEvent"];
    }

    /**
     *
     * @return {Event}
     */
    clone() {

        return new PrintExportDataRequestEvent
            (this.type
            , this.filter
            , this.bubbles
            , this.cancelable
            );

    }
}

flexiciousNmsp.PrintExportDataRequestEvent = PrintExportDataRequestEvent; //add to name space 
PrintExportDataRequestEvent.prototype.typeName = PrintExportDataRequestEvent.typeName = 'PrintExportDataRequestEvent';//for quick inspection

PrintExportDataRequestEvent.PRINT_EXPORT_DATA_REQUEST = "printExportDataRequest";
PrintExportDataRequestEvent.PRINT_EXPORT_DATA_RECD = "printExportDataReceived";