/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */


import Constants from '../../utils/Constants'
import UIUtils from '../../utils/UIUtils' 
import HtmlExporter from './HtmlExporter';

/**
 * Exports the grid in DOC format
 * @constructor
 * @class DocExporter
 * @namespace flexiciousNmsp
 */
export default class DocExporter extends HtmlExporter {

    getClassNames() {
        return ["DocExporter","HtmlExporter","Exporter"];
    }

    /**
     * Extension of the download file.
     * @return {String}
     *
     */
    getExtension() {
        return "doc";
    }

    /**
     * Returns the content type so MS Word launches
     * when the exporter is run.
     * @return {String}
     *
     */
    getContentType() {
        return "application/msword";
    }

    /**
     * Name of the exporter
     * @return {String}
     */
    getName() {
        return "Word";
    }
}

flexiciousNmsp.DocExporter = DocExporter; //add to name space
DocExporter.prototype.typeName = DocExporter.typeName = 'DocExporter';//for quick inspection