/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */


import Constants from '../../utils/Constants'
import UIUtils from '../../utils/UIUtils' 
import HtmlExporter from './HtmlExporter'
/**
 * An extension to the basic HTML Exporter that exports excel
 * @constructor
 * @class ExcelExporter
 * @namespace flexiciousNmsp
 */
export default class ExcelExporter extends HtmlExporter {

    getClassNames() {
        return ["ExcelExporter", "HtmlExporter", "Exporter"];
    }

    /**
     * Writes the header of the grid (columns) in excel format
     * @param grid
     * @return {String}
     */
    writeHeader(grid) {
        return `<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n<html xmlns="http://www.w3.org/1999/xhtml">\n<head>\n\n<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />\n<style>\n</style>\n</head>\n<body>\n${flexiciousNmsp.HtmlExporter.prototype.writeHeader.apply(this, [grid]).replace("<table ", "<table border=1")}`;
    }

    /**
     * Writes the footer in excel format
     * @param grid
     * @param dataProvider
     * @return {String}
     */
    writeFooter(grid, dataProvider) {

        return `${flexiciousNmsp.HtmlExporter.prototype.writeFooter.apply(this, [grid, dataProvider])}\n</body>\n</html>`;

    }

    /**
     * Extension of the download file.
     * @return {String}
     */
    getExtension() {
        return "xls";
    }

    /**
     * Returns the content type so MS Excel launches
     * when the exporter is run.
     * @return {String}
     */
    getContentType() {
        return "application/vnd.ms-excel"
    }

    /**
     * Name of the exporter
     * @return {String}
     */
    getName() {
        return "Excel";
    }
}

flexiciousNmsp.ExcelExporter = ExcelExporter; //add to name space
ExcelExporter.prototype.typeName = ExcelExporter.typeName = 'ExcelExporter';//for quick inspection
