
/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */
import Constants from '../../utils/Constants'
import UIUtils from '../../utils/UIUtils' 
import UIComponent from '../../core/UIComponent'
/**
 * Basically an extended UIComponent that manages the filter and footer cell visibility, heights, and the y positions
 * @constructor
 * @class LockedContent
 * @namespace flexiciousNmsp
 * 
 */
export default class LockedContent extends UIComponent {
    constructor(grid) {
        super({}, "div");
        this.grid = grid;
    }

    /**
     * @method getClassNames
     * @return Array
     */     
    getClassNames() {
        return ["LockedContent", "ExtendedUIComponent", "UIComponent"];
    }

    /**
     * handle placeSection
     * @method placeSection
     */
    placeSection() {

        const hidden = false;
        let htRemoved;
        const affectedCells = [];

        for (var i = 0; i < this.numChildren(); i++) {
            var cell = this.getChildAt(i).component;
            if (cell) {
                const wasVisible = cell.getVisible();
                const row = cell.rowInfo;
                if (row) {
                    if (row.getIsPagerRow())
                        cell.setVisible(this.grid.getPagerVisible());
                    else if (row.getIsHeaderRow())
                        cell.setVisible(this.grid.getHeaderVisible());
                    else if (row.getIsFilterRow())
                        cell.setVisible(this.grid.getFilterVisible());
                }

                if (wasVisible && !cell.getVisible()) {
                    htRemoved = cell.getHeight();
                    affectedCells.push(cell);
                }
                else if (!wasVisible && cell.getVisible()) {
                    htRemoved = 0 - cell.getHeight();
                    affectedCells.push(cell);
                }
            }
        }
        if (affectedCells.length > 0) {
            for (i = 0; i < this.numChildren(); i++) {
                cell = this.getChildAt(i).component;
                if (cell) {
                    if (!affectedCells.indexOf(cell) >= 0) {
                        cell.setY(cell.getY() - htRemoved);
                    }
                    cell.invalidateDisplayList();
                }
            }
        }

    }

    /**
     * @method kill
     */
    kill() {
        flexiciousNmsp.UIComponent.prototype.kill.apply(this);
        this.grid = null;
    }
}

flexiciousNmsp.LockedContent = LockedContent; //add to name space
LockedContent.prototype.typeName = LockedContent.typeName = 'LockedContent';//for quick inspection