/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */
 
import Filter from './Filter'
import UIUtils from '../../../utils/UIUtils'
/**
 * A container object that encapsulates all the
 * individual property filter settings, page settings
 * and the sort state.
 * @constructor
 * @class AdvancedFilter
 * @namespace flexiciousNmsp.filter
 */
export default class AdvancedFilter extends Filter {
    constructor() {
        super();
        this.parentObject = null;

        this.level = null;
    }

    getClassNames() {
        return ["AdvancedFilter", "Filter"];
    }

    /**
     * @return {flexiciousNmsp.FlexDataGridColumnLevel} returns level
     */
    getLevel() {
        return this.level;
    }

    /**
     * @param {flexiciousNmsp.Filter} param 
     * @return {flexiciousNmsp.AdvancedFilter}
     */
    static from(param) {
        const f = new AdvancedFilter();
        f.pageIndex = param.pageIndex;
        f.pageSize = param.pageSize;
        f.recordCount = param.recordCount;
        f.filterExpressions = param.filterExpressions;
        for (const key in param) {
            if (param.hasOwnProperty(key) && UIUtils.isPrimitive(param[key])) {
                f[key] = param[key];
            }
        }
        return f;
    }
}

flexiciousNmsp.AdvancedFilter = AdvancedFilter; //add to name space
AdvancedFilter.prototype.typeName = AdvancedFilter.typeName = 'AdvancedFilter';//for quick inspection
AdvancedFilter.ALL_ITEM = "All";