/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */


import Constants from '../../../utils/Constants'
import UIUtils from '../../../utils/UIUtils' 
import TypedObject from '../../../core/TypedObject'
/**
 * The advanced grid supports multi column sorting
 * This class was created in order to provide server
 * support for multi column sorting.
 * @constructor
 * @class FilterSort
 * @namespace flexiciousNmsp
 * 
 */
export default class FilterSort extends TypedObject {
    constructor(sortColumn, isAscending) {
        super();
        if (typeof sortColumn == "undefined") sortColumn = '';
        if (typeof isAscending == "undefined") isAscending = true;
        /**
         * The column object associated with the sort
         */
        this.column = null;
        this.sortColumn = null;
        this.sortCompareFunction = null;
        this.isAscending = true;
        this.sortComparisionType = "auto";
        /**
         * Ultimate has support to define caseInsensitive sorts
         */
        this.sortCaseInsensitive = false;
        /**
         * Ultimate has support to define numeric sorts
         */
        this.sortNumeric = false;

        this.sortColumn = sortColumn;
        this.isAscending = isAscending;
    }

    getClassNames() {
        return ["FilterSort", "TypedObject"];
    }

    /**
     * Copy sort properties to current instance
     * @param {Object} filterSort 
     */
    copyFrom(filterSort) {

        this.sortColumn = filterSort.sortColumn;
        this.isAscending = filterSort.isAscending;
        this.sortComparisionType = filterSort.sortComparisionType;
        this.sortCaseInsensitive = filterSort.sortCaseInsensitive;
        this.sortNumeric = filterSort.sortNumeric;

    }
}

flexiciousNmsp.FilterSort = FilterSort; //add to name space
FilterSort.prototype.typeName = FilterSort.typeName = "FilterSort";//for quick inspection