/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */


import Constants from '../../../utils/Constants'
import UIUtils from '../../../utils/UIUtils' 
import Filter from './Filter'
/**
 * A class that extends the base filter object, but adds
 * the additional properties, to store whether the user
 * chose to print all pages, or specific pages of data.
 *
 * Please note, this is only required when the grid's
 * filterPageSortMode is server.
 * @constructor
 * @class PrintExportFilter
 * @namespace flexiciousNmsp
 */
export default class PrintExportFilter extends Filter {
    constructor() {
        super();
        /**
         *The printOptions object or exportOptions
         * object on basis of whether the user is printing
         * or exporting.
         */
        this.printExportOptions = null;

    }

    getClassNames() {
        return ["PrintExportFilter", "Filter"];
    }
}

flexiciousNmsp.PrintExportFilter = PrintExportFilter; //add to name space 
PrintExportFilter.prototype.typeName = PrintExportFilter.typeName = 'PrintExportFilter';//for quick inspection