/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */


import Constants from '../../utils/Constants'
import UIUtils from '../../utils/UIUtils' 
import TypedObject from '../../core/TypedObject'

/**
 * Class added in 2.9 to support multiple preferences. Store information about the
 * name of the preference, whether or not it is a system preference (which cannot be deleted),
 * and the preference string associated with this name.
 * @constructor
 * @class PreferenceInfo
 * @namespace flexiciousNmsp
 * 
 */
export default class PreferenceInfo extends TypedObject {
    constructor() {
        super();
        /**
         * Name of the preference
         * @type {String}
         * @property name
         * @default null
         */
        this.name = null;
        /**
         * These cannot be deleted
         * @type {Boolean}
         * @property isSystemPref
         * @default false
         */
        this.isSystemPref = false;
        /**
         * The actual text (or xml) of preferences.
         * @type {String}
         * @property preferences
         * @default null
         */
        this.preferences = null;

    }

    /**
     *
     * @return {Array}
     */
    getClassNames() {
        return ["PreferenceInfo", "TypedObject"];
    }
}

/**
 *
 * @type {Function}
 */
flexiciousNmsp.PreferenceInfo = PreferenceInfo; //add to name space
PreferenceInfo.prototype.typeName = PreferenceInfo.typeName = 'PreferenceInfo';//for quick inspection