/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

(function(window)
{
    "use strict";
    var ExtendedPrintController, uiUtil = flexiciousNmsp.UIUtils, flxConstants = flexiciousNmsp.Constants;

    ExtendedPrintController=function(){

        this._pageInfos = [];

        this._instance = null;

        flexiciousNmsp.PrintController.apply(this);
    };
    flexiciousNmsp.ExtendedPrintController = ExtendedPrintController; //add to name space
    ExtendedPrintController.prototype = new flexiciousNmsp.PrintController(); //setup hierarchy
    ExtendedPrintController.prototype.typeName = ExtendedPrintController.typeName = 'ExtendedPrintController';//for quick inspection
    ExtendedPrintController.prototype.getClassNames=function(){
        return ["ExtendedPrintController","PrintController","TypedObject"];
    };

    ExtendedPrintController._instance = new ExtendedPrintController();
    ExtendedPrintController.instance=function(){
         return ExtendedPrintController._instance;
    };
    ExtendedPrintController.prototype.print=function(printable, printOptions){
        if(typeof  printOptions=="undefined") printOptions=null;

        this.totalDirty=true;
        if(printOptions.printComponentRenderer==null)
            printOptions.printComponentRenderer = new flexiciousNmsp.ClassFactory(flexiciousNmsp.PrintFlexDataGrid,undefined);

        flexiciousNmsp.PrintController.prototype.print.apply(this,[printable, printOptions]);
    };
    ExtendedPrintController.prototype.printWithOptions=function(printable, printOptions){

        this.serverDataRetrieved=false;
        printOptions.printedPages=[];

        if (printOptions.preview)
            this.previewWithOptions(printable, printOptions);
        else{

            //html2canvas(document.getElementById('flexiciousPrintWindow'),{async:false}).then(function(canvas) {
            //    document.getElementById('themeContainer').appendChild(canvas);
            //});

            flexiciousNmsp.PrintController.prototype.printWithOptions.apply(this,[printable,printOptions]);
        }

    };
    ExtendedPrintController.prototype.onPrintComplete=function (){

        flexiciousNmsp.PrintController.prototype.onPrintComplete.apply(this,[]);
        if(this.getPrintOptions().printToPdf && !this.getPrintOptions().preview){
            var pvEvent = new flexiciousNmsp.PrintPreviewEvent(flexiciousNmsp.PrintPreviewEvent.PDF_BYTES_READY);
            pvEvent.printOptions=this.getPrintOptions();
            this.getPrintOptions().printable.dispatchEvent(pvEvent);
        }

    };

    ExtendedPrintController.prototype.cloneStyles = function(from, to){
        if(!from || !to)
            return;
        for( var styleProp in flexiciousNmsp.PrintFlexDataGrid.styles)
            to.setStyle(styleProp, from.getStyle(styleProp));
        //to.invalidateDisplayList();
    };


    /**
     * @param printable
     *@param printOptions
     */
    ExtendedPrintController.prototype.createPrintWindow=function (printable, printOptions){

        var pw= flexiciousNmsp.PrintController.prototype.createPrintWindow.apply(this,[printable, printOptions]);
        var grid=printable;
        var from= grid;
        var to=pw.getPrintDataGrid();
        if(!pw.initialized){
            pw.initialize();
        }
        for(var levelProp in grid)
        {
            //todo
            if(levelProp=="width" || levelProp=="height" ||levelProp=="parent" ||levelProp=="owner"  ||levelProp=="preferences"
                ||levelProp=="columnLevel"||levelProp=="columns"  ||levelProp=="groupedColumns" || levelProp=="columnGroups"|| levelProp=="styleName"
                || (levelProp.indexOf("selected")==0)
                || (levelProp.indexOf("ScrollPosition")>0)
                || levelProp=="pageIndex"
                || levelProp=="domElement"
                ||typeof from[levelProp]=="function"
            ||from[levelProp]==null
            )continue;
            if(UIUtils.isPrimitive(from[levelProp]) || (levelProp.indexOf("Renderer")>0)||
                (levelProp.indexOf("Function")>0)){
                if((to[levelProp]!=from[levelProp])){
                    to[levelProp]=from[levelProp];
                }
            }
        }
        if(to.implementsOrExtends("PrintFlexDataGrid"))
        {
            for (var prop in flexiciousNmsp.PrintFlexDataGrid.styles) {
                UIUtils.checkSetterAndApply(to, prop, flexiciousNmsp.PrintFlexDataGrid.styles[prop]);
            }
        }
        //to.setWidth("100%");
        //to.setHeight("100%");
        to.allowInteractivity=false;
        to.horizontalScrollPolicy=Constants.SCROLL_POLICY_OFF;
        return pw;
    };
    ExtendedPrintController.prototype.setupPrintWindow=function (printable, printOptions, printWindow){

        if(this.totalDirty){
            var grid=printable.implementsOrExtends("IExtendedDataGrid")?printable:null;
            var nestedPrintDatagrid=printWindow.getPrintDataGrid().implementsOrExtends("PrintFlexDataGrid")?printWindow.getPrintDataGrid():null;
            nestedPrintDatagrid.printWindow=printWindow;
            var treeDataGrid = grid.implementsOrExtends("FlexDataGrid")?grid:null;
            nestedPrintDatagrid.setColumnLevel(treeDataGrid.getColumnLevel().clone());
            nestedPrintDatagrid.getColumnLevel().initializeLevel(nestedPrintDatagrid);
            //this.cloneStyles(grid ,nestedPrintDatagrid);
            nestedPrintDatagrid.itemFilters=treeDataGrid.itemFilters;
            nestedPrintDatagrid.setEnablePaging(false);
            nestedPrintDatagrid.setForcePagerRow(false);
            nestedPrintDatagrid.setFilterVisible(false);
            nestedPrintDatagrid.getBodyContainer().openItems = treeDataGrid.getBodyContainer().openItems;
            nestedPrintDatagrid.enableMultiColumnSort=false;
            if(printOptions.columnsToPrint.length > 0){
                //this means user only wants to print select columns
                nestedPrintDatagrid.showColumns(printOptions.columnsToPrint);
            } else {
                nestedPrintDatagrid.showPrintableColumns();
            }

            var pe = new flexiciousNmsp.FlexDataGridPrintEvent(flexiciousNmsp.FlexDataGridPrintEvent.BEFORE_PRINT_PROVIDER_SET,grid.implementsOrExtends("FlexDataGrid"),nestedPrintDatagrid);
            grid.dispatchEvent(pe);

             var index=0;
            var cols=nestedPrintDatagrid.getColumnLevel().getVisibleColumns();
            for(var i=0;i<cols.length;i++)
            {
                var col=cols[i];
                col.setWidth(printOptions.columnWidths.length>index?
                    printOptions.columnWidths[index++]:col._naturalLastColWidth||col.getWidth());
                if(col.getColumnWidthMode()==flexiciousNmsp.FlexDataGridColumn.COLUMN_WIDTH_MODE_PERCENT)
                    col.setColumnWidthMode(flexiciousNmsp.FlexDataGridColumn.COLUMN_WIDTH_MODE_NONE);
                if(col.getColumnLockMode()!=flexiciousNmsp.FlexDataGridColumn.LOCK_MODE_NONE)
                {
                    col.setColumnLockMode(flexiciousNmsp.FlexDataGridColumn.LOCK_MODE_NONE);
                }
            }
            nestedPrintDatagrid.setDataProvider(treeDataGrid.getDataForPrintExport(printOptions));
            nestedPrintDatagrid.getBodyContainer().openItems = treeDataGrid.getBodyContainer().openItems;
            this.calculateTotalPages(grid.getDataProvider(),false);//run the print.
            grid.lastPrintOptionsString = printOptions.toPersistenceString(grid);


            pe = new flexiciousNmsp.FlexDataGridPrintEvent(flexiciousNmsp.FlexDataGridPrintEvent.BEFORE_PRINT,grid.implementsOrExtends("FlexDataGrid"),nestedPrintDatagrid);
            grid.dispatchEvent(pe);
        }

    };
    ExtendedPrintController.prototype.getBodyContainerHeight=function(page){

        var printWindow = this._printWindow;
        var nestedPrintDatagrid=printWindow.getPrintDataGrid().implementsOrExtends("PrintFlexDataGrid")?printWindow.getPrintDataGrid():null;
        var chromeHeight=nestedPrintDatagrid.getHeaderHeight()+nestedPrintDatagrid.getFooterRowHeight();
        var printOptions=this._printOptions;
        var surroundingHeights= parseFloat(printWindow.getStyle("paddingTop")||"0")+
            parseFloat(printWindow.getStyle("paddingBottom")||"0")+
            ((printOptions.includePrintHeader && (page=="first"||page=="single"))?printWindow.printerHeader.getHeight():0)+
            ((printOptions.includePrintFooter && (page=="last"||page=="single"))?printWindow.printerFooter.getHeight():0)+
            (printOptions.includePageHeader?printWindow.pageHeader.getHeight():0)+
            (printOptions.includePageFooter?printWindow.pageFooter.getHeight():0)+
            (chromeHeight);
        return printWindow.getHeight()-surroundingHeights;

    };
    ExtendedPrintController.prototype.calculateTotalPages=function (iCollectionView,hasGrouped){

        this.totalDirty=false;
        var printWindow = this._printWindow;
        printWindow.showSinglePage(true);
        var nestedPrintDatagrid=printWindow.getPrintDataGrid().implementsOrExtends("PrintFlexDataGrid")?printWindow.getPrintDataGrid():null;
        var chromeHeight=nestedPrintDatagrid.getHeaderHeight()+nestedPrintDatagrid.getFooterRowHeight();
        var firstPageGridHt=this.getBodyContainerHeight("single");
        var contentHeight=nestedPrintDatagrid.getBodyContainer().calculateTotalHeight();
        this._pageInfos=[];
        var itemPositions= nestedPrintDatagrid.getBodyContainer().getItemVerticalPositions();

        if(firstPageGridHt>contentHeight){
            //this means there is just one page.
            printWindow.setTotalPages(1);
            if(itemPositions.length>0)
                this._pageInfos=[[itemPositions[0],itemPositions[itemPositions.length-1],firstPageGridHt]];
        }else{
            firstPageGridHt=this.getBodyContainerHeight("first");
            var middlePageGridHt=this.getBodyContainerHeight("middle");
            var lastPageGridHt=this.getBodyContainerHeight("last");
            var currentGridHt=firstPageGridHt;
            var covered=0;
            UIUtils.sortOn(itemPositions,"verticalPosition",true);
            var currentPageInfo=[];
            var lastPost;
            var pageStart;
            for(var i=0;i<itemPositions.length;i++){
                var pos=itemPositions[i];
                if(currentPageInfo.length==0){
                    currentPageInfo.push(pos);
                    pageStart=pos;
                }
                if((pos.getVerticalPositionPlusHeight()-pageStart.getVerticalPosition())>currentGridHt){
                    covered=pos.getVerticalPositionPlusHeight();
                    pageStart=pos;
                    currentPageInfo.push(lastPost);
                    currentPageInfo.push(covered);
                    currentGridHt=middlePageGridHt;
                    this._pageInfos.push(currentPageInfo);
                    currentPageInfo=[pos];
                }
                lastPost=pos;
            }
            if(currentPageInfo.length==1){
                covered+=currentGridHt;
                currentPageInfo.push(itemPositions[itemPositions.length-1]);
                currentPageInfo.push(covered);
                this._pageInfos.push(currentPageInfo);
            }
            if((this._pageInfos[this._pageInfos.length-1][1].getVerticalPositionPlusHeight()-
                this._pageInfos[this._pageInfos.length-1][0].getVerticalPosition())>lastPageGridHt){
                printWindow.setTotalPages(this._pageInfos.length+1);
            }
            else
                printWindow.setTotalPages(this._pageInfos.length);
            nestedPrintDatagrid.totalPagesHeight=covered;
        }
  };

    ExtendedPrintController.prototype.getVerticalPositionPlusHeight=function (){
        return this.getVerticalPosition()+this.getRowHeight();
    };
    ExtendedPrintController.prototype.generatePreview=function(printPreview, printWindow){

        flexiciousNmsp.PrintController.prototype.generatePreview.apply(this,[printPreview, printWindow]);
        //if(printWindow.printOptions.printToPdf){
        //    var printBtn=UIUtils.findElementWithClassName(printWindow.domElement,'BTN_PRINT');
        //    printBtn.value="Generate PDF";
        //}
        this._printOptions.availableColumns=[];
        var colIndex=0;
        var printCols=this._extendedDataGrid.getPrintableColumns(this.getPrintOptions());
        for(var i=0;i<printCols.length;i++)
        {
            var col=printCols[i];
            var colName=col.getHeaderText() ? col.getHeaderText() : col.getDataField() ? col.getDataField() : ('Column ' + (colIndex + 1));
            this._printOptions.availableColumns.push({'displayName':colName,'name':colName,'headerText':col.getConcatenatedHeaderText()});
            colIndex++;
        }
        //todo
        //printPreview["cbxColumns"].labelField="displayName";
        //printPreview["cbxColumns"].setDataProvider(this._printOptions.availableColumns);
        //printPreview["cbxColumns"].validateNow();
        //var cols=UIUtils.extractPropertyValues(this._printOptions.columnsToPrint,'name');
        //if(cols.length>0)
        //    printPreview["cbxColumns"].selectedValues=cols;

    };
    /*printPreview["cbxColumns"].dataField="headerText";
     printPreview["cbxColumns"].dataProvider= _extendedDataGrid.getPrintableColumns(printOptions);
     printPreview["cbxColumns"].validateNow();
     if(printWindow.printOptions.columnsToPrint.source.length>0)
     printPreview["cbxColumns"].selectedItems = printWindow.printOptions.columnsToPrint.source;*/
    ExtendedPrintController.prototype.gotoCurrentPage=function (){

        var printWindow = this._printWindow;
        var nestedPrintDatagrid=printWindow.getPrintDataGrid().implementsOrExtends("PrintFlexDataGrid")?printWindow.getPrintDataGrid():null;
        nestedPrintDatagrid.showPositions(this._pageInfos[printWindow.getCurrentPage()-1]);

    };
    /**
     * The current grid being exported
     */
    ExtendedPrintController.prototype.getGrid = function() {
        return this._extendedDataGrid;
    };
    /**
     * The current export options
     */
    ExtendedPrintController.prototype.getPrintOptions = function() {
        return this._printOptions;
    };
}(window));




/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

(function(window)
{
    "use strict";
    var CustomPrintController, uiUtil = flexiciousNmsp.UIUtils, flxConstants = flexiciousNmsp.Constants;
    /**
     *  This class is used to extend the print and pdf mechanism to any Flex component.
     * The Print Controller adds this functionality for the DataGrid components. The
     * Custom Print controller takes this concept and applies them to any component that implements
     * IPrintable
     *
     * @constructor
     * @namespace com.flexicious.print.customprint
     */
    CustomPrintController=function(){
        this.pagesCalculated=false;
    };
    flexiciousNmsp.CustomPrintController = CustomPrintController; //add to name space
    CustomPrintController.prototype = new flexiciousNmsp.PrintController(); //setup hierarchy
    CustomPrintController.prototype.typeName = CustomPrintController.typeName = 'CustomPrintController';//for quick inspection
    CustomPrintController.prototype.getClassNames=function(){
        return ["CustomPrintController","PrintController"];
    };
    CustomPrintController._instance = new CustomPrintController();
    CustomPrintController.instance=function(){
        return CustomPrintController._instance;
    };

    /**
     * We need to recalculate the page count when this happens.
     */
    CustomPrintController.prototype.onPreviewPageOptionsChanged=function (event){

        this.pagesCalculated=false;
        flexiciousNmsp.PrintController.prototype.onPreviewPageOptionsChanged.apply(this,[event]);

    };
    /**
     * Called by the grid to print its contents to the printer on basis
     * of the passed in print options. If the preview property of the
     * printOptions parameter is true, it will popup a preview window.
     * @param grid			The IPrintable to print
     * @param printOptions	PrintOptions to use for printing
     */
    CustomPrintController.prototype.print=function(printable, printOptions){
        if(typeof  printOptions=="undefined") printOptions=null;

        if (printOptions == null)
            printOptions=new flexiciousNmsp.PrintOptions();
        this._printOptions=printOptions;
        this._printOptions.printable=printable;
        this.printWithOptions(printable, printOptions)

    };
    CustomPrintController.prototype.printWithOptions=function(printable, printOptions){

        this.pagesCalculated=false;
        this.serverDataRetrieved=false;
        flexiciousNmsp.UIUtils.removeAll(printOptions.printedPages);
        this._printOptions.printable=printable;
        if (printOptions.preview)
            this.previewWithOptions(printable, printOptions);
        else{
            (printable).validateNow();
            flexiciousNmsp.PrintController.prototype.printWithOptions.apply(this,[printable,printOptions]);
            printOptions.preview=false;
            if(printOptions.printToPdf && !printOptions.preview){
                var pvEvent = new flexiciousNmsp.PrintPreviewEvent(flexiciousNmsp.PrintPreviewEvent.PDF_BYTES_READY);
                pvEvent.printOptions=printOptions;
                printable.dispatchEvent(pvEvent);
            }
        }
        var pe = new flexiciousNmsp.PrintPreviewEvent(flexiciousNmsp.PrintPreviewEvent.AFTER_PRINT);
        pe.printOptions = printOptions;
        printable.dispatchEvent(pe);
        this.pagesCalculated=true;

    };
    /**
     *  Called by both the print and the preview, to populate the grid on basis of the provided options.
     */
    CustomPrintController.prototype.setupPrintWindow=function (printable, printOptions, printWindow){

        var printComponent = printWindow.printComponent;
        if(!this.pagesCalculated){
            printWindow.validateNow();
            printComponent.initializeFromPrintable(printable);
            printWindow.validateNow();
            printWindow.setTotalPages(printComponent.calculateTotalPages());//just so we know in advance what the total number of pages is.
            //printComponent.getLastPagePaddingComponent().setHeight( (printWindow.totalPages * this._printOptions.pageSize.height) - printComponent.getHeight());
            this.pagesCalculated=true;
        }
        var pe = new flexiciousNmsp.PrintPreviewEvent(flexiciousNmsp.PrintPreviewEvent.BEFORE_PRINT);
        pe.printOptions = printOptions;
        printable.dispatchEvent(pe);


    };
    ///**
    // * Generates a preview of the dashboard
    // */
    //CustomPrintController.prototype.generatePreview=function(printPreview, printWindow){
    //
    //    flexiciousNmsp.PrintController.generatePreview.apply(this,[printPreview, printWindow]);
    //    if(printWindow.printOptions.printToPdf){
    //        printPreview["BTN_PRT_1"].label="Generate PDF";
    //    }
    //
    //};
    /**
     * Unused, dashboard printouts are currently one page only.
     */
    CustomPrintController.prototype.gotoCurrentPage=function (){
        //need to take care of this.
        //_printWindow.printDataGrid.gotoRow(_printWindow.getPageStart());
        (this._printWindow.printComponent).gotoPage(this._printWindow.currentPage)

    };
}(window));
