/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */
const uiUtil = flexiciousNmsp.UIUtils;
const flxConstants = flexiciousNmsp.Constants;
import TypedObject from '../../core/TypedObject'


/**
 * Stores information about the common paper
 * formats
 * @constructor
 * @namespace com.flexicious.print.printareas
 * 
 */
export default class PageSize extends TypedObject {
    constructor(name, width, height) {
        super();
        this.name = name;

        this._width = width-90;//*1.08;

        this._height = height-90;//*1.16;

        this.isLandscape = false;

        this.name = name;
        this.width = width;
        this.height = height;
    }

    getClassNames() {
        return ["PageSize","TypedObject"];
    }

    /**
     * Gets the paper size by name
     * @param name
     * @return
        *
     */
    static getByName(name) {

        return name=="A3"?PageSize.PAGE_SIZE_A3.clone():
            name=="A4"?PageSize.PAGE_SIZE_A4.clone():
                name=="A5"?PageSize.PAGE_SIZE_A5.clone():
                    name=="Letter"?PageSize.PAGE_SIZE_LETTER.clone():
                        name=="Legal"?PageSize.PAGE_SIZE_LEGAL:PageSize.PAGE_SIZE_A4.clone();

    }

    /**
     *
     * Gets the paper size given the width and the height
     * @param width
     * @param height
     * @return
        *
     */
    static getBySize(width, height) {

        return (width==PageSize.PAGE_SIZE_A3.getWidth() && height==PageSize.PAGE_SIZE_A3.getHeight())?PageSize.PAGE_SIZE_A3.clone():
            (width==PageSize.PAGE_SIZE_A3.getHeight()&& height==PageSize.PAGE_SIZE_A3.getWidth() )?PageSize.PAGE_SIZE_A3.clone().rotate():
            (width==PageSize.PAGE_SIZE_A4.getWidth() && height==PageSize.PAGE_SIZE_A4.getHeight())?PageSize.PAGE_SIZE_A4.clone():
            (width==PageSize.PAGE_SIZE_A4.getHeight()&& height==PageSize.PAGE_SIZE_A4.getWidth() )?PageSize.PAGE_SIZE_A4.clone().rotate():
            (width==PageSize.PAGE_SIZE_A5.getWidth() && height==PageSize.PAGE_SIZE_A5.getHeight())?PageSize.PAGE_SIZE_A5.clone():
            (width==PageSize.PAGE_SIZE_A5.getHeight()&& height==PageSize.PAGE_SIZE_A5.getWidth() )?PageSize.PAGE_SIZE_A5.clone().rotate():
            (width==PageSize.PAGE_SIZE_LEGAL.getWidth() && height==PageSize.PAGE_SIZE_LEGAL.getHeight())?PageSize.PAGE_SIZE_LEGAL.clone():
            (width==PageSize.PAGE_SIZE_LEGAL.getHeight()&& height==PageSize.PAGE_SIZE_LEGAL.getWidth() )?PageSize.PAGE_SIZE_LEGAL.clone().rotate():
            (width==PageSize.PAGE_SIZE_LETTER.getWidth() && height==PageSize.PAGE_SIZE_LETTER.getHeight())?PageSize.PAGE_SIZE_LETTER.clone():
            (width==PageSize.PAGE_SIZE_LETTER.getHeight()&& height==PageSize.PAGE_SIZE_LETTER.getWidth() )?PageSize.PAGE_SIZE_LETTER.clone().rotate():
            new PageSize("Custom",width,height);


    }

    /**
     * Clones the paper size
     * @return
        *
     */
    clone() {

        return new PageSize(this.name,this.getWidth(),this.getHeight());

    }

    /**
     * Flips the orientation from potrait to landscape
     * and back
     * @return
        *
     */
    rotate() {

        this.isLandscape=!this.isLandscape;
        return this;

    }

    /**
     * Width of the paper size
     * @return
        *
     */
    getWidth() {
        return this.isLandscape?this._height:this._width;
    }

    setWidth(val) {
        this._width = val;
    }

    /**
     * Height of the paper size
     * @return
        *
     */
    getHeight() {
        return this.isLandscape?this._width:this._height;
    }

    setHeight(val) {
        this._height = val;
    }
}

flexiciousNmsp.PageSize = PageSize; //add to name space
PageSize.prototype.typeName = PageSize.typeName = 'PageSize';//for quick inspection
PageSize.PAGE_LAYOUT_POTRAIT='Portrait';
PageSize.PAGE_LAYOUT_LANDSCAPE='Landscape';
PageSize.PAGE_SIZE_A3=new PageSize("A3",11.7* 96,16.5* 96);
PageSize.PAGE_SIZE_A4=new PageSize("A4",8.27* 96,11.7* 96);
PageSize.PAGE_SIZE_A5=new PageSize("A5",5.83 * 96,8.27* 96);
PageSize.PAGE_SIZE_LEGAL=new PageSize("Legal",8.5*96,14*96);
PageSize.PAGE_SIZE_LETTER=new PageSize("Letter",8.5*96,11*96);