/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

(function(window)
{
    "use strict";
    var PrintFlexDataGrid, uiUtil = flexiciousNmsp.UIUtils, flxConstants = flexiciousNmsp.Constants;
    /**
     * Specialized extension of the FlexDataGrid that is used for printing. Hides the
     * vertical scrollbar, and shows only what can be displayed on the page given the
     * height constraints of the page being printed to.
     * @constructor
     * @namespace flexiciousNmsp.print
     */
    PrintFlexDataGrid=function(){
        /**
         * The Print Window object contains the Report Header, Page Header, Grid, Page Footer and Report Footer.
         */
        this.printWindow=null;
        /**
         * Height of all the pages combined
         */
        this.totalPagesHeight=null;



        this.allowInteractivity=false;

        flexiciousNmsp.FlexDataGrid.apply(this);

        this.setVerticalScrollPolicy("off");
        this.setHorizontalScrollPolicy("off");


    };
    flexiciousNmsp.PrintFlexDataGrid = PrintFlexDataGrid; //add to name space
    PrintFlexDataGrid.prototype = new flexiciousNmsp.FlexDataGrid(); //setup hierarchy
    PrintFlexDataGrid.prototype.typeName = PrintFlexDataGrid.typeName = 'PrintFlexDataGrid';//for quick inspection
    PrintFlexDataGrid.prototype.getClassNames=function(){
        return ["PrintFlexDataGrid","FlexDataGrid","NdgBase","UIComponent","IPrintDatagrid",
            "IExtendedFlexDataGrid", "IExtendedDataGrid","ISpinnerOwner"];
    };

    /**
     * We create a specialized body container
     * @return
        *
     */
    PrintFlexDataGrid.prototype.createBodyContainer=function (){

        return new flexiciousNmsp.PrintFlexDataGridBodyContainer(this);


    };
    /**
     * Not applicable for Nested Tree DataGrid, used to conform to interface
     */
    PrintFlexDataGrid.prototype.setResizableColumns=function(val){



    };
    /**
     * Goes to the next page of data.
     */
    PrintFlexDataGrid.prototype.nextPage=function(){

        this.getBodyContainer().nextPage();
        this.synchronizeLockedVerticalScroll();

    };
    /**
     * @private
     * @param [row]
     *
     */
    PrintFlexDataGrid.prototype.placeComponents=function (row){

        this.placeChildComponents(row.cells);

    };
    /**
     * Given an array of ItemPositionInfo objects, draws them in the visible area.
     * @param [positions]
     *
     */
    PrintFlexDataGrid.prototype.showPositions=function(positions){

        this.getBodyContainer().showPositions(positions);

    };
    /**
     * Returns true if there is another page of data after this one
     */
    PrintFlexDataGrid.prototype.getValidNextPage = function() {
        return this.getBodyContainer().getValidNextPage();
    };
    PrintFlexDataGrid.prototype.getHeaderHeight = function() {
        return this.getHeaderSectionHeight();
    };
    PrintFlexDataGrid.prototype.getEnableHeightAutoAdjust = function() {

        return false;
    };
    /**
     * Not applicable for Nested Tree DataGrid, used to conform to interface
     */
    PrintFlexDataGrid.prototype.getPrintListItems = function() {
        return [null];
    };

    PrintFlexDataGrid.prototype.setHeight = function(val) {
        flexiciousNmsp.FlexDataGrid.prototype.setHeight.apply(this,[val]);
    };
    PrintFlexDataGrid.prototype.onMouseWheel = function (event) {

    };

    PrintFlexDataGrid.prototype.setWidth = function (val) {
        flexiciousNmsp.FlexDataGrid.prototype.setWidth.apply(this, [val]);
    };

    PrintFlexDataGrid.styles={
        alternatingItemColors:  [0xFFFFFF, 0xFFFFFF],
        alternatingTextColors:  [0x000000, 0x000000],
        rollOverColor: 0xCEDBEF,
        headerRollOverColors:  [0xE6E6E6, 0xFFFFFF],
        headerColors:  [0xE6E6E6, 0xFFFFFF],
        columnGroupRollOverColors:  [0xE6E6E6, 0xFFFFFF],
        columnGroupColors:  [0xE6E6E6, 0xFFFFFF],
        filterRollOverColors:  [0xBDCFEF, 0xD6E7F7],
        filterColors:  [0xCFCFCF,0xCFCFCF],
        pagerColors:  [0xE6E6E6, 0xFFFFFF],
        footerColors:  [0xE6E6E6, 0xFFFFFF],
        rendererRollOverColors:  [0xFFFFFF, 0xFFFFFF],
        rendererColors:   [0xFFFFFF,0xFFFFFF],
        textSelectedColor:0x000000,
        textRollOverColor:0x000000,
        borderColor: 0x666666,
        selectionColor: [0xFFEFB5,0xFFDF8C]
    }
}(window));
