/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

(function(window)
{
    "use strict";
    var PrintOptionsView, uiUtil = flexiciousNmsp.UIUtils, flxConstants = flexiciousNmsp.Constants;
    /**
     * A PrintOptionsView that which can be used within the filtering/binding infrastructure.
     * @constructor
     * @namespace flexiciousNmsp
     * 
     */
    PrintOptionsView=function(){
        flexiciousNmsp.UIComponent.apply(this,["div"]);
        UIUtils.attachClass(this.domElement,"flexiciousGrid");
        this.cbxColumns = new flexiciousNmsp.MultiSelectComboBox();
        this.cbxColumns.alwaysVisible=true;

        this.setWidth(500);
        this.printOptions=new flexiciousNmsp.PrintOptions();

    };

    flexiciousNmsp.PrintOptionsView = PrintOptionsView; //add to name space
    PrintOptionsView.prototype = new flexiciousNmsp.UIComponent(); //setup hierarchy
    PrintOptionsView.prototype.typeName = PrintOptionsView.typeName = 'PrintOptionsView';//for quick inspection
    /**
     *
     * @return {Array}
     */
    PrintOptionsView.prototype.getClassNames=function(){
        return ["PrintOptionsView","UIComponent"];
    };

    PrintOptionsView.prototype.setGrid = function(val) {
        this._grid=val;
        this.enablePaging = val.getEnablePaging();
        this.pageCount = val.getPageSize()>0?Math.ceil(val.getTotalRecords()/val.getPageSize()):1;
        this.selectedObjectsCount = val.getSelectedObjectsTopLevel().length;
    };

    PrintOptionsView.prototype.titlewindow1_creationCompleteHandler=function (event){

        if(this.printOptions.columnsToPrint.length>0)
            this.cbxColumns.selectedValues=UIUtils.extractPropertyValues(this.printOptions.columnsToPrint,'name');

    };

    PrintOptionsView.prototype.onOK=function (){
        var pagingRadios = document.getElementsByName("flxsExportpaging");

        for(var i = 0; i <= pagingRadios.length; i++) {
            if(pagingRadios[i].checked == true) {
                this.printOptions.printExportOption =  pagingRadios[i].value;
                break;
            }
        }

        var pgFrom=parseInt(UIUtils.findElementWithClassName(this.domElement,'txtPageFrom').value);
        var pgTo=parseInt(UIUtils.findElementWithClassName(this.domElement,'txtPageTo').value);
        if(UIUtils.findElementWithClassName(this.domElement,'RBN_SELECT_PGS').checked){
            if(pgFrom>=1 && pgTo>=1 && pgFrom <=(this.pageCount+1)&& pgTo <=(this.pageCount+1) && pgFrom<=pgTo){
                this.printOptions.pageFrom = pgFrom;
                this.printOptions.pageTo = pgTo;
                this.close(Constants.ALERT_OK);

            }else{
                window.alert("Please ensure that the 'page from' is less than or equal to 'page to'");
            }
        }
        else{
            this.close(Constants.ALERT_OK);
        }
    };

    PrintOptionsView.prototype.close=function (dialogResult){
        var closeEvent = new flexiciousNmsp.BaseEvent(Constants.EVENT_CLOSE);
        closeEvent.detail=dialogResult;
        this.dispatchEvent(closeEvent);
        UIUtils.removePopUp(this);
    };

    PrintOptionsView.prototype.updateExportColumns=function (){
        this.printOptions.columnsToPrint=(this.cbxColumns.getSelectedItems());
        if (this.printOptions.columnsToPrint.length == 1 && this.printOptions.columnsToPrint[0].name == "All")
        {
            this.printOptions.columnsToPrint=[];
        }
    };

    PrintOptionsView.prototype.onCancel=function (evt){
        //UIUtils.removePopUp(this);
        this.close(Constants.ALERT_CANCEL);
    };
    /**
     * Initializes the auto complete and watermark plugins
     */
    PrintOptionsView.prototype.initialize=function(){
        flexiciousNmsp.UIComponent.prototype.initialize.apply(this);
        var container = new flexiciousNmsp.UIComponent("div");
        container.domElement.className= "printOptionsView";
        this.addChild(container);
        var html = ""
        html +="   <div class='columnsLabel'>"+Constants.PRT_LBL_COLS_TO_PRINT_TEXT+"</div>  <div class='options'>" +
            "   <input type='radio' class='RBN_CURRENT_PAGE' checked name='flxsExportpaging'  value='"+flexiciousNmsp.PrintExportOptions.PRINT_EXPORT_CURRENT_PAGE+"'>"+Constants.PRT_RBN_CURRENT_PAGE_LABEL+"<br/>"  +
            "   <input type='radio' class='RBN_ALL_PAGES' name='flxsExportpaging' value='"+flexiciousNmsp.PrintExportOptions.PRINT_EXPORT_ALL_PAGES+"'> "+Constants.PRT_RBN_ALL_PAGES_LABEL+"<br/>" +
            "   <input type='radio' class='RBN_SELECT_PGS' name='flxsExportpaging' value='"+flexiciousNmsp.PrintExportOptions.PRINT_EXPORT_SELECTED_PAGES+"'> "+Constants.PRT_RBN_SELECT_PGS_LABEL+"<br/>"+
            "   <input  type='number' class='txtPageFrom' maxlength='5 '>"+
            "   <label>"+Constants.PGR_TO+"</label>" +
            "   <input   type='number' class='txtPageTo' maxlength='5'>" +
            "   <label>"+(this.pageCount+1)+"</label><br/>"+
            "   <input "+(this.selectedObjectsCount>0?'':'disabled')+" type='radio' class='rbnSelectedRecords'   name='flxsExportpaging' value='"+flexiciousNmsp.PrintExportOptions.PRINT_EXPORT_SELECTED_RECORDS+"'>"
            +Constants.SELECTED_RECORDS+"(" + (this.selectedObjectsCount==0?' None Selected)':this.selectedObjectsCount+" selected)")+ "<br/>" +
            "</div><br/><br/>";
        html +="<div class='bottomButtonBar'>" +
            " <a  class='BTN_EXPORT button' alt='Export'>"+Constants.PRT_BTN_PRINT_LABEL+"</a>" +
            " <a class='BTN_CANCEL button' alt='Cancel'>"+Constants.PRT_BTN_CANCEL_LABEL+"</a>" +
            "</div>";

        container.setInnerHTML(html);

        var exportBtn=UIUtils.findElementWithClassName(this.domElement,'BTN_EXPORT');
        var cancelBtn=UIUtils.findElementWithClassName(this.domElement,'BTN_CANCEL');

        UIUtils.addDomEventListener(this, exportBtn, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'flexiciousGrid').component.onOK();
        });
        UIUtils.addDomEventListener(this, cancelBtn, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'flexiciousGrid').component.onCancel();
        });

        this.cbxColumns.setDataProvider(this.printOptions.availableColumns);
        this.cbxColumns.labelField="headerText";
        this.cbxColumns.dataField="name";
        this.cbxColumns.addEventListener(this,Constants.EVENT_CHANGE,this.updateExportColumns);
        container.addChild(this.cbxColumns);
        this.cbxColumns.showPopup(container);
    };
}(window));