/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

(function(window)
{
    "use strict";
    var PrintPreview, uiUtil = flexiciousNmsp.UIUtils, flxConstants = flexiciousNmsp.Constants;
    /**
     * A PrintPreview that which can be used within the filtering/binding infrastructure.
     * @constructor
     * @namespace flexiciousNmsp
     * 
     */
    PrintPreview=function(){
        this._currentPage=1;
        flexiciousNmsp.UIComponent.apply(this,["div"]);
    };
    flexiciousNmsp.PrintPreview = PrintPreview; //add to name space
    PrintPreview.prototype = new flexiciousNmsp.Label(); //setup hierarchy
    PrintPreview.prototype.typeName = PrintPreview.typeName = 'PrintPreview';//for quick inspection
    PrintPreview.prototype.getClassNames=function(){
        return ["PrintPreview","TitleWindow","IPrintPreview","UIComponent"];
    };

    PrintPreview.prototype.getCurrentPage = function() {
        return this._currentPage;
    };
    PrintPreview.prototype.setCurrentPage = function(val) {
        this._currentPage=val;
    };

    PrintPreview.prototype.getTotalPages = function() {
     return this._totalPages;
    };

    PrintPreview.prototype.setTotalPages = function(val) {
        this._totalPages=val;
    };

    PrintPreview.prototype.getPrintOptions  = function() {
    return this._printOptions;
    };

    PrintPreview.prototype.setPrintOptions = function(val) {
        this._printOptions=val;
        var cols=[];
        var pageSizeSelect=UIUtils.findElementWithClassName(this.domElement,"pageSizeSelect");
        var pageLayoutSelect=UIUtils.findElementWithClassName(this.domElement,"pageLayoutSelect");

        pageSizeSelect.value = val.pageSize.name;
        pageLayoutSelect.value = val.pageSize.isLandscape?flexiciousNmsp.PageSize.PAGE_LAYOUT_LANDSCAPE:flexiciousNmsp.PageSize.PAGE_LAYOUT_POTRAIT;

        this.setButtons();
        //var items=val.columnsToPrint;
        //for(var i=0;i<items.length;i++){
        //    var colToPrint=items[i];
        //    cols.push(colToPrint.name);
        //}
        //if(cols.length>0)
        //    cbxColumns.selectedValues=cols;
    };

    PrintPreview.prototype.getContent = function() {
        return this.pageContent;
    };

    //called when the user changes any property like pagesize, layout or the page index
    PrintPreview.prototype.recreate=function (eventType){
        if(typeof eventType=="undefined")eventType="pageOptionsChanged";
        var pageSizeSelect=UIUtils.findElementWithClassName(this.domElement,'pageSizeSelect');
        var pageLayoutSelect=UIUtils.findElementWithClassName(this.domElement,'pageLayoutSelect');
        this._printOptions.pageSize = flexiciousNmsp.PageSize.getByName(pageSizeSelect.value.toString());
        this._printOptions.pageSize.isLandscape = pageLayoutSelect.value ==flexiciousNmsp.PageSize.PAGE_LAYOUT_LANDSCAPE;

        //this._printOptions.columnsToPrint=new flexiciousNmsp.Array(cbxColumns.selectedItems);
        //if(this._printOptions.columnsToPrint.length==1 && this._printOptions.columnsToPrint[0][cbxColumns.labelField]=="All"){
        //    this._printOptions.columnsToPrint.removeAll();
        //}

        this.dispatchEvent(new flexiciousNmsp.PrintPreviewEvent(eventType)); //this will cause the entire canvas to be redrawn, including rebuilding the grid

        this.setButtons();
    };
    PrintPreview.prototype.setButtons=function(){
        var btnPrevPage=UIUtils.findElementWithClassName(this.domElement,'firstPageButton');
        var btnFirstPage=UIUtils.findElementWithClassName(this.domElement,'previousPageButton');
        var btnNextPage=UIUtils.findElementWithClassName(this.domElement,'nextPageButton');
        var btnLastPage=UIUtils.findElementWithClassName(this.domElement,'lastPageButon');


        btnPrevPage.disabled=this._currentPage==1;
        btnFirstPage.disabled=this._currentPage==1;
        btnNextPage.disabled=this._totalPages==this._currentPage;
        btnLastPage.disabled=this._totalPages==this._currentPage;

        var pageHeaderCb=UIUtils.findElementWithClassName(this.domElement,'pageHeaderCheckbox');
        var reportHeaderCb=UIUtils.findElementWithClassName(this.domElement,'reportHeaderCheckbox');
        var pageFooterCb=UIUtils.findElementWithClassName(this.domElement,'pageFooterCheckbox');
        var reportFooterCb=UIUtils.findElementWithClassName(this.domElement,'pageFooterLabel');

        if(this._printOptions)
        {
            pageHeaderCb.checked= this._printOptions.includePageHeader;
            pageFooterCb.checked= this._printOptions.includePageFooter;
            reportHeaderCb.checked= this._printOptions.includePrintHeader;
            reportFooterCb.checked= this._printOptions.includePrintFooter;
        }
    };

    //this simply shows the message saying we cannot change the actual print settings.
    PrintPreview.prototype.showSettingsMessage=function (){
        //if(this._printOptions.showWarningMessage)
        //settingsMessage.visible=settingsMessage.includeInLayout=true;
    };

    PrintPreview.prototype.titlewindow1_creationCompleteHandler=function (event){
        //this.title=Constants.PPRV_LBL_TITLE_TEXT;
        //Constants.applyLabels("PPRV",[LBL_PG_SIZE,LBL_LAYOUT,LBL_COLS,CB_PAGE_HDR,CB_PAGE_FTR,CB_RPT_FTR,CB_RPT_HDR,
        //BTN_PRT,BTN_CANCEL,LBL_SETTINGS_1,LBL_SETTINGS_2,BTN_PRT_1,BTN_CANCEL_1],
        //["text","label","toolTip"]);
    };

    PrintPreview.prototype.getProgress = function() {
        return this._progress;
    };

    PrintPreview.prototype.setProgress = function(value) {
        //var vals=value.split("|");
        //this._progress = value;
        //pb.visible=true;
        //pb.setProgress(parseInt(vals[0]),parseInt(vals[1]));
        //pb.label ="Processing page " + vals[0] + " of " + vals[1];
        //pb.validateNow();
    };

    PrintPreview.prototype.onPrint=function (evt){
        this.isPrinting=true;
        this.dispatchEvent(new flexiciousNmsp.PrintPreviewEvent(flexiciousNmsp.PrintPreviewEvent.PRINT_REQUESTED));
    };

    PrintPreview.prototype.onCancel=function (evt){
        UIUtils.removePopUp(this);
        this.dispatchEvent(new flexiciousNmsp.PrintPreviewEvent(flexiciousNmsp.PrintPreviewEvent.PRINT_CANCELED));
    };
    PrintPreview.prototype.generateOptions=function(arr){

        var optionsStr = "";
        for(var i=0;i<arr.length;i++){
            optionsStr += "<option value='"+arr[i]+"'>" + arr[i] + "</option>";
        }
        return optionsStr;

    };

    /**
     * Initializes the auto complete and watermark plugins
     */
    PrintPreview.prototype.initialize=function(){
        flexiciousNmsp.UIComponent.prototype.initialize.apply(this);
        var html = "<div>The preferences you specify below will be retained when this grid is loaded in the future:</div>";

        var PageSize=flexiciousNmsp.PageSize;

        html += "<table>" +
        "<tr> " +
        "<td>"+Constants.PPRV_LBL_PG_SIZE_TEXT+"</td>" +
        "<td>"+Constants.PPRV_LBL_LAYOUT_TEXT+"</td>" +
        "<td></td>" +
        "<td><input class='pageHeaderCheckbox' type='checkbox' value='"+Constants.PPRV_CB_PAGE_HDR_LABEL+"'>"+Constants.PPRV_CB_PAGE_HDR_LABEL+"</td>" +
        "<td><input class='reportHeaderCheckbox' type='checkbox' value='"+Constants.PPRV_CB_RPT_HDR_LABEL+"'>"+Constants.PPRV_CB_RPT_HDR_LABEL+"</td>" +
        "</tr>" +
        "<tr> " +
        "<td><select class='pageSizeSelect' >" +this.generateOptions([PageSize.PAGE_SIZE_LEGAL.name,PageSize.PAGE_SIZE_LETTER.name,PageSize.PAGE_SIZE_A3.name,PageSize.PAGE_SIZE_A4.name,PageSize.PAGE_SIZE_A5.name])+"</select></td>" +
        "<td><select class='pageLayoutSelect'>" +this.generateOptions([PageSize.PAGE_LAYOUT_LANDSCAPE,PageSize.PAGE_LAYOUT_POTRAIT])+"</select></td>" +
        "<td></td>" +
        "<td><input class='pageFooterCheckbox' type='checkbox' value='"+Constants.PPRV_CB_PAGE_FTR_LABEL+"'>"+Constants.PPRV_CB_PAGE_FTR_LABEL+"</td>" +
        "<td><input class='pageFooterLabel' type='checkbox' value='"+Constants.PPRV_CB_RPT_FTR_LABEL+"'>"+Constants.PPRV_CB_RPT_FTR_LABEL+"</td>" +
        "</tr>" +
        "<tr> " +
        "<td><input  class='firstPageButton' type='button' value='&lt;&lt;'>&nbsp;" +
        "<input class='previousPageButton' type='button' value='&lt;'></td>" +
        "<td><input class='nextPageButton' type='button' value='&gt;'>&nbsp;" +
        "<input class='lastPageButon' type='button' value='&gt;&gt;'></td>" +
        "<td><input type='button' class='"+Constants.PRT_BTN_PRINT_LABEL+"' value='"+Constants.PRT_BTN_PRINT_LABEL+"'></td>" +
        "<td><input type='button' class='"+Constants.PRT_BTN_CANCEL_LABEL+"' value='"+Constants.PRT_BTN_CANCEL_LABEL+"'></td>" +
        "</tr>" +
        "</table>";



        this.topBar = new flexiciousNmsp.UIComponent();
        this.topBar.setInnerHTML(html);
        this.addChild(this.topBar);


        this.content = new flexiciousNmsp.UIComponent("div");
        this.addChild(this.content);
        this.content.domElement.style.overflow="auto";
        this.content.domElement.className="flxiciousPrintContent";
        this.pageContent=this.content;


        html ="<div style='padding-top : 7px'>" + "<a  class='BTN_PRINT button' alt='Print'>Print</a>" +
            " <a class='BTN_CANCEL button' alt='Cancel'>Cancel</a>" +
            "</div>";
        this.bottomBar = new flexiciousNmsp.UIComponent();
        this.bottomBar.domElement.className = 'flexiciousGrid'; // to make the print and cancel button styles
        this.bottomBar.setInnerHTML(html);
        this.addChild(this.bottomBar);



        var printBtn=UIUtils.findElementWithClassName(this.domElement,'BTN_PRINT');
        var cancelBtn=UIUtils.findElementWithClassName(this.domElement,'BTN_CANCEL');

        UIUtils.addDomEventListener(this, printBtn, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onPrint();
        });
        UIUtils.addDomEventListener(this, cancelBtn, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onCancel();
        });


        printBtn=UIUtils.findElementWithClassName(this.domElement,Constants.PRT_BTN_PRINT_LABEL);
        cancelBtn=UIUtils.findElementWithClassName(this.domElement,Constants.PRT_BTN_CANCEL_LABEL);

        UIUtils.addDomEventListener(this, printBtn, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onPrint();
        });
        UIUtils.addDomEventListener(this, cancelBtn, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onCancel();
        });


        var pageHeaderCb=UIUtils.findElementWithClassName(this.domElement,'pageHeaderCheckbox');
        var reportHeaderCb=UIUtils.findElementWithClassName(this.domElement,'reportHeaderCheckbox');
        var pageFooterCb=UIUtils.findElementWithClassName(this.domElement,'pageFooterCheckbox');
        var reportFooterCb=UIUtils.findElementWithClassName(this.domElement,'pageFooterLabel');

        var pageSizeSelect=UIUtils.findElementWithClassName(this.domElement,'pageSizeSelect');
        var pageLayoutSelect=UIUtils.findElementWithClassName(this.domElement,'pageLayoutSelect');

        var btnFirstPage=UIUtils.findElementWithClassName(this.domElement,'firstPageButton');
        var btnPrevPage=UIUtils.findElementWithClassName(this.domElement,'previousPageButton');
        var btnNextPage=UIUtils.findElementWithClassName(this.domElement,'nextPageButton');
        var btnLastPage=UIUtils.findElementWithClassName(this.domElement,'lastPageButon');


        UIUtils.addDomEventListener(this, pageHeaderCb, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onPageHeaderCbClick(evt.target || evt.srcElement);
        });

        UIUtils.addDomEventListener(this, reportHeaderCb, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onReportHeaderCbClick(evt.target || evt.srcElement);
        });

        UIUtils.addDomEventListener(this, pageFooterCb, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onPageFooterCbClick(evt.target || evt.srcElement);
        });

        UIUtils.addDomEventListener(this, reportFooterCb, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onReportFooterCbClick(evt.target || evt.srcElement);
        });

        UIUtils.addDomEventListener(this, pageSizeSelect, "change", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onPageSizeSelectChange(evt.target || evt.srcElement);
        });

        UIUtils.addDomEventListener(this, pageLayoutSelect, "change", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onPageLayoutSelectChange(evt.target || evt.srcElement);
        });

        UIUtils.addDomEventListener(this, btnPrevPage, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onPrevPageClick(evt.target || evt.srcElement);
        });

        UIUtils.addDomEventListener(this, btnFirstPage, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onFirstPageClick(evt.target || evt.srcElement);
        });

        UIUtils.addDomEventListener(this, btnNextPage, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onNextPageClick(evt.target || evt.srcElement);
        });

        UIUtils.addDomEventListener(this, btnLastPage, "click", function (evt){
            UIUtils.findAncestorByClassName(evt.target || evt.srcElement, 'printPreview').component.onLastPageClick(evt.target || evt.srcElement);
        });
        this.setButtons();
    };

    PrintPreview.prototype.onPageHeaderCbClick = function(elem) {
        this._printOptions.includePageHeader = elem.checked;
        this.recreate();
    };
    PrintPreview.prototype.onReportHeaderCbClick = function(elem) {
        this._printOptions.includePrintHeader = elem.checked;
        this.recreate();

    };
    PrintPreview.prototype.onPageFooterCbClick = function(elem) {
        this._printOptions.includePageFooter = elem.checked;
        this.recreate();

    };
    PrintPreview.prototype.onReportFooterCbClick = function(elem) {
        this._printOptions.includePrintFooter = elem.checked;
        this.recreate();

    };
    PrintPreview.prototype.onPageSizeSelectChange = function(elem) {
        this.showSettingsMessage();
        this.recreate();

    };
    PrintPreview.prototype.onPageLayoutSelectChange = function(elem) {
        this.showSettingsMessage();
        this.recreate();

    };
    PrintPreview.prototype.onPrevPageClick = function(elem) {
        this._currentPage--;
        this.recreate(flexiciousNmsp.PrintPreviewEvent.PAGE_INDEX_CHANGED)
    };
    PrintPreview.prototype.onFirstPageClick = function(elem) {
        this._currentPage=1;
        this.recreate(flexiciousNmsp.PrintPreviewEvent.PAGE_INDEX_CHANGED)
    };
    PrintPreview.prototype.onNextPageClick = function(elem) {
        this._currentPage++;
        this.recreate(flexiciousNmsp.PrintPreviewEvent.PAGE_INDEX_CHANGED)

    };
    PrintPreview.prototype.onLastPageClick = function(elem) {
        this._currentPage=this._totalPages;
        this.recreate(flexiciousNmsp.PrintPreviewEvent.PAGE_INDEX_CHANGED)

    };


}(window));