/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

(function (window) {
    "use strict";
    var PrintWindow, uiUtil = flexiciousNmsp.UIUtils, flxConstants = flexiciousNmsp.Constants;

    PrintWindow = function () {
        this.rowsOnPage = null;

        this.printOptions = null;

        this.printComponent = null;

        this.printable = null;

        this.printComponentRenderer = null;

        this.printDataGridDirty = false;

        this.printerHeader = null;

        this.reportHeaderRenderer = null;

        this.printerHeaderDirty = false;

        this.printerFooter = null;

        this.reportFooterRenderer = null;

        this.printerFooterDirty = false;

        this.pageHeader = null;

        this.pageHeaderRenderer = null;

        this.pageHeaderDirty = false;

        this.pageFooter = null;

        this.pageFooterRenderer = null;

        this.pageFooterDirty = false;

        this.currentPage = 1;

        this.pageRecordsDirty = false;

        this.totalPages = null;

        this.preReportPagesComponent = null;

        this.postReportPagesComponent = null;

        this.showing = "none";


        this.rowsOnPage = [];


        flexiciousNmsp.UIComponent.apply(this, ["div"]);
        this.setVerticalScrollPolicy("off");
        this.setHorizontalScrollPolicy("off");
        this.setStyle("verticalGap", "0");
    };
    flexiciousNmsp.PrintWindow = PrintWindow; //add to name space
    PrintWindow.prototype = new flexiciousNmsp.UIComponent(); //setup hierarchy
    PrintWindow.prototype.typeName = PrintWindow.typeName = 'PrintWindow';//for quick inspection
    PrintWindow.prototype.getClassNames = function () {
        return ["PrintWindow", "UIComponent","TitleWindow"];
    };
    PrintWindow.prototype.initialize = function () {

        flexiciousNmsp.UIComponent.prototype.initialize.apply(this, []);
        if(!this.printComponentRenderer)
            this.setPrintComponentRenderer(new flexiciousNmsp.ClassFactory(flexiciousNmsp.PrintFlexDataGrid));
        this.setReportHeaderRenderer(new flexiciousNmsp.ClassFactory(flexiciousNmsp.ReportHeader));
        this.setReportFooterRenderer(new flexiciousNmsp.ClassFactory(flexiciousNmsp.ReportFooter));
        this.setPageHeaderRenderer(new flexiciousNmsp.ClassFactory(flexiciousNmsp.PageHeader));
        this.setPageFooterRenderer(new flexiciousNmsp.ClassFactory(flexiciousNmsp.PageFooter));

        if (!(this.printerHeader)) {
            this.setPrinterHeader (this.reportHeaderRenderer.newInstance() );
        }
        if (!(this.pageHeader)) {
            this.setPageHeader (this.pageHeaderRenderer.newInstance() );
        }
        if (!(this.printComponent)) {
            this.setPrintComponent (this.printComponentRenderer.newInstance() );
        }
        if (!(this.pageFooter)) {
            this.setPageFooter (this.pageFooterRenderer.newInstance());
        }
        if (!(this.printerFooter)) {
            this.setPrinterFooter (this.reportFooterRenderer.newInstance() );
        }

    };
    PrintWindow.prototype.removeIfExists = function (val) {

        var obj = (val);
        if (((obj))) {
            this.removeChild(obj);
        }
    };
    PrintWindow.prototype.updateDisplayList = function () {

        var printArea1;
        var printArea;
        var currentRecords;
        var allRecords;
        var iCollectionView;
        var pageStart;
        var pageEnd;
        var index;
        var record;
        var printAreas=this.getPrintAreas();
        flexiciousNmsp.UIComponent.prototype.updateDisplayList.apply(this, []);
        if (this.printerHeaderDirty) {
            this.printerHeaderDirty = false;
            this.addChild((this.printerHeader));
        }
        if (this.pageHeaderDirty) {
            this.pageHeaderDirty = false;
            this.addChild((this.pageHeader));
        }
        if (this.printDataGridDirty) {
            this.printDataGridDirty = false;
            this.addChild((this.printComponent ));
            if (((this.preReportPagesComponent) || (this.postReportPagesComponent))) {
                if (this.preReportPagesComponent) {
                    this.addChild((this.preReportPagesComponent ));
                }
                if (this.postReportPagesComponent) {
                    this.addChild((this.postReportPagesComponent ));
                }
            }
        }
        if (this.pageFooterDirty) {
            this.pageFooterDirty = false;
            this.addChild((this.pageFooter ));
        }
        if (this.printerFooterDirty) {
            this.printerFooterDirty = false;
            this.addChild((this.printerFooter ));
        }
        if (this.pageRecordsDirty) {
            this.pageRecordsDirty = false;
            if (this.getPrintDataGrid().implementsOrExtends('PrintFlexDataGrid')) {
                currentRecords = [];// new flexiciousNmsp.ArrayCollection();
                allRecords = [];//new flexiciousNmsp.ArrayCollection();
                if ((this.getPrintDataGrid().getDataProvider() )) {
                    iCollectionView = (this.getPrintDataGrid().getDataProvider() );
                    //if (!((iCollectionView is IHierarchicalCollectionView)))
                    {
                        pageStart = this.getPageStart(false);
                        pageEnd = this.getPageEnd(false);
                        index = pageStart;
                        while (index < pageEnd) {
                            currentRecords.push(iCollectionView[index]);
                            index++;
                        }
                        for (i = 0; i < iCollectionView.length; i++) {
                            record = iCollectionView[i];
                            allRecords.push(record);
                        }
                    }
                }
            }
            for (i = 0; i < printAreas.length; i++) {
                printArea = printAreas[i];
                printArea.currentPage=(this.currentPage);
                printArea.pageRecords = currentRecords;
                printArea.allRecords = allRecords;
            }
        }
        for (var i = 0; i < printAreas.length; i++) {
            printArea1 = printAreas[i];
            printArea1.totalPages=(this.totalPages);
            printArea1.printOptions = this.printOptions;
            printArea1.printComponent = this.printComponent;
            printArea1.printable = this.printable;
            printArea1.updateDisplayList(printArea1.getWidth(), printArea1.getHeight());

        }

    };
    PrintWindow.prototype.showPrintComponentBasedOnPageIndex = function (navigateGrid) {

        var gridPages = ((this.totalPages - this.printOptions.preReportPages) - this.printOptions.postReportPages);
        if (this.currentPage <= this.printOptions.preReportPages) {
            this.printComponent.setIncludeInLayout ( false);
            this.postReportPagesComponent.setIncludeInLayout(false);
            this.preReportPagesComponent.setIncludeInLayout(true);
            this.preReportPagesComponent.gotoPage(this.currentPage);
        }
        else {
            if (this.currentPage <= (this.printOptions.preReportPages + gridPages)) {
                this.preReportPagesComponent.setVisible(this.preReportPagesComponent.includeInLayout = false);
                this.postReportPagesComponent.setVisible(this.postReportPagesComponent.includeInLayout = false);
                this.printComponent.setVisible(true);
                this.printComponent.setIncludeInLayout (true);
                if (navigateGrid) {
                    this.getPrintDataGrid().gotoRow(this.getPageStart());
                }
            }
            else {
                this.printComponent.setIncludeInLayout  (false);
                this.preReportPagesComponent.setIncludeInLayout (false);
                this.postReportPagesComponent.setIncludeInLayout  (true);
                this.postReportPagesComponent.gotoPage(this.currentPage);
            }
        }

    };
    PrintWindow.prototype.getPageStart = function (usePrePostPages) {
        if (typeof usePrePostPages == "undefined")usePrePostPages = true;

        var pageStart;
        var i;
        var calcCurrentPage = (this.currentPage - ((usePrePostPages) ? this.printOptions.preReportPages : 0));
        if (this.rowsOnPage.length > 0) {
            i = 1;
            while (i < calcCurrentPage) {
                pageStart = (pageStart + this.rowsOnPage[(i - 1)]);
                i++;
            }
            return (pageStart);
        }
        return ((((calcCurrentPage == 1)) ? 0 : (((calcCurrentPage == 2)) ? this.firstPageRowCount : ((this.middlePageRowCount * (calcCurrentPage - 2)) + this.firstPageRowCount))));

    };
    PrintWindow.prototype.getPageEnd = function (usePrePostPages) {
        if (typeof usePrePostPages == "undefined")usePrePostPages = true;

        var calcCurrentPage = (this.currentPage - ((usePrePostPages) ? this.printOptions.preReportPages : 0));
        var iCollectionView = (this.getPrintDataGrid().getDataProvider());
        var pageEnd = (this.getPageStart(usePrePostPages) + (((this.rowsOnPage.length > 0)) ? this.rowsOnPage[(calcCurrentPage - 1)] : (((calcCurrentPage == 1)) ? this.firstPageRowCount : this.middlePageRowCount)));
        pageEnd = (((pageEnd > iCollectionView.length)) ? iCollectionView.length : pageEnd);
        return (pageEnd);

    };
    PrintWindow.prototype.getGridHeight = function () {

        return (((((((this.getPixelHeight() - ((((this.printerHeader) && (this.printerHeader.includeInLayout))) ? this.printerHeader.getPixelHeight() : 0))
        - ((((this.printerFooter) && (this.printerFooter.includeInLayout))) ? this.printerFooter.getPixelHeight() : 0))
        - ((((this.pageHeader) && (this.pageHeader.includeInLayout))) ? this.pageHeader.getPixelHeight() : 0))
        - ((((this.pageFooter) && (this.pageFooter.includeInLayout))) ? this.pageFooter.getPixelHeight() : 0)) - (this.getStyle("paddingTop")||0)) - (this.getStyle("paddingBottom")||0)));

    };
    PrintWindow.prototype.showFirstPage = function (validate) {
        if (typeof validate == "undefined")validate = true;

        if (this.showing == "first") {
            return;
        }
        this.showing = "first";
        this.showHide(this.printerFooter, false);
        this.showHide(this.printerHeader, this.printOptions.includePrintHeader);
        this.showHide(this.pageHeader, this.printOptions.includePageHeader);
        this.showHide(this.pageFooter, this.printOptions.includePageFooter);
        if (validate) {
            this.callValidate();
        }

    };
    PrintWindow.prototype.showLastPage = function (validate) {
        if (typeof validate == "undefined")validate = true;

        if (this.showing == "last") {
            return;
        }
        this.showing = "last";
        this.showHide(this.printerFooter, this.printOptions.includePrintFooter);
        this.showHide(this.printerHeader, false);
        this.showHide(this.pageHeader, this.printOptions.includePageHeader);
        this.showHide(this.pageFooter, this.printOptions.includePageFooter);
        if (validate) {
            this.callValidate();
        }

    };
    PrintWindow.prototype.showMiddlePage = function (validate) {
        if (typeof validate == "undefined")validate = true;

        if (this.showing == "middle") {
            return;
        }
        this.showing = "middle";
        this.showHide(this.printerFooter, false);
        this.showHide(this.printerHeader, false);
        this.showHide(this.pageHeader, this.printOptions.includePageHeader);
        this.showHide(this.pageFooter, this.printOptions.includePageFooter);
        if (validate) {
            this.callValidate();
        }

    };
    PrintWindow.prototype.showSinglePage = function (validate) {
        if (typeof validate == "undefined")validate = true;

        if (this.showing == "single") {
            return;
        }
        this.showing = "single";
        this.showHide(this.printerFooter, this.printOptions.includePrintFooter);
        this.showHide(this.printerHeader, this.printOptions.includePrintHeader);
        this.showHide(this.pageHeader, this.printOptions.includePageHeader);
        this.showHide(this.pageFooter, this.printOptions.includePageFooter);
        if (validate) {
            this.callValidate();
        }

    };
    PrintWindow.prototype.callValidate = function () {
        this.validateNow();
        if (this.printComponent) {
            var currentHt = this.printComponent.getHeight();
            var newHt = this.getGridHeight();
            if (currentHt != newHt) {
                this.printComponent.setHeight(newHt);
                this.validateNow();
                this.printComponent.validateNow();
            }
        }
    };
    PrintWindow.prototype.showHide = function (val, showHide) {

        var obj = (val );
        if (((obj) && (!((obj.includeInLayout == showHide))))) {
            //obj.visible = showHide;
            obj.setIncludeInLayout(showHide);
        }

    };
    PrintWindow.prototype.onColumnResize = function (event) {

        var col;
        var index;
        var newCol;
        flexiciousNmsp.UIUtils.removeAll(this.printOptions.columnWidths);
        for (var i = 0; i < this.getPrintDataGrid().getColumns().length; i++) {
             col = this.getPrintDataGrid().getColumns()[i];
            if (col.visible) {
                this.printOptions.columnWidths.push(col.width);
            }
        }
        this.getParent().dispatchEvent(new flexiciousNmsp.PrintPreviewEvent(flexiciousNmsp.PrintPreviewEvent.COLUMNS_RESIZED));
        if (this.getPrintDataGrid().variableRowHeight) {
            this.getParent().dispatchEvent(new flexiciousNmsp.PrintPreviewEvent(flexiciousNmsp.PrintPreviewEvent.DATAGRID_RECREATE_REQUIRED));
            this.getPrintDataGrid().setHorizontalScrollPolicy ("on");
            index = 0;
            for (i = 0; i < this.getPrintDataGrid().getColumns().length; i++)
            {
                newCol = this.getPrintDataGrid().getColumns()[i];
                if (newCol.visible) {
                    newCol.width = this.printOptions.columnWidths[index++];
                }
            }
            this.getPrintDataGrid().setHorizontalScrollPolicy ("off");
        }
    };
    PrintWindow.prototype.onItemOpen = function (event) {
        this.getParent().dispatchEvent(new flexiciousNmsp.PrintPreviewEvent(flexiciousNmsp.PrintPreviewEvent.DATAGRID_RECREATE_REQUIRED));
    };
    PrintWindow.prototype.getPrinterFooter = function () {
        return (this.printerFooter);
    };
    PrintWindow.prototype.setPrinterFooter = function (val) {
        this.removeIfExists(val);
        this.printerFooter = val;
        this.printerFooterDirty = true;
        this.invalidateDisplayList();
    };
    PrintWindow.prototype.getPrintComponentRenderer = function () {
        return (this.printComponentRenderer);
    };
    PrintWindow.prototype.setPrintComponentRenderer = function (val) {
        this.printComponentRenderer = val;
        this.setPrintComponent (this.printComponentRenderer.newInstance() );
    };
    PrintWindow.prototype.getPrintable = function () {
        return ((this.printable));
    };
    PrintWindow.prototype.setPrintable = function (val) {
        this.printable = val;
    };
    PrintWindow.prototype.getPageFooterRenderer = function () {
        return (this.pageFooterRenderer);
    };
    PrintWindow.prototype.setPageFooterRenderer = function (val) {
        this.pageFooterRenderer = val;
        this.setPageFooter(this.pageFooterRenderer.newInstance());
    };
    PrintWindow.prototype.getPrintComponent = function () {
        return (this.printComponent);
    };
    PrintWindow.prototype.setPrintComponent = function (val) {
        var pdg;
        this.printComponent = val;
        this.removeIfExists(val);
        this.removeIfExists(this.postReportPagesComponent);
        this.removeIfExists(this.preReportPagesComponent);
        if (this.printOptions.preReportPagesFactory) {
            this.preReportPagesComponent = (this.printOptions.preReportPagesFactory.newInstance());
        }
        if (this.printOptions.postReportPagesFactory) {
            this.postReportPagesComponent = (this.printOptions.postReportPagesFactory.newInstance());
        }
        if ((this.printComponent && this.printComponent.implementsOrExtends('PrintFlexDataGrid'))) {
            this.printComponent = val;
            pdg = (this.printComponent);

            pdg.setResizableColumns(true);
            pdg.addEventListener(flexiciousNmsp.FlexDataGridEvent.COLUMN_STRETCH, this.onColumnResize, false, 0, true);
            if (pdg["hasOwnProperty"]("groupedColumns")) {
                pdg.addEventListener("itemOpen", this.onItemOpen, false, 0, true);
                pdg.addEventListener("itemClose", this.onItemOpen, false, 0, true);
            }
        }
        val.percentHeight = 100;
        val.percentWidth = 100;
        this.printDataGridDirty = true;
        this.invalidateDisplayList();
    };
    PrintWindow.prototype.getPageHeaderRenderer = function () {
        return (this.pageHeaderRenderer);
    };
    PrintWindow.prototype.setPageHeaderRenderer = function (val) {
        this.pageHeaderRenderer = val;
        this.setPageHeader (this.pageHeaderRenderer.newInstance());
    };
    PrintWindow.prototype.getPrintOptions = function () {
        return (this.printOptions);
    };
    PrintWindow.prototype.setPrintOptions = function (val) {
        this.printOptions = val;
    };
    PrintWindow.prototype.getCurrentPage = function () {
        return (this.currentPage);
    };
    PrintWindow.prototype.setCurrentPage = function (val) {
        this.currentPage = val;
        this.pageRecordsDirty = true;
        this.invalidateDisplayList();
    };
    PrintWindow.prototype.getReportHeaderRenderer = function () {
        return (this.reportHeaderRenderer);
    };
    PrintWindow.prototype.setReportHeaderRenderer = function (val) {
        this.reportHeaderRenderer = val;
        this.setPrinterHeader(this.reportHeaderRenderer.newInstance());
    };
    PrintWindow.prototype.getPrintDataGrid = function () {
        return ((this.printComponent));
    };
    PrintWindow.prototype.getPageFooter = function () {
        return (this.pageFooter);
    };
    PrintWindow.prototype.setPageFooter = function (val) {
        this.removeIfExists(val);
        this.pageFooter = val;
        this.pageFooterDirty = true;
        this.invalidateDisplayList();
    };
    PrintWindow.prototype.getPageHeader = function () {
        return (this.pageHeader);
    };
    PrintWindow.prototype.setPageHeader = function (val) {
        this.removeIfExists(val);
        this.pageHeader = val;
        this.pageHeaderDirty = true;
        this.invalidateDisplayList();
    };
    PrintWindow.prototype.getTotalPages = function () {
        return (this.totalPages);
    };
    PrintWindow.prototype.setTotalPages = function (val) {
        this.totalPages = val;
        this.invalidateDisplayList();
    };
    PrintWindow.prototype.getPrintAreas = function () {
        var array = [];
        if (this.printerHeader) {
            array.push(this.printerHeader);
        }
        if (this.printerFooter) {
            array.push(this.printerFooter);
        }
        if (this.pageHeader) {
            array.push(this.pageHeader);
        }
        if (this.pageFooter) {
            array.push(this.pageFooter);
        }
        return (array);
    };
    PrintWindow.prototype.getReportFooterRenderer = function () {
        return (this.reportFooterRenderer);
    };
    PrintWindow.prototype.setReportFooterRenderer = function (val) {
        this.reportFooterRenderer = val;
        this.setPrinterFooter(this.reportFooterRenderer.newInstance() );
    };
    PrintWindow.prototype.getExtendedDataGrid = function () {
        return ((this.printable));
    };
    PrintWindow.prototype.setExtendedDataGrid = function (val) {
        this.printable = val;
    };
    PrintWindow.prototype.getPrinterHeader = function () {
        return (this.printerHeader);
    };
    PrintWindow.prototype.setPrinterHeader = function (val) {
        this.removeIfExists(val);
        this.printerHeader = val;
        this.printerHeaderDirty = true;
        this.invalidateDisplayList();
    };
}(window));