/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */


import Constants from '../../utils/Constants'
import UIUtils from '../../utils/UIUtils' 
import TypedObject from '../../core/TypedObject'


/**
 * Creates an instance of InsertionLocationInfo.
 * @constructor
 * @class InsertionLocationInfo
 */
export default class InsertionLocationInfo extends TypedObject {
    constructor() {
        super();
        /**
         *
         * @type {Number}
         * @property contentX
         * @default 0
         */
        this.contentX = 0;
        /**
         *
         * @type {Number}
         * @property headerX
         * @default 0
         */
        this.headerX = 0;

        /**
         *
         * @type {Number}
         * @property contentY
         * @default 0
         */
        this.contentY = 0;
        /**
         *
         * @type {Number}
         * @property leftLockedContentX
         * @default 0
         */
        this.leftLockedContentX = 0;
        /**
         *
         * @type {Number}
         * @property rightLockedContentX
         * @default 0
         */
        this.rightLockedContentX = 0;
        /**
         *
         * @type {Number}
         * @property leftLockedHeaderX
         * @default 0
         */
        this.leftLockedHeaderX = 0;
        /**
         *
         * @type {Number}
         * @property leftLockedHeaderY
         * @default 0
         */
        this.leftLockedHeaderY = 0;
        /**
         *
         * @type {Number}
         * @property rightLockedHeaderX
         * @default 0
         */
        this.rightLockedHeaderX = 0;
        /**
         *
         * @type {Number}
         * @property rightLockedHeaderY
         * @default 0
         */
        this.rightLockedHeaderY = 0;
        /**
         *
         * @type {Number}
         * @property leftLockedFooterX
         * @default 0
         */
        this.leftLockedFooterX = 0;
        /**
         *
         * @type {Number}
         * @property leftLockedFooterY
         * @default 0
         */
        this.leftLockedFooterY = 0;
        /**
         *
         * @type {Number}
         * @property rightLockedFooterX
         * @default 0
         */
        this.rightLockedFooterX = 0;
        /**
         *
         * @type {Number}
         * @property rightLockedFooterY
         * @default 0
         */
        this.rightLockedFooterY = 0;


    }

    /**
     *
     * @return {Array}
     */
    getClassNames() {
        return ["InsertionLocationInfo", "TypedObject"];
    }

    /**
     *
     * @param row
     */
    nextChromeRow(row) {

        this.leftLockedContentX = this.rightLockedContentX = this.leftLockedHeaderX = this.leftLockedFooterX = this.rightLockedFooterX = this.rightLockedHeaderX = 0;
        if (row.chromeType == flexiciousNmsp.RowPositionInfo.ROW_TYPE_HEADER
            || row.chromeType == flexiciousNmsp.RowPositionInfo.ROW_TYPE_COLUMN_GROUP
            || row.chromeType == flexiciousNmsp.RowPositionInfo.ROW_TYPE_FILTER
        ) {
            this.leftLockedHeaderY += row.getHeight();
            this.rightLockedHeaderY += row.getHeight();
        }
        else if (row.chromeType == flexiciousNmsp.RowPositionInfo.ROW_TYPE_FOOTER || row.chromeType == flexiciousNmsp.RowPositionInfo.ROW_TYPE_PAGER) {
            this.leftLockedFooterY += row.getHeight();
            this.rightLockedFooterY += row.getHeight();
        }


    }

    /**
     * handle reset
     */
    reset() {

        this.contentX = 0;
        this.contentY = 0;

        this.leftLockedContentX = 0;
        this.rightLockedContentX = 0;
        this.leftLockedHeaderX = 0;
        this.leftLockedHeaderY = 0;

        this.rightLockedHeaderX = 0;
        this.rightLockedHeaderY = 0;

        this.leftLockedFooterX = 0;
        this.leftLockedFooterY = 0;

        this.rightLockedFooterX = 0;
        this.rightLockedFooterY = 0;


    }
}

/**
 *
 * @type {Function}
 */
flexiciousNmsp.InsertionLocationInfo = InsertionLocationInfo; //add to name space

/**
 *
 * @type {String}
 */
InsertionLocationInfo.prototype.typeName = InsertionLocationInfo.typeName = 'InsertionLocationInfo';//for quick inspection