/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */


import Constants from '../../utils/Constants'
import UIUtils from '../../utils/UIUtils' 
import TypedObject from '../../core/TypedObject'


/**
 * In lazy loaded grids, stores information about which items
 * are being loaded or have been loaded.
 * @constructor
 * @class ItemLoadInfo
 * @namespace flexiciousNmsp
 * 
 * @param item
 * @param level
 * @param hasLoaded
 */
export default class ItemLoadInfo extends TypedObject {
    constructor(item, level, hasLoaded) {
        super();
        if (typeof hasLoaded == "undefined") hasLoaded = false;
        /**
         *
         * @type {Object}
         * @property item
         * @default null
         */
        this.item = null;
        /**
         *
         * @type {Boolean}
         * @property hasLoaded
         * @default false
         */
        this.hasLoaded = false;
        /**
         *
         * @type {Number}
         * @property totalRecords
         * @default -1
         */
        this.totalRecords = -1;
        /**
         *
         * @type {Number}
         * @property pageIndex
         * @default 0
         */
        this.pageIndex = 0;
        /**
         *
         * @type {FlexDataGridColumnLevel}
         * @property level
         * @default null
         */
        this.level = null;
        /**
         *
         * @type {Object}
         * @property item
         * @default item
         */
        this.item = item;
        /**
         *
         * @type {Boolean }
         * @property hasLoaded
         * @default hasLoaded
         */
        this.hasLoaded = hasLoaded;
        /**
         *
         * @type {FlexDataGridColumnLevel}
         * @property level
         * @default level
         */
        this.level = level;
    }

    /**
     *
     * @return {Array}
     */
    getClassNames() {
        return ["ItemLoadInfo", "TypedObject"];
    }

    /**
     *
     * @param compare
     * @param levelToCompare
     * @param useSelectedKeyField
     * @return {Boolean}
     */
    isEqual(compare, levelToCompare, useSelectedKeyField) {

        if (useSelectedKeyField) {
            return (UIUtils.resolveExpression(compare, this.level.selectedKeyField)
                == UIUtils.resolveExpression(this.item, this.level.selectedKeyField)) && (levelToCompare == this.level);
        } else {
            return compare == this.item && (levelToCompare == this.level);
        }

    }
}

/**
 *
 * @type {Function}
 */
flexiciousNmsp.ItemLoadInfo = ItemLoadInfo; //add to name space
/**
 *
 * @type {String}
 */
ItemLoadInfo.prototype.typeName = ItemLoadInfo.typeName = 'ItemLoadInfo';//for quick inspection