/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */


import Constants from '../../utils/Constants'
import UIUtils from '../../utils/UIUtils' 
import TypedObject from '../../core/TypedObject'

/**
 * Support for selection based on exclusion. In scenarios where you have lazy loaded grids, selection cascade and select all will
 * simply set flags on the selectionInfo object. The selectedObjects and selectedKeys no longer contain references to data that is selected
 * Instead, they contain the items that the user explicitly selected. unSelectedObjects will contain items that the user explicitly unselected.
 * This helps maintain selection across very large lazy loaded datasets. When you set the enableSelectionExclusion flag to true, use the selectionInfo object to
 * access the selection (or build a query on the server) to identify the objects user selected. The selectionInfo object is a simple list of LevelSelectionInfo objects,
 *  which contains explicitly selected and unselected objects, which can then be used to construct a query on the server as to what the selection on the client was.
 * @constructor
 * @class LevelSelectionInfo
 * @namespace flexiciousNmsp
 */
export default class LevelSelectionInfo extends TypedObject {
 constructor() {
     super();
     /**
      *
      * @type {Number}
      * @property levelNestDepth
      * @default -1
      */
     this.levelNestDepth=-1;
     /**
      *
      * @type {Array}
      * @property selectedObjects
      * @default []
      */
     this.selectedObjects=[];
     /**
      *
      * @type {Array}
      * @property excludedObjects
      * @default []
      */
      this.excludedObjects=[];



 }

 /**
  *
  * @return {Array}
  */
 getClassNames() {
     return ["LevelSelectionInfo","TypedObject"];
 }
}

/**
 *
 * @type {Function}
 */
flexiciousNmsp.LevelSelectionInfo = LevelSelectionInfo; //add to name space
/**
 *
 * @type {String}
 */
LevelSelectionInfo.prototype.typeName = LevelSelectionInfo.typeName = 'LevelSelectionInfo';//for quick inspection