/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */


import Constants from '../../utils/Constants'
import UIUtils from '../../utils/UIUtils' 
import TypedObject from '../../core/TypedObject'

/**
 *
 * @constructor
 * @class SelectionInfo
 */
export default class SelectionInfo extends TypedObject {
    constructor() {
        super();
        /**
         * Array of LevelSelectionInfo
         * @type {Array}
         * @property  levelSelections
         * @default []
         */
        this.levelSelections = [];
        /**
         * The top level selection.
         * @type {Boolean}
         * @property  isSelectAll
         * @default false
         */
        this.isSelectAll = false;
    }

    /**
    *
    * @return {String}
    */
    getClassNames() {
        return "SelectionInfo";
    }

    /**
     *
     * @return {String}
     */
    toString() {
        let str = `IsSelectAll:${this.isSelectAll}\n`;

        for (const lvl of this.levelSelections) {
            str += `, Level Depth:${lvl.levelNestDepth}, Selected Objects:${lvl.selectedObjects.length}, Excluded Objects:${lvl.excludedObjects.length}\n`;
        }

        return str;
    }

    /**
     *
     * @return {Boolean}
     */
    getHasAnySelections() {
        for (const level of this.levelSelections) {
            if (level.selectedObjects.length > 0)
                return true;
            if (level.excludedObjects.length > 0)
                return true;
        }

        return false;
    }
}

flexiciousNmsp.SelectionInfo = SelectionInfo;