/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */
import React from 'react'
import TypedObject from '../core/TypedObject'
import FlexDataGridColumn from '../flexgrid/grids/FlexDataGridColumn'
import FlexDataGridCheckBoxColumn from '../flexgrid/grids/FlexDataGridCheckBoxColumn'


/**
 * Configuration for the {@link ReactDataGridColumn} - this is not a visual component, just container
 * for properties for the corresponding {@link FlexDataGridColumn} object.
 * 
 * For more details, refer to the documentation of the {@link ReactDataGrid} class.
 */
export default class ReactDataGridColumn extends React.Component {

    static process(grid, level, props, group) {
        let column;
        //the grid has already called will mount, so we have the grid.
        if (props.hasOwnProperty('type') && props.type == 'checkbox') {
            column = props.checkboxColumnFactory ? new props.checkboxColumnFactory() : new FlexDataGridCheckBoxColumn();
        }
        else {
            column = props.columnFactory ? new props.columnFactory() : new FlexDataGridColumn();
        }
        //we parse out all the columns and store it - we dont
        //want to touch the original level until we are all done, because if we do that, it will
        //try to render that level, which is not complete yet.
        if (!level.hasOwnProperty('_tempCols'))
            level._tempCols = [];
        if (group) {
            if (!group.hasOwnProperty('_tempCols'))
                group._tempCols = [];
            group._tempCols.push(column);
        } else {
            level._tempCols.push(column);
        }

        for (var prop in props) {
            //here we apply all the attributes that were set on us from the calling component
            if (prop == "children" || prop == "grid") continue;
            grid.applyAttribute(column, prop, props[prop], true);
        }
        return column;
    }
}

flexiciousNmsp.ReactDataGridColumn = ReactDataGridColumn; //add to name space
ReactDataGridColumn.prototype.typeName = ReactDataGridColumn.typeName = 'ReactDataGridColumn';//for quick inspection
