/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */
import React from 'react'
import TypedObject from '../core/TypedObject'
import ReactDataGridColumn from './ReactDataGridColumn'
import FlexDataGridColumnGroup from '../flexgrid/grids/FlexDataGridColumnGroup'

/**
 * Configuration for the ReactDataGridColumnGroup - this is not a visual component, just container
 * for properties for the corresponding {@link FlexDataGridColumnGroup} object.
 * 
 * For more details, refer to the documentation of the {@link ReactDataGrid} class.
 */
export default class ReactDataGridColumnGroup extends React.Component {
    static process(grid, level, props, parentGroup) {
        let columnGroup = props.columnGroupFactory ? new props.columnGroupFactory() :new FlexDataGridColumnGroup();
        //we parse out all the columns and store it - we dont
        //want to touch the original level until we are all done, because if we do that, it will
        //try to render that level, which is not complete yet.
        if (!level.hasOwnProperty('_tempCols'))
            level._tempCols = [];
        if (parentGroup) {

        } else {
            level._tempCols.push(columnGroup);
        }

        for (var prop in props) {
            //here we apply all the attributes that were set on us from the calling component
            if (prop == "children" || prop == "grid") continue;
            grid.applyAttribute(columnGroup, prop, props[prop], true);
        }
        let hasGroups = false;
        let childCols = [];
        var childrenWithProps = React.Children.map(props.children, (child) => {
            if (child.type.typeName == "ReactDataGridColumn") {
                
                childCols.push(ReactDataGridColumn.process(grid, level, child.props, columnGroup));
            } else if (child.type.typeName == "ReactDataGridColumnGroup") {
                childCols.push(ReactDataGridColumnGroup.process(grid, level, child.props, columnGroup));
                hasGroups = true;
            } else {
                console.error("Invalid Child type specified for ReactDataGridColumnGroup - must be one of ReactDataGridColumn|ReactDataGridColumnGroup")
            }
        });
        if (parentGroup) {
            if (hasGroups) {
                parentGroup.setGroupedColumns(childCols);
            } else {
                parentGroup.setColumns(childCols);
            }
        } else if (columnGroup._tempCols) {
            columnGroup.setGroupedColumns(columnGroup._tempCols);
        }
        return columnGroup;
    }

}

flexiciousNmsp.ReactDataGridColumnGroup = ReactDataGridColumnGroup; //add to name space
ReactDataGridColumnGroup.prototype.typeName = ReactDataGridColumnGroup.typeName = 'ReactDataGridColumnGroup';//for quick inspection
