/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */
import UIComponent from '../../core/UIComponent'
import Constants from '../../utils/Constants'
import UIUtils from '../../utils/UIUtils'

/**
 * A ScrollableDiv that which can be used within the filtering/binding infrastructure.
 * @class ScrollableDiv
 * @constructor
 * @namespace flexiciousNmsp
 * 
 */
export default class ScrollableDiv extends UIComponent {
    constructor(tag) {
        super(tag);
    }

    componentDidMountCustom() {
        this.addEventListener(this, Constants.EVENT_SCROLL, this.scrollCallBack);
    }
    componentWillUnmountCustom(){
        this.removeEventListener(Constants.EVENT_SCROLL, this.scrollCallBack);        
    }
    scrollCallBack(e){
        if(this.callBack){
            return this.callBack(e);
        }
    }
}

flexiciousNmsp.ScrollableDiv = ScrollableDiv; //add to name space
ScrollableDiv.prototype.typeName = ScrollableDiv.typeName = 'ScrollableDiv';//for quick inspection
