/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */
import React from 'react';
import TypedObject from '../core/TypedObject'
/**
 * A Class that holds constant values
 * @constructor
 * @class Constants
 * @namespace flexiciousNmsp
 */
export default class Constants {
    static isMobileBrowser() {
        return ( /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent) );
    }
}

Constants.DISABLE_POPUP_BLOCKERS = "Unable to open new browser window. Please disable your popup-blockers.";
Constants.TOP_LEVEL_FILTER = "TOP_LEVEL_FILTER";
Constants.TEXT_HEIGHT_PADDING = 4;
Constants.SCROLL_POLICY_OFF = "off";
Constants.SCROLL_POLICY_ON = "on";
Constants.SCROLL_POLICY_AUTO = "auto";
Constants.SELECT_ALL_CHANGED = "selectAllChanged";
Constants.SELECTED_KEYS_CHANGED = "selectedKeysChanged";
Constants.FILTER_ABOVE_HEADER = "aboveHeader";
Constants.FILTER_BELOW_HEADER = "belowHeader";
Constants.CLICK_BEHAVIOR_HOVER_POPUP = "hoverPopup";
Constants.CLICK_BEHAVIOR_CLICK_POPUP = "clickPopup";
Constants.CLICK_BEHAVIOR_BOTH = "clickAndHoverPopup";
Constants.CLICK_BEHAVIOR_NONE = "none";
Constants.PERSIST_COLUMN_ORDER = "columnOrder";
Constants.PERSIST_COLUMN_VISIBILITY = "columnVisibility";
Constants.PERSIST_COLUMN_WIDTH = "columnWidth";
Constants.PERSIST_FILTER = "filter";
Constants.PERSIST_SORT = "sort";
Constants.PERSIST_VERTICAL_SCROLL = "verticalScroll";
Constants.PERSIST_HORIZONTAL_SCROLL = "horizontalScroll";
Constants.PERSIST_FOOTER_FILTER_VISIBILITY = "footerFilterVisibility";
Constants.PERSIST_PAGE_SIZE = "pageSize";
Constants.PERSIST_PRINT_SETTINGS = "printSettings";


Constants.MCS_LBL_TITLE_TEXT = "Multi Column Sort";
Constants.MCS_LBL_HEADER_TEXT = "Please specify the sort order and direction of the columns you wish to sort by:";
Constants.MCS_LBL_SORT_BY_TEXT = "Sort By: ";
Constants.MCS_LBL_THEN_BY_TEXT = "Then By: ";
Constants.MCS_LBL_CHOOSE_COLS = "Choose Columns: ";
Constants.MCS_RBN_ASCENDING_LABEL = "Ascending";
Constants.MCS_RBN_DESCENDING_LABEL = "Descending";
Constants.MCS_BTN_CLEAR_ALL_LABEL = "Clear All";
Constants.MCS_BTN_APPLY_LABEL = "Apply";
Constants.MCS_BTN_CANCEL_LABEL = "Cancel";
Constants.PGR_BTN_WORD_TOOLTIP = "Export to Word";
Constants.PGR_BTN_EXCEL_TOOLTIP = "Export to Excel";
Constants.PGR_BTN_PDF_TOOLTIP = "Print to PDF";
Constants.PGR_BTN_PRINT_TOOLTIP = "Print";
Constants.PGR_BTN_CLEAR_FILTER_TOOLTIP = "Clear Filter";
Constants.PGR_BTN_RUN_FILTER_TOOLTIP = "Run Filter";
Constants.PGR_BTN_FILTER_TOOLTIP = "Show/Hide Filter";
Constants.PGR_BTN_FOOTER_TOOLTIP = "Show/Hide Footer";
Constants.PGR_BTN_SAVE_PREFS_TOOLTIP = "Save Preferences";
Constants.PGR_BTN_OPEN_PREFS_TOOLTIP = "Open Preferences";
Constants.PGR_BTN_PREFERENCES_TOOLTIP = "Preferences";
Constants.PGR_BTN_COLLAPSE_ALL_TOOLTIP = "Collapse All";
Constants.PGR_BTN_SORT_TOOLTIP = "Sort";
Constants.PGR_BTN_SETTINGS_TOOLTIP = "Settings";
Constants.PGR_BTN_OPEN_SETTINGS_TOOLTIP = "Open Settings";
Constants.PGR_BTN_SAVE_SETTINGS_TOOLTIP = "Save Settings";
Constants.PGR_BTN_EXP_ALL_TOOLTIP = "Expand All";
Constants.PGR_BTN_EXP_ONE_UP_TOOLTIP = "Expand One Level Up";
Constants.PGR_BTN_EXP_ONE_DOWN_TOOLTIP = "Expand One Level Down";
Constants.PGR_BTN_MCS_TOOLTIP = "Multiple Column Sort";
Constants.PGR_BTN_FIRST_PAGE_TOOLTIP = "First Page";
Constants.PGR_BTN_PREV_PAGE_TOOLTIP = "Previous Page";
Constants.PGR_BTN_NEXT_PAGE_TOOLTIP = "Next Page";
Constants.PGR_BTN_LAST_PAGE_TOOLTIP = "Last Page";
Constants.PGR_LBL_GOTO_PAGE_TEXT = "Go to Page:";
Constants.PGR_ITEMS = "Items";
Constants.PGR_TO = "to";
Constants.PGR_OF = "of";
Constants.PGR_PAGE = "Page";
Constants.SELECTED_RECORDS = "Selected Records";
Constants.NONE_SELECTED = "None Selected";
Constants.EXP_LBL_TITLE_TEXT = "Export Options";
Constants.EXP_RBN_CURRENT_PAGE_LABEL = "Current Page";
Constants.EXP_RBN_ALL_PAGES_LABEL = "All Pages";
Constants.EXP_RBN_SELECT_PGS_LABEL = "Specify Pages";
Constants.EXP_LBL_EXPORT_FORMAT_TEXT = "Export Format:";
Constants.EXP_LBL_COLS_TO_EXPORT_TEXT = "Columns To Export:";
Constants.EXP_BTN_EXPORT_LABEL = "Export";
Constants.EXP_BTN_CANCEL_LABEL = "Cancel";
Constants.PRT_LBL_TITLE_TEXT = "Print Options";
Constants.PRT_LBL_PRT_OPTIONS_TEXT = "Print Options:";
Constants.PRT_LBL_EXPORT_FORMAT_TEXT = "Print Format:";
Constants.PRT_RBN_CURRENT_PAGE_LABEL = "Current Page";
Constants.PRT_RBN_ALL_PAGES_LABEL = "All Pages";
Constants.PRT_RBN_SELECT_PGS_LABEL = "Specify Pages";
Constants.PRT_CB_PRVW_PRINT_LABEL = "Preview Before Print";
Constants.PRT_LBL_COLS_TO_PRINT_TEXT = "Columns to Print:";
Constants.PRT_BTN_PRINT_LABEL = "Print";
Constants.PRT_BTN_CANCEL_LABEL = "Cancel";
Constants.PPRV_LBL_PG_SIZE_TEXT = "Page Size:";
Constants.PPRV_LBL_LAYOUT_TEXT = "Layout:";
Constants.PPRV_LBL_COLS_TEXT = "Columns:";
Constants.PPRV_CB_PAGE_HDR_LABEL = "Page Header";
Constants.PPRV_CB_PAGE_FTR_LABEL = "Page Footer";
Constants.PPRV_CB_RPT_HDR_LABEL = "Report Header";
Constants.PPRV_CB_RPT_FTR_LABEL = "Report Footer";
Constants.PPRV_BTN_PRT_LABEL = "Print";
Constants.PPRV_BTN_CANCEL_LABEL = "Cancel";
Constants.PPRV_LBL_SETTINGS_1_TEXT = "Note: Changing Page Size or Layout will only update the Preview, not the actual Print.";
Constants.PPRV_LBL_SETTINGS_2_TEXT = "Please set the Page Size/Layout on Printer Settings via the Print Dialog Box that will be shown when you print.";
Constants.PPRV_BTN_PRT_1_LABEL = "Print";
Constants.PPRV_BTN_CANCEL_1_LABEL = "Cancel";
Constants.PPRV_LBL_TITLE_TEXT = "Print Preview";


Constants.SAVE_SETTINGS_TITLE = "The preferences you specify below will be retained when this grid is loaded in the future:";
Constants.SAVE_SETTINGS_PREFERENCE_NAME = "Preference Name:";
Constants.SAVE_SETTINGS_ORDER_OF_COLUMNS = "Order of Columns";
Constants.SAVE_SETTINGS_VISIBILITY_OF_COLUMNS = "Visibility of Columns";
Constants.SAVE_SETTINGS_WIDTHS_OF_COLUMNS = "Widths of Columns";
Constants.SAVE_SETTINGS_FILTER_CRITERIA = "Filter Criteria";
Constants.SAVE_SETTINGS_SORT_SETTINGS = "Sort Settings";
Constants.SAVE_SETTINGS_SCROLL_POSITIONS = "Scroll Positions";
Constants.SAVE_SETTINGS_FILTER_AND_FOOTER_VISIBILITY = "Filter & Footer Visiblity";
Constants.SAVE_SETTINGS_RECORDS_PER_PAGE = "Records Per Page";
Constants.SAVE_SETTINGS_PRINT_SETTINGS = "Print Settings";
Constants.SAVE_SETTINGS_REMOVE_ALL_SAVED_PREFERENCES = "Remove All Saved Preferences";
Constants.SAVE_SETTINGS_CLEAR_SAVED_PREFERENCES = "Clear Saved Preferences";
Constants.SAVE_SETTINGS_SAVE_PREFERENCES = "Save Preferences";
Constants.SAVE_SETTINGS_CANCEL = "Cancel";

Constants.SETTINGS_COLUMNS_TO_SHOW = "Columns To Show";
Constants.SETTINGS_SHOW_FOOTERS = "Show Footers";
Constants.SETTINGS_SHOW_FILTER = "Show Filter";
Constants.SETTINGS_RECORDS_PER_PAGE = "Records Per Page";
Constants.SETTINGS_APPLY = "Apply";
Constants.SETTINGS_CANCEL = "Cancel";

Constants.OPEN_SETTINGS_DEFAULT = "Default?";
Constants.OPEN_SETTINGS_PREFERENCE_NAME = "Preference Name";
Constants.OPEN_SETTINGS_DELETE = "Delete";
Constants.OPEN_SETTINGS_APPLY = "Apply";
Constants.OPEN_SETTINGS_REMOVE_ALL_SAVED_PREFERENCES = "Remove All Saved Preferences";
Constants.OPEN_SETTINGS_SAVE_CHANGES = "Save Changes";
Constants.OPEN_SETTINGS_CLOSE = "Close";


Constants.SETTINGS_POPUP_TITLE = "Settings:";
Constants.SAVE_SETTINGS_POPUP_TITLE = "Save Settings:";
Constants.OPEN_SETTINGS_POPUP_TITLE = "Manage Settings:";
Constants.EXPORT_OPTIONS_TITLE = "Export Options";
Constants.PRINT_OPTIONS_TITLE = "Print Options";
Constants.PRINT_PREVIEW_TITLE = "Print Preview";


Constants.CELL_POSITION_ABOVE = "above";
Constants.CELL_POSITION_BELOW = "below";
Constants.CELL_POSITION_BELOW_FIRST = "belowFirst";
Constants.CELL_POSITION_ABOVE_LAST = "aboveFirst";
Constants.CELL_POSITION_LEFT = "left";
Constants.CELL_POSITION_RIGHT = "right";


Constants.EVENT_RESIZE = "resize";
Constants.EVENT_MOUSE_CLICK = "click";

Constants.EVENT_MOUSE_OVER = "mouseover";
Constants.EVENT_MOUSE_OUT = "mouseout";
Constants.EVENT_CREATION_COMPLETE = "creationComplete";
Constants.EVENT_MOUSE_WHEEL = "mousewheel";
Constants.EVENT_SCROLL = "scroll";

Constants.EVENT_TIMER = "timer";
Constants.EVENT_TIMER_COMPLETE = "timer_complete";

Constants.EVENT_DRAG_ENTER = "drag_enter";
Constants.EVENT_DRAG_DROP = "drag_drop";
Constants.EVENT_DRAG_COMPLETE = "drag_complete";

Constants.EVENT_CANCEL = "cancel";
Constants.EVENT_CLOSE = "close";
Constants.EVENT_FOCUS_IN = "focusin";
Constants.EVENT_FOCUS_OUT = "blur";
Constants.EVENT_KEY_UP = "keyup";
Constants.EVENT_KEY_PRESS = "keypress";
Constants.EVENT_CLICK = "click";
Constants.EVENT_LOAD = "load";
Constants.EVENT_DOUBLE_CLICK = "dblclick";
Constants.EVENT_MOUSE_MOVE = "mousemove";
Constants.EVENT_MOUSE_DOWN = "mousedown";
Constants.EVENT_MOUSE_UP = "mouseup";
Constants.EVENT_MOVE = "move";
Constants.EVENT_VALUE_COMMIT = "blur";
Constants.EVENT_KEY_DOWN = "keydown";
Constants.EVENT_FOCUS_CHANGE = "blur";
Constants.EVENT_CHANGE = "change";

Constants.COPY_CELL = "copyCell";
Constants.COPY_ROW = "copyRow";
Constants.COPY_TABLE = "copyTable";
Constants.COPY_SELECTED_RECORDS = "copySelectedRecords";

Constants.STATE_CHECKED = "checked";
Constants.CHECK_BOX_STATE_UNCHECKED = "unchecked";
Constants.STATE_MIDDLE = "middle";


Constants.KEYBOARD_LEFT = 37;
Constants.KEYBOARD_UP = 38;
Constants.KEYBOARD_RIGHT = 39;
Constants.KEYBOARD_DOWN = 40;

Constants.KEYBOARD_NUMPAD_MULTIPLY = 106;
Constants.KEYBOARD_NUMPAD_DIVIDE = 111;
Constants.KEYBOARD_NUMPAD_SUBTRACT = 109;
Constants.KEYBOARD_NUMPAD_ADD = 107;
Constants.KEYBOARD_TAB = 9;
Constants.KEYBOARD_PAGE_DOWN = 34;
Constants.KEYBOARD_PAGE_UP = 33;
Constants.KEYBOARD_HOME = 36;
Constants.KEYBOARD_END = 35;
Constants.KEYBOARD_F2 = 113;
Constants.KEYBOARD_SPACE = 32;
Constants.KEYBOARD_ESCAPE = 27;
Constants.KEYBOARD_ENTER = 13;
Constants.KEYBOARD_DELETE = 46;
Constants.KEYBOARD_BACKSPACE = 8;


Constants.MOVE_TOP = "moveTop";
Constants.MOVE_UP = "moveUp";
Constants.MOVE_DOWN = "moveDown";
Constants.MOVE_BOTTOM = "moveBottom";
Constants.SELECTION_MODE_SINGLE_ROW = "singleRow";
Constants.SELECTION_MODE_MULTIPLE_ROWS = "multipleRows";
Constants.SELECTION_MODE_SINGLE_CELL = "singleCell";
Constants.SELECTION_MODE_MULTIPLE_CELLS = "multipleCells";
Constants.SELECTION_MODE_NONE = "none";


Constants.TEMPLATE_HEADER_CELL = "TEMPLATE_HEADER_CELL";

Constants.TEMPLATE_ICON_CELL = "TEMPLATE_ICON_CELL";
Constants.TEMPLATE_ICON_CELL = "TEMPLATE_ICON_CELL";


Constants.TEMPLATE_BODY_CELL = "TEMPLATE_BODY_CELL";
Constants.TEMPLATE_FILTER_CELL = "TEMPLATE_FILTER_CELL";
Constants.TEMPLATE_FOOTER_CELL = "TEMPLATE_FOOTER_CELL";
Constants.TEMPLATE_PAGER_CELL = "TEMPLATE_PAGER_CELL";
Constants.TEMPLATE_LEVEL_RENDERER_CELL = "TEMPLATE_LEVEL_RENDERER_CELL";
Constants.TEMPLATE_EXPAND_COLLAPSE_CELL = "TEMPLATE_EXPAND_COLLAPSE_CELL";
Constants.TEMPLATE_PADDING_CELL = "TEMPLATE_PADDING_CELL";
Constants.TEMPLATE_FILL_CELL = "TEMPLATE_FILL_CELL";
Constants.TEMPLATE_GRID = "TEMPLATE_GRID";




Constants.HTML_EXPORT_CSS= "<style>"+
    "table {font-family: Arial, Verdana, sans-serif;border-collapse: collapse; border-spacing: 0; }		"+
    "td {border: 1px solid #CCC; text-align: center;width: 10em;padding: 1em;}		"+
    "th {border: 1px solid #CCC; text-align: center;padding: 1em;background-color: #DFDFDF;}"+
    "tr {height: 1em;}"+
    "table tr.even {background-color: #F1F1F1;}"+
    "table tr.footer {border: 1px solid #CCC; text-align: center;padding: 1em;background-color: #DFDFDF;}"+
    "table tr.odd {background-color:#fefefe;}</style>";

Constants.WORD_EXPORT_CSS= "<style>"+
    "table {font-family: Arial, Verdana, sans-serif;border-collapse: collapse; border-spacing: 0; }		"+
    "td {border: 1px solid #CCC; text-align: center;width: 10em;padding: 1em;}		"+
    "th {border: 1px solid #CCC; text-align: center;padding: 1em;background-color: #DFDFDF;}"+
    "tr {height: 1em;}"+
    "table tr.even {background-color: #F1F1F1;}"+
    "table tr.footer {border: 1px solid #CCC; text-align: center;padding: 1em;background-color: #DFDFDF;}"+
    "table tr.odd {background-color:#fefefe;}</style>";

Constants.ALERT_YES = 0x0001;
Constants.ALERT_NO = 0x0002;
Constants.ALERT_OK = 0x0004;
Constants.ALERT_CANCEL = 0x0008;


Constants.TEMPLATE_PAGER_CONTROL = "TEMPLATE_PAGER_CONTROL";

Constants.IMAGE_PATH="http://www.htmltreegrid.com/demo/flexicious/css/images/";

Constants.VERTICAL_SCROLLBAR_WIDTH = Constants.isMobileBrowser()?0:19;
Constants.HORIZONTAL_SCROLLBAR_HEIGHT = Constants.isMobileBrowser()?0:19;
//these are jquery specific



Constants.DEFAULT_DATE_FORMAT = "MMM D, YYYY";
Constants.SHORT_DATE_MASK = "MM/DD/YY";
Constants.MEDIUM_DATE_MASK = "MMM D, YYYY";
Constants.LONG_DATE_MASK =  "MMMM D, YYYY";
Constants.FULL_DATE_MASK = "EEEE, MMMM D, YYYY";
Constants.SHORT_TIME_MASK = "L:NN A";
Constants.MEDIUM_TIME_MASK = "L:NN:SS A";
Constants.LONG_TIME_MASK = `${Constants.MEDIUM_TIME_MASK} TZD`;

Constants.DEFAULT_ALL_ITEM_TEXT = "All";

Constants.DEFAULT_MSCB_HEIGHT =19;
if (/Firefox/i.test(navigator.userAgent)) {
    Constants.EVENT_MOUSE_WHEEL = "DOMMouseScroll"; //FF doesn't recognize mouse wheel as of FF3.x
}

Constants.COMBO_BOX_BASE_TAG= "select"; 

Constants.TEMPLATE_TEXTINPUT= <span><input className={'textBox'} type={'text'} /><img className={'insideIcon inputIcon'}/>
                                <img className={'outsideIcon inputIcon'} style={{visibility: 'hidden'}} /></span>;

Constants.TEMPLATE_MULTISELECT_TEXTINPUT= <span><span className={'selectedItems'}></span><input className={'textBox'} type={'text'} /><img className={'insideIcon inputIcon'}/>
                                <img className={'outsideIcon inputIcon'} style={{visibility: 'hidden'}} /></span>;


Constants.NUMERIC_RANGE_BOX_ERROR_MSG_TXT = "Please ensure that the start and end values are numeric, and start value is less than or equals the end value.";

Constants.DATE_PICKER_START_DATE = "Choose Start Date";
Constants.DATE_PICKER_END_DATE = "Choose End Date";
Constants.DATE_PICKER_MSG_TXT_ERROR_MSG_TXT = "Please ensure that the start and end values are numeric, and start value is less than or equals the end value.";
Constants.EMPTY_FILTER = "EMPTY_FILTER";

flexiciousNmsp.Constants = Constants;
