/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

import TypedObject from '../core/TypedObject'
import Constants from './Constants'
import UIUtils from './UIUtils'
import fecha from './Fecha'
/**
 * A wrapper around date formatting functions from various underlying libraries DateFormatter
 * @constructor
 * @class DateFormatter
 * @namespace flexiciousNmsp
 */
export default class DateFormatter extends TypedObject {

    getClassNames() {
        return ["DateFormatter"];
    }

    /**
     * format a date
     * @param value 
     * @return {Object}
     */
    format(value) {
        if (value instanceof Date)
            return fecha.format(value, this.formatString)
        else
            return "";
    }

    /**
     * Parse a date string into an object, changes - into
     * @param {Object} value 
     * @return {Object}
     */
    parse(value){
            return fecha.parse(value, this.formatString)        
    }
}
DateFormatter.prototype.formatString = Constants.DEFAULT_DATE_FORMAT;
flexiciousNmsp.DateFormatter = DateFormatter;
