//done:
//markup processor
//itemrenderers
//column lock mode
//lazy load
//demo console
//checkResize
//implement material
//remove jquery (tether react-date-picker)
//filters
//datepicker
//column reorder
//settings, export, 
//flxConstants && UIUtils rename
//rename ReactDataGrid to ReactDataGrid
//sort icon Placement
//general look and feel
//website
//toasters
//make it work in IE
//remaining examples
//material popups
//webpack copy text
//build lib only.
//flexiciousNmsp remove
//publish react-datagrid-material-adapter-flexicious
//publish react-datagrid-flexicious



//way to extend DG, DGC, DGCG
//docs
//userguide
//server rendering
// print popups print
//performance triggers - horizontal scrolling
//material filters


/*eslint-disable */
/**
 * Flexicious
 * Copyright 2011, Flexicious LLC
 */

import UIUtils from '../../utils/UIUtils'
import Constants from '../../utils/Constants'

import NdgBase from './NdgBase'
import KeyValuePairCollection from './cache/KeyValuePairCollection'
import RendererCache from './cache/RendererCache'
import FlexDataGridBodyContainer from './FlexDataGridBodyContainer'
import FlexDataGridCheckBoxColumn from './FlexDataGridCheckBoxColumn'
import FlexDataGridColumn from './FlexDataGridColumn'
import FlexDataGridColumnGroup from './FlexDataGridColumnGroup'
import FlexDataGridColumnLevel from './FlexDataGridColumnLevel'
import FlexDataGridHeaderContainer from './FlexDataGridHeaderContainer'
import FlexDataGridVirtualBodyContainer from './FlexDataGridVirtualBodyContainer'
import LockedContent from './LockedContent'
import ElasticContainer from './ElasticContainer'
import StyleDefaults from './StyleDefaults'
import ExtendedFilterPageSortChangeEvent from '../events/ExtendedFilterPageSortChangeEvent'

import UIComponent from '../../core/UIComponent'
import ReactDataGridCellContainer from '../../core/ReactDataGridCellContainer'

import SpinnerBehavior from "../../behaviors/SpinnerBehavior"
import TooltipBehavior from "../../behaviors/TooltipBehavior"
import MultiSelectComboBox from "../../controls/MultiSelectComboBox"
import TriStateCheckBox from "../../controls/TriStateCheckBox"
import NumericRangeBox from '../../controls/NumericRangeBox'

import GridPreferencesInfo from '../persistence/GridPreferencesInfo'
import PrintOptions from '../print/PrintOptions'
import ExportOptions from '../export/ExportOptions'


import CsvExporter from '../export/CsvExporter'
import DocExporter from '../export/DocExporter'
import HtmlExporter from '../export/HtmlExporter'
import TxtExporter from '../export/TxtExporter'
import XmlExporter from '../export/XmlExporter'

import SaveSettingsPopup from '../persistence/SaveSettingsPopup'
import SettingsPopup from '../persistence/SettingsPopup'
import OpenSettingsPopup from '../persistence/OpenSettingsPopup'

import ExportOptionsView from '../export/ExportOptionsView'

import RowPositionInfo from '../valueobjects/RowPositionInfo'
import SelectionInfo from '../valueobjects/SelectionInfo'
import LevelSelectionInfo from '../valueobjects/LevelSelectionInfo'

import Timer from '../../utils/Timer'
import UserSettingsController from '../persistence/UserSettingsController'
import UserSettingsOptions from '../persistence/UserSettingsOptions'
import DateRange from '../../utils/DateRange'

import ExtendedExportController from '../export/ExtendedExportController'

import MultiColumnSortPopup from '../toolbar/MultiColumnSortPopup'

/**
 * <p>
 * FlexDataGrid is the class name for Flexicious Ultimate, a DataGrid component built for the Flex SDK from the ground up to cater to the needs of UI developers who create complex Line of Business applications.<br/><br/>
 * 
 * It attempts to provide most of the functionality that is currently available in the Adobe SDK DataGrid, AdvancedDataGrid, and the Flexicious Extensions in addition to a number of unique features. <br/><br/>
 * </p>
 * <p>
 * Although Flexicious Ultimate offers all of the features outlined below, The ones in bold or italic are features that are exclusive to the Flexicious 
 * family of products, and not available in the Halo DataGrid/Advanced DataGrid components that ship with the SDK. 
 * The features in bold above are exclusive to Flexicious Ultimate. Features in italic are
 * available both in Ultimate, as well as Flexicious Classic. The rest of the features are found 
 * in the Flexicious Grids, as well as either the SDK DataGrid or AdvancedDataGrid.
 * 
 * Flexicious Ultimate attempts to bring to you a Single Grid, that incorporates all these features in one.
 * </p>
 * <ol>
 * <li>Ability to organize information as rows and columns, with locked headers</li>
 * <li>Ability to Customize the appearance Rows and Columns</li>
 * <li>Inline Editing, Customizable Editors, with validation hooks</li>
 * <li>User Interactive, Draggable, Resizable, Sortable and Editable Columns</li>
 * <li>Fully Configurable Drag and Drop</li>
 * <li>Keyboard Navigation</li>
 * <li>Multi Column Sort</li>
 * <li>Multi Level, Expand Collapse enabled Grouped Column Headers</li>
 * <li>Single Cell, Single Row, Multiple Cell, Multiple Row selection modes.</li>
 * <li>Support for UI skinning via styles, factories, as well as programmatic control</li>
 * <li>Display of Homogenous Hierarchical Data (Single Set Of Columns)</li>
 * <li><em>Inline Filtering, with numerous built in Filter Controls, and extensible architecture to define your own.</em></li>
 * <li><em>Server and Client based Paging, with a fully Customizable Pager UI.</em></li>
 * <li><em>Summary Footers, with fine tuned control over Formula, Precision, Formatting, Placement and Rendering of Footers.</em></li>
 * <li><em>Print and Live Print Preview, with ability to control Page Size, Orientation, Columns To Print, Page/Report Headers and Footers.</em></li>
 * <li><em>Ability to Export the Print output to any ActionScript PDF library, including Alive PDF</em></li>
 * <li><em>Ability to create Customizable Reports with your own Headers/Footers.</em></li>
 * <li><em>Ability to Export to Excel, Word, Text, XML and other formats. Ability to plug in your own Exporters</em></li>
 * <li><em>Preference Persistence (Ability for your end users to save viewing preferences)</em></li>
 * <li><em>CheckBox based selection of data, with Tri State CheckBox Header</em></li>
 * <li><em>Customizable loading Animation</em></li> 
 * <li><b>Smooth Scrolling</b></li>
 * <li><b>Display of Heterogonous Hierarchical Data (Multiple Sets Of Columns)</b></li>
 * <li><b>Ability to define paging, filtering and summary footers at each hierarchical level</b></li>
 * <li><b>Ability to define Fully Lazy Loaded, Partially Lazy Loaded and Initial Loaded Flat as well as Hierarchical Data Grids.</b></li>
 * <li><b>Left and Right Locked columns</b></li>
 * <li>A vast number of Business Scenarios supported out of the box:</li>
 * 	<ul>
 * 	<li><b>Cascading of row selection for hierarchical data</b></li>
 * 	<li><b>Ability to control whether or not rows with no children are shown (For grouped entries)</b></li>
 * 	<li><b>Drill Down/Drill Up/Drill To of Hierarchical data</b></li>
 * 	<li><b>Toolbar action icons, with ability to define custom actions</b></li>
 * 	<li><b>Ability to define initial sort values at any level</b></li>
 * 	<li><b>Ability to programmatically navigate to a row</b></li>
 * 	<li><b>Ability to show custom tooltip on hover over</b></li>
 * 	<li><b>Ability to fully customize sizes, borders, backgrounds, and styles for any cell programmatically as well as via CSS</b></li>
 * 	<li><b>Ability to define custom logic that control row selection, enabled, background, border.</b></li>
 * 	<li><b>Auto adjustment of the height on basis of the number of rows displayed</b></li>
 * 	<li><em>Read write nested properties of complex objects</em></li>
 * 	<li><em>Automatic column width adjustment on basis of data</em></li>
 * 	<li><em>Context menu based copying of data rows</em></li>
 *  <li><em>Ability to define Hand Cursors, Underline, truncateToFit, wordWrap on the columns</em></li>
 * 	<li><em>Ability to define various column width modes, like fitToContent, Percentage and Fixed</em></li>
 * 	</ul>
 * </ol>
*/
export default class FlexDataGrid extends NdgBase {
    /**
     * The constructor is responsible for instantiating the body container, header,footer,filter,pager containers, 
     * as well as the left/right Locked header/footer containers.
     * @constructor FlexDataGrid
     * @param props
     * @param arg1
     * @param arg2
     */
    constructor(props, arg1, arg2) {
        super(props, "div", false);
        if (!FlexDataGrid.measurerText) {
            FlexDataGrid.measurerText = new flexiciousNmsp.UIComponent("div");
        }
        const options = props;


        if (options) {

            if (options.id) {
                this.__id = options.id
            } else {
                if (!flexiciousNmsp.idCounter) {
                    flexiciousNmsp.idCounter = 0;
                }
                this.__id = `grid${flexiciousNmsp.idCounter++}`;
            }

        }

        if (!flexiciousNmsp.registry) {
            flexiciousNmsp.registry = {};
        }
        flexiciousNmsp.registry[this.__id] = this;
        /**
         *
         * @type {Dictionary}
         * @property itemFilters
         * @default {}
         */
        this.itemFilters = new flexiciousNmsp.KeyValuePairCollection();
        const that = this;

        this.attachClass("flexiciousGrid");
        /**
         *
         * @type {RendererCache}
         * @property rendererCache
         * @default null
         */
        this.rendererCache = null;

        /**
         * @type {String}
         * @property themeID
         * Default theme
         */
        this.themeID = "";
        this._preferencePersistenceKey = "";

        this.lastVScroll = 0;
        this.lastHScroll = 0;
        /**
         *
         * @type {FlexDataGridHeaderContainer}
         * @private
         * @property _treeDataGridContainer
         * @default null
         */
        this._treeDataGridContainer = null;

        /**
         *
         * @type {FlexDataGridColumnLevel}
         * @private
         * @property _columnLevel
         * @default null
         */
        this._columnLevel = null;

        /**
         *
         * @type {null}
         * @private
         * @property _treeDataGridHeader
         * @default null
         */
        this._treeDataGridHeader = null;
        /**
         *
         * @type {null}
         * @private
         * @property _treeDataGridFilter
         * @default null
         */
        this._treeDataGridFilter = null;

        /**
         *
         * @type {null}
         * @private
         * @property _treeDataGridFooter
         * @default null
         */
        this._treeDataGridFooter = null;

        /**
         *
         * @type {null}
         * @private
         * @property _treeDataGridPager
         * @default null
         */
        this._treeDataGridPager = null;
        /**
         * The cell that is the current mouse over. This could be any type of a cell, including header, footer, filter, pager or data cell.
         * If enableActiveCellHighlight is set to true, this cell will be highlighted using the activeCellColor style property.
         * @type {null}
         * @private
         * @property currentCell
         * @default null
         */
        this.currentCell = null;

        /**
         *
         * @type {null}
         * @private
         * @property _leftLockedHeader
         * @default null
         */
        this._leftLockedHeader = null;
        /**
         *
         * @type {null}
         * @private
         * @property _leftLockedContent
         * @default null
         */
        this._leftLockedContent = null;
        /**
         *
         * @type {null}
         * @private
         * @property _leftLockedFooter
         * @default null
         */
        this._leftLockedFooter = null;

        /**
         *
         * @type {Boolean}
         * @property enableKeyboardNavigation
         * @default true
         */
        this.enableKeyboardNavigation = true;
        /**
         *
         * @type {null}
         * @private
         * @property _rightLockedHeader
         * @default null
         */
        this._rightLockedHeader = null;
        /**
         *
         * @type {null}
         * @private
         * @property _rightLockedContent
         * @default null
         */
        this._rightLockedContent = null;
        /**
         *
         * @type {null}
         * @private
         * @property _rightLockedFooter
         * @default null
         */
        this._rightLockedFooter = null;
        this._rightLockedContent = null;
        /**
         *
         * @type {flexiciousNmsp.InsertionLocationInfo}
         * @property currentPoint
         * @default null
         */
        this.currentPoint = new flexiciousNmsp.InsertionLocationInfo();
        /**
         *
         * @type {Number}
         * @property isHScrollBarVisible
         * @default 0
         */
        this.isHScrollBarVisible = 0;
        /**
         *
         * @type {Number}
         * @property isVScrollBarVisible
         * @default 0
         */
        this.isVScrollBarVisible = 0;
        /**
         *
         * @type {Boolean}
         * @property useRollOver
         * @default true
         */
        this.useRollOver = true;
        /**
         *
         * @type {Boolean}
         * @private
         * @property _dataProviderSet
         * @default false
         */
        this._dataProviderSet = false;

        /**
         *
         * @type {Boolean}
         * @private
         * @property _preservePager
         * @default false
         */
        this._preservePager = false;
        /**
         * A box to cover the space left behind by the horizontal scrollbar when horizontalScrollPolicy=on and there are left locked columns.
         * @type {flexiciousNmsp.UIComponent}
         * @property  bottomBarLeft
         */
        this.bottomBarLeft = new flexiciousNmsp.UIComponent();
        /**
         * A box to cover the space left behind by the horizontal scrollbar when horizontalScrollPolicy=on and there are left locked columns.
         * @type {flexiciousNmsp.UIComponent}
         * @property  bottomBarRight
         */
        this.bottomBarRight = new flexiciousNmsp.UIComponent();
        /**
         * Set to true when the context menu is shown.
         * @type {Boolean}
         * @property  contextMenuShown
         * @default false
         */
        this.contextMenuShown = false;
        /**
         * By default, there is no filter applied. This is used by enableHideIfNoChildren, to hide items if there is a filter and no children qualify.
         * @type {Boolean}
         * @property  hasFilter
         * @default false
         */
        this.hasFilter = false;

        /**
         *
         * @type {null}
         * @private
         * @property _multiSortRenderer
         * @default null
         */
        this._multiSortRenderer = null;

        /**
         *
         * @type {Boolean}
         * @private
         * @property  _isScrolling
         * @default false
         */
        this._isScrolling = false;

        /**
         *
         * @type {Object}
         * @property  itemFilters
         * @default {}
         */
        this.itemFilters = new flexiciousNmsp.KeyValuePairCollection();

        /**
         *
         * @type {Boolean}
         * @private
         * @property  _needHorizontalRecycle
         * @default false
         */
        this._needHorizontalRecycle = false;

        /**
         *
         * @type {null}
         * @private
         * @property  _dragColumn
         * @default null
         */
        this._dragColumn = null;

        /**
         * Flag to enable export to word and excel.
         * @type {Boolean}
         * @property  enableExport
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/dynamiccolumns
         */
        this.enableExport = null;

		/**
		 * The default exporter in flexicious is a pure CSV exporter. 
		 * This property lets you hook in a native excel exporter using a libary
		 * like as3xls. Just like Alive PDF, as3xls is not embedded in to the 
		 * core flexicious library, instead it is distributed as a part of the sample.
		 * Just like for pdf, you hook up the AlivePdfPrinter, you use the nativeExcelExporter to 
		 * hookup an implementation of the flexicious expoter that interfaces with the as3xls library
		 * to provide native excel export 
         * @type {*}
         * @property nativeExcelExporter
         * @default null
		 */
        this.nativeExcelExporter = null;

        /**
         * Flag to enable edit on doubleclick as opposed to single click.
         * 
         * Editable columns begin edit when the user clicks on their cells. 
		 * In cases where you have a cell based selection mode, this conflicts
		 * with the user gesture of selecting a cell. In scenarios like this, you 
		 * may wish to  set enableDoubleClickEdit=true
         * 
         * @type {Boolean}
         * @property  enableDoubleClickEdit
         * @default null
         */
        this.enableDoubleClickEdit = null;

        /**
         * When enableVirtualScroll=true, setting this to true will cause each scroll event to issue a server request..
         * When this is set to false, the grid will only dispatch a virtualScroll event
		 * when the uses pauses scroll, as opposed to continuously as they scroll. 
         * 
         * @type {Boolean}
         * @property  enableDrawAsYouScroll
         * @default false
         */
        this.enableDrawAsYouScroll = false;

        /**
         * Flag to enable creation of the next level dynamically as the hierarchy is set.
         * 
         * For grouped nested datagrids where the Nest Hierarchy is not known at the outset,
		 * set this to true. When the grid hits the last "predefined" level, it calls the 
		 * dynamicLevelHasChildrenFunction function on the grid to see if there are more children.
		 * If this function returns true, a FlexDataGridColumnLevel object will automatically be created.
		 * This level will be a clone of the base level.
         * 
         * @type {Boolean}
         * @property  enableDynamicLevels
         * @default false
         * @see http://www.reactdatagrid.com/demo/#/DynamicLevels
         */
        this.enableDynamicLevels = false;

        /**
         * Function to determine if the given object has children.
         * 
         * Defaults to the defaultDynamicLevelHasChildrenFunction method of the grid.
		 * 
		 * For grouped nested datagrids where the Nest Hierarchy is not known at the outset,
		 * set enableDynamicLevels to true. When the grid hits the last "predefined" level, the grid calls the 
		 * dynamicLevelHasChildrenFunction function on the grid to see if there are more children.
		 * If this function returns true, a FlexDataGridColumnLevel object will automatically be created.
		 * <pre>
		 * private function hasChildren(target:Object):Boolean{
		 * 		//your code here
		 * }
		 * </pre>
         * 
         * @type {Function}
         * @property  dynamicLevelHasChildrenFunction
         * @default defaultDynamicLevelHasChildrenFunction
         * @example 
         *   dynamicLevelHasChildrenFunction(item) {
         *      return this.getLength(this.getChildren(item, this.getColumnLevel())) > 0;
         *   }
         */
        this.dynamicLevelHasChildrenFunction = this.defaultDynamicLevelHasChildrenFunction;

        /**
         * Function to intercept the body scrolling.
         * 
         * Defaults to null.
		 * 
		 * Here you can prevent the grid's body from scrolling on mousewheel. This is used to implement 
         * fixed scrolling type scenarios where you want the page to scroll upto a certain point and then 
         * the grid to start scrolling.
		 * @example
		 * private function scrollEnabledFunction(event:Event):void{
		 * 		//your code here
         *      const doc = document.documentElement;
         * const top = (window.pageYOffset || doc.scrollTop) - (doc.clientTop || 0);
         * if (evt.wheelDelta > 0) {
         *  //scroll down
         *  if (top < 100) {//or some predefined value
         * evt.preventDefault
         *   window.scrollBy(0, 20); // Scroll 100px to the bottom
         *  }
         * }
		 * }
         * 
         * @type {Function}
         * @property  scrollEnabledFunction
         * @default null
         * @example 
         *  checkScrollEnabled(evt) {
         *       const doc = document.documentElement;
         *       const top = (window.pageYOffset || doc.scrollTop) - (doc.clientTop || 0);
         *       if (evt.wheelDelta > 0) {
         *           //scroll down
         *           if (top < 100) { //or some predefined value
         *               evt.preventDefault();
         *               window.scrollBy(0, 20); // Scroll 100px to the bottom
         *           }
         *       }
         *   }
         */
        this.scrollEnabledFunction=null;
        /**
         * Flag to enable tristate behavior for selection checkboxes.
		 * Applicable in nested grids, where if you select a child, the parent goes into middle state, indicating visually that
		 * atleast one of the children is selected. 
		 * Post 2.6, this property works in tandem with enableSelectionBubble and enableSelectionCascade.
		 * Setting this to true requires that you also set enableSelectionBubble and enableSelectionCascade to true.
         * 
         * @type {Boolean}
         * @property  enableTriStateCheckbox
         * @default true
         * @see http://www.reactdatagrid.com/demo/#/SelectionOptions
         */
        this.enableTriStateCheckbox = true;

        /**
         * A flag to bubble up selection from children to parents.
		 * If this is set to true, If all of the parents children
		 * are selected, the parent will be added to its corresponding levels selectedObjects property
		 * If any of the children are unselected, the parent will be removed from its corresponding levels selectedObjects Property, in addition
		 * to the child being removed from its corresponding level.
		 * 
		 * Please note - if your dataprovider is a flat array collection, along with childrenfield, you will also need to specify a parentField
		 * that exists on the children object to point back to the parent.
		 * 
		 * Post 2.6, this property works in tandem with enableSelectionCascade and enableTristateCheckbox.
		 * Setting this to true requires that you also set enableSelectionCascade and enableTristateCheckbox to true
         * 
         * @type {Boolean}
         * @property  enableSelectionBubble
         * @default true
         * @see http://www.reactdatagrid.com/demo/#/SelectionOptions
         */
        this.enableSelectionBubble = true;

        /**
         * Flag to cascade checkbox or row selection down from the selection level.
		 * Post 2.6, this property works in tandem with enableSelectionBubble and enableTristateCheckbox.
		 * Setting this to true requires that you also set enableSelectionBubble and enableTristateCheckbox to true
         * 
         * @type {Boolean}
         * @property  enableSelectionCascade
         * @default true
         * @see http://www.reactdatagrid.com/demo/#/SelectionOptions
         */
        this.enableSelectionCascade = true;

        /**
         * Flag to size the grid on basis of the number of rows displayed. When set to true, 
		 * the grid will shrink or expand to show all the rows displayed, 
		 * upto a maximum of the maxAutoAdjustHeight (which defaults to 500).
		 * 
         * @type {Boolean}
         * @property  enableHeightAutoAdjust
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/AutoResizingGrid
         */
        this.enableHeightAutoAdjust = null;

        /**
         * The maximum height to adjust the grid when enableHeightAutoAdjust is set to true.
		 * When enableHeightAutoAdjust set to true, the grid will shrink or expand to show all the rows displayed, 
		 * upto a maximum of the maxAutoAdjustHeight (which defaults to 500).
         * 
         * @type {Number}
         * @property  maxAutoAdjustHeight
         * @default 500
         * @see http://www.reactdatagrid.com/demo/#/AutoResizingGrid
         */
        this.maxAutoAdjustHeight = 500;
        /**
         * Flag to control whether or not an item that has no children is filtered out or not.
         * 
         * @type {Boolean}
         * @property  enableHideIfNoChildren
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/xmlgroupeddata
         */
        this.enableHideIfNoChildren = null;

        /**
         * Flag to enable the context menu copy items. If set to true, three custom context menu items will be added. <br/>
		 * 1) The copy Cell context menu item, text controlled via the copyCellMenuText property. <br/>
		 * Will call itemToLabel on the column associated with the current cell under the mouse passing in the rowData object of the rowInfo.<br/> 
		 * 2) The copy Row context menu item, text controlled via the copyRowMenuText property. <br/>
		 * Will call itemToLabel on all the visible columns associated with the level of the current cell under the mouse passing in the rowData object of the rowInfo.<br/>
		 * 3) The copy All Rows context menu item, text controlled via the copyAllRowsMenuText property. <br/>
		 * Will basically perform a inbuilt export to TXT<br/>
		 * 
		 * The result of the copy operation is pasted to the clipboard
		 * 
		 * In Flex or Flash Builder, only top-level components in the application can have context menus.
		 * For example, if a DataGrid control is a child of a TabNavigator or VBox container, the DataGrid control cannot have its own context menu
         * @type {Boolean}
         * @property  enableCopy
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/xmlgroupeddata
         */
        this.enableCopy = null;

        /**
         * Enables the print operation.
         * @type {Boolean}
         * @property  enablePrint
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/xmlgroupeddata
         */
        this.enablePrint = null;

        /**
         * Enables the print pdf operation.
         * @type {Boolean}
         * @property  enablePdf
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/simple
         */
        this.enablePdf = false;
        /**
         * @private
         */
        this._useSelectedSelectAllState;
        /**
         * If all items from the top level are selected, returns TriStateCheckBox.STATE_CHECKED.
         * @type {String}
         * @private
         * @property  _selectAllState
         * @default flexiciousNmsp.TriStateCheckBox.STATE_UNCHECKED
         */
        this._selectAllState = flexiciousNmsp.TriStateCheckBox.STATE_UNCHECKED;
        /**
         *
         * @type {null}
         * @private
         * @property  _editor
         * @default null
         */
        this._editor = null;
        /**
         *
         * @type {null}
         * @private
         * @property  _editCell
         * @default null
         */
        this._editCell = null;

        /*
         * If we're setting filters programatically,
         * we may not want the filterPageSortChange event
         * to fire. This flag, when set to true will
         * prevent the event from being fired
         * @type {Boolean}
         * @private
         * @property  _triggerEvent
         * @default true
         */
        this._triggerEvent = true;

        /*
         *	If we're setting filters programatically,
         * we may not want the filterPageSortChange event
         * to fire. This flag, when set to true will
         * prevent the event from being fired
         * @type {Boolean}
         * @private
         * @property  _filterDirty
         * @default false
         */
        this._filterDirty = false;

        /**
         *
         * @type {Number}
         * @private
         * @property  _currentExpandLevel
         * @default 0
         */
        this._currentExpandLevel = 0;
        /**
         *
         * @type {Boolean}
         * @property  updateTotalRecords
         * @default true
         */
        this.updateTotalRecords = true;
        /**
         *
         * @type {Number}
         * @private
         */
        this._totalRecords = 0;
        /**
         *
         * @type {Boolean}
         * @property  inRebuildBody
         * @default false
         */
        this.inRebuildBody = false;
        /**
         * TooltipBehavior
         * @type {flexiciousNmsp.TooltipBehavior}
         * @property  tooltipBehavior
         */
        this.tooltipBehavior = new flexiciousNmsp.TooltipBehavior(this);
        /**
         *
         * @type {null}
         * @property currentExportLevel
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/xmlgroupeddata
         */
        this.currentExportLevel = null;

        /**
         * Last time the auto refresh timer was triggered 
         * @type {Date}
         * @property lastAutoRefresh
         */
        this.lastAutoRefresh = new Date();

        /**
         * If flag is set to true, grid will dispatch an AUTO_REFRESH event every autoRefreshInterval milliseconds. 
         * @property enableAutoRefresh
         * @type {null}
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/selectionui2
         */
        this.enableAutoRefresh = null;
        /**
         * The number of milliseconds to wait before issuing an autorefresh call.
		 * Defaults to 30000 (30 seconds) 
         * @type {Number}
         * @property autoRefreshInterval
         * @default 30000
         */
        this.autoRefreshInterval = 30000;
        /**
         * Timer instance to work with the auto refresh mechanism
         * @type {Timer}
         * @property autoRefreshTimer
         * @default null
         */
        this.autoRefreshTimer = null;
        /**
         * Tooltip to display when user hovers over expand icon
         *  @type {String}
         *  @property expandTooltip
         *  @default Expand
         */
        this.expandTooltip = "Expand";
        /**
         * Tooltip to display when user hovers over collapse icon
         * @type {String}
         * @property collapseTooltip
         * @default Collapse
         */
        this.collapseTooltip = "Collapse";
        /**
         * Default function will return the value of expandTooltip or collapseTooltip. Should take a IFlexDataGridCell object
         * 
         * If grid.openItems.contains(getItemKey(cell.rowInfo.data)), 
		 * return the value of expandTooltip else collapseTooltip
         * 
         * @type {Function}
         * @property expandCollapseTooltipFunction
         * @default defaultExpandCollapseTooltipFunction
         * @example 
         *    expandCollapseTooltipFunction(cell) {
         *           if (!this.allowInteractivity) return "";
         *           if (cell.level.isItemOpen(cell.rowInfo.getData())) {
         *               return this.collapseTooltip;
         *           } else {
         *               return this.expandTooltip;
         *           }
         *       }
         */
        this.expandCollapseTooltipFunction = this.defaultExpandCollapseTooltipFunction;

        /**
         *
         * @type {String}
         * @property builtInActions
         * @default edit,delete,moveTo,moveUp,moveDown,separator,addRow,filter
         * @see http://www.reactdatagrid.com/demo/#/selectionui1
         */
        this.builtInActions = "edit,delete,moveTo,moveUp,moveDown,separator,addRow,filter";
        /**
         *
         * @type {Object}
         * @property errorMap
         * @default null
         */
        this.errorMap = new flexiciousNmsp.KeyValuePairCollection();
        /**
         * A Flag that indicates if there are any errors
         * @type {Boolean}
         * @property hasErrors
         * @default false
         */
        this.hasErrors = false;
        /**
         * Flag to enable dragging multiple rows.
         * @type {Boolean}
         * @property allowMultipleRowDrag
         * @default false
         */
        this.allowMultipleRowDrag = false;

        /**
         * A flag that indicates whether the individual rows can have different height. 
		 * Please note, atleast one column needs to have the wordWrap flag set to true. If you use custom item rendereres, these are not accounted for in the height measurement for performance reasons. In this case, you should override the getRowHeight method or define a getRowHeightFunction and provide your own implementation which is optimized for your situation. 
         * @type {Boolean}
         * @property variableRowHeight
         * @default false
         * @see http://www.reactdatagrid.com/demo/#/xmldata
         */
        this.variableRowHeight = false;
        /**
         * By default, the flexicious Ultimate Grid does not instantiate and
         * measure each cell renderer when you set variable row heights. It
         * just uses the measureText functionality to estimate the height required
         * to fit the given text. In case where you have custom item renderers that have
         * other flex components that affect the heights of the cells, the grid does not
         * take these into consideration, for performance reasons.
         *
         * This flag, introduced in 2.8 will change this behavior so such cells will be
         * taken in to account and a renderer will be instantiated. The grid will instantiate
         * a renderer, set its data, and then measure it to calculate the height required to render
         * it. Please note, this may slightly degrade performance, so set this flag to true only if you
         * need it. Specifying a getRowHeightFunction and estimating the height without involving
         * display objects will be usually faster.
         * @type {Boolean}
         * @property variableRowHeightUseRendererForCalculation
         * @default false
         * @see http://www.reactdatagrid.com/demo/#/variableheaderrowheight
         */
        this.variableRowHeightUseRendererForCalculation = false;
        /**
         * In case the calculations of the row height with text measurements is not
         * accurate (Flash player bug) you can use this variable to adjust the calculation
         * based on your scenario
         * @type {Number}
         * @property variableRowHeightOffset
         * @default 0
         */
        this.variableRowHeightOffset = 0;
        /**
         * Flag that controls whether or not to rebuild the entire grid on dataprovider change. If you set this to false, only the body will be rebuilt.
         * @type {Boolean}
         * @property rebuildGridOnDataProviderChange
         * @default true
         * @see http://www.reactdatagrid.com/demo/#/simple
         */
        this.rebuildGridOnDataProviderChange = true;
        /**
         * Flag that controls whether or not to clear out selectedObjects and selectedKeys when the data provider changes
         * Defaults to true, so if you are using server paging, set this false
         * @type {Boolean}
         * @property clearSelectionOnDataProviderChange
         * @default true
         * @see http://www.reactdatagrid.com/demo/#/fulllazyload
         */
        this.clearSelectionOnDataProviderChange = true;
        /**
         * Flag that controls whether or not to clear out openItems when the data provider changes
         * Defaults to true, so if you are using server paging, set this false
         * @type {Boolean}
         * @property clearOpenItemsOnDataProviderChange
         * @default true
         * @see http://www.reactdatagrid.com/demo/#/selectionoptions
         */
        this.clearOpenItemsOnDataProviderChange = true;
        /**
         * Flag that controls whether or not to clear out errors when the data provider changes
         * Defaults to true, so if you are using server paging, set this false
         * @type {Boolean}
         * @property clearErrorsOnDataProviderChange
         * @default true
         */
        this.clearErrorsOnDataProviderChange = true;
        /**
         * Flag that controls whether or not to clear out selectedObjects and selectedKeys when the filter changes
         * Defaults to false
         * @type {Boolean}
         * @property clearSelectionOnFilter
         * @default false
         */
        this.clearSelectionOnFilter = false;
        /**
         * Flag to automatically generate columns. If the data provider is set, has atleast one item, and there are no columns specified the grid will attempt
         * to introspect the first item and create columns on basis of the properties on the first item. Set this flag to false if you do not want this behavior.
         * @type {Boolean}
         * @property generateColumns
         * @default true
         * @see http://www.reactdatagrid.com/demo/#/dynamiccolumns
         */
        this.generateColumns = true;
        /**
         *
         * @type {Boolean}
         * @property editable
         * @default false
         * @see http://www.reactdatagrid.com/demo/#/selectionui2
         */
        this.editable = false;
        /**
         * Flag to enable virtual scroll. This property can only be set at initialization time. In other words, changing this at runtime has no impact. 
		 * Please note, when you set virtual scroll, you cannot set variableRowHeight. Printing and Export will work only if you wire up the printExportDataRequest
		 * event, and the grid will print only what you return in the printExportDataRequest event. For an example of how this is used, see the "Remoting Example" grid.
		 * 
		 * Selection cascade, bubble and tristate will only work with enableSelectionExclusion. This blog post has more information about selection exclusion:
		 * http://blog.flexicious.com/post/Filtering-with-hierarchical-data-and-selection-across-large-lazy-loaded-datasets.aspx
		 * 
		 * Please refer http://blog.flexicious.com/post/Ultimate-DataGrid-now-supports-Virtual-Scroll-with-Hierarchical-Data.aspx for more information.
		 * 
		 * When grid.enableVirtualScroll=true, the grid dispatches a virtualScroll event when the grid scrolls.
		 * This event contains a recordsToLoad array, which contains an series of VirtualScrollLoadInfo records.
		 * This provides the application a list of record indexes to load, and which levels to load them at.
		 * 
		 * In flat grids, the FlexDataGridVirtualScrollEvent.recordsToLoad will always contain a list of VirtualScrollLoadInfo records were level=1.
		 * For nested grids, depending on where the user scrolls and which items are open, you could get a list of records from multiple levels,
		 * for example. Records 1-3 from level 1, All children of record 3 from level 2, and then Record 4-10 from level 1.
		 * 
		 * Setting enableVirtualScroll requires that you specify childrenCountField as well as selectedKeyField. 
		 * Additionally, enableVirtualScroll also requires that you set filterPageSortMode=server and 
         * itemLoadMode=server. Finally, virtual scroll does not work with variableRowHeights.
         * @type {null}
         * @property enableVirtualScroll
         * @default null
         */
        this.enableVirtualScroll = null;
        /**
		 * A function that can be used to control the background color of each cell in this column. 
		 * If this function is null or returns null, the cell  will
		 * use the alternatingItemColors style property. This function should take a IFlexDataGridDataCell 
		 * object, which has a pointer to the row data (data) as well as other related information
		 * found in the documentation of the FlexDataGridDataCell class. This function
		 * should return an array of colors for a gradient fill, or a single color 
		 * hex code (uint) for a single color fill.
         * @type {Function}
         * @property cellBackgroundColorFunction
         * @default null
         * @example
         * getColumnBackground(cell) {
         *      if (cell.getLevel().getSelectedKeys().indexOf(UIUtils.resolveExpression(cell.getRowInfo().getData(), cell.level.selectedKeyField)) > -1) 
         *          return cell.getLevel().grid.getStyle("selectionColor");
         *      }
         *      var val = UIUtils.resolveExpression(cell.getRowInfo().getData(), cell.getColumn().dataField);
         *      if (val < 10000) {
         *          return 0xCC3300;
         *      } else if (val > 50000) {
         *          return 0x66BB88;
         *      }
         *      else {
         *          return null;
         *      }
         *     }
         * @see http://www.reactdatagrid.com/demo/#/changetrackingapi
         */
        this.cellBackgroundColorFunction = null;
        /**
         *
         * @type {Function}
         * @property cellTextColorFunction
         * @default null
         */
        this.cellTextColorFunction = null;
        /**
         * @type {Function}
         * @property fillerCellCreatedFunction
         * @default null
         */
        this.fillerCellCreatedFunction = null;
        /**
         * By default, the grid draws a set of expand collapse icons on the left locked section.
		 * In case when you have a column with enableExpandCollapseIcon=true, you may choose to 
		 * set this flag to false. 
         * 
         * @type {Boolean}
         * @property enableDefaultDisclosureIcon
         * @default true
         * @see http://www.reactdatagrid.com/demo/#/selectionui2
         */
        this.enableDefaultDisclosureIcon = true;
        /**
         *
         * @type {Array}
         * @private
         * @property _changes
         * @default null
         */

        this._changes = [];
        /**
         * Flag to enable change tracking
         * If set to true, each addition, update(via the grid) or deletion to the data provider will be tracked. These can then be retrieved using the
         * changes collection on the grid. The Changes Collection is an array of ChangeInfo objects that contains all the changes made to the data provider using the grid editing mechanism.
         * @type {Boolean}
         * @property enableTrackChanges
         * @default false
         * @see http://www.reactdatagrid.com/demo/#/changetrackingapi
         */
        this.enableTrackChanges = false;
        /**
         * Flag to enable dataprovider based preselection of data. Please ensure you set selectedField at all appropriate columns levels.
         * @type {null}
         * @property enableSelectionBasedOnSelectedField
         * @default null
         */
        this.enableSelectionBasedOnSelectedField = null;
        /**
         *  Performance optimization, set this to true only if you are listening for the FlexDataGridEvent.CELL_RENDERED event
         * @type {Boolean}
         * @property dispatchCellRenderered
         * @default false
         */
        this.dispatchCellRenderered = false;
        /**
         *  Performance optimization, set this to true only if you are listening for the FlexDataGridEvent.RENDERER_INITIALIZED event
         * @type {Boolean}
         * @property dispatchRendererInitialized
         * @default false
         */
        this.dispatchRendererInitialized = false;
        /**
         *  Performance optimization, set this to true only if you are listening for the FlexDataGridEvent.CELL_CREATED event
         * @type {Boolean}
         * @property dispatchCellCreated
         * @default false
         */
        this.dispatchCellCreated = false;
        /**
         * Flag to hightlight the active cell. If set to true (default) the cell under the mouse or if navigating via keyboard, the current reference cell will be highlighted with the activeCellColor style.
         * @type {Boolean}
         * @property enableActiveCellHighlight
         * @default true
         * @see http://www.reactdatagrid.com/demo/#/simple
         */
        this.enableActiveCellHighlight = true;
        /**
         * Flag to hightlight the edit row. If set to true (default) the edit row will be highlighted with the editItemColors style.
         * @type {Boolean}
         * @property enableEditRowHighlight
         * @default true
         */
        this.enableEditRowHighlight = true;
        /**
         * The number of field dropdowns to display in the multi column sort popup.
         * @type {Number}
         * @property multiColumnSortNumberFields
         * @default 4
         */
        this.multiColumnSortNumberFields = 4;
        /**
         * By default, for hierarchical datagrids, when there is a object that does not have the property being searched for, these objects are included in the filter match. Set this flag to true to exclude such objects
         * @type {Boolean}
         * @property filterExcludeObjectsWithoutMatchField
         * @default false
         * @see http://www.reactdatagrid.com/demo/#/selectionui2
         */
        this.filterExcludeObjectsWithoutMatchField = false;
        /**
         * Function to control all the filtering at all levels. If you specify this, all built in filtering mechanics are ignored. This allows you to have full control over filtering.
         * @type {null}
         * @property globalFilterMatchFunction
         * @default null
         * @example todo
         */
        this.globalFilterMatchFunction = null;
        /**
         * If enabled (set to a string with length>0), when a dataprovider with zero items is set, or when filter criteria returns no records, a message is shown with this data. To disable this functionality, please set this property to a blank string.
         * @type {String}
         * @property noDataMessage
         * @default No Records Foun
         */
        this.noDataMessage = "No Records Found";
        /**
         * @type {Boolean}
         * @property _enableSplitHeader
         * @default true
         */
        this._enableSplitHeader = true;
        /**
         * Support for selection based on exclusion. In scenarios where you have lazy loaded grids, selection cascade and select all will
         * simply set flags on the selectionInfo object. The selectedObjects and selectedKeys no longer contain references to data that is selected
         * Instead, they contain the items that the user explicitly selected. unSelectedObjects will contain items that the user explicitly unselected.
         * This helps maintain selection across very large lazy loaded datasets. When you set the enableSelectionExclusion flag to true, use the selectionInfo object to
         * access the selection (or build a query on the server) to identify the objects user selected. Selection
         * @type {Boolean}
         * @property enableSelectionExclusion
         * @default false
         * @see http://www.reactdatagrid.com/demo/#/SelectionOptions
         */
        this.enableSelectionExclusion = false;
        /**
         *
         *
         * When grid.enableSelectionExclusion=true, we keep track of chains of each explicitly selected/unselected item. We need to do this
         * in order to correctly put the parents in the chain to middle state.
         * @type {Object}
         * @property selectionChain
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/SelectionOptions
         */
        this.selectionChain = {};
        /**
         * @type {Boolean}
         * @property _hasRowSpanOrColSpan
         * @default false
         * @private
         */
        this._hasRowSpanOrColSpan = false;
        /**
         * A function that takes in a data object, and a column, and returns a
         * number. -1 indicates that the row should span the entire height of the
         * grid. Please note, rowspans and col spans are only supported for data
         * rows.
         * @type {null}
         * @property rowSpanFunction
         * @default null
         * @example 
         *   getRowSpan(cell) {
         *       if (!rbnRowSpanselected) return 1;
         *       if (cell.getLevel().getNestDepth() == 1 //top level
         *       && cell.getLevel().isItemOpen(cell.rowInfo.getData())//item is open
         *       && cell.getColumn()
         *       && cell.getColumn().getDataField() == "question" //its the first column
         *       && cell.getRowInfo().getIsDataRow() //its the data row, not the header or the footer row
         *       && !cell.getRowInfo().getIsFillRow()//since the filler is also considered a data row
         *       )
         *       return cell.getRowInfo().getData().answers.length + 1;
         *       return 1;
         *   }
         * @see http://www.reactdatagrid.com/demo/#/RowSpanColSpan
         */
        this.rowSpanFunction = null;
        /**
         * A function that takes in a data object, and a column, and returns a
         * number. -1 indicates that the row should span the entire width of the
         * grid. Please note, rowspans and col spans are only supported for data
         * rows.
         *
         * Since this function is defined on the grid, it will get a
         * IFlexDataGridCell object that you should use to return a rowSpan or
         * colSpan.
         *
         * @type {null}
         * @property colSpanFunction
         * @default null
         * @example 
         *   getColSpan(cell) {
         *      if (!rbnColSpanselected) return 1;
         *      if (cell.getLevel().getNestDepth() == 1 //top level
         *      && cell.getColumn()
         *      && cell.getColumn().getDataField() == "question" //its the first column
         *      && cell.getRowInfo().getIsDataRow() //its the data row, not the header or the footer row
         *      && !cell.getRowInfo().getIsFillRow()//since the filler is also considered a data row
         *   )
         *   return cell.getGrid().getColumns().length;
         *   return 1;
         * }
         * @see http://www.reactdatagrid.com/demo/#/RowSpanColSpan
         */
        this.colSpanFunction = null;
        /**
         * By default, the grid renders when the dataprovider is set. This might lead to a blank area being shown while the data is being fetched.
         * If you set this flag to true, the grid will draw the columns, filter, pager, etc and then re-render when the data is fetched. This might add to the
         * overall render time, but would be a better user experience if there is a slower backed with a significant lag in data load time. For faster backends,
         * it is recommended that this flag remain false, for slower backends, it should be set to true. It is also recommended that you set the showSpinnerOnFilterPageSort
         * flag to true, so a spinning animation will be shown while the data is being fetched.
         * @type {Boolean}
         * @property enableEagerDraw
         * @default false
         * @see http://www.reactdatagrid.com/demo/#/simple
         */
        this.enableEagerDraw = true;
        /**
         * When variableRowHeight =true, atleast one column needs to have the wordWrap flag set to true. If you use custom item rendereres, these are not accounted for in the
         * height measurement for performance reasons. In this case, you should define a getRowHeightFunction and provide your own implementation which is optimized for your situation.
         * It should take the following parameters
         * <ul>
         * <li>param item        The item being displayed</li>
         * <li>param level        The FlexDataGridColumnLevel object that the item belongs to</li>
         * <li>param rowType    The type of the row, one of the RowPositionInfo.ROW_TYPE_XXXX constants </li>
         * </ul>
         * and return             Height of the row
         * @type {null}
         * @property getRowHeightFunction
         * @default null
         * @example 
         *     getRowHeight(item, level, type) {
         *           if (type == RowPositionInfo.ROW_TYPE_DATA)
         *               return level.getNestDepth() == 1 ? 25 : 40;
         *           return -1;
         *       }
         */
        this.getRowHeightFunction = null;
        /**
         * Function that actually runs the print. Defaults to defaultPrintHandlerFunction
         * @type {Function}
         * @property toolbarPrintHandlerFunction
         * @default defaultPrintHandlerFunction
         * @see http://www.reactdatagrid.com/demo/#/customtoolbar
         */
        this.toolbarPrintHandlerFunction = this.defaultPrintHandlerFunction;
        /**
         * Function that actually runs the pdf. Defaults to defaultPdfHandlerFunction
         * @type {Function}
         * @property toolbarPdfHandlerFunction
         * @default defaultPdfHandlerFunction
         * @see http://www.reactdatagrid.com/demo/#/customtoolbar
         */
        this.toolbarPdfHandlerFunction = this.defaultPdfHandlerFunction;
        /**
         * Function that actually runs the export to word. Defaults to defaultWordHandlerFunction
         * @type {Function}
         * @property toolbarWordHandlerFunction
         * @default defaultWordHandlerFunction
         * @see http://www.reactdatagrid.com/demo/#/customtoolbar
         */
        this.toolbarWordHandlerFunction = this.defaultWordHandlerFunction;
        /**
         * Function that actually runs the export to excel. Defaults to defaultExcelHandlerFunction
         * @type {Function}
         * @property toolbarExcelHandlerFunction
         * @default defaultExcelHandlerFunction
         * @see http://www.reactdatagrid.com/demo/#/customtoolbar
         */
        this.toolbarExcelHandlerFunction = this.defaultExcelHandlerFunction;
        /**
         *
         * @type {flexiciousNmsp.ClassFactory}
         * @property printComponentFactory
         * @default PrintFlexDataGrid
         */
        this.printComponentFactory = null;//TODO new flexiciousNmsp.ClassFactory(flexiciousNmsp.PrintFlexDataGrid);
        /**
         * Only applicable when selectionMode=multipleRows or multipleCells
         * By default, when you click on a row (or cell), the grid will add it to the selection. If you click again, the grid will remove it from selection.
         * If you click on another row (or cell), the grid will add that row/cell to the selection.
         *
         * When you set this to false, when you click on a row, the grid will add it to selection, If you click again nothing will happen. If you click with the control key down
         * the grid will remove it from selection. If you click another row/cell, the originally selected row/cell will be unselected. If you CTRL click on another row,
         * the grid will add that row in addition to the previously selected row. In short, the grid will behave like the SDK MX datagrid.
         * @type {Boolean}
         * @property enableStickyControlKeySelection
         * @default true
         * @see http://www.reactdatagrid.com/demo/#/selectionmodes
         */
        this.enableStickyControlKeySelection = true;
        /**
         * Not supported.
         * @type {Boolean}
         * @property enableFillerRows
         * @default true
         */
        this.enableFillerRows = true;

        /**
         * Flag should be set to true when you have large variable height based rows that are potentially
         * taller than the grid itself. The first row in view is the reference view. As you scroll,
         * newer rows become the reference rows and the view port end updated. However, when you have rows
         * that are taller than the grid, or when they account for a disproportionate amount of the viewport
         * the grid no longer renders view port end becuase the reference row is large and has not scrolled
         * out of view. This flag is used to instruct the grid to check after
         * each scroll gesture whether or not additional rows have come into view.
         * @type {Boolean}
         * @property recalculateSeedOnEachScroll
         * @default false
         */
        this.recalculateSeedOnEachScroll = false;
        /**
         * This function basically gives you the opportunity to tie in to the grids hierarchy lookup mechanism.
         * By default, the grid will call the getChildren method on this class to get the children of any object
         * when it is time to draw the hierarchy. By defining a custom getChildrenFunction, you can intercept
         * this mechanism to provide your own implementation of retrieving children.
         * The signature of this function should be like below:
         * getChildren(object:Object,level:FlexDataGridColumnLevel):Object
         * @type {Function}
         * @property getChildrenFunction
         * @default null
         * @example todo
         */
        this.getChildrenFunction = null;
        /**
         *
         * @type {null}
         * @property spinner
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/selectionoptions
         */
        this.spinner = null;
        /**
         *
         * @type {flexiciousNmsp.SpinnerBehavior}
         * @property spinnerBehavior
         * @default SpinnerBehavior
         */
        this.spinnerBehavior = new flexiciousNmsp.SpinnerBehavior(this);
        /**
         * Added in 2.9 to avoid flicker.
         * @type {Boolean}
         * @property enableLocalStyles
         * @default true
         */
        this.enableLocalStyles = true;
        /**
         * Added in 2.9 to avoid multiple change events from firing. Actions like select all, (selecting a parent with enableSelectionCascade, selecting a child with enableSelectionBubble) will result
		 * that add or remove multiple items from the selected set, will result in multiple change events being dispatched. If you set this flag to true (this is the default starting in 2.9)
		 * the call to the change event dispatch gets queued for the next update cycle. This results in a single change event being dispatched irrespective of the number
		 * of rows selected/unselected. 
         * 
         * @type {Boolean}
         * @property enableDelayChange
         * @default true
         */
        this.enableDelayChange = true;
        /**
         * Added in 2.9 to force columns to take the widths that the user specified.
         * Once the user resizes the column, the column widths basically are set to "fixed".
         * @type {Boolean}
         * @property enableColumnWidthUserOverride
         * @default true
         */
        this.enableColumnWidthUserOverride = true;
        /**
         *
         * @type {Boolean}
         * @property inUpdate
         * @default false
         */
        this.inUpdate = false;
        /**
         *
         * @type {Boolean}
         * @property _changePending
         * @default false
         */
        this._changePending = false;
        /**
         * When you enable headerWordWrap=true, then we need to set this to true, because
         * we will dyamically adjust the height of the header row. Please be advised, currently, (as of 2.9)
         * columnGroups get the same height as the header cells.
         * @type {Boolean}
         * @property variableHeaderHeight
         * @default false
         * @see http://www.reactdatagrid.com/demo/#/variableheaderrowheight
         */
        this.variableHeaderHeight = false;

        /**
         * In case the calculations of the row height with text measurements is not
         * accurate browser style issue you can use this variable to adjust the calculation
         * based on your scenario
         * @type {Number}
         * @property variableHeaderHeightOffset
         * @default 0
         */
        this.variableHeaderHeightOffset = 0;
        /**
         *
         * @type {Boolean}
         * @property _fillerInvalidated
         * @default false
         */
        this._fillerInvalidated = false;
        /**
         *
         * @type {*}
         * @property preferencesToPersist
         * @default concatenatePersistenceValues
         */
        this.preferencesToPersist = this.concatenatePersistenceValues();
        /**
         * When set to true, causes the grid to look for settings stored
         * previously in the local shared object store if
         * preferencePersistenceMode='client' or dispatch an event requesting
         * settings from the server in preferencePersistenceMode='server'
         * @type {Boolean}
         * @property enablePreferencePersistence
         * @default false
         * @see http://www.reactdatagrid.com/demo/#/simple
         */
        this.enablePreferencePersistence = false;
        /**
         * String value "server" or "client". When this property
         * is set to client(default), the grid uses a shared object
         * on the client to store preference settings. When it is
         * set to server, the grid fires an event, preferencesChanged,
         * which contains a XML string representation of the preference
         * values. This can then be persisted on the backend, tied to a
         * specific user id.
         * @type {String}
         * @property preferencePersistenceMode
         * @default client
         */
        this.preferencePersistenceMode = "client";
        /**
         *
         * @type {Boolean}
         * @property preferencesSet
         * @default false
         */
        this.preferencesSet = false;
        /**
         *
         * @type {Boolean}
         * @property _userPersistedColumnWidths
         * @default false
         */
        this._userPersistedColumnWidths = false;
        /**
         * If set to true, uses the newer preference persistence scheme introduced in
         * Flexicious 2.0, which stores the preferences as custom string as opposed to XML,
         * making it a lot less verbose.
         *
         * Please note, for the JavaScript edition, only useCompactPreferences=true is supported.
         * @type {Boolean}
         * @property useCompactPreferences
         * @default true
         * @see http://www.reactdatagrid.com/demo/#/simple
         */
        this.useCompactPreferences = true;
        /**
         * @type {Boolean}
         * @property _preferencesLoaded
         * @default false
         */

        this._preferencesLoaded = false;
        /**
         * @type {Function}
         * @property userSettingsOptionsFunction
         * @default defaultUseSettingsOptionsFunction
         */

        this.userSettingsOptionsFunction = this.defaultUseSettingsOptionsFunction;
        /**
         * @type {null}
         * @property pdfPrinter
         * @default null
         */
        this.pdfPrinter = null;
        /**
         * @type {Boolean}
         * @property enableMultiplePreferences
         * @default true
         * @see http://www.reactdatagrid.com/demo/#/customtoolbar
         */
        this.enableMultiplePreferences = false;
        /**
         *
         * @type {flexiciousNmsp.GridPreferencesInfo}
         * @private
         * @property _gridPreferencesInfo
         * @default GridPreferencesInfo
         */
        this._gridPreferencesInfo = new flexiciousNmsp.GridPreferencesInfo();
        /**
         * @type {Boolean}
         * @property showSpinnerOnFilterPageSort
         * @default false
         * @see http://www.reactdatagrid.com/demo/#/simple
         */
        this.showSpinnerOnFilterPageSort = true;
        /**
         * @type {null}
         * @property _currentPreference
         * @default null
         */
        this._currentPreference = null;
        /**
         * By default, when the grid's creation complete event is dispatched, the grid will go
         * in and load the saved preference. This works well in most cases, but in some cases, where
         * the data needed to build selection comboboxes (for filters) is built from the dataprovider,
         * it makes sense to wait until the dataprovider is loaded to parse and set the preferences, otherwise
         * the grid will end up ignoring saved preferences for filters that have dropdown based UI. In this case
         * set autoLoadPreferences to true, and manually call loadPreferences when the data is received from
         * the server and the dataprovider is set.<br/>
         *
         * grid:FlexDataGrid autoLoadPreferences=”false” <br/>
         * And then, when you set the dataprovider: <br/>
         * dgReport.dataProvider=dp;<br/>
         * if(!dgReport.getPreferencesLoaded()){<br/>
         *         dgReport.loadPreferences();<br/>
         * }<br/>
         * @type {Boolean}
         * @property autoLoadPreferences
         * @default true
         */
        this.autoLoadPreferences = true;
        /**
         *
         * @type {flexiciousNmsp.ClassFactory}
         * @property popupFactoryContextMenuPopup
         * @default null
         */
        this.popupFactoryContextMenuPopup = UIUtils.adapter 
        && UIUtils.createContextMenuPopup &&
        UIUtils.adapter.createContextMenuPopup 
        ? UIUtils.createContextMenuPopup() : null; //new flexiciousNmsp.ClassFactory(flexiciousNmsp.ContextMenuPopup);
        /**
         *
         * @type {flexiciousNmsp.ClassFactory}
         * @property popupFactorySaveSettingsPopup
         * @default SaveSettingsPopup
         * @see http://www.reactdatagrid.com/demo/#/customtoolbar
         */
        this.popupFactorySaveSettingsPopup = UIUtils.adapter ? UIUtils.createSaveSettingsPopup() : new flexiciousNmsp.ClassFactory(flexiciousNmsp.SaveSettingsPopup);
        /**
         *
         * @type {flexiciousNmsp.ClassFactory}
         * @property popupFactoryOpenSettingsPopup
         * @default OpenSettingsPopup
         * @see http://www.reactdatagrid.com/demo/#/customtoolbar
         */
        this.popupFactoryOpenSettingsPopup = null//new flexiciousNmsp.ClassFactory(flexiciousNmsp.OpenSettingsPopup);
        /**
         *
         * @type {flexiciousNmsp.ClassFactory}
         * @property popupFactorySettingsPopup
         * @default SettingsPopup
         * @see http://www.reactdatagrid.com/demo/#/customtoolbar
         */
        this.popupFactorySettingsPopup = UIUtils.adapter ? UIUtils.createSettingsPopup() : new flexiciousNmsp.ClassFactory(flexiciousNmsp.SettingsPopup);
        /**
         *
         * @type {flexiciousNmsp.ClassFactory}
         * @property popupFactoryPrintOptions
         * @default PrintOptionsView
         */
        this.popupFactoryPrintOptions = null//TODO new flexiciousNmsp.ClassFactory(flexiciousNmsp.PrintOptionsView);
        /**
         *
         * @type {flexiciousNmsp.ClassFactory}
         * @property popupFactoryExportOptions
         * @default ExportOptionsView
         */
        this.popupFactoryExportOptions = UIUtils.adapter ? UIUtils.createExportPopup() : new flexiciousNmsp.ClassFactory(flexiciousNmsp.ExportOptionsView);
        /**
         * The Print options object that is used to configure the print behavior - currently only supported in Ultimate
         * @type {PrintOptions}
         * @property printOptions
         * @default
         */
        this.printOptions = {};//TODO flexiciousNmsp.PrintOptions.create();

        /**
         * HTMLTreeGrid v3.0 introduced an enhanced printing feature, for those of you who want the old feature, just set this flag to false.
         * @type {Boolean}
         * @property useEnhancedPrint
         * @default true
         */
        this.useEnhancedPrint = true;
        /**
         * HTMLTreeGrid v3.0 introduced an enhanced printing feature, for those of you who want the old feature, just set this flag to false.
         * If set to false, it will use the basic PDF export, which is simple text pdf as opposed to a full graphical. Text is better pdf quality. But graphics has
         * support for screenshot based output, which is lower quality but an accurate representation of the grid.
         * @type {Boolean}
         * @property useEnhancedPdf
         * @default true
         */
        this.useEnhancedPdf = false;
        /**
         * The Print options object that is used to configure the pdf behavior - currently only supported in Ultimate
         * @type {PrintOptions}
         * @property pdfOptions
         * @default
         */
        this.pdfOptions = {};//TODO flexiciousNmsp.PrintOptions.create(true);

        /**
         * The Export options object that is used to configure the html export behavior - currently only supported in Ultimate
         * @type {ExportOptions}
         * @property htmlOptions
         * @default
         */
        this.pdfOptionsBasic = flexiciousNmsp.ExportOptions.create(flexiciousNmsp.ExportOptions.PDF_EXPORT);

        /**
         * The Export options object that is used to configure the excel export behavior - currently only supported in Ultimate
         * @type {ExportOptions}
         * @property excelOptions
         * @default
         * @see http://www.reactdatagrid.com/demo/#/dynamiccolumngroups
         */
        this.excelOptions = flexiciousNmsp.ExportOptions.create();
        this.excelOptions.popupParent = this;
        /**
         * The Export options object that is used to configure the word export behavior - currently only supported in Ultimate
         * @type {ExportOptions}
         * @property wordOptions
         * @default
         */
        this.wordOptions = flexiciousNmsp.ExportOptions.create(flexiciousNmsp.ExportOptions.DOC_EXPORT);
        this.wordOptions.popupParent = this;
        /**
         * The Export options object that is used to configure the html export behavior - currently only supported in Ultimate
         * @type {ExportOptions}
         * @property htmlOptions
         * @default
         */
        this.htmlOptions = flexiciousNmsp.ExportOptions.create(flexiciousNmsp.ExportOptions.HTML_EXPORT);
        this.htmlOptions.openNewWindow = true;
        this.htmlOptions.popupParent = this;
        this.htmlOptions.exportOptionsWindowTitle = Constants.PRINT_OPTIONS_TITLE;
        /**
         *
         * @type {Boolean}
         * @property doubleClickEnabled
         * @default true
         * @see http://www.reactdatagrid.com/demo/#/nested
         */
        this.doubleClickEnabled = true;

        /**
         * The root path to all images used by the grid
         * @type {String}
         */
        this.imagesRoot = null;
        /**
         *  Color of the border.
         *  The default value depends on the component class;
         *  if not overridden for the class, the default value is <code>0xB7BABC</code>.
         * [Style(name="borderColor", type="uint", format="Color", inherit="no")]
         * @type {uint}
         * @property borderColor
         * @default null
         */
        this.borderColor = null;
        /**
         *  Bounding box sides.
         *  A space-delimited String that specifies the sides of the border to show.
         *  The String can contain <code>"left"</code>, <code>"top"</code>,
         *  <code>"right"</code>, and <code>"bottom"</code> in any order.
         *  The default value is <code>"left top right bottom"</code>,
         *  which shows all four sides.
         *
         *  This style is only used when borderStyle is <code>"solid"</code>.
         * [Style(name="borderSides", type="String", inherit="no")]
         * @type {String}
         * @property borderSides
         * @default null
         */
        this.borderSides = null;
        /**
         *  Bounding box thickness.
         *  @default 1
         * [Style(name="borderThickness", type="Number", format="Length", inherit="no")]
         * @type {Number}
         * @property borderThickness
         * @default null
         */
        this.borderThickness = null;
        /**
         * Colors for the spinners as an array.
         * First element for the circle color and second for the spinner color
         * [Style(name="spinnerColors",type="Array",format="Color")]
         * @type {Array}
         * @property spinnerColors
         * @default null
         */
        this.spinnerColors = null;
        /**
         * Spinner radius , default value is 10
         *
         * [Style(name="spinnerRadius", type="Number", format="Length", minValue="0.0")]
         * @type {null}
         * @property spinnerRadius
         * @default null
         */
        this.spinnerRadius = null;
        /**
         * Spinner thickness , default value is 5
         * [Style(name="spinnerThickness", type="Number", format="Length", minValue="0.0")]
         * @type {Number}
         * @property spinnerThickness
         * @default null
         */
        this.spinnerThickness = null;
        /**
         * Background color of the grid when the spinner is active
         * [Style(name="spinnerGridAlpha", type="Number", format="Length", minValue="0.0")]
         * @type {Number}
         * @property spinnerGridAlpha
         * @default null
         */

        this.spinnerGridAlpha = null;
        /**
         *  Backgrond color, the color of the fill area.
         * [Style(name="backgroundColor",  type="Array", arrayType="uint", format="Color", inherit="no")]
         * @type {Array}
         * @property backgroundColor
         * @default null
         */

        this.backgroundColor = null;

        /**
         *  Alignment of text within a container.
         *  Possible values are <code>"left"</code>, <code>"right"</code>,
         *  or <code>"center"</code>.
         *
         *  <p>The default value for most components is <code>"left"</code>.
         *  For the FormItem component,
         *  the default value is <code>"right"</code>.
         *  For the Button, LinkButton, and AccordionHeader components,
         *  the default value is <code>"center"</code>, and
         *  this property is only recognized when the
         *  <code>labelPlacement</code> property is set to <code>"left"</code> or
         *  <code>"right"</code>.
         *  If <code>labelPlacement</code> is set to <code>"top"</code> or
         *  <code>"bottom"</code>, the text and any icon are centered.</p>
         *
         * [Style(name="textAlign", type="String", enumeration="left,center,right", inherit="yes")]
         * @type {String}
         * @property textAlign
         * @default null
         */

        this.textAlign = null;
        /**
         *  The width of  the numeric value representing the order of the column sort.
         *  @default 10
         *
         * [Style(name="multiColumnSortNumberWidth", type="Number", inherit="no")]
         * @type {Number}
         * @property multiColumnSortNumberWidth
         * @default null
         */

        this.multiColumnSortNumberWidth = null;
        /**
         *  The height of  the numeric value representing the order of the column sort.
         *  @default 15
         *
         * [Style(name="multiColumnSortNumberHeight", type="Number", inherit="no")]
         * @type {Number}
         * @property multiColumnSortNumberHeight
         * @default null
         */

        this.multiColumnSortNumberHeight = null;
        /**
         *  The name of a CSS style declaration for controlling other aspects of
         *  the appearance of the numeric value representing the order of the column sort.
         *  @default "multiColumnSortNumberStyle"
         *
         * [Style(name="multiColumnSortNumberStyleName", type="String", inherit="no")]
         * @type {String}
         * @property multiColumnSortNumberStyleName
         * @default null
         */

        this.multiColumnSortNumberStyleName = null;
        /**
         *  The name of a CSS style declaration for controlling other aspects of
         *  the appearance of the column groups.
         *  @default "columnGroupStyle"
         *
         * [Style(name="columnGroupStyleName", type="String", inherit="no")]
         * @type {String}
         * @property columnGroupStyleName
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/largedynamicgrid
         */

        this.columnGroupStyleName = null;
        /**
         *  The name of a CSS style declaration for controlling other aspects of
         *  the appearance of the column headers.
         *  @default "dataGridStyles"
         *
         * [Style(name="headerStyleName", type="String", inherit="no")]
         * @type {String}
         * @property headerStyleName
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/rowspancolspan
         */

        this.headerStyleName = null;
        /**
         *  The name of a CSS style declaration for controlling other aspects of
         *  the appearance of the pager bar(toolbar).
         *
         * [Style(name="pagerStyleName", type="String", inherit="no")]
         * @type {String}
         * @property pagerStyleName
         * @default null
         */
        this.pagerStyleName = null;
        /**
         *  The name of a CSS style declaration for controlling other aspects of
         *  the appearance of the column headers.
         *  @default "dataGridStyles"
         * [Style(name="footerStyleName", type="String", inherit="no")]
         * @type {String}
         * @property footerStyleName
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/rowspancolspan
         */

        this.footerStyleName = null;
        /**
         *  Flag that indicates whether to show vertical grid lines between
         *  the columns.
         *  If <code>true</code>, shows vertical grid lines.
         *  If <code>false</code>, hides vertical grid lines.
         *  @default true
         * [Style(name="verticalGridLines", type="Boolean", inherit="no")]
         * @type {Boolean}
         * @property verticalGridLines
         * @default null
         */

        this.verticalGridLines = null;
        /**
         *  Flag that indicates whether to show horizontal grid lines between
         *  the rows.
         *  If <code>true</code>, shows horizontal grid lines.
         *  If <code>false</code>, hides horizontal grid lines.
         *  @default false
         * [Style(name="horizontalGridLines", type="Boolean", inherit="no")]
         * @type {Boolean}
         * @property horizontalGridLines
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/rowspancolspan
         */

        this.horizontalGridLines = null;
        /**
         *  The color of the vertical grid lines.
         *  @default 0x666666
         * [Style(name="verticalGridLineColor", type="uint", format="Color", inherit="yes")]
         * @type {uint}
         * @property verticalGridLineColor
         * @default null
         */

        this.verticalGridLineColor = null;
        /**
         *  The color of the horizontal grid lines.
         * [Style(name="horizontalGridLineColor", type="uint", format="Color", inherit="yes")]
         * @type {uint}
         * @property horizontalGridLineColor
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/outlook
         */

        this.horizontalGridLineColor = null;
        /**
         *  Thickness of the horizontal grid lines.
         *  @default 1
         * [Style(name="horizontalGridLineThickness", type="Number", format="Length", inherit="yes")]
         * @type {Number}
         * @property horizontalGridLineThickness
         * @default null
         * @see http://www.reactdatagrid.com/demo/#/outlook
         */

        this.horizontalGridLineThickness = null;
        /**
         *  Thickness of the vertical grid lines.
         *  @default 1
         * [Style(name="verticalGridLineThickness", type="Number", format="Length", inherit="yes")]
         * @type {Number}
         * @property verticalGridLineThickness
         * @default null
         */

        this.verticalGridLineThickness = null;
        /**
         *  Flag that indicates whether to show vertical grid lines between
         *  the columns.
         *  If <code>true</code>, shows vertical grid lines.
         *  If <code>false</code>, hides vertical grid lines.
         *  @default true
         * [Style(name="headerVerticalGridLines", type="Boolean", inherit="no")]
         * @type {Boolean}
         * @property headerVerticalGridLines
         * @default null
         */

        this.headerVerticalGridLines = null;
        /**
         *  Flag that indicates whether to show horizontal grid lines between
         *  the rows.
         *  If <code>true</code>, shows horizontal grid lines.
         *  If <code>false</code>, hides horizontal grid lines.
         *  @default false
         * [Style(name="headerHorizontalGridLines", type="Boolean", inherit="no")]
         * @type {Boolean}
         * @property headerHorizontalGridLines
         * @default null
         */

        this.headerHorizontalGridLines = null;
        /**
         *  The color of the vertical grid lines.
         *  @default 0x666666
         * [Style(name="headerVerticalGridLineColor", type="uint", format="Color", inherit="yes")]
         * @type {uint}
         * @property headerVerticalGridLineColor
         * @default null
         */

        this.headerVerticalGridLineColor = null;
        /**
         *  The color of the horizontal grid lines.
         * [Style(name="headerHorizontalGridLineColor", type="uint", format="Color", inherit="yes")]
         * @type {uint}
         * @property headerHorizontalGridLineColor
         * @default null
         */

        this.headerHorizontalGridLineColor = null;
        /**
         *  Thickness of the header horizontal grid lines.
         *  @default 1
         * [Style(name="headerHorizontalGridLineThickness", type="Number", format="Length")]
         * @type {Number}
         * @property headerHorizontalGridLineThickness
         * @default null
         */

        this.headerHorizontalGridLineThickness = null;
        /**
         *  Thickness of the header vertical grid lines.
         * [Style(name="headerVerticalGridLineThickness", type="Number", format="Length")]
         * @default 1
         * @type {Number}
         * @property headerVerticalGridLineThickness
         * @see http://www.reactdatagrid.com/demo/#/selectionui2
         */

        this.headerVerticalGridLineThickness = null;
        /**
         *  Flag that indicates whether to force the top border
         * [Style(name="headerDrawTopBorder", type="Boolean", inherit="no")]
         *  @default false
         * @type {Boolen}
         * @property headerDrawTopBorder
         */

        this.headerDrawTopBorder = null;
        /**
         * [Style(name="columnGroupVerticalGridLines", type="Boolean", inherit="no")]
         *  Flag that indicates whether to show vertical grid lines between
         *  the columns.
         *  If <code>true</code>, shows vertical grid lines.
         *  If <code>false</code>, hides vertical grid lines.
         *  @default true
         * @type {Boolean}
         * @property columnGroupVerticalGridLines
         */

        this.columnGroupVerticalGridLines = null;
        /**
         * [Style(name="columnGroupHorizontalGridLines", type="Boolean", inherit="no")]
         *  Flag that indicates whether to show horizontal grid lines between
         *  the rows.
         *  If <code>true</code>, shows horizontal grid lines.
         *  If <code>false</code>, hides horizontal grid lines.
         *  @default false
         * @type {Boolean}
         * @property columnGroupHorizontalGridLines
         */

        this.columnGroupHorizontalGridLines = null;
        /**
         * [Style(name="columnGroupVerticalGridLineColor", type="uint", format="Color", inherit="yes")]
         *  The color of the vertical grid lines.
         *  @default 0x666666
         * @type {uint}
         * @property columnGroupVerticalGridLineColor
         */

        this.columnGroupVerticalGridLineColor = null;
        /**
         * [Style(name="columnGroupHorizontalGridLineColor", type="uint", format="Color", inherit="yes")]
         *  The color of the horizontal grid lines.
         * @default nill
         * @type {uint}
         * @property columnGroupHorizontalGridLineColor
         */

        this.columnGroupHorizontalGridLineColor = null;
        /**
         * [Style(name="columnGroupHorizontalGridLineThickness", type="Number", format="Length")]
         *  Thickness of the header horizontal grid lines.
         *  @default 1
         * @type {Number}
         * @property columnGroupHorizontalGridLineThickness
         */

        this.columnGroupHorizontalGridLineThickness = null;
        /**
         * [Style(name="columnGroupVerticalGridLineThickness", type="Number", format="Length")]
         *  Thickness of the header vertical grid lines.
         *  @default 1
         * @type {Number}
         * @property columnGroupVerticalGridLineThickness
         */

        this.columnGroupVerticalGridLineThickness = null;
        /**
         * [Style(name="columnGroupDrawTopBorder", type="Boolean", inherit="no")]
         *  Flag that indicates whether to force the top border
         *  @default false
         * @type {Boolean}
         * @property columnGroupDrawTopBorder
         */

        this.columnGroupDrawTopBorder = null;
        /**
         * [Style(name="filterVerticalGridLines", type="Boolean", inherit="no")]
         *  Flag that indicates whether to show vertical grid lines between
         *  the columns.
         *  If <code>true</code>, shows vertical grid lines.
         *  If <code>false</code>, hides vertical grid lines.
         *  @default true
         * @type {Boolean}
         * @property filterVerticalGridLines
         */

        this.filterVerticalGridLines = null;
        /**
         * [Style(name="filterHorizontalGridLines", type="Boolean", inherit="no")]
         *  Flag that indicates whether to show horizontal grid lines between
         *  the rows.
         *  If <code>true</code>, shows horizontal grid lines.
         *  If <code>false</code>, hides horizontal grid lines.
         *  @default false
         * @type {Boolean}
         * @property filterHorizontalGridLines
         */

        this.filterHorizontalGridLines = null;
        /**
         * [Style(name="filterVerticalGridLineColor", type="uint", format="Color", inherit="yes")]
         *  The color of the vertical grid lines.
         *  @default 0x666666
         * @type {uint}
         * @property filterVerticalGridLineColor
         */

        this.filterVerticalGridLineColor = null;
        /**
         *  The color of the horizontal grid lines.
         * [Style(name="filterHorizontalGridLineColor", type="uint", format="Color", inherit="yes")]
         * @default 0x666666
         * @type {uint}
         * @property filterHorizontalGridLineColor
         *
         */

        this.filterHorizontalGridLineColor = null;
        /**
         * [Style(name="filterHorizontalGridLineThickness", type="Number", format="Length")]
         *  Thickness of the filter horizontal grid lines.
         *  @default 1
         * @type {Number}
         * @property filterHorizontalGridLineThickness
         */

        this.filterHorizontalGridLineThickness = null;
        /**
         * [Style(name="filterVerticalGridLineThickness", type="Number", format="Length")]
         *  Thickness of the filter vertical grid lines.
         *  @default 1
         *  @type {Number}
         *  @property filterVerticalGridLineThickness
         *
         */

        this.filterVerticalGridLineThickness = null;
        /**
         * [Style(name="filterDrawTopBorder", type="Boolean", inherit="no")]
         *  Flag that indicates whether to force the top border, when horizontal gridlines are not drawn
         *  @default false
         *  @type {Boolean}
         *  @property filterDrawTopBorder
         *
         */

        this.filterDrawTopBorder = null;
        /**
         * [Style(name="footerVerticalGridLines", type="Boolean", inherit="no")]
         *  Flag that indicates whether to show vertical grid lines between
         *  the columns.
         *  If <code>true</code>, shows vertical grid lines.
         *  If <code>false</code>, hides vertical grid lines.
         *  @default true
         *  @type {Boolean}
         *  @property footerVerticalGridLines
         *
         */

        this.footerVerticalGridLines = null;
        /**
         * [Style(name="footerHorizontalGridLines", type="Boolean", inherit="no")]
         *  Flag that indicates whether to show horizontal grid lines between
         *  the rows.
         *  If <code>true</code>, shows horizontal grid lines.
         *  If <code>false</code>, hides horizontal grid lines.
         *  @default false
         *  @type {Boolean}
         *  @property footerHorizontalGridLines
         *
         */

        this.footerHorizontalGridLines = null;
        /**
         * [Style(name="footerVerticalGridLineColor", type="uint", format="Color", inherit="yes")]
         *  The color of the vertical grid lines.
         *  @default 0x666666
         *  @type {uint}
         *  @property footerVerticalGridLineColor
         *
         */

        this.footerVerticalGridLineColor = null;
        /**
         * [Style(name="footerHorizontalGridLineColor", type="uint", format="Color", inherit="yes")]
         *  The color of the horizontal grid lines.
         *  @default null
         *  @type {uint}
         *  @property footerHorizontalGridLineColor
         */

        this.footerHorizontalGridLineColor = null;
        /**
         * [Style(name="footerHorizontalGridLineThickness", type="Number", format="Length")]
         *  Thickness of the footer horizontal grid lines.
         *  @default 1
         *  @type {Number}
         *  @property footerHorizontalGridLineThickness
         */

        this.footerHorizontalGridLineThickness = null;
        /**
         * [Style(name="footerVerticalGridLineThickness", type="Number", format="Length")]
         *  Thickness of the footer vertical grid lines.
         *  @default 1
         *  @type {Number}
         *  @property footerVerticalGridLineThickness
         */

        this.footerVerticalGridLineThickness = null;
        /**
         * [Style(name="footerDrawTopBorder", type="Boolean", inherit="no")]
         *  Flag that indicates whether to force the top border, when horizontal gridlines are not drawn
         *  @default false
         *  @type {Boolean}
         *  @property  footerDrawTopBorder
         *  @see http://www.reactdatagrid.com/demo/#/simple
         */

        this.footerDrawTopBorder = null;
        /**
         * [Style(name="pagerVerticalGridLines", type="Boolean", inherit="no")]
         *  Flag that indicates whether to show vertical grid lines between
         *  the columns.
         *  If <code>true</code>, shows vertical grid lines.
         *  If <code>false</code>, hides vertical grid lines.
         *  @default true
         *  @type {Boolean}
         *  @property pagerVerticalGridLines
         */

        this.pagerVerticalGridLines = null;
        /**
         * [Style(name="pagerHorizontalGridLines", type="Boolean", inherit="no")]
         *  Flag that indicates whether to show horizontal grid lines between
         *  the rows.
         *  If <code>true</code>, shows horizontal grid lines.
         *  If <code>false</code>, hides horizontal grid lines.
         *  @default false
         *  @type {Boolean}
         *  @property pagerHorizontalGridLines
         */

        this.pagerHorizontalGridLines = null;
        /**
         * [Style(name="pagerVerticalGridLineColor", type="uint", format="Color", inherit="yes")]
         *  The color of the vertical grid lines.
         *  @default 0x666666
         *  @type {uint}
         *  @property pagerVerticalGridLineColor
         */

        this.pagerVerticalGridLineColor = null;
        /**
         * [Style(name="pagerHorizontalGridLineColor", type="uint", format="Color", inherit="yes")]
         *  The color of the horizontal grid lines.
         *  @type {uint}
         *  @property pagerHorizontalGridLineColor
         */

        this.pagerHorizontalGridLineColor = null;
        /**
         * [Style(name="pagerHorizontalGridLineThickness", type="Number", format="Length")]
         *  Thickness of the pager horizontal grid lines.
         *  @default 1
         *  @type {Number}
         *  @property pagerHorizontalGridLineThickness
         */

        this.pagerHorizontalGridLineThickness = null;
        /**
         * [Style(name="pagerVerticalGridLineThickness", type="Number", format="Length")]
         *  Thickness of the pager vertical grid lines.
         *  @default 1
         *  @type {Number}
         *  @property pagerVerticalGridLineThickness
         */

        this.pagerVerticalGridLineThickness = null;
        /**
         * [Style(name="pagerDrawTopBorder", type="Boolean", inherit="no")]
         *  Flag that indicates whether to force the top border, when horizontal gridlines are not drawn
         *  @default false
         *  @type {Boolean}
         *  @property pagerDrawTopBorder
         */

        this.pagerDrawTopBorder = null;
        /**
         * [Style(name="rendererVerticalGridLines", type="Boolean", inherit="no")]
         *  Flag that indicates whether to show vertical grid lines between
         *  the columns.
         *  If <code>true</code>, shows vertical grid lines.
         *  If <code>false</code>, hides vertical grid lines.
         *  @default true
         *  @type {Boolean}
         *  @property rendererVerticalGridLines
         */

        this.rendererVerticalGridLines = null;
        /**
         * [Style(name="rendererHorizontalGridLines", type="Boolean", inherit="no")]
         *  Flag that indicates whether to show horizontal grid lines between
         *  the rows.
         *  If <code>true</code>, shows horizontal grid lines.
         *  If <code>false</code>, hides horizontal grid lines.
         *  @default false
         *  @type {Boolean}
         *  @property rendererHorizontalGridLines
         */

        this.rendererHorizontalGridLines = null;
        /**
         * [Style(name="rendererVerticalGridLineColor", type="uint", format="Color", inherit="yes")]
         *  The color of the vertical grid lines.
         *  @default 0x666666
         *  @type {uint}
         *  @property rendererVerticalGridLineColor
         */

        this.rendererVerticalGridLineColor = null;
        /**
         * [Style(name="rendererHorizontalGridLineColor", type="uint", format="Color", inherit="yes")]
         *  The color of the horizontal grid lines.
         *  @default null
         *  @type {uint}
         *  @property rendererHorizontalGridLineColor
         */

        this.rendererHorizontalGridLineColor = null;
        /**
         * [Style(name="rendererHorizontalGridLineThickness", type="Number", format="Length")]
         *  Thickness of the renderer horizontal grid lines.
         *  @default 1
         *  @type {Number}
         *  @property rendererHorizontalGridLineThickness
         */

        this.rendererHorizontalGridLineThickness = null;
        /**
         * [Style(name="rendererVerticalGridLineThickness", type="Number", format="Length")]
         *  Thickness of the renderer vertical grid lines.
         *  @default 1
         *  @type {Number}
         *  @property rendererVerticalGridLineThickness
         */

        this.rendererVerticalGridLineThickness = null;
        /**
         * [Style(name="rendererDrawTopBorder", type="Boolean", inherit="no")]
         *  Flag that indicates whether to force the top border, when horizontal gridlines are not drawn
         *  @default false
         *  @type {Boolean}
         *  @property rendererDrawTopBorder
         */

        this.rendererDrawTopBorder = null;
        /**
         * [Style(name="headerDrawTopBorder", type="Boolean", inherit="no")]
         *  Flag that indicates whether to force the top border, when horizontal gridlines are not drawn
         *  @default false
         *  @type {Boolean}
         *  @property headerDrawTopBorder
         */

        this.headerDrawTopBorder = null;
        /**
         * [Style(name="filterDrawTopBorder", type="Boolean", inherit="no")]
         *  Flag that indicates whether to force the top border, when horizontal gridlines are not drawn
         *  @default false
         *  @type {Boolean}
         *  @property filterDrawTopBorder
         */

        this.filterDrawTopBorder = null;
        /**
         * [Style(name="footerDrawTopBorder", type="Boolean", inherit="no")]
         *  Flag that indicates whether to force the top border, when horizontal gridlines are not drawn
         *  @default false
         *  @type {Boolean}
         *  @property footerDrawTopBorder
         *  @see http://www.reactdatagrid.com/demo/#/simple
         */

        this.footerDrawTopBorder = null;
        /**
         * [Style(name="pagerDrawTopBorder", type="Boolean", inherit="no")]
         *  Flag that indicates whether to force the top border, when horizontal gridlines are not drawn
         *  @default false
         *  @type {Boolean}
         *  @property pagerDrawTopBorder
         */

        this.pagerDrawTopBorder = null;
        /**
         * [Style(name="rendererDrawTopBorder", type="Boolean", inherit="no")]
         *  Flag that indicates whether to force the top border, when horizontal gridlines are not drawn
         *  @default false
         *  @type {Boolean}
         *  @property rendererDrawTopBorder
         */

        this.rendererDrawTopBorder = null;
        /**
         * [Style(name="selectionColor", type="uint", format="Color", inherit="yes")]
         *  The color of the background for the row when the user selects
         *  an item renderer in the row.
         *
         *  The default value for the Halo theme is <code>0x7FCEFF</code>.
         *  The default value for the Spark theme is <code>0xA8C6EE</code>.
         */

        this.selectionColor = null;

        /**
         * [Style(name="sortArrowSkin", type="Class", inherit="no")]
         *  The class to use as the skin for the arrow that indicates the column sort
         *  direction.
         *  The default value for the Halo theme is <code>mx.skins.halo.DataGridSortArrow</code>.
         *  The default value for the Spark theme is <code>mx.skins.spark.DataGridSortArrow</code>.
         */

        this.sortArrowSkin = null;

        /**
         * [Style(name="sortArrowSkin", type="Class", inherit="no")]
         *  The class to use as the skin for the checkbox that appears when you drag and drop a header cell to reposition the column, and you
         *  drop it on a header cell where you can actually complete the re-order operation
         *  The default value for the Halo theme is <code>mx.skins.halo.DataGridSortArrow</code>.
         *  The default value for the Spark theme is <code>mx.skins.spark.DataGridSortArrow</code>.
         */

        this.checkIconClass = null;


        /**
         * [Style(name="sortArrowSkin", type="Class", inherit="no")]
         *  The class to use as the skin for the checkbox that appears when you drag and drop a header cell to reposition the column, and you
         *  drop it on a header cell where you can NOT  complete the re-order operation
         *
         *  The default value for the Halo theme is <code>mx.skins.halo.DataGridSortArrow</code>.
         *  The default value for the Spark theme is <code>mx.skins.spark.DataGridSortArrow</code>.
         */

        this.crossIconClass = null;
        /**
         * [Style(name="paddingLeft", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 1
         *  @type {Number}
         *  @property paddingLeft
         */

        this.paddingLeft = null;
        /**
         * [Style(name="paddingRight", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 0
         *  @type {Number}
         *  @property paddingRight
         */

        this.paddingRight = null;
        /**
         * [Style(name="paddingTop", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property paddingTop
         */

        this.paddingTop = null;
        /**
         * [Style(name="paddingBottom", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property paddingBottom
         */

        this.paddingBottom = null;
        /**
         * [Style(name="headerPaddingLeft", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 1
         *  @type {Number}
         *  @property headerPaddingLeft
         */

        this.headerPaddingLeft = null;
        /**
         * [Style(name="headerPaddingRight", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 0
         *  @type {Number}
         *  @property headerPaddingRight
         */

        this.headerPaddingRight = null;
        /**
         * [Style(name="headerPaddingTop", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property headerPaddingTop
         */

        this.headerPaddingTop = null;
        /**
         * [Style(name="headerPaddingBottom", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property headerPaddingBottom
         */

        this.headerPaddingBottom = null;
        /**
         * [Style(name="columnGroupPaddingLeft", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 1
         *  @type {Number}
         *  @property columnGroupPaddingLeft
         */

        this.columnGroupPaddingLeft = null;
        /**
         * [Style(name="columnGroupPaddingRight", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 0
         *  @type {Number}
         *  @property columnGroupPaddingRight
         */

        this.columnGroupPaddingRight = null;
        /**
         * [Style(name="columnGroupPaddingTop", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property columnGroupPaddingTop
         */

        this.columnGroupPaddingTop = null;
        /**
         * [Style(name="columnGroupPaddingBottom", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property columnGroupPaddingBottom
         */

        this.columnGroupPaddingBottom = null;

        /**
         * [Style(name="footerPaddingLeft", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 1
         *  @type {Number}
         *  @property footerPaddingLeft
         */

        this.footerPaddingLeft = null;
        /**
         * [Style(name="footerPaddingRight", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 0
         *  @type {Number}
         *  @property footerPaddingRight
         */

        this.footerPaddingRight = null;
        /**
         * [Style(name="footerPaddingTop", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property footerPaddingTop
         */

        this.footerPaddingTop = null;
        /**
         * [Style(name="footerPaddingBottom", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property footerPaddingBottom
         */

        this.footerPaddingBottom = null;
        /**
         * [Style(name="filterPaddingLeft", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 1
         *  @type {Number}
         *  @property filterPaddingLeft
         */

        this.filterPaddingLeft = null;
        /**
         * [Style(name="filterPaddingRight", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 0
         *  @type {Number}
         *  @property filterPaddingRight
         */

        this.filterPaddingRight = null;
        /**
         * [Style(name="filterPaddingTop", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property filterPaddingTop
         */

        this.filterPaddingTop = null;
        /**
         * [Style(name="filterPaddingBottom", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property filterPaddingBottom
         */

        this.filterPaddingBottom = null;
        /**
         * [Style(name="pagerPaddingLeft", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 1
         *  @type {Number}
         *  @property pagerPaddingLeft
         */

        this.pagerPaddingLeft = null;
        /**
         * [Style(name="pagerPaddingRight", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 0
         *  @type {Number}
         *  @property pagerPaddingRight
         */

        this.pagerPaddingRight = null;
        /**
         * [Style(name="pagerPaddingTop", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property pagerPaddingTop
         */

        this.pagerPaddingTop = null;
        /**
         * [Style(name="pagerPaddingBottom", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property pagerPaddingBottom
         */

        this.pagerPaddingBottom = null;
        /**
         * [Style(name="rendererPaddingLeft", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 1
         *  @type {Number}
         *  @property rendererPaddingLeft
         */

        this.rendererPaddingLeft = null;
        /**
         * [Style(name="rendererPaddingRight", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 0
         *  @type {Number}
         *  @property rendererPaddingRight
         */

        this.rendererPaddingRight = null;
        /**
         * [Style(name="rendererPaddingTop", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's left border
         *  and the left edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property rendererPaddingTop
         */

        this.rendererPaddingTop = null;
        /**
         * [Style(name="rendererPaddingBottom", type="Number", format="Length", inherit="no")]
         *  Number of pixels between the control's right border
         *  and the right edge of its content area.
         *
         *  @default 2
         *  @type {Number}
         *  @property rendererPaddingBottom
         */

        this.rendererPaddingBottom = null;
        /**
         * [Style(name="alternatingItemColors", type="Array", arrayType="uint", format="Color", inherit="yes")]
         *  The colors to use for the backgrounds of the items in the grid.
         *  The value is an array of two or more colors.
         *  The backgrounds of the list items alternate among the colors in the array.
         *  @default undefined
         *  @type {Number}
         *  @property alternatingItemColors
         *  @see http://www.reactdatagrid.com/demo/#/rowspancolspan
         */

        this.alternatingItemColors = null;
        /**
         * [Style(name="alternatingTextColors", type="Array", arrayType="uint", format="Color", inherit="yes")]
         *  The colors to use for the text of the items in the grid.
         *  The value is an array of two colors.
         *  The text color of the list items alternate among the colors in the array.
         *  @default [ #000000, #000000]
         *  @type {Array}
         *  @property alternatingTextColors
         */

        this.alternatingTextColors = null;
        /**
         * [Style(name="editItemColor", type="Array", arrayType="uint", format="Color")]
         *  The colors to use for the backgrounds of the items in the grid in the editable mode.
         *  The value is an array two colors.
         *  @default undefined
         *  @type {Array}
         *  @property editItemColor
         */

        this.editItemColor = null;
        /**
         * [Style(name="editTextColor", format="Color")]
         *  The colors to use for the text of the items in the editable grid.
         *  @default null
         *  @type {null}
         *  @property editTextColor
         */

        this.editTextColor = null;

        /**
         * [Style(name="selectionDisabledColor", type="uint", format="Color", inherit="yes")]
         *  The color of the background of a renderer when the component is disabled.
         *  @default null
         *  @type {uint}
         *  @property selectionDisabledColor
         */

        this.selectionDisabledColor = null;
        /**
         * [Style(name="disclosureOpenIcon", type="Class", format="EmbeddedFile", inherit="no")]
         *  The icon that is displayed next to an open branch node of the navigation tree.
         *  The default value is <code>TreeDisclosureOpen</code> in the assets.swf file.
         *  @default null
         *  @type {Class}
         *  @property disclosureOpenIcon
         */

        this.disclosureOpenIcon = null;
        /**
         * [Style(name="disclosureClosedIcon", type="Class", format="EmbeddedFile", inherit="no")]
         *  The icon that is displayed next to a closed branch node of the navigation tree.
         *  The default value is <code>TreeDisclosureClosed</code> in the assets.swf file.
         *  @default null
         *  @type {Class}
         *  @property disclosureClosedIcon
         */

        this.disclosureClosedIcon = null;
        /**
         * [Style(name="columnGroupOpenIcon", type="Class", format="EmbeddedFile", inherit="no")]
         *  The icon that is displayed next to an open column group.
         *  The default value is <code>TreeDisclosureOpen</code> in the assets.swf file.
         *  @default null
         *  @type {Class}
         *  @property columnGroupOpenIcon
         */

        this.columnGroupOpenIcon = null;
        /**
         * [Style(name="columnGroupClosedIcon", type="Class", format="EmbeddedFile", inherit="no")]
         *  The icon that is displayed next to a closed column group.
         *
         *  The default value is <code>TreeDisclosureClosed</code> in the assets.swf file.
         *  @default null
         *  @type {Class}
         *  @property columnGroupClosedIcon
         */

        this.columnGroupClosedIcon = null;
        /**
         * [Style(name="rollOverColor", type="uint", format="Color", inherit="yes")]
         *  The color of the row background when the user rolls over the row.
         *
         *  The default value for the Halo theme is <code>0xB2E1FF</code>.
         *  The default value for the Spark theme is <code>0xCEDBEF</code>.
         *  @default null
         *  @type {uint}
         *  @property rollOverColor
         */

        this.rollOverColor = null;
        /**
         * [Style(name="activeCellColor", type="uint", format="Color", inherit="yes")]
         *  The color of the cell directly under the mouse or if using keyboard navigation, current keyboard seed.
         *  @default #000000
         *  @type {uint}
         *  @property activeCellColor
         */

        this.activeCellColor = null;
        /**
         * [Style(name="footerColors", type="Array", arrayType="uint", format="Color", inherit="yes")]
         *  An array of two colors used to draw the footer background gradient.
         *  The first color is the top color.
         *  The second color is the bottom color.
         *  @default [0xCFCFCF, 0xCCCCCC]
         *  @type {Array}
         *  @property footerColors
         *  @see http://www.reactdatagrid.com/demo/#/rowspancolspan
         */

        this.footerColors = null;
        /**
         * [Style(name="footerRollOverColors",  type="Array", arrayType="uint", format="Color", inherit="yes")]
         *  The color of the row background when the user rolls over the footer.
         *  The default value is [0xCCCCCC,0xCFCFCF]
         *  @type {Array}
         *  @property footerRollOverColors
         * @see http://www.reactdatagrid.com/demo/#/rowspancolspan
         */

        this.footerRollOverColors = null;
        /**
         * [Style(name="filterColors",  type="Array", arrayType="uint", format="Color", inherit="yes")]
         *  The color of the row background for the filter.
         *  The default value is [0xCFCFCF,0xCFCFCF]
         *  @type {Array}
         *  @property filterColors
         */

        this.filterColors = null;
        /**
         * [Style(name="filterRollOverColors",  type="Array", arrayType="uint", format="Color", inherit="yes")]
         *  The color of the row background when the user rolls over the filter.
         *  The default value is [0xCFCFCF,0xCFCFCF]
         *  @type {Array}
         *  @property filterRollOverColors
         *  @see http://www.reactdatagrid.com/demo/#/rowspancolspan
         */

        this.filterRollOverColors = null;
        /**
         * [Style(name="headerColors", type="Array", arrayType="uint", format="Color", inherit="yes")]
         *  An array of two colors used to draw the header background gradient.
         *  The first color is the top color.
         *  The second color is the bottom color.
         *  @default [0xFFFFFF, 0xE6E6E6]
         *  @type {Array}
         *  @property headerColors
         *  @see http://www.reactdatagrid.com/demo/#/rowspancolspan
         */

        this.headerColors = null;
        /**
         * [Style(name="headerRollOverColors",  type="Array", arrayType="uint", format="Color", inherit="yes")]
         *  The color of the row background when the user rolls over the header.
         *
         *  The default value is [0xE6E6E6,0xFFFFFF]
         *  @type {Array}
         *  @property headerRollOverColors
         *  @see http://www.reactdatagrid.com/demo/#/rowspancolspan
         */

        this.headerRollOverColors = null;
        /**
         * [Style(name="columnGroupColors", type="Array", arrayType="uint", format="Color", inherit="yes")]
         *  An array of two colors used to draw the Column Groups background gradient.
         *  The first color is the top color.
         *  The second color is the bottom color.
         *  @default [0xFFFFFF, 0xE6E6E6]
         *  @type {Array}
         *  @property columnGroupColors
         *  @see http://www.reactdatagrid.com/demo/#/rowspancolspan
         */

        this.columnGroupColors = null;
        /**
         * [Style(name="columnGroupRollOverColors",  type="Array", arrayType="uint", format="Color", inherit="yes")]
         *  The color of the row background when the user rolls over the Column Groups.
         *
         *  The default value is [0xE6E6E6,0xFFFFFF]
         *  @type {Array}
         *  @property columnGroupRollOverColors
         */

        this.columnGroupRollOverColors = null;
        /**
         * [Style(name="rendererColors", type="Array", arrayType="uint", format="Color", inherit="yes")]
         *  An array of two colors used to draw the renderer background gradient.
         *  The first color is the top color.
         *  The second color is the bottom color.
         *  @default [0xFFFFFF, 0xFFFFFF]
         *  @type {Array}
         *  @property rendererColors
         */

        this.rendererColors = null;
        /**
         * * [Style(name="rendererRollOverColors", type="uint", format="Color", inherit="yes")]
         *  The color of the row background when the user rolls over a level renderer.
         *  The default value is [0xFFFFFF,0xFFFFFF]
         *  @type {uint}
         *  @property rendererRollOverColors
         */

        this.rendererRollOverColors = null;
        /**
         * [Style(name="pagerColors", type="Array", arrayType="uint", format="Color", inherit="yes")]
         *  An array of two colors used to draw the pager background gradient.
         *  The first color is the top color.
         *  The second color is the bottom color.
         *  @default [0xCCCCCC, 0xCCCCCC]
         *  @type {Array}
         *  @property pagerColors
         */

        this.pagerColors = null;
        /**
         * [Style(name="pagerRollOverColors",type="Array", arrayType="uint", format="Color", inherit="yes")]
         *  The color of the row background when the user rolls over the pager.
         *  The default value is [0xE6E6E6,0xFFFFFF]
         *  @type {Array}
         *  @property pagerRollOverColors
         */

        this.pagerRollOverColors = null;
        /**
         * [Style(name="textSelectedColor", type="uint", format="Color", inherit="yes")]
         *  Color of the text when the user selects a row.
         *  @default 0x000000
         *  @type {uint}
         *  @property textSelectedColor
         */

        this.textSelectedColor = null;
        /**
         * [Style(name="textRollOverColor", type="uint", format="Color", inherit="yes")]
         *  Color of the text when the user rolls over a row.
         *
         *  @default 0x000000
         *  @type {uint}
         *  @property textRollOverColor
         */

        this.textRollOverColor = null;
        /**
         * [Style(name="textDisabledColor", type="uint", format="Color", inherit="yes")]
         *  The color of the text of a renderer when the component is disabled.
         *  @default 0xDDDDDD
         *  @type {uint}
         *  @property textDisabledColor
         */

        this.textDisabledColor = null;

        /**
         * [Style(name="lockedSeperatorThickness", type="Number", inherit="yes")]
         *  The width of the vertical seperators for the locked content.
         * @default 1
         *  @type {Number}
         *  @property lockedSeperatorThickness
         *  @see http://www.reactdatagrid.com/demo/#/selectionui2
         */

        this.lockedSeperatorThickness = null;
        /**
         * [Style(name="lockedSeperatorColor", type="uint", format="Color", inherit="yes")]
         *  The color of the vertical seperators for the locked content.
         * @default #000000
         *  @type {uint}
         *  @property lockedSeperatorColor
         *  @see http://www.reactdatagrid.com/demo/#/rowspancolspan
         */

        this.lockedSeperatorColor = null;
        /**
         * [Style(name="errorBackgroundColor", type="uint", format="Color", inherit="yes")]
         * The background color of the row that has the error .
         * @default #FCDCDF
         *  @type {uint}
         *  @property errorBackgroundColor
         */

        this.errorBackgroundColor = null;
        /**
         * [Style(name="errorBorderColor", type="uint", format="Color", inherit="yes")]
         * The border color of the cell that has the error .
         * @default #F23E2C
         *  @type {uint}
         *  @property errorBorderColor
         */

        this.errorBorderColor = null;
        /**
         * [Style(name="dragAlpha", type="Number")]
         *  Alpha for the drag operation.
         *  @default 0.8
         *  @type {Number}
         *  @property dragAlpha
         */

        this.dragAlpha = null;
        /**
         * [Style(name="dragRowBorderStyle", type="String")]
         *  Border for the drag row for the drag operation.
         *  @default 0.8
         *  @type {String}
         *  @property dragRowBorderStyle
         */

        this.dragRowBorderStyle = null;

        /**
         * [Style(name="fixedColumnFillColors", type="Array", arrayType="uint", format="Color", inherit="yes")]
         * A box to cover the space left behind by the horizontal scrollbar when horizontalScrollPolicy=on and there are left locked columns
         *  @default null
         *  @type {Array}
         *  @property fixedColumnFillColors
         */

        this.fixedColumnFillColors = null;

        /**
         * [Style(name="columnMoveResizeSeparatorColor", format="Color")]
         * The color of the line to draw when the user is moving or resizing the column
         *  @default null
         *  @type {null}
         *  @property columnMoveResizeSeparatorColor
         */

        this.columnMoveResizeSeparatorColor = null;
        /**
         * [Style(name="headerSortSeparatorColor", format="Color")]
         * The color of the line between header and the sort section for multi column sort
         *  @default null
         *  @type {null}
         *  @property headerSortSeparatorColor
         */

        this.headerSortSeparatorColor = null;
        /**
         * [Style(name="headerSortSeparatorRight", format="int")]
         * The distance between the sort line and the right edge of the header cell
         *  @default null
         *  @type {null}
         *  @property headerSortSeparatorRight
         */

        this.headerSortSeparatorRight = null;
        /**
         * [Style(name="columnMoveAlpha")]
         * The alpha to apply to the glyph when moving the column.
         * @deprecated    Starting in 2.9 we no longer draw a glyph, we simply draw a line. This is to add support
         * for dropping column on both sides of the target cell.
         *  @default null
         *  @type {null}
         *  @property columnMoveAlpha
         */

        this.columnMoveAlpha = null;


        /**
         * A Class that holds cells that are not being rendered, but ones that
         * we can reuse when we rebuild.
         * @type {flexiciousNmsp.RendererCache}
         */
        this.rendererCache = new flexiciousNmsp.RendererCache(this);



        /**
         * This is a property that gets called to determine if a expand/collapse icon needs to be drawn.
         * If this is null, or returns true, then the expand collapse icon is drawn on basis of whether or not
         * there are children. This is useful when you have a nextLevelRenderer defined, but do not want to show
         * it if you dont have children. It should take an object (the row data)  and a cell parameter.
         * @type {Function}
         * @property hasChildrenFunction
         * @example todo
         */
        this.hasChildrenFunction = null;


        /**
         * This is a fimctopm that gets called when the cell is placed. It will get a parameter which is the cell being placed. It will be placed at its default position.
         * @type {Function}
         * @property cellPlacementFunction
         *  @see http://www.reactdatagrid.com/demo/#/grouped2
         * @example 
         *   cellPlaced(cell) {
         *       if (cell.implementsOrExtends('FlexDataGridDataCell') && cell.getColumn().enableHierarchicalNestIndent
         *       && cell.getLevel().nextLevel) {
         *       cell.move(0, cell.getY());
         *       cell.setActualSize(cell.parent.getWidth(), cell.getHeight());
         *       cell.setStyleAttribute("zIndex", 9);
         *       }
         *   }
         */
        this.cellPlacementFunction = null;

        /**
         * @type {Function}
         * @property sortIconPlacementFunction
         * @default null
         */
        this.sortIconPlacementFunction = null;


        /**
         * The behavior responsible for adding responsiveness to the grid
         * @type {flexiciousNmsp.ResponsiveBehavior}
         * @property responsiveBehavior
         * @default ResponsiveBehavior
         */
        this.responsiveBehavior = flexiciousNmsp.ResponsiveBehavior ? new flexiciousNmsp.ResponsiveBehavior(this) : null;

        /**
         * In server mode, if the user selects all and hits page change, this flag will control if the next page of newly
         * loaded records is automatically selected.
         * @type Boolean
         * @property enableSelectAllOnPageChange
         * @default true
         *  @see http://www.reactdatagrid.com/demo/#/fulllazyload
         */
        this.enableSelectAllOnPageChange = true;
        /**
         * In server mode, if this flag is set to true and the user hits select all on a particular page, the grid will maintain the selections made on previous pages.
         * If this flag is set to false, (default) selections on othere pages will be cleared.
         * @type Boolean
         * @property enableMaintainSelectionOnSelectAll
         * @default false
         * @see http://www.reactdatagrid.com/demo/#/fulllazyload
         */
        this.enableMaintainSelectionOnSelectAll = false;

        /**
         * @type Boolean
         * @property enableControlClickMultiSort
         * @default false
         */
        this.enableControlClickMultiSort = false;

        /**
         * when enableHideBuiltInContextMenuItems=true, hide browser built comtext menu items
         * @type Boolean
         * @property enableHideBuiltInContextMenuItems
         * @default false
         */
        this.enableHideBuiltInContextMenuItems = false;

        /**
        * A flag used to show reduced item list in ComboBox as per filtered items. 
        * @type Boolean
        * @property filterComboBoxDataProviderEnableReduce
        * @default false
        */
        this.filterComboBoxDataProviderEnableReduce = false;
       
        this.forceZeroPadding=false;

        this.useRendererCache = true;

        this._treeDataGridContainer = this.createBodyContainer();
        this._treeDataGridHeader = this.createChromeContainer();
        this._treeDataGridFooter = this.createChromeContainer();
        this._treeDataGridPager = this.createChromeContainer();
        this._treeDataGridFilter = this.createChromeContainer();
        this._treeDataGridFilter.enableHorizontalRecycling = false;
        this.enableHorizontalScrollOptimizationsBETA = false;
        /**
         * To watch if our size changed and react accordingly
         * @type {flexiciousNmsp.Timer}
         */
        this.resizeTimer = null;
        /**
         * When used in conjunction with any third party library (like angular js)
         * YOu may want to point this variable to the controller. This way any
         * function names you have will point to the delegate.
         */
        this.delegate = null;

        if (options && options.delegate) {
            this.delegate = options.delegate;
        }

        /**
         * Flag To watch if our size changed and react accordingly
         * @type {Boolean}
         */
        this.enableResizeTimer = true;

        this._globalFilterString = "";

        this._globalFilterOrHighLightDirty = false;

        this._globalFilterColumns = [];

        this._globalHightlightAll = true;

        this._globalHightlightString = null;

        this._globalHighlightColumns = [];
        this.matchedObjects = [];

        this._currentMatch = null;
        this.highlightedCellInfo = null;


        this.getFilterContainer().chromeType = flexiciousNmsp.RowPositionInfo.ROW_TYPE_FILTER;
        this.getPagerContainer().chromeType = flexiciousNmsp.RowPositionInfo.ROW_TYPE_PAGER;
        this.getFooterContainer().chromeType = flexiciousNmsp.RowPositionInfo.ROW_TYPE_FOOTER;

        this._leftLockedHeader = this.createLockedContent();
        this._leftLockedFooter = this.createLockedContent();
        this._leftLockedContent = this.createElasticContainer();
        this._leftLockedContent.boundContainer = this.getBodyContainer();
        this._rightLockedHeader = this.createLockedContent();
        this._rightLockedFooter = this.createLockedContent();
        this._rightLockedContent = this.createElasticContainer();
        this._rightLockedContent.boundContainer = this.getBodyContainer();




        this.setHorizontalScrollPolicy(Constants.SCROLL_POLICY_AUTO);



        for (var prop in flexiciousNmsp.StyleDefaults.defaults) {
            this.checkSetterAndApply(this, prop, flexiciousNmsp.StyleDefaults.defaults[prop]);
        }

        if (options && options.configuration) {
            this.buildFromXml(options.configuration);
        }

        if (options && options.dataProvider) {
            this.setDataProvider(options.dataProvider);
        }

        if (options && options.styles) {
            for (var prop in options.styles) {
                UIUtils.checkSetterAndApply(this, prop, options.styles[prop]);
            }
        }

        this.addEventListener(this, Constants.EVENT_CREATION_COMPLETE, this.onCreationComplete);
        this.addEventListener(this, Constants.EVENT_MOUSE_OUT, this.onGridMouseOut);
        this.addEventListener(this, Constants.EVENT_DOUBLE_CLICK, this.onDoubleClick);
        this._leftLockedContent.addEventListener(this, Constants.EVENT_MOUSE_WHEEL, this.onMouseWheel);
        this._rightLockedContent.addEventListener(this, Constants.EVENT_MOUSE_WHEEL, this.onMouseWheel);
        this.addEventListener(this, flexiciousNmsp.FlexDataGridEvent.ITEM_RIGHT_CLICK, this.onGridRightClick);
        this.addEventListener(this, Constants.EVENT_RESIZE, this.onGridResized);
        this.addEventListener(this, Constants.EVENT_CLICK, this.onGridMouseClick);
        if (props) {

            this.initFromProps(props);
            if (!props.hasOwnProperty("width")) {
                this.setWidth(800);
            }
            if (!props.hasOwnProperty("height")) {
                this.setHeight(600);
            }
        }
        
    }
    checkScrollEnabled(evt) {
        if(this.scrollEnabledFunction){
            this.scrollEnabledFunction(evt);
        }
    }
    componentDidMount() {
        super.componentDidMount();
        this.addEventListener(this, Constants.EVENT_KEY_DOWN, this.keyDownHandler); 
        const that = this;
        this.domElement.tabIndex = 0;

        if (this._percentHeightPending) {
            this.domElement.style.height = this._percentHeightPending;
            this._percentHeightPending = "";
        }
        if (this._percentWidthPending) {
            this.domElement.style.width = this._percentWidthPending;
            this._percentWidthPending = "";
        }
        if (this.enableEagerDraw) {
            this.rebuild();
            this.validateNow();
        }



    }
    getClassNames() {
        return ["FlexDataGrid", "NdgBase", "UIComponent", "IExtendedFlexDataGrid", " ISpinnerOwner"
            , "IFocusManagerComponent", "IExtendedDataGrid"];
    }

    /**
     * Method to create an instance of the FlexDataGridBodyContainer class.
     * In case you need to implement custom logic by extending the FlexDataGridBodyContainer you will need to override this method.
     * Creates an instance of FlexDataGridVirtualBodyContainer if enableVirtualScroll, else creates FlexDataGridBodyContainer
     * @method createBodyContainer
     */
    createBodyContainer() {

        return new flexiciousNmsp.FlexDataGridVirtualBodyContainer(this);

    }

    /**
     * Method to create an instance of the FlexDataGridHeaderContainer class.
     * In case you need to implement custom logic by extending the FlexDataGridHeaderContainer you will need to override this method.
     * @method createChromeContainer
     */
    createChromeContainer() {

        return new flexiciousNmsp.FlexDataGridHeaderContainer(this);

    }

    /**
     * The container for the filter cells. This is an instance of the FlexDataGridHeaderContainer class.
     * This class manages cell initialization, recycling, mouse events on each cell, etc. The rows collection
     * of this object will aways contain a single RowInfo object, which has a cells collection. This will
     * be a series of ComponentInfo objects, which has a component property that will be an instance of FlexDataGridFilterCell
     * Although the parent property of each of the cells could be either the
     * leftLockedHeader, rightLockedHeader or the this.getFilterContainer(), the rowInfo is the same, so the cells will
     * include left, right, and unlocked cells.
     * @method getFilterContainer
     */
    getFilterContainer() {
        return this._treeDataGridFilter;
    }

    /**
     * Method to create an instance of the LockedContent class.
     * In case you need to implement custom logic by extending the LockedContent you will need to override this method.
     * The Left Locked Header, Left Locked Footer,Right Locked Header, and Right Locked Footer are all instance of LockedContent
     * @method createLockedContent
     */
    createLockedContent() {

        return new flexiciousNmsp.LockedContent(this);

    }

    /**
     * Method to create an instance of the ElasticContainer class.
     * In case you need to implement custom logic by extending the ElasticContainer you will need to override this method.
     * The Left Locked Content, and Right Locked Content are instances of ElasticContainer
     * @method createElasticContainer
     */
    createElasticContainer() {

        return new flexiciousNmsp.ElasticContainer(this);

    }

    /**
     * Transfers mouse wheel events over the locked left and right sections to scroll events on the body container,
     * so we scroll when the user mouse wheels over the left or right locked containers.
     * @method onMouseWheel
     * @param event
     */
    onMouseWheel(event) {

        var e = event.triggerEvent;
        if (e.preventDefault)
            e.preventDefault();
        //e.returnValue = false; 


        const scrollEvent = new flexiciousNmsp.FlexDataGridEvent(Constants.EVENT_SCROLL);
        let scrollpos = this.getVerticalScrollPosition();
        scrollpos += event.wheelDelta;
        if (scrollpos > this.getBodyContainer().getMaxVerticalScrollPosition() + this.getRowHeight()) {
            scrollpos = this.getBodyContainer().getMaxVerticalScrollPosition() + this.getRowHeight();
        } else if (scrollpos < 0) {
            scrollpos = 0;
        }
        scrollEvent.scrollTop = scrollpos;
        scrollEvent.type = event.type;
        this.getBodyContainer().setVerticalScrollPosition(scrollpos);
        this.onContainerScroll(scrollEvent);
    }

    /**
     *
     * @method concatenatePersistenceValues
     */
    concatenatePersistenceValues() {
        return [Constants.PERSIST_COLUMN_ORDER, Constants.PERSIST_COLUMN_VISIBILITY,
        Constants.PERSIST_COLUMN_WIDTH, Constants.PERSIST_FILTER, Constants.PERSIST_SORT,
        Constants.PERSIST_VERTICAL_SCROLL,
        Constants.PERSIST_HORIZONTAL_SCROLL,
        Constants.PERSIST_FOOTER_FILTER_VISIBILITY, Constants.PERSIST_PAGE_SIZE,
        Constants.PERSIST_PRINT_SETTINGS].join(",")
    }

    /**
     *
     *  Measures the DataGrid based on its contents,
     *  summing the total of the visible column widths.
     * @method measure
     */
    measure() {

        //if there is height and width specified, we call measure to see what we should size ourself
        const n = this.getColumns().length;
        if (n == 0) {
            this.measuredHeight = this.getHeaderSectionHeight() + (this.defaultRowCount * this.getRowHeight()) + this.getFooterRowHeight();
            this.measuredMinHeight = this.measuredHeight;
            this.measuredWidth = flexiciousNmsp.NdgBase.DEFAULT_MEASURED_WIDTH;
            this.measuredMinWidth = flexiciousNmsp.NdgBase.DEFAULT_MEASURED_MIN_WIDTH;
            return;
        }

        let columnWidths = 0;
        let columnMinWidths = 0;
        for (let i = 0; i < n; i++) {
            if (this.getColumns()[i].getVisible()) {
                columnWidths += 100;
                columnMinWidths += this.getColumns()[i].minWidth;
            }
        }

        this.measuredWidth = Math.max(Math.min(this.getWidth() ? this.getWidth() : 1000, columnWidths), 200);

        this.measuredHeight = this.getHeaderSectionHeight() + (this.defaultRowCount * this.getRowHeight()) + this.getFooterRowHeight();
        this.measuredMinHeight = this.measuredHeight;
    }
    componentWillReceiveProps(nextProps) {
        if (!this._dataProvider)
            this.initFromProps(nextProps);
        if (nextProps.dataProvider != this._dataProvider) {
            if (nextProps.dataProvider) {
                this.setDataProvider(nextProps.dataProvider);
            }
        }
    }

    /**
     * Initializes the auto complete and watermark plugins
     * @method initialize
     */
    initialize() {
        //        if(this.enableFillerRows){
        //            var canvas2DSupported = !!window.CanvasRenderingContext2D;
        //            if(!canvas2DSupported){
        //                this.enableFillerRows=false;//filler rows need canvas.
        //            }
        //        }

        flexiciousNmsp.NdgBase.prototype.initialize.apply(this);

    }

    /**
     *
     * @method updateDisplayList
     */
    updateDisplayList(unscaledWidth, unscaledHeight) {
        if (this.commitProperties) {
            this.commitProperties();
        }
        this.traceEvent("update display list");
        if (this.enableDynamicLevels && this.getColumnLevel().nextLevel == null) {
            this.ensureLevelsCreated();
            this.dispatchEvent(new flexiciousNmsp.FlexDataGridEvent(flexiciousNmsp.FlexDataGridEvent.DYNAMIC_ALL_LEVELS_CREATED, this,
                this.getColumnLevel()));
        }
        super.updateDisplayList(unscaledWidth, unscaledHeight);
        if (this.enableLockedSectionSeparators) {
            if (this.lockedSectionSeparatorDrawFunction == null || this.lockedSectionSeparatorDrawFunction()) {
                this.drawDefaultSeparators();
            }
        }
        this.inUpdate = true;
        if (this._filterDirty && this.getHeight() > 0) {
            this.processFilter();
            this._filterDirty = false;

        }
        let placed = false;
        if (this._structureDirty && this.getHeight() > 0 && parent != null) {
            if (!this.getForceColumnsToFitVisibleArea()) {
                this.setHorizontalScrollPosition(0);
                this.getBodyContainer().setVerticalScrollPosition(0);
            }
            if (this.enableSelectionBasedOnSelectedField) {
                this.setSelectedItemsBasedOnSelectedField(undefined, undefined);
            }

            this.getBodyContainer().invalidateCalculatedHeight();
            this.placed = true;
            this.createComponents();
            if (!this.getForceColumnsToFitVisibleArea()) {
                this.recycleH(true);
            }
            this._structureDirty = false;
            this._placementDirty = false;
        }
        if (this._placementDirty && this.getHeight() > 0 && this._componentsCreated) {
            placed = true;
            this.createComponents();
            if (!this.getForceColumnsToFitVisibleArea()) {
                this.recycleH(true);
            }
            this._placementDirty = false;
            this._snapDirty = false;
        }

        if (this._selectionInvalid) {
            this.invalidateCells();
            this.refreshCheckBoxes();
            this._selectionInvalid = false;
        }
        if (this._heightIncreased || this._widthIncreased) {

            if (this.getEnableFilters()) {
                for (const row of this.getFilterContainer().rows) {
                    for (const cell of row.cells) {
                        const fdg = cell.component;
                        if (fdg.getRenderer() != null && fdg.getRenderer().typeName == "MultiSelectComboBox" && fdg.getRenderer().popup) {
                            fdg.getRenderer().destroyPopup();
                        }
                    }
                }
            }


            if (this.variableRowHeight) {
                this.placeSections();
                this.redrawBody();
                
                this.getBodyContainer().recycle(this.getColumnLevel(), true);
            }
            else {
                this.placeSections();
                this.getBodyContainer().recycle(this.getColumnLevel(), true);
            }
            if (!this.getForceColumnsToFitVisibleArea())
                this.recycleH(true)
            this._heightIncreased = false;
            this._widthIncreased = false;
            this._placementDirty=false;
        }
        if (this._snapDirty) {
            this._snapDirty = false;
            this.snapToColumnWidths();
        }
        if (this._needHorizontalRecycle) {
            this._needHorizontalRecycle = false;
            this.recycleH(true);
        }
        if (this._changePending) {
            this._changePending = false;
            const evt = new flexiciousNmsp.FlexDataGridEvent(flexiciousNmsp.FlexDataGridEvent.CHANGE, this);
            this.dispatchEvent(evt);
        }
        if (this._fillerInvalidated) {
            this._fillerInvalidated = false;
            if(!this.getBodyContainer().verticalSpill)
            this.drawFiller();
        }

        const that = this;
        setTimeout(() => {
            that.placeBottomBar()
        }, 100);
        super.updateDisplayList(unscaledWidth, unscaledHeight)
        this.traceEvent("end display list");
        this.inUpdate = false;

    }

    /*
     * @method invalidateDisplayList
     */
    invalidateDisplayList() {
        if (!this.inUpdate)
            super.invalidateDisplayList();

    }

    /**
     * Called when you scroll and expand collapse. When you do this, previously drawn rows
     * may have been drawn with a different horizontal scroll position. So the cells that are
     * currently in view may not have been drawn. This method will ensure that a pass at the
     * horizontal recycle runs at the next update and we render the correct cells.
     * @method
     */
    invalidateHorizontalScroll() {

        this._needHorizontalRecycle = true;
        this.invalidateDisplayList();


    }

    /**
     * When you have left or right locked sections, the scroll bar only covers the area occupied by the body container,
     * or the unlocked columns section. So we do not show a blank whitespace in the area of the scroll bar in the locked
     * sections, we place two sprites there, and this method is responsible for drawing and positioning these sprites.
     * @method placeBottomBar
     */
    placeBottomBar() {
        if (!this.domElement) return;
        if (this.getHorizontalScrollBar()) {
            this.bottomBarLeft.attachClass("bottomBar");
            this.bottomBarRight.attachClass("bottomBar");
            this.bottomBarLeft.setAttribute("id", "bottomBar");
            const borderThickness = this.getStyle("borderThickness");
            this.bottomBarLeft.setHeight(this.getHorizontalScrollBar().getHeight());
            this.bottomBarRight.setHeight(this.getHorizontalScrollBar().getHeight());
            const y = this.getBodyContainer().getY() + this.getBodyContainer().getHeight() - this.getHorizontalScrollBar().getHeight();
            this.bottomBarLeft.setY(y);
            this.bottomBarRight.setY(y);
            this.bottomBarLeft.setWidth(this.getLeftLockedContent().getWidth() - this.getStyle("lockedSeperatorThickness") + 1);
            this.bottomBarLeft.setX(this.getLeftLockedContent().getX());

            this.bottomBarRight.setWidth(this.getRightLockedContent().getWidth() - (this.getRightLockedContent().getWidth() == 0 ? 3 : this.getStyle("lockedSeperatorThickness")));
            this.bottomBarRight.setX(this.getRightLockedContent().getX() + (this.getRightLockedContent().getWidth() > 0 ? this.getStyle("lockedSeperatorThickness") : 0));

            UIUtils.gradientFill(this.bottomBarRight, this.getStyle("fixedColumnFillColors"));

            UIUtils.gradientFill(this.bottomBarLeft, this.getStyle("fixedColumnFillColors"));
            if (this.getRightLockedContent().getWidth() == 0) {
                UIUtils.gradientFill(this.bottomBarRight, []);
            }
        } else {
            UIUtils.gradientFill(this.bottomBarRight, []);
            UIUtils.gradientFill(this.bottomBarLeft, []);
        }

    }

    /**
     * When enableDynamicLevels=true and there is only one level,
     * we iterate through the data provider and ensure that the maximum depth
     * has been accounted for.
     * @method ensureLevelsCreated
     *
     */
    ensureLevelsCreated(item, level) {
        if (typeof item == "undefined") item = null;
        if (typeof level == "undefined") level = null;

        if (item == null) item = this.getRootFlat();
        if (level == null) level = this.getColumnLevel();

        for (const child of item) {
            const children = this.getChildren(child, level);
            let childLength = this.getLength(children);
            if (level.childrenCountField && child.hasOwnProperty(level.childrenCountField)) {
                childLength = UIUtils.resolveExpression(child, level.childrenCountField);
            }
            if (level.nextLevel == null && childLength > 0) {
                level.nextLevel = this.getColumnLevel().clone(false);
                level.nextLevel.reusePreviousLevelColumns = true;
                this.getColumnLevel().initializeLevel(this);
                this.dispatchEvent(new flexiciousNmsp.FlexDataGridEvent(flexiciousNmsp.FlexDataGridEvent.DYNAMIC_LEVEL_CREATED, this, level.nextLevel));
                this.reDraw();
            }
            this.ensureLevelsCreated(children, level.nextLevel);
        }
    }

    /**
     *
     * @param event
     * @method onCreationComplete
     */
    onCreationComplete(event) {

        if (this.enablePreferencePersistence && !this._preferencesLoaded && this.autoLoadPreferences) {
            this._preferencesLoaded = true;
            this.loadPreferences();
        }

    }

    /**
     * In this method, we trap all double click events, walk up the target tree until we hit
     * a IFlexDataGridDataCell object, and if we indeed double clicked a data cell, we dispatch and ITEM_DOUBLE_CLICK event.
     * @method onDoubleClick
     */
    onDoubleClick(event) {
        if (this.doubleClickEnabled) {
            const cell = this.currentCell;
            if (!cell) return;
            const evt = new flexiciousNmsp.FlexDataGridEvent(flexiciousNmsp.FlexDataGridEvent.
                ITEM_DOUBLE_CLICK, this, cell.level, cell.getColumn(),
                cell, cell.rowInfo ? cell.rowInfo.getData() : null, event);
            cell.level.dispatchEvent(evt);
        }
    }

    /**
     * Support for key board interaction.
     * <br/>
     * First, if allowInteractivity or enableKeyboardNavigation flags are not set, then we do not handle any keyboard interaction.
     * <br/>
     * If the body container is in edit mode, keyboard interaction that is handled is limited to the TAB and Enter keys, which will end the
     * edit session and move on to the next cell or row on basis of which key has been selected.
     * <br/>
     * If we are in any of the filter control, the TAB and SHIFT TAB keys will move between the filter controls. Once you focus on a filter control,
     * all keyboard interaction except TAB, SHIFT TAB and Arrow Keys is handled by the Filter Control in question. These are all Flex SDK controls, and you should
     * refer to the the documentation of the SDK control for more information about its keyboard interaction. Arrow keys will move focus out of the filter control
     * and highlight the next cell (for down arrow) or the header (for up arrow) on basis of what the displayOrder property of the grid specifies.
     * <br/>
     * For TextInput Filter control where filterTriggerEvent=enterKeyUp, hitting the enter key will cause the filter to run.
     * <br/>
     * For the most part, the Flexicious Ultimate grid's keyboard interactions are similar to the SDK datagrid, with one important difference.
     * We have a concept of an active cell, which is the cell that is currently active either via a mouseover gesture, or via a arrow key navigation gesture.
     * You can style this color of the active cell via the activeCellColor style. You can completely disable the active cell tracking by setting enableActiveCellHighlight
     * to false.
     *
     * When the grid is not in edit mode, and focus is not on the filter but on a specific grid cell, the following keyboard interactions are available:
     * <ul>
     * <li>Keyboard.UP  : Navigates to the cell and row above the currently highlighted cell. The active cell is highligted via the activeCellColor style, and the active row is highligted via the rollover color style</li>
     * <li>Keyboard.DOWN  : Navigates to the cell and row below the currently highlighted cell</li>
     * <li>Keyboard.LEFT  : Navigates to the cell to the left the currently highlighted cell</li>
     * <li>Keyboard.RIGHT : Navigates to the cell to the right the currently highlighted cell</li>
     * <li>Keyboard.TAB : Relinquishes focus from the grid and moves on to the next focussable control in the display tree</li>
     * <li>Keyboard.PAGE_DOWN: Moves the scroll bar down by the height of the grid and highlights the newly visible first row</li>
     * <li>Keyboard.PAGE_UP: Moves the scroll bar up by the height of the grid and highlights the newly visible first row</li>
     * <li>Keyboard.HOME: Moves the scroll to the top (i.e.) the first record of the grid and highlights the newly visible first row</li>
     * <li>Keyboard.END: Moves the scroll to the end (i.e.) the last record of the grid and highlights the newly visible first row</li>
     * <li>Keyboard.F2: </li>
     * <li>Keyboard.NUMPAD_MULTIPLY OR CTRL + SHIFT + DOWN : If the current row can be expanded, expands it, AND all of its children. (Shows child records)</li>
     * <li>Keyboard.NUMPAD_DIVIDE OR CTRL + SHIFT + UP : If the current row can be collapsed, collapses it. (Hides child records)</li>
     * <li>Keyboard.NUMPAD_ADD OR CTRL + SHIFT + RIGHT : If the current row can be expanded, expands it. (Shows child records)</li>
     * <li>Keyboard.NUMPAD_SUBSTRACT OR CTRL + SHIFT + LEFT : If the current row can be collapsed, collapses it. (Hides child records)</li>
     * <li>Keyboard.SPACE: Performs the equivalent of a click on the active cell</li>
     * </ul>
     *
     * @method keyDownHandler
     */
    keyDownHandler(event) {

        if (event.ctrlKey && event.shiftKey) return;//textbox selection

        const target = event.triggerEvent.target;
        if ((event.keyCode == Constants.KEYBOARD_LEFT || event.keyCode == Constants.KEYBOARD_RIGHT || event.keyCode == Constants.KEYBOARD_TAB)
            && target && (this.getFilterContainer().owns(target))) {
            //we do not want to handle arrow keys from the filter container
            return;
        }
        if (this.keyboardListenersPaused) return;
        if (event.isDefaultPrevented()) return;
        if (!this.allowInteractivity) return;
        if (!this.enableKeyboardNavigation) return;
        if (this.getBodyContainer()._inEdit) return;


        let nextCell;
        if (this.getIsRowSelectionMode() || this.getIsCellSelectionMode()) {
            if (!this.currentCell)
                this.getBodyContainer().setCurrentCellToFirst();
            if (this.currentCell)
                this.getContainerForCell(this.currentCell).handleCellKeyUp(this.currentCell, event.keyCode, event);
        }
        //        if ((event.keyCode == Constants.KEYBOARD_LEFT || event.keyCode == Constants.KEYBOARD_RIGHT || event.keyCode == Constants.KEYBOARD_TAB)
        //            || event.keyCode == Constants.KEYBOARD_UP|| event.keyCode == Constants.KEYBOARD_DOWN) {
        //            //we do not want to handle arrow keys from the filter container
        //            var that =this;
        //            this.allowInteractivity=false;
        //            window.setTimeout(function(){that.allowInteractivity=true;}, 100);
        //        }

    }

    /**
     *
     * Not used, because it is handled by the grid itself.
     * @method keyUpOrDown
     */
    keyUpOrDown(keyCode) {
    }

    /**
     *
     * @method onGridMouseOut
     */
    onGridMouseOut(event) {

        //this.getBodyContainer().gridMouseOut();

    }

    /**
     *
     * @method onGridRightClick
     */
    onGridRightClick(event) {
        if(this.popupFactoryContextMenuPopup) {
            const popup = this.popupFactoryContextMenuPopup.newInstance();

            popup.addEventListener(this, Constants.EVENT_CLOSE, this.onContextMenuClosed);

            popup.setGrid(this); 
            popup.showDialog();

            let pt = new flexiciousNmsp.Point(event.triggerEvent.triggerEvent.clientX, event.triggerEvent.triggerEvent.clientY);
            pt = this.globalToLocal(pt);
            popup.move(pt.x, pt.y);
        }
    }

    onContextMenuClosed(event) {
        switch(event.detail) {
            case Constants.COPY_CELL:
            this.onCellContextMenuItemClick(event);
            break;
            case Constants.COPY_ROW:
            this.onRowContextMenuItemClick(event);
            break;
            case Constants.COPY_TABLE:
            this.onTableContextMenuItemClick(event);
            break;
            case Constants.COPY_SELECTED_RECORDS:
            let options = flexiciousNmsp.ExportOptions.create(flexiciousNmsp.ExportOptions.TXT_EXPORT);
            options.showColumnPicker = false;
            options.copyToClipboard = true;
            options.printExportOption = flexiciousNmsp.PrintExportOptions.PRINT_EXPORT_SELECTED_RECORDS;
            flexiciousNmsp.ExtendedExportController.instance().doexport(this, options);
            flexiciousNmsp.UIUtils.showMessage("Copied to clipboard.");  
            break;
        }
    }

    /**
     * If a noDataMessage value is specified, and a dataprovider with zero records is set, calls the showMessage function passing in the noDataMessage, which in turn
     * shows the value of the noDataMessage using the Spinner component with its spinner hidden.
     * @method checkNoDataMessage
     */
    checkNoDataMessage(force) {
        if (typeof force == "undefined") force = false;

        if (this.noDataMessage && this._dataProviderSet) {
            if (this.getLength(this.getDataProvider()) == 0 || force) {
                this.showMessage(this.noDataMessage);
            } else {
                this.hideSpinner();
            }
        }

    }

    /**
     * Clears out the following collections
     * <ul>
     * <li>All Open Items</li>
     * <li>All Errors</li>
     * <li>Selection (only if clearSelectionOnDataProviderChange==true)</li>
     * <li>Some internal housekeeping collections</li>
     * </ul>
     * @method clearAllCollections
     */
    clearAllCollections() {

        if (this.clearSelectionOnDataProviderChange)
            this.clearSelection();
        if (this.clearErrorsOnDataProviderChange)
            this.clearAllErrors();
        this._flattenedLevels = {};
        this.hasErrors = false;
        this.getBodyContainer().clearAllCollections();
        this.clearChanges();

    }

    /**
     * Sets changes to an empty array.
     * @method clearChanges
     */
    clearChanges() {

        this._changes = [];
        this.dispatchEvent(new flexiciousNmsp.BaseEvent("rowChanged", false, false));

    }

    /**
     * The grid is composed of the following sections:
     *
     * Left Locked Header <br/>
     * Left Locked Content <br/>
     * Left Locked Footer <br/>
     * Right Locked Header <br/>
     * Right Locked Content <br/>
     * Right Locked Footer <br/>
     * UnLocked Header <br/>
     * UnLocked Content <br/>
     * UnLocked Footer <br/>
     *
     * On basis of the column lock modes specified, this method will
     * size each section and place them in the correct location.
     * @method placeSections
     */
    placeSections() {
        if (!this.getColumnLevel()) return;
        if (!this.getWidth() && !this.getHeight()) {
            this.measure();
            this.setWidth(this.measuredWidth);
            this.setHeight(this.measuredHeight);
        }
        this.placedHeight = (this.domElement ? this.domElement.offsetHeight : 0) || this.getHeight();
        this.placedWidth = (this.domElement ? this.domElement.offsetWidth : 0) || this.getWidth();

        this.dispatchEvent(new flexiciousNmsp.FlexDataGridEvent(flexiciousNmsp.FlexDataGridEvent.PLACING_SECTIONS, this));

        const borderThickness = this.getStyle("borderThickness");
        const paddingX = this.hasBorderSide("left") ? borderThickness : 0;
        const paddingRight = this.hasBorderSide("right") ? borderThickness : 0;
        const paddingY = this.hasBorderSide("top") ? borderThickness : 0;
        const paddingBottom = this.hasBorderSide("bottom") ? borderThickness : 0;
        const widestLeftLockedWidth = this.getColumnLevel().getWidestLeftLockedWidth();
        const widestRightLockedWidth = this.getColumnLevel().getWidestRightLockedWidth();
        const thisisVScrollBarVisible = 0;
        const vertSep = this.getStyle("lockedSeperatorThickness");
        const leftVertSep = (this.getColumnLevel().getLeftLockedColumns().length > 0) ? vertSep : 0;
        let bodyWidth = this.getWidth() - widestLeftLockedWidth - (leftVertSep) - widestRightLockedWidth - (widestRightLockedWidth ? vertSep : 0) - (paddingX)
            - paddingRight - thisisVScrollBarVisible;
        if (UIUtils.isIE8()) {
            bodyWidth -= 1;
        }

        this.getLeftLockedContent().setHorizontalScrollPolicy(Constants.SCROLL_POLICY_OFF);
        this.getLeftLockedContent().setVerticalScrollPolicy(Constants.SCROLL_POLICY_OFF);
        this.getRightLockedContent().setHorizontalScrollPolicy(Constants.SCROLL_POLICY_OFF);
        this.getRightLockedContent().setVerticalScrollPolicy(Constants.SCROLL_POLICY_OFF);
        this.getFilterContainer().setWidth(bodyWidth + thisisVScrollBarVisible);
        this.getHeaderContainer().setWidth(bodyWidth + thisisVScrollBarVisible);
        this.getFooterContainer().setWidth(bodyWidth + thisisVScrollBarVisible);
        this.getBodyContainer().setWidth(bodyWidth);
        this.getPagerContainer().setWidth(this.getWidth() - (paddingX)
            - paddingRight - 1);

        this.getLeftLockedHeader().setWidth(widestLeftLockedWidth);
        this.getLeftLockedFooter().setWidth(widestLeftLockedWidth);
        this.getLeftLockedContent().setWidth(widestLeftLockedWidth);


        this.getRightLockedHeader().setWidth(widestRightLockedWidth);
        this.getRightLockedFooter().setWidth(widestRightLockedWidth);
        this.getRightLockedContent().setWidth(widestRightLockedWidth);

        //now that the widths are set, we can calculate columns
        this.getColumnLevel().adjustColumnWidths();
        this.snapToColumnWidths();

        if (this.variableHeaderHeight) {
            this.getColumnLevel().calculateHeaderHeights();
        }


        let bodyHeight = this.getHeight() - this.getHeaderSectionHeight() - this.getFooterRowHeight() - paddingY - paddingBottom - (thisisVScrollBarVisible ? 2 : 1);//when the scrollbar shows up, it takes up 1 px extra so we allow for that scenario.
        bodyHeight = Math.max(this.getColumnLevel().getRowHeight(), bodyHeight);//fix for print issue.
        this.getBodyContainer().setHeight(this.getLeftLockedContent().setHeight(this.getRightLockedContent().setHeight(bodyHeight)));
        this.getFilterContainer().setHeight(this.getColumnLevel().getFilterRowHeight());
        this.getHeaderContainer().setHeight(this.getColumnLevel().getHeaderHeight() * this.getColumnLevel().getMaxColumnGroupDepth());
        this.getFooterContainer().setHeight(this.getColumnLevel().getFooterRowHeight());
        this.getPagerContainer().setHeight(this.getColumnLevel().getPagerRowHeight());

        const headerHt = this.getHeaderContainer().getHeight() + this.getFilterContainer().getHeight();
        this.getLeftLockedHeader().setHeight(headerHt);
        this.getRightLockedHeader().setHeight(headerHt);
        const footerHt = this.getColumnLevel().getFooterRowHeight();
        this.getLeftLockedFooter().setHeight(footerHt);
        this.getRightLockedFooter().setHeight(footerHt);

        this.getLeftLockedHeader().setX(0);
        this.getLeftLockedFooter().setX(0);
        this.getLeftLockedContent().setX(0);
        this.getPagerContainer().setX(0);

        let rhlx = this.getWidth() - this.getRightLockedContent().getWidth() - 2;
        this.getRightLockedHeader().setX(rhlx);
        this.getRightLockedFooter().setX(rhlx);
        this.getRightLockedContent().setX(rhlx);

        rhlx = widestLeftLockedWidth + (widestLeftLockedWidth ? leftVertSep : 0);
        this.getFilterContainer().setX(rhlx);
        this.getFooterContainer().setX(rhlx);
        this.getBodyContainer().setX(rhlx);
        this.getHeaderContainer().setX(rhlx);


        this._rightLockedContent.setVisible(widestRightLockedWidth > 0);
        this._rightLockedFooter.setVisible(widestRightLockedWidth > 0);
        this._rightLockedHeader.setVisible(widestRightLockedWidth > 0);

        const sections = this.getDisplayOrder().split(",");
        let thisY = 0;

        for (const section of sections) {
            thisY += this.placeSectionByName(section, thisY - ((this.getDisplayOrder().indexOf(section) > this.getDisplayOrder().indexOf("body")) ? this.isHScrollBarVisible : 0));
        }

        const borderColor = UIUtils.decimalToColor(this.getStyle("borderColor"));
        if (this.hasBorderSide('left')) {
            this.setStyleAttribute("borderLeft", `solid ${this.getStyle("borderThickness")}px ${borderColor}`);
        }
        if (this.hasBorderSide('right')) {
            this.setStyleAttribute("borderRight", `solid ${this.getStyle("borderThickness")}px ${borderColor}`);
        }
        if (this.hasBorderSide('top')) {
            this.setStyleAttribute("borderTop", `solid ${this.getStyle("borderThickness")}px ${borderColor}`);
        }
        if (this.hasBorderSide('bottom')) {
            this.setStyleAttribute("borderBottom", `solid ${this.getStyle("borderThickness")}px ${borderColor}`);
        }
        if (this.enableLockedSectionSeparators) {
            this.drawDefaultSeperators();
        }
        // this.getBodyContainer().pauseState();
        // this.getBodyContainer().removeMatchSticks();
        this.getBodyContainer().addMatchSticks();
        // this.getBodyContainer().resumeState();
        
    }

    /**
     * Used by filter to identify where relative position for each control for tabbing
     * @method getFilterX
     */
    getFilterX(renderer) {

        return (renderer.parent).getPerceivedX();

    }

    /**
     * For some operations, like shift tab and tab key up, purposely pause the Container keyboard listenters,
     * so we do not overwrite the work of one keyboard handler by triggering another.
     * @method pauseKeyboardListeners
     */
    pauseKeyboardListeners(filterRenderer) {

        this.keyboardListenersPaused = true;
        window.setTimeout(this.resumeKeyboardListeners, 100);

        if (filterRenderer) {
            this.currentCell = filterRenderer.parent;
        }

    }

    /**
     * Given a IFlexDataGridCell, returns a container that holds that cell.
     * @param cell The IFlexDataGridCell object to get the container for.
     * @return The container that holds the provided cell. Can be either one of the below:
     * <ul>
     * <li>headerContainer</li>
     * <li>filterContainer</li>
     * <li>footerContainer</li>
     * <li>pagerContainer</li>
     * <li>bodyContainer</li>
     * </ul>
     * @method getContainerForCell
     */
    getContainerForCell(cell) {

        if (cell.level == this.getColumnLevel()) {
            if (cell.rowInfo.getIsHeaderRow() || cell.rowInfo.getIsColumnGroupRow())
                return this.getHeaderContainer();
            else if (cell.rowInfo.getIsFooterRow())
                return this.getFooterContainer();
            else if (cell.rowInfo.getIsFilterRow())
                return this.getFilterContainer();
            else if (cell.rowInfo.getIsPagerRow())
                return this.getPagerContainer();
            else
                return this.getBodyContainer();
        }
        else
            return this.getBodyContainer();

    }

    /**
     * Returns the section above or below the provided section. Based on the displayOrder property,
     * the grid will stack the various sections in order specified by the user. This method uses
     * the displayOrder property to figure out which container exists above or below the specified
     * section.
     * @param container Name of the section. Must be one of the displayOrder strings (filter,header,body,footer,pager).
     * @param up    Whether to return the section above or below
     * @return A FlexDataGridContainerBase object
     * @method getContainerInDirection
     */
    getContainerInDirection(container, up) {
        let prevSec = null;
        let nextSec = null;
        const sections = this.getDisplayOrder().split(",");
        let hit = false;

        for (const section of sections) {
            if (section == container)
                hit = true;
            if (this.getNamedContainer(section) && section != container && !hit)
                prevSec = this.getNamedContainer(section);
            if (this.getNamedContainer(section) && section != container && hit && nextSec == null)
                nextSec = this.getNamedContainer(section);
        }

        return up ? prevSec : nextSec;
    }

    /**
     * Given a container, returns its displayOrder string equivalent. Based on the displayOrder property,
     * the grid will stack the various sections in order specified by the user. This method uses
     * the takes a container and returns the associated displayOrder property.
     * Container Should be one of the following:
     * <ul>
     * <li>headerContainer</li>
     * <li>filterContainer</li>
     * <li>footerContainer</li>
     * <li>pagerContainer</li>
     * <li>bodyContainer</li>
     * </ul>
     * Will return one of the following:
     * <ul>
     * <li>header</li>
     * <li>filter</li>
     * <li>footer</li>
     * <li>pager</li>
     * <li>body</li>
     * </ul>
     * @param container    The container to look for.
     * @method getContainerName
     */
    getContainerName(container) {

        if (container == this.getHeaderContainer()) {
            return "header";
        }
        else if (container == this.getFooterContainer()) {
            return "footer";
        }
        else if (container == this.getPagerContainer()) {
            return "pager";
        }
        else if (container == this.getFilterContainer()) {
            return "filter";
        }
        return "body";


    }

    /**
     * Given a displayOrder string , returns its container equivalent. Based on the displayOrder property,
     * the grid will stack the various sections in order specified by the user. This method uses
     * the takes a displayOrder string and returns the associated container.
     * Display Order String Should be one of the following:
     * <ul>
     * <li>header</li>
     * <li>filter</li>
     * <li>footer</li>
     * <li>pager</li>
     * <li>body</li>
     * </ul>
     * Will return one of the following:
     * <ul>
     * <li>headerContainer</li>
     * <li>filterContainer</li>
     * <li>footerContainer</li>
     * <li>pagerContainer</li>
     * <li>bodyContainer</li>
     * </ul>
     * @method getNamedContainer
     */
    getNamedContainer(name) {

        if (name == "header") {
            return this.getHeaderContainer();
        }
        else if (name == "footer" && this.getFooterRowHeight()) {
            return this.getFooterContainer();
        }
        else if (name == "pager" && this.getPagerRowHeight()) {
            return this.getPagerContainer();
        }
        else if (name == "filter" && this.getFilterRowHeight()) {
            return this.getFilterContainer();
        }
        else if (name == "body") {
            return this.getBodyContainer();
        }
        return null;

    }

    /**
     * @private
     * @method placeSectionByName
     */
    placeSectionByName(name, thisY) {

        const filterAboveHeader = this.getDisplayOrder().indexOf("filter") < this.getDisplayOrder().indexOf("header");

        if (name == "header") {
            if (this.getHeaderVisible()) {
                this.getHeaderContainer().setY(thisY);
                if (!filterAboveHeader) {
                    this.getLeftLockedHeader().setY(thisY);
                    this.getRightLockedHeader().setY(thisY);
                }
                return this.getHeaderContainer().getHeight();

            } else {
                return 0;
            }
        }
        else if (name == "footer") {
            if (this.getFooterVisible() && this.getEnableFooters()) {
                this.getLeftLockedFooter().setY(thisY);
                this.getRightLockedFooter().setY(thisY);
                this.getFooterContainer().setY(thisY);
                return this.getFooterContainer().getHeight();
            } else {
                return 0;
            }
        }
        else if (name == "pager") {
            if ((this.getPagerVisible() && this.getEnablePaging()) || this.getForcePagerRow()) {
                this.getPagerContainer().setY(thisY);
                return this.getPagerContainer().getHeight();
            } else {
                return 0;
            }
        }
        else if (name == "filter") {
            if ((this.getFilterVisible() && this.getEnableFilters())) {
                this.getFilterContainer().setY(thisY);
                if (filterAboveHeader) {
                    this.getLeftLockedHeader().setY(thisY);
                    this.getRightLockedHeader().setY(thisY);
                }
                return this.getFilterContainer().getHeight();
            } else {
                return 0;
            }
        }
        else if (name == "body") {
            this.getLeftLockedContent().setY(thisY);
            this.getRightLockedContent().setY(thisY);
            this.getBodyContainer().setY(thisY);
            return this.getBodyContainer().getHeight();
        }
        else
            throw new Error(`Invalid section specified for the displayOrder property ${name}`);

    }

    /**
     * Goes through all the sections and resizes the cells to match the current column widths.
     * If you update the column widths programatically, call this to resize the currently visible cells.
     * @method snapToColumnWidths
     */
    snapToColumnWidths() {
        if (this._placementDirty || this._structureDirty || this._snapDirty) return;
        const sections = [this.getBodyContainer(), this.getFilterContainer(), this.getHeaderContainer(), this.getFooterContainer()];

        for (const section of sections) {
            section.snapToColumnWidths();
        }
    }

    /**
     *
     * @method createComponents
     */
    createComponents(currentScroll) {
        this.pauseState();
        if (typeof currentScroll == "undefined") currentScroll = 0;

        if (this.enableHeightAutoAdjust) {
            this.getBodyContainer().ensureAutoAjustHeight();
        }
        //        TODO if (!contextMenu) {
        //            this.contextMenu = new this.ContextMenu();
        //        }
        //        if (this.contextMenu) {
        //            this.contextMenu.addEventListener(this,this.ContextMenuEvent.MENU_SELECT, this.onContextMenuSelect);
        //            if (enableHideBuiltInContextMenuItems)
        //                contextMenu.hideBuiltInItems();
        //        }
        const spinnerVisible = this.spinnerBehavior.spinnerVisible;
        const currentFocus = document.activeElement && document.activeElement.component ? document.activeElement.component : null;
        this.currentDataFld = "";
        if (currentFocus && currentFocus["implementsOrExtends"] != null
            && (currentFocus.implementsOrExtends('IFilterControl'))
            && currentFocus.hasOwnProperty("parent")) {
            const fc = currentFocus["parent"];
            if (fc && typeof fc.getColumn === "function" && fc.getColumn())
                this.currentDataFld = fc.getColumn().getDataField();
        }
        //if (this.enableCopy) {

        //                    if (!_copyCellContextMenuItem) {
        //                        _copyCellContextMenuItem = new ContextMenuItem(copyCellMenuText);
        //                        _copyCellContextMenuItem.addEventListener(this,ContextMenuEvent.MENU_ITEM_SELECT, onCellContextMenuItemClick);
        //                        contextMenu.customItems.push(_copyCellContextMenuItem);
        //                    }
        //                    if (!_copyRowContextMenuItem) {
        //
        //                        _copyRowContextMenuItem = new ContextMenuItem(copySelectedRowMenuText);
        //                        _copyRowContextMenuItem.addEventListener(this,ContextMenuEvent.MENU_ITEM_SELECT, onRowContextMenuItemClick);
        //                        contextMenu.customItems.push(_copyRowContextMenuItem);
        //                    }
        //                    if (!_copyTableContextMenuItem) {
        //                        _copyTableContextMenuItem = new ContextMenuItem(copyAllRowsMenuText);
        //                        _copyTableContextMenuItem.addEventListener(this,ContextMenuEvent.MENU_ITEM_SELECT, onTableContextMenuItemClick);
        //                        contextMenu.customItems.push(_copyTableContextMenuItem);
        //                    } //TODO
        //}
        if (this.getColumns().length == 0 && this.getLength(this.getDataProvider()) > 0 && this.generateColumns) {
            //there are no columns, so introspect
            const flt = this.getRootFlat();
            const newCols = [];
            const itmObj = flt[0];
            for (const prop in itmObj) {
                if (itmObj.hasOwnProperty(prop) && prop != "uid") {
                    const col1 = new flexiciousNmsp.FlexDataGridColumn();
                    col1.setDataField(prop);
                    newCols.push(col1);

                }
            }
            if (newCols.length == 0) {
                for (const p in itmObj) {
                    if (p != "uid") {
                        const col = new flexiciousNmsp.FlexDataGridColumn();
                        col.setDataField(p);
                        newCols.push(col);
                    }
                }
            }
            this.setColumns(newCols);
        }
        const pp = this.getPreservePager();
        this.traceEvent("create comp start");
        this.getColumnLevel().initializeLevel(this);

        while (this.numChildren() > (pp ? 1 : 0)) {
            this.removeChildAt(pp ? this.getChildAt(0) == this.getPagerContainer() ? 1 : 0 : 0);
        }

        this.currentPoint.reset();
        const sections = [this.getBodyContainer(), this.getFilterContainer(), this.getHeaderContainer(), this.getFooterContainer()];

        for (const section of sections) {
            section.removeAllComponents(false);
        }

        this._heightIncreased = false;
        this._widthIncreased = false;
        this.placeSections();

        this.getFilterContainer().addEventListener(this, flexiciousNmsp.ExtendedFilterPageSortChangeEvent.FILTER_CHANGE, this.onRootFilterChange);
        this.addComponent(this.getFilterContainer());

        this.getHeaderContainer().addEventListener(this, flexiciousNmsp.FlexDataGridEvent.SELECT_ALL_CHECKBOX_CHANGED, this.onSelectAllChanged);

        this.getHeaderContainer().addEventListener(this, flexiciousNmsp.FlexDataGridEvent.COLUMNS_RESIZED, this.onColumnResized);

        this.addComponent(this.getHeaderContainer());


        this.addComponent(this.getBodyContainer());
        this.getBodyContainer().addEventListener(this, Constants.EVENT_MOUSE_WHEEL, this.checkScrollEnabled);
        this.addComponent(this.getFooterContainer());

        this.addComponent(this.getLeftLockedContent());
        this.addComponent(this.getRightLockedContent());

        this.addComponent(this.getLeftLockedHeader());
        this.addComponent(this.getRightLockedHeader());
        this.addComponent(this.getLeftLockedFooter());
        this.addComponent(this.getRightLockedFooter());
        if (!pp)
            this.addComponent(this.getPagerContainer());
        this.addComponent(this.getLeftLockedVerticalSeparator());
        this.addComponent(this.getRightLockedVerticalSeparator());
        this.addComponent(this.bottomBarLeft);
        this.addComponent(this.bottomBarRight);

        this.dropIndicator.setVisible(false);
        this.getBodyContainer().verticalSpill = false;
        this.getColumnLevel().adjustColumnWidths();
        const flat = this.getBodyContainer().filterPageSort(this.getDataProvider(), this.getColumnLevel(), null, true, false, true);
        if (this.getColumnLevel().getEnableFilters()) {
            this.traceEvent("begin filter");
            this.getFilterContainer().createComponents(this.getColumnLevel(), 0, flat);
            if (this.currentDataFld) {
                const filterCol = this.getColumnLevel().getColumnByDataField(this.currentDataFld);
                if (filterCol && (this.getFilterContainer().rows.length > 0)) {
                    this.setFilterFocus(filterCol.getSearchField());
                    this.currentCell = this.getFilterContainer().getCellForRowColumn(
                        this.getFilterContainer().rows[0].getData(), filterCol);
                }
            }
            this.traceEvent("end filter");
            this.currentPoint.nextChromeRow(this.getFilterContainer());
        }
        this.traceEvent("begin calc");
        this.getBodyContainer().calculateTotalHeight();
        this.traceEvent("end calc");
        this.getBodyContainer().setVisibleRange();
        this.traceEvent("begin header");
        this.getHeaderContainer().createComponents(this.getColumnLevel(), 0, flat);
        this.traceEvent("end header");
        this.currentPoint.nextChromeRow(this.getHeaderContainer());
        if (this.getColumnLevel().getEnableFooters()) {
            this.traceEvent("begin footer");
            this.getFooterContainer().createComponents(this.getColumnLevel(), 0, flat);
            this.traceEvent("end footer");
            this.currentPoint.nextChromeRow(this.getFooterContainer());
        }
        if (!pp) {
            if (this.getColumnLevel().enablePaging || this.getColumnLevel().forcePagerRow) {
                this.traceEvent("begin pager");
                this.getPagerContainer().createComponents(this.getColumnLevel(), 0, flat);
                this.traceEvent("end pager");
                this.currentPoint.nextChromeRow(this.getPagerContainer());
            }
        }

        this.getBodyContainer().createComponents(this.getColumnLevel(), currentScroll);
        if(!this.enableHorizontalScrollOptimizationsBETA)
        this.getBodyContainer().addEventListener(this, Constants.EVENT_SCROLL, this.onContainerScroll);
        this.getBodyContainer().addEventListener(this, flexiciousNmsp.FlexDataGridEvent.COLUMNS_RESIZED, this.onColumnResized);

        if (!pp) {
            this.getPagerContainer().addEventListener(this, flexiciousNmsp.ExtendedFilterPageSortChangeEvent.PAGE_CHANGE, this.onRootPageChange);
        }
        //setChildIndex(bodyContainer,this.numChildren-1);
        this.addComponent(this.getDropIndicator());
        this.invalidateDisplayList();
        this.traceEvent("create comp complete");
        if (!this._componentsCreated && this.enableResizeTimer) {
            //firstt timer
            this.resizeTimer = new flexiciousNmsp.Timer(1000);
            this.resizeTimer.addEventListener(this, Constants.EVENT_TIMER, this.checkResize);
            this.resizeTimer.start();
        }
        this._componentsCreated = true;
        this.dispatchEvent(new flexiciousNmsp.FlexDataGridEvent(flexiciousNmsp.FlexDataGridEvent.COMPONENTS_CREATED, this));
        this.setPreservePager(false);

        this.getRightLockedFooter().placeSection();
        this.getRightLockedHeader().placeSection();
        this.getLeftLockedFooter().placeSection();
        this.getLeftLockedHeader().placeSection();
        if (!this._dataProviderSet && spinnerVisible && this.showSpinnerOnFilterPageSort) {
            this.showSpinner();
        } else {
            if (this.getColumnLevel().getIsClientFilterPageSortMode()) {
                this.checkNoDataMessage(this.getBodyContainer().itemVerticalPositions.length == 0);
            } else {
                this.checkNoDataMessage();
            }
        }
        this.resumeState();
    }

    /**
     * @method onContextMenuSelect
     */
    onContextMenuSelect(event) {

        //TODO

    }

    /**
     * @method setContextMenuShownFalse
     */

    setContextMenuShownFalse() {


        this.contextMenuShown = false;


    }

    /**
     * Method to handle the click for the copy cell menu item
     * Copies the current cell in tab delimited format into the clipboard
     * @param event
     * @method onCellContextMenuItemClick
     */
    onCellContextMenuItemClick(event) {

        if (!this.currentCell) {
            if (event && event.target.implementsOrExtends('IFlexDataGridDataCell')) {
                this.currentCell = event.target
            }
            if (!(this.currentCell.implementsOrExtends('IFlexDataGridDataCell'))) {
                UIUtils.showError("Invalid Cell Selected.");
                return;
            }
        }
        if (this.currentCell && this.currentCell.getColumn()) {
            const text = this.currentCell.getColumn().itemToLabel(this.currentCell.rowInfo.getData(), this.currentCell);
            if (text) {
                UIUtils.pasteToClipBoard(text);
                UIUtils.showMessage("Copied to clipboard.");
            }
        }
    }

    /**
     * Method to handle the click for the copy row menu item
     * Copies the current row in tab delimited format into the clipboard
     * @method onRowContextMenuItemClick
     * @param event
     */


    onRowContextMenuItemClick(event) {

        if (!this.currentCell) {
            if (event && event.target.implementsOrExtends('IFlexDataGridDataCell')) {
                this.currentCell = event.target;
            }
            if (!(this.currentCell.implementsOrExtends('IFlexDataGridDataCell)'))) {
                UIUtils.showError("Invalid Cell Selected.");
                return;
            }
        }
        if (this.currentCell && this.currentCell.getColumn()) {
            UIUtils.pasteToClipBoard(this.getRowText(this.currentCell.rowInfo.getData(), this.currentCell.getColumn().level.getVisibleColumns()));
            UIUtils.showMessage("Copied to clipboard.");

        }
    }

    /**
     * Triggered when the drag is complete. Does nothing. Use the dragDropCompleteFunction
     * to wire up custom logic.
     * @method dragComplete
     * @param event
     */
    dragComplete(event) {
        this.dropIndicator.setVisible(false);


    }

    /**
     * Iterates through the passed in cols, calls itemToLabel on each of them
     * passing in the item, and return the resulting string in tab delimited format.
     * Converts an objects properties into tab delimited format
     * @method getRowText
     * 
     * @param {Object} item
     * @param {Array} cols
	 * @return {String} return string value
     */
    getRowText(item, cols) {
        let text = "";

        for (const column of cols) {
            if (column.getVisible()) {
                text += `${column.itemToLabel(item)}\t`;
            }
        }

        text += "\n";
        return text;
    }

    /**
     * @method onRootFilterChange
     * @param event
     */
    onRootFilterChange(event) {

        if (this.clearSelectionOnFilter) {
            this.clearSelection();
        }
        if (!this._triggerEvent) return;
        this.processRootFilter(event.triggerEvent);
        this.lastVScroll = 0;
    }

    /**
     * Processes filters at the root level.
     * 1) Ensures the root filter exists<br/>
     * 2) In filterPageSortMode="client", invalidates the row position info objects, so they are rebuilt<br/>
     * 3) In filterPageSortMode="client", Calls the create components method on each of the container sections.<br/>
     * 4) In Server mode, gathers the filter information, and dispatches a filterPageSortChange event, for the client code to listen to.<br/>
     * @method processFilter
     */
    processFilter() {

        this.processRootFilter(null)

    }

    /**
     *
     * @method processRootFilter
     * @param triggerEvent
     */
    processRootFilter(triggerEvent) {
        if (typeof triggerEvent == "undefined") triggerEvent = null;

        if (!this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER))
            this.itemFilters.addItem(Constants.TOP_LEVEL_FILTER, new flexiciousNmsp.AdvancedFilter());

        this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER).pageIndex = 0;
        this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER).pageSize = this.getColumnLevel().pageSize;



        if (triggerEvent) {
            this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER).filterExpressions = triggerEvent.filter.filterExpressions;
            //from Veena :
            this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER).pageSize = triggerEvent.filter.pageSize;
        }
        else
            this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER).filterExpressions = this.getFilterArguments();

        if (this.getColumnLevel().additionalFilterArgumentsFunction != null) {
            const additionalArguments = this.getColumnLevel().additionalFilterArgumentsFunction();

            for (const arg of additionalArguments) {
                this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER).filterExpressions.push(arg);
            }
        }

        this.hasFilter = (this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER).filterExpressions.length > 0);
        if (this.getColumnLevel().getIsClientFilterPageSortMode()) {
            this.gotoVerticalPosition(0);
            this.rebuildBody(true);
            this.getHeaderContainer().refreshCells();
            this.getFooterContainer().refreshCells();
            if (!this._filterDirty)
                this.checkNoDataMessage(this.getBodyContainer().itemVerticalPositions.length == 0);
        }
        //else
        {
            const filter = this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER);
            filter.level = this.getColumnLevel();
            filter.sorts = this.getColumnLevel().currentSorts;
            const nested =
                new flexiciousNmsp.ExtendedFilterPageSortChangeEvent(flexiciousNmsp.ExtendedFilterPageSortChangeEvent.FILTER_PAGE_SORT_CHANGE,
                    filter ? filter : this.getBodyContainer().createFilter(this.getColumnLevel(), null));
            nested.triggerEvent = triggerEvent;
            nested.cause = flexiciousNmsp.ExtendedFilterPageSortChangeEvent.FILTER_CHANGE;
            this.getColumnLevel().dispatchEvent(nested);
        }

    }

    /**
     *
     * @param event
     * @method onRootPageChange
     */
    onRootPageChange(event) {

        this.setVerticalScrollPosition(0);

        const iPager = event.triggerEvent.target;
        if (!this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER)) {
            this.itemFilters.setValue(Constants.TOP_LEVEL_FILTER, new flexiciousNmsp.AdvancedFilter());
            this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER).pageIndex = 0;
        }
        const filter = this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER);
        filter.pageIndex = iPager.getPageIndex();

        if (this.getColumnLevel().getIsClientFilterPageSortMode()) {
            this.rebuildBody();
        }
        else {
            this.getBodyContainer().dispatchPageChange(event.triggerEvent);
        }

    }

    /**
     * @private
     */
    showHideVScroll(show, scrollBarWidth) {

        let offset = 0;
        if (!this.isVScrollBarVisible && show) {
            offset -= scrollBarWidth;
            this.isVScrollBarVisible = scrollBarWidth;
        }
        else if (this.isVScrollBarVisible && !show) {
            offset += this.isVScrollBarVisible;
            this.isVScrollBarVisible = 0;
        }
        if (offset != 0) {

            //            this.getRightLockedContent().setX(this.getRightLockedContent().getX() + offset);
            //            this.getRightLockedHeader().setX(this.getRightLockedHeader().getX() + offset);
            //            this.getRightLockedFooter().setX(this.getRightLockedFooter().getX() + offset);
            //            this.getPagerContainer().setWidth(this.getPagerContainer().getWidth() + offset);
            this.getColumnLevel().adjustColumnWidths();
            this.invalidateCellWidths();
            this.invalidateDisplayList();
            if (this.enableFillerRows) {
                this.invalidateFiller();
            }
        }
    }

    /**
     * @private
     */
    showHideHScroll(show, scrollBarHeight) {

        let offset = 0;
        if (!this.isHScrollBarVisible && show) {
            offset -= scrollBarHeight;
            this.isHScrollBarVisible = scrollBarHeight;
        }
        else if (this.isHScrollBarVisible && !show) {
            offset += this.isHScrollBarVisible;
            this.isHScrollBarVisible = 0;
        }
        if (offset != 0) {
            const pagerBelowBody = this.getDisplayOrder().indexOf("pager") > this.getDisplayOrder().indexOf("body");
            const footerBelowBody = this.getDisplayOrder().indexOf("footer") > this.getDisplayOrder().indexOf("body");
            if (pagerBelowBody)
                this.getPagerContainer().setY(this.getPagerContainer().getY() + offset);
            if (footerBelowBody) {
                this.getFooterContainer().setY(this.getFooterContainer().getY() + offset);
                this.getLeftLockedFooter().setY(this.getFooterContainer().getY() + offset);
                this.getRightLockedFooter().setY(this.getFooterContainer().getY() + offset);
            }
            this.getBodyContainer().ensureAutoAjustHeight();
            this.getBodyContainer().adjustFiller(offset);
            this.invalidateDisplayList();
        }

    }

    /**
     * Gets the text of the tooltip to show to the user to prompt for the multi column sort.
     * @method multiColumnSortGetTooltip
     */
    multiColumnSortGetTooltip(cell) {

        let result = "";
        if (!this.getEnableSplitHeader())
            result += "Click to open multiple column sort.";
        return result;

    }

    /**
     * Creates an instance of the multiSortRenderer and pushes it into view
     * @method multiColumnSortShowPopup
     */
    multiColumnSortShowPopup() {

        const popup = this.getMultiSortRenderer().newInstance();
        popup.setGrid(this);
        popup.showDialog();
    }

    /**
     * Updates the visible state of all row selection checkboxes and header checkboxes.
     * @method refreshCheckBoxes
     */
    refreshCheckBoxes() {

        this.getHeaderContainer().refreshCheckBoxes();
        this.getBodyContainer().refreshCheckBoxes();

    }

    /**
     * Calls the refresh cell method on all visible cells in the bodyContainer section. <br/>
     * The refreshCell method re-evaulates the following properties:<br/>
     * <ul>
     * <li> Cell Text </li>
     * <li> Cell Enabled </li>
     * <li> Cell data </li>
     * <li> Various style properties like text decoration, underline </li>
     * <li> Sets the width, and places the renderer appropriately. </li>
     * <li> Dispatches the renderer intialized event. </li>
     * </ul>
     * If you wish to re evaluate the background/border, use the invalidate cells instead.
     * @method refreshCells
     */
    refreshCells() {

        if(this.enableMultiColumnSort)
            this.getHeaderContainer().refreshCells();

        this.getBodyContainer().refreshCells();
        if (this.getEnableFooters())
            this.getFooterContainer().refreshCells();

    }

    /**
     * @private
     * @method onColumnResized
     */

    onColumnResized(event) {

        this.snapToColumnWidths();
        this.validateNow();
        if (!this.getForceColumnsToFitVisibleArea()) {
            this.recycleH(true);
            //this.getBodyContainer().validateDisplayList();
        }
        if (this.getStyle('horizontalScrollPolicy') == Constants.SCROLL_POLICY_AUTO) {
            this.placeBottomBar();//bug fix to clean up fixed column fill
        }

        this.getBodyContainer().addMatchSticks();
        this.refreshCells();
    }

    /**
     * @private
     * @method onSelectAllChanged
     */
    onSelectAllChanged(event) {
        this._selectionInvalid = true;
        this.doInvalidate();
    }

    /**
     * @private
     * @method onSelectChanged
     */
    onSelectChanged(event) {
        this._selectionInvalid = true;
        this.doInvalidate();
    }
    setupScrollTimer() {
        ReactDataGridCellContainer.isScrolling = true;
        UIComponent.statePaused = true;

        if (!this.scrollTimer) {
            this.scrollTimer = new Timer(this.scrollPaintDelay || 200, 1);
            this.scrollTimer.addEventListener(this, Constants.EVENT_TIMER_COMPLETE, this.onScrollTimerComplete, false, 0, true);
        }


        this.scrollTimer.reset(); // reset if already set...
        this.scrollTimer.repeatCount = 1;
        // starts the timer ticking
        this.scrollTimer.start();
        this._isScrolling = true;

    }
    /**
     * @method onContainerScroll
     */
    onContainerScroll(evt) {
        //this.setupScrollTimer(evt);


        this.dispatchEvent(evt);
        let delta;
        const bc = this.getBodyContainer();
        //console.log(this.lastHScroll + ":" + evt.scrollLeft)
        if (evt.scrollTop > this.getBodyContainer().getMaxVerticalScrollPosition()) {
            evt.scrollTop = this.getBodyContainer().getMaxVerticalScrollPosition();
        }
        if (evt.scrollTop < 0) {
            evt.scrollTop = 0;
        }

        if (this.lastVScroll != evt.scrollTop) {

            delta = evt.scrollTop - this.lastVScroll;
            if ((this.lastVScroll + delta) > bc.getMaxVerticalScrollPosition()) {
                this.synchronizeLockedVerticalScroll();
                return;
            }

            this.lastVScroll = evt.scrollTop;
            const seedHeight = bc.getVerticalScrollPosition();
            if (seedHeight >= 0 && bc.setCurrentRowAtScrollPosition(seedHeight)) {
                bc.recycle(this.getColumnLevel(), delta > 0, delta);//only recycle if our seed actually changed..
                if(this.enableHorizontalScrollOptimizationsBETA){
                    this.invalidateHorizontalScroll();
                }else{
                    if (!this.getForceColumnsToFitVisibleArea())
                    bc.recycleH();
                }
            }
        } else if (this.lastHScroll != evt.scrollLeft) {
            this.synchronizeHorizontalScroll();
            delta = evt.scrollLeft - this.lastHScroll;
            if ((this.lastHScroll + delta) > this.getColumnLevel().getWidestWidth()) return;
            this.lastHScroll = evt.scrollLeft;
            this.recycleH(delta);

            //                (this.getHeaderContainer().domElement).style.left = lastHScroll + "px";
            //            (this.getFooterContainer().domElement).style.left = lastHScroll + "px";
            //            (this.getBodyContainer().domElement).style.left = lastHScroll + "px";
            //            (this.getFilterContainer().domElement).style.left = lastHScroll + "px";
        }
        this.synchronizeHorizontalScroll();
        this.synchronizeLockedVerticalScroll();

        if (this.enableVirtualScroll) {
            const that = this;
            setTimeout(() => {
                that.synchronizeLockedVerticalScroll();
            }, 500);
        }

    }

    /**
     * @method recycleH
     */
    recycleH(right) {

        this.getBodyContainer().recycleH(this.getColumnLevel(), this.right);
        this.getHeaderContainer().recycleH(this.getColumnLevel(), this.right);
        if (this.getEnableFooters())
            this.getFooterContainer().recycleH(this.getColumnLevel(), this.right);
        if (this.getEnableFilters())
            this.getFilterContainer().recycleH(this.getColumnLevel(), this.right);
        this.synchronizeHorizontalScroll();
        if (this.enableFillerRows) {
            this.invalidateFiller();
        }


    }

    /**
     * In lazy loaded grid levels, (filterPageSortMode=server), when
     * the user expands a level for the first time, since the data
     * is not loaded, the level dispatches the filterPageSortChange, or itemLoad.
     *
     * This event is then handled by client code, and when the data
     * is retreieved from the server, this method should be called
     * with the item being expanded, and children to insert.
     *
     * @param item         The item that is being expanded. You can pass in an ID value if you set useSelectedKeyField=true (default)
     * @param children     The list of items to add to the children collection of the item being expanded
     * @param level    The parent level (the level at which the item object is located).
     * @param totalRecords Total number of child records. Only applicable if the filterPageSortMode for the child level is server. Use this parameter to tell the level that you are showing the first page of totalRecords records
     * @param useSelectedKeyField    Flag to indicate whether to use the selectedKeyField to identify the item being expanded, or
     * to compare against the item directly against the list of items pending expansion.
     * @method setChildData
     */
    setChildData(item, children, level, totalRecords, useSelectedKeyField) {
        if (typeof totalRecords == "undefined") totalRecords = -1;
        if (typeof useSelectedKeyField == "undefined") useSelectedKeyField = true;

        if (this.showSpinnerOnFilterPageSort)
            this.hideSpinner();
        this.getBodyContainer().setChildData(item, children, level, totalRecords, useSelectedKeyField);

    }

    /**
     * Invalidates the display (Calls invalidateDisplayList of all the cells).
     * This will re-evaluate the backgroud and borders of each cell.
     * There are four functions that you can use to redraw the grid, on basis of what your needs are.
     * <ul>
     * <li>rebuild : Most expensive. Rebuilds the entire grid. This is also the most expensive function</li>
     * <li>reDraw  : Removes the cells in view, and redraws them. Should be used when there are no additions/removals to the data provider</li>
     * <li>refreshCells : Resets the text,enabled, styles and border/background etc. of the currently visible cells. See the refreshCells() function for details.</li>
     * <li>invalidateCells : Least expensive. Only resets the border/background of the currently visible cells. </li>
     * </ul>
     * @method invalidateCells
     * */
    invalidateCells() {
        const sections = [this.getBodyContainer(), this.getFilterContainer(), this.getHeaderContainer(), this.getFooterContainer()];

        for (const section of sections) {
            section.invalidateCells();
        }
    }

    /**
     * Calls the rebuild function, which basically rebuild the entire grid. This is also the most expensive functions.
     * There are four functions that you can use to redraw the grid, on basis of what your needs are.
     * <ul>
     * <li>rebuild : Most expensive. Rebuilds the entire grid. This is also the most expensive function</li>
     * <li>reDraw  : Removes the cells in view, and redraws them. Should be used when there are no additions/removals to the data provider</li>
     * <li>refreshCells : Resets the text,enabled, styles and border/background etc. of the currently visible cells. See the refreshCells() function for details.</li>
     * <li>invalidateCells : Least expensive. Only resets the border/background of the currently visible cells. </li>
     * </ul>
     * @method invalidateList
     */
    invalidateList() {
        this.rebuild();
    }

    /**
     * Clears the selected rows and cells.
     * @method clearSelection
     */
    clearSelection() {

        if (this.getSelectedCells().length > 0)
        flexiciousNmsp.UIUtils.removeAll(this.getSelectedCells());
        this.getColumnLevel().clearSelection();
        this.invalidateSelection();
        this.selectionChain = {};
        if (this.enableSelectionExclusion) {
            this._selectAllState = flexiciousNmsp.TriStateCheckBox.STATE_UNCHECKED;
        }

    }

    /**
     * Gets the cell in the specified direction of the provided cell
     * @param cell        The cell to start searching at.
     * @param direction    The direction to search. Should be one of FlexDataGrid.CELL_POSITION_XXXX constants
     * @return The cell, if one matches the provided criteria, or null
     * @method getCellInDirection
     */
    getCellInDirection(cell, direction) {

        return this.getBodyContainer().getCellInDirection(cell, direction);

    }

    /**
     * Returns a iterable representation of the dataprovider. If it is a hierarchical collection
     * view, returns the source property of the underlying Hierarchical Data object else returns dataprovider as is.
     * @method getRootFlat
     */
    getRootFlat() {

        return this.getBodyContainer().getRootFlat();

    }

    /**
     * For hierarchical data grids, returns the data provider as a flat list that matches the
     * specified criteria.
     *
     * @param depthRequested    The depth until which to recurse.
     * @param inclusive            Whether to add the parent object to the resulting
     * @param filter            Whether to run filter while getting children of parent objects
     * @param page                Whether to page while getting children of parent objects
     * @param sort                Whether to sort while getting children of parent objects
     * @param max                The maximum number of records to return
     * @return {Array}
     * @method flatten
     */
    flatten(depthRequested, inclusive, filter, page, sort, max) {
        if (typeof depthRequested == "undefined") depthRequested = 1;
        if (typeof inclusive == "undefined") inclusive = true;
        if (typeof filter == "undefined") filter = false;

        const key = depthRequested + "" + inclusive + "" + filter + "" + page + "" + sort + "" + max;
        if (this._flattenedLevels[key]) return this._flattenedLevels[key];
        const result = [];
        const flatRoot = this.getRootFlat();

        for (const item of flatRoot) {
            this.flattenRecursive(depthRequested, result, item, this.getColumnLevel(), inclusive, filter, page, sort);
            if (max != -1 && result.length > max) break;
        }

        this._flattenedLevels[key] = result;
        return result;
    }

    /**
     * When the dataprovider changes or when new data comes in from the server for lazy loaded grids, you can call this to clear out the flattened cache.
     *
     * @method clearFlattenedCache
     */
    clearFlattenedCache() {
        this._flattenedLevels = {};
    }

    flattenRecursive(depthRequested, result, parent, level, inclusive, filter, page, sort) {

        if (level == null || (inclusive && (level.getNestDepth() <= depthRequested))
            || level.getNestDepth() == depthRequested || depthRequested == -1) {
            result.push(parent);
        }
        if (level.nextLevel && (level.nextLevel.getNestDepth() <= depthRequested || depthRequested == -1)) {
            const lchildren = level.getChildren(parent, filter, page, sort);

            for (const child of lchildren) {
                this.flattenRecursive(depthRequested, result, child, level.nextLevel, inclusive, filter, page, sort);
            }
        }

    }

    /**
     * On basis of the highLight flag, removes or adds highlight to the row in question. Triggered in response
     * to a rollover event.
     *
     * Sets the currentBackgroundColors property is a result of the following logic.
     * When highLight=true
     * <ul>
     * <li>If enableActiveCellHighlight=true uses the value of the activeCellColor style.</li>
     * <li>Else, uses the value of the rollOverColor style property.</li>
     * </ul>
     * When highLight=false, sets it to null.
     * <br/>
     * Sets the currentTextColors property is a result of the following logic.
     * <ul>
     * <li>When highLight=true, sets it to value of the textRollOverColor property</li>
     * <li>When highLight=false, sets it to null.</li>
     * </ul>
     *
     * @param cell    The IFlexDataGridCell to highligh or remove the highlight from
     * @param row    The rowInfo object associated with this cell.
     * @param highLight    Whether to add a highlight or remove the highlight
     * @param highLightColor    If you want to override the color that is calculated using the logic above.
     * @method highlightRow
     */
    highlightRow(cell, row, highLight, highLightColor) {

        if (typeof highLightColor == "undefined") highLightColor = 0;
        if (this._isScrolling) {
            return;
        }
        const cells = this.getIsRowSelectionMode() && !row.getIsChromeRow() ? row.cells : [new flexiciousNmsp.ComponentInfo(cell, 0, null)];

        let rollOverColor;
        let rollOverTextColor;

        if (cell) {
            rollOverColor = cell.getRolloverColor();
            rollOverTextColor = cell.getRolloverTextColor();
        }

        for (const comp of cells) {
            const rowCell = comp.component;
            if (rowCell) {
                if (rollOverColor == null && rowCell == null)
                    rollOverColor = rowCell.getRolloverColor();
                if (!highLight) {
                    if (rowCell.currentBackgroundColors) {
                        rowCell.currentBackgroundColors = null;
                        rowCell.currentTextColors = null;
                        rowCell.invalidateBackground();
                    }
                }
                else {
                    if (rollOverColor && (this.useRollOver)) {
                        rowCell.currentBackgroundColors = highLightColor != 0 ? highLightColor :
                            ((rowCell == this.currentCell) && rowCell.rowInfo.getIsDataRow() && this.enableActiveCellHighlight) ? cell.getStyleValue("activeCellColor") : rollOverColor;
                        rowCell.currentTextColors = rollOverTextColor;
                        rowCell.invalidateBackground();
                    }
                }
            }
        }
    }

    /**
     * Triggered when drag is starting. Use the dragAvailableFunction to control whether drag proceeds
     * @param event
     * @method  gin
     */
    dragBegin(event) {
        const cell = event.currentTarget;
        if (flexiciousNmsp.DisplayList.isMouseDown && !this.dragDropGlyph) {
            var pt = new flexiciousNmsp.Point(0, 0);

            if (!cell.getEnabled()) return;
            if (cell) {
                if (this.dragAvailableFunction != null) {
                    if (!this.dragAvailableFunction(cell))
                        return;
                }
                this._dragColumn = cell.getColumn();
                this._dragRowData = cell.rowInfo.getData();
                pt = cell.localToGlobal(pt);
                pt = this.globalToLocal(pt);

                this.dragDropGlyph = new flexiciousNmsp.UIComponent();
                this.addChild((this.dragDropGlyph));
                this.dragDropGlyph.attachClass("flexiciousUnSelectableText");

                const row = cell.getRowInfo();
                let html = "";

                for (const rowCell of row.cells) {
                    html += rowCell.component.domElement.outerHTML;
                }

                //console.log(pt.x +":" + pt.y)
                this.dragDropGlyph.domElement.style.position = "absolute";
                var pt = new flexiciousNmsp.Point(event.pageX, event.pageY);
                pt = this.globalToLocal(pt);
                this.dragDropGlyph.move(pt.x, pt.y + 16);
                html = html.replace(/top:/ig, "top_old:");
                this.dragDropGlyph.domElement.innerHTML = `<div class='flexiciousGrid' style='width:300px;height:25px;'>${html}</div>`;
                const sbRoot = flexiciousNmsp.DisplayList.instance().documentComponent;
                sbRoot.addEventListener(this, Constants.EVENT_MOUSE_MOVE, this.onDragMove, true);
                sbRoot.addEventListener(this, Constants.EVENT_MOUSE_UP, this.onDragEnd, true);
                this.attachClass("flexiciousUnSelectableText");
                UIUtils.attachClass(document.body, "flexiciousUnSelectableText");
                FlexDataGrid.currentDragCell = cell;
            }

        } else if (FlexDataGrid.currentDragCell && cell && cell.rowInfo.getIsDataRow()) {
            this.dragAcceptReject(cell);
        } else {
            this.dropIndicator.setVisible(false);
        }


    }

    onDragMove(evt) {


        let pt = new flexiciousNmsp.Point(evt.pageX, evt.pageY);
        pt = this.globalToLocal(pt);
        this.dragDropGlyph.move(pt.x, pt.y + 16);
    }

    onDragEnd(event) {

        const sbRoot = flexiciousNmsp.DisplayList.instance().documentComponent;

        sbRoot.removeEventListener(Constants.EVENT_MOUSE_MOVE, this.onDragMove, true);
        sbRoot.removeEventListener(Constants.EVENT_MOUSE_UP, this.onDragEnd, true);
        UIUtils.detachClass(this.domElement, "flexiciousUnSelectableText");
        UIUtils.detachClass(document.body, "flexiciousUnSelectableText");

        this.getBodyContainer().isMouseDown = 0;
        if (!this.dragDropGlyph)
            return;
        if (this.dragDropGlyph) {
            this.removeChild((this.dragDropGlyph));
            this.dragDropGlyph = null;
        }
        if (this.dropIndicator.getVisible()) {
            this.dragDropInternal(FlexDataGrid.currentDropCell);
        }
        FlexDataGrid.currentDragCell = null;

        flexiciousNmsp.DisplayList.isMouseDown = 0;
    }

    /**
     * @method dragEnterInternal
     */

    dragEnterInternal(event) {

        this.dragEnter(event);

    }

    /**
     * @method dragDropInternal
     */

    dragDropInternal(event) {
        if (this.enableDrop && FlexDataGrid.currentDropCell && FlexDataGrid.currentDropCell.level.grid == this) {
            this.dragDrop(event);
        }

    }

    /**
     * Called when the DragEnter event is dispatched over any of the cells.
     * The event is passes in as is.
     * @param event
     * @method dragEnter
     */
    dragEnter(event) {


    }

    /**
     * Called when the drag enters over a cell. Use the dropAcceptRejectFunction to control behavior
     * @method dragAcceptReject
     */
    dragAcceptReject(cell) {
        if (!this.enableDrop) return;
        if (this.dropAcceptRejectFunction != null) {
            if (!this.dropAcceptRejectFunction(cell)) {
                this.dropIndicator.setVisible(false);
                return;
            }
        }
        //DragManager.acceptDragDrop(cell ? cell.implementsOrExtends('IUIComponentbodyContainer'));
        this.showDropIndicator(cell);

    }

    /**
     * Scrolls to the row that appears at the specified vertical position
     * @param vsp            Vertical Position to Scroll to
     * @param scrollDown     Whether you are scrolling up or down
     * @method scrollToExistingRow
     *
     */
    scrollToExistingRow(vsp, scrollDown) {

        this.getBodyContainer().scrollToExistingRow(vsp, scrollDown);
        if (flexiciousNmsp.DisplayList.isMouseDown) {
            this.dropIndicator.setVisible(false);
        }

    }

    /**
     * Given a data object and a colum, return the IFlexDataGridDataCell object for the combination
     * @param data        The row data
     * @param column     The FlexDataGridColumn
     * @method getCellForRowColumn
     */
    getCellForRowColumn(data, column) {

        return this.getBodyContainer().getCellForRowColumn(data, column);

    }

    /**
     * Called to show the drop indicator below the passed in cells row. IF you
     * wish to see custom drop signs, override this function.
     * @method showDropIndicator
     */
    showDropIndicator(cell) {

        this.dropIndicator.setVisible(true);
        this.dropIndicator.setX(1);
        if (cell)
            this.dropIndicator.setY(this.globalToLocal(cell.localToGlobal(new flexiciousNmsp.Point(0, cell.getHeight()))).getY());
        else
            this.dropIndicator.setY(this.getBodyContainer().getY() + (this.getBodyContainer().getCalculatedTotalHeight()));

        this.dropIndicator.setWidth((this.getWidth() - this.isVScrollBarVisible));
        this.dropIndicator.setHeight(this.getStyle("dropIndicatorThickness"));
        //this.dropIndicator.domElement.style.border = "solid 1px red"
        //this.dropIndicator.domElement.innerHTML = "<p>helllo i am here</p>"
        this.dropIndicator.domElement.style.backgroundColor = this.getStyle("dropIndicatorColor") || "#ff0000";
        this.dropIndicator.domElement.style.position = "absolute";
        this.dropIndicator.domElement.style.display = "block";
        FlexDataGrid.currentDropCell = cell;

    }

    /**
     * Called when the DragDrop event is dispatched over any of the cells.
     * The event is passes in as is.
     * @param event
     * @method dragDrop
     */
    dragDrop(event) {
        if (FlexDataGrid.currentDropCell && FlexDataGrid.currentDragCell) {
            if (this.dragDropCompleteFunction != null) {
                this.dragDropCompleteFunction(event);
            }
        }
        this.dropIndicator.setVisible(false);

    }

    /**
     * Generates a snapshot of the row for the drag visual indicator
     * @param cell
     * @return 
     * @method generateImageForDrag
     */
    generateImageForDrag(cell) {
        //todo

    }

    /**
     * @method invalidateSelection
     */

    invalidateSelection() {
        this._selectionInvalid = true;
        this.doInvalidate();
    }

    /**
     * @method placeComponents
     */
    placeComponents(row) {
        this.placeChildComponents(row.cells);
    }

    /**
     * @method placeChildComponents
     */

    placeChildComponents(components) {
        for (const comp of components) {
            this.placeComponent(comp);
        }
    }

    /**
     * Corner areas are special containers that exist to hold filter and header on the top
     * and Pager and Footer on the bottom
     * If I am filter cell, return 0 if filter is above header (true always)
     * IF I am header cell, return filterHeight + (headerHeight * header Depth)
     * If I am footer cell, return 0
     * If I am pager cell, return pager footer height
     * @method getCornerY
     */
    getCornerY(comp) {


        const filterAboveHeader = this.getDisplayOrder().indexOf("filter") < this.getDisplayOrder().indexOf("header");
        if (comp.row.getIsFilterRow()) {
            return filterAboveHeader ? 0 : (this.getColumnLevel().getHeaderHeight() * this.getColumnLevel().getMaxColumnGroupDepth());
        }
        else if (comp.row.getIsHeaderRow() || comp.row.getIsColumnGroupRow()) {
            const filterOffset = filterAboveHeader ? this.getFilterRowHeight() : 0;
            if (comp.component.implementsOrExtends('FlexDataGridColumnGroupCell')) {
                //cg cell
                return filterOffset + ((comp.component).columnGroup.getDepth() *
                    this.getColumnLevel().getHeaderHeight()
                )
                    - this.getColumnLevel().getHeaderHeight();
            }

            return filterOffset + (this.getColumnLevel().getMaxColumnGroupDepth() * this.getColumnLevel().getHeaderHeight())
                - this.getColumnLevel().getHeaderHeight() - (comp.component.getHeight() - comp.row.getHeight());
        }
        return comp.component.getY();

    }

    /**
     * @method placeComponent
     */

    placeComponent(comp) {

        const v = (comp.row && !comp.inCornerAreas ? comp.row.getY() -
            ((comp.row.getIsHeaderRow() || comp.row.getIsColumnGroupRow()) ?
                comp.component.getHeight() - comp.row.getHeight() : 0) : this.getCornerY(comp));
        const compx = comp.component.implementsOrExtends("FlexDataGridColumnGroupCell") ? comp.component.getX() : comp.getX();

        comp.component.move(compx, v);
        if (this.cellPlacementFunction) {
            this.cellPlacementFunction(comp.component);
        }
    }

    /**
     */
    addComponent(component) {
        this.addChild(component);
    }

    addPopup(component) {
        this.addChild(component);
        this.resizeListenerPaused = true;
    }
    removePopup(component) {
        this.removeChild(component);
        this.resizeListenerPaused = false;
    }

    /**
     * @method drawDefaultSeperators
     */
    drawDefaultSeperators() {

        this.getLeftLockedVerticalSeparator().setVisible(false);
        this.getRightLockedVerticalSeparator().setVisible(false);

        const lockedSeperatorColor = UIUtils.decimalToColor(this.getStyle("lockedSeperatorColor"));
        if (this.getColumnLevel().getLeftLockedColumns().length > 0) {
            this.getLeftLockedVerticalSeparator().attachClass("leftLockedVerticalSeparator");
            this.getLeftLockedVerticalSeparator().setX(this.getLeftLockedContent().getWidth());
            this.getLeftLockedVerticalSeparator().setY(this.getHeaderContainer().getY());
            this.getLeftLockedVerticalSeparator().setHeight((this.getHeaderContainer().getHeight() + this.getFilterContainer().getHeight() + this.getBodyContainer().getHeight() + this.getFooterContainer().getHeight()) - this.isHScrollBarVisible);
            this.getLeftLockedVerticalSeparator().setWidth(this.getStyle("lockedSeperatorThickness"));
            this.getLeftLockedVerticalSeparator().setVisible(true);
            this.getLeftLockedVerticalSeparator().setStyleAttribute("backgroundColor", lockedSeperatorColor);
            this.setChildIndex(this.getLeftLockedVerticalSeparator(), this.numChildren());
        }
        if (this.getColumnLevel().getRightLockedColumns().length > 0) {

            this.getRightLockedVerticalSeparator().attachClass("rightLockedVerticalSeparator");
            this.getRightLockedVerticalSeparator().setX(this.getRightLockedContent().getX());
            this.getRightLockedVerticalSeparator().setY(this.getHeaderContainer().getY());
            this.getRightLockedVerticalSeparator().setHeight((this.getHeaderContainer().getHeight() + this.getFilterContainer().getHeight() + this.getBodyContainer().getHeight() + this.getFooterContainer().getHeight()) - this.isHScrollBarVisible);
            this.getRightLockedVerticalSeparator().setWidth(this.getStyle("lockedSeperatorThickness"));
            this.getRightLockedVerticalSeparator().setVisible(true);
            this.getRightLockedVerticalSeparator().setStyleAttribute("backgroundColor", lockedSeperatorColor);
            this.setChildIndex(this.getRightLockedVerticalSeparator(), this.numChildren());
        }

    }

    /**
     * Goes to the specified horizontal position. Going to a specified horizontal
     * scroll position requires the renderers to recycle if the set of visible
     * columns changes.
     * @method gotoHorizontalPosition
     */
    gotoHorizontalPosition(vsp) {

        this.getBodyContainer().gotoHorizontalPosition(vsp);
        this.recycleH(true);

    }

    /**
     * Goes to the specified vertical position. Going to a specified horizontal
     * scroll position requires the renderers to recycle if the set of visible
     * rows changes.
     * @method gotoVerticalPosition
     */
    gotoVerticalPosition(vsp) {
        this.getBodyContainer().gotoVerticalPosition(vsp);
        this.synchronizeLockedVerticalScroll();
    }

    /**
     * Returns all columns at all levels.
     * @return
     * @method getExportableColumns
     *
     */
    getExportableColumns(exportOptions) {
        return this.getColumnLevel().getExportableColumns(null, true, exportOptions);
    }

    /**
     * Removes all the sorts and calls doInvalidate.
     *
     * @method removeAllSorts
     */
    removeAllSorts() {
        const lsw = this.getDataProvider();
        this.getColumnLevel().removeAllSorts();
        if (!this.getColumnLevel().getIsClientFilterPageSortMode()) {
            //fpsmode=server
            this.processFilter();
        }
        else {
            this.rebuild();
        }

    }

    /**
     * @method getPrintableColumns
     */
    getPrintableColumns(options) {
        const result = [];
        const pCols = this.getColumnLevel().getPrintableColumns();

        for (const fdg of pCols) {
            if (!options.excludeHiddenColumns || fdg.getVisible())
                result.push(fdg);
        }

        return result;
    }

    /**
     * Returns the top level filter.
     * @method createFilter
     */
    createFilter() {
        return this.getFilterContainer().createFilter(this.getColumnLevel(), null);
    }

    /**
     * Clears filters at all levels and rebuilds the grid.
     * @method clearAllFilters
     */
    clearAllFilters() {

        this.itemFilters.clear();
        this.rebuild();

    }

    /**
     * Clears the filters at all levels
     * @method clearFilter
     */
    clearFilter() {

        this.itemFilters.addItem(Constants.TOP_LEVEL_FILTER, null);
        if (this.getFilterContainer().rows.length > 0) {
            this._triggerEvent = false;
            this.getFilterContainer().rows[0].clearFilter();
            this._triggerEvent = true;
            this.getFilterContainer().rows[0].processFilter();
        }

    }

    /**
     * Inserts the column specified column before the specified column
     * @method shiftColumns
     */
    shiftColumns(columnToInsert, insertBefore, level, movingCg) {
        if (typeof movingCg == "undefined") movingCg = false;

        level.shiftColumns(columnToInsert, insertBefore, movingCg);
        this.getBodyContainer().shiftColumns(columnToInsert, insertBefore);
        this.reDraw();

    }

    /**
     * Evaluates whether the given toolbar action is valid or not.
     *
     * If toolbarActionValidFunction is not null, returns the result of the function passing in the given ToolbarAction.
     * Else returns true.
     * @method isToolbarActionValid
     */
    isToolbarActionValid(action, currentTarget, extendedPager) {

        if (this.toolbarActionValidFunction != null) {
            return this.toolbarActionValidFunction(action, currentTarget, extendedPager);
        } else if (action.requiresSingleSelection) {
            if (this.getSelectedKeys().length == 1) {
                const appliesToLevel = action.level;
                const itemLvl = this.getLevelForItem(this.getSelectedObjects()[0]);
                if (appliesToLevel == -1 || (itemLvl && (itemLvl.getNestDepth() == appliesToLevel)))
                    return true;
                else
                    return false;
            }
            return false;
        } else if (action.requiresSelection) {
            return this.getSelectedKeys().length > 0;
        }
        return true;

    }

    /**
     * In addition to initial enable/disable of toolbar actions, this function
     * can be used to enable or disable toolbar actions at run time.
     * @method enableDisableToolbarAction
     */
    enableDisableToolbarAction(code, enable) {

        const existingAction = this.getActionByCode(code);
        if (existingAction)
            existingAction.enabled = enable;

    }

    /**
     * Gets the actual button object for the provided toolbar action.
     * @param code
     * @return
     * @method getToolbarActionButton
     */
    getToolbarActionButton(code) {

        const existingAction = this.getActionByCode(code);
        if (existingAction)
            return existingAction.trigger;
        return null;

    }

    /**
     * Sets a property or a style of the button object associated with the toolbar action
     * that has the given code.
     * @method setToolbarActionButtonProperty
     */
    setToolbarActionButtonProperty(toolbarActionCode, property, value) {

        const button = this.getToolbarActionButton(toolbarActionCode);
        if (button) {
            if (button.hasOwnProperty(property)) {
                button[property] = value;
            } else {
                button.setStyle(property, value);
            }
        }

    }

    /**
     * Returns true if the getLength method on the result of the getChildren
     * method returns more than 0
     * @param item
     * @return
     * @method defaultDynamicLevelHasChildrenFunction
     *
     */
    defaultDynamicLevelHasChildrenFunction(item) {

        return this.getLength(this.getChildren(item, this.getColumnLevel())) > 0;

    }

    /**
     * A list of selected objects from the data provider. This is the sdk equivalent of selectedItems. 
		 * We do not have selectedItems, but selectedObjects will almost always be the same as selectedItems. 
		 * The only exception is when you use server side paging. In this case, selectedObjects will contain all the items
		 * selected, on all pages.
		 * 
		 * When a row is selected in the grid, we store the  the selected object in the selectedObects array collection. 
		 * This allows for multiple pages of data that comes down from the server and not maintained in memory 
		 * to still keep track of the objects that were selected on other pages.
		 * 
		 * Please note, for hierarchical grids, each level has its own collection of selected keys.
		 * The grid.selectedObjects returns the selectedKeys at the top level. To access the selected keys
		 * at a lower level, you may navigate to that level using grid.columnLevel.nextLevel...nextLevel.selectedKeys 
		 * You can also call grid.selectedObjectsAtAllLevels to get selected objects at all levels. 
     * @method getSelectedObjects
     */
    getSelectedObjects(getKey, unSelected) {
        if (typeof getKey == "undefined") getKey = false;
        if (typeof unSelected == "undefined") unSelected = false;

        const sObjects = [];
        const items = unSelected ? this.getColumnLevel().getUnSelectedObjects() : this.getColumnLevel().getSelectedObjects();

        for (const item of items) {
            sObjects.push(getKey ? this.getColumnLevel().getItemKey(item) : item);
        }

        if (this.getColumnLevel().nextLevel) {
            this.getColumnLevel().nextLevel.getSelectedObjectsDeep(sObjects, getKey, unSelected);
        }
        return sObjects;
    }

    /**
     * Returns a copy of the open items array.
     * @method getOpenObjects
     */
    getOpenObjects() {

        return this.getOpenItems().source.slice();

    }

    /**
     * A list of ID values, based on the selectedKeyField property.
     * For hierarchical datagrids, used to get all open(expanded) records at all levels.
     * Please NOTE - this is a read only collection. Adding to this does nothing.
     *
     * If you want to programatically modify the collapse expand, use the setOpenKeys instead, or add directly to the open items.
     * @method getOpenKeys
     * */
    getOpenKeys() {

        const keys = [];
        this.getColumnLevel().getOpenKeys(keys);
        return keys;

    }

    /**
     * For nested/grouped hierarchical datagrids, used to select records.
     * Iterates through the data provider, matching each object, and if matches, adds the object
     * to the grid.getOpenItems()
     *
     * When you reset the dataprovider via server call, the original objects that we were tracking with
     * openItems are gone, so the grid no longer has  a handle to know which items to retain open. To combat
     * this, you may use the following snippet:
     *
     * <p>
     * var openKeys:Array=grid.getOpenKeys(); <br/>
     * grid.dataProvider=yourNewDataProvider;<br/>
     * grid.setOpenKeys(openKeys);<br/>
     * </p>
     *
     * Please note, these API calls rely on the selectedKeyField being defined at each level, as well as the key values being unique.
     * @method setOpenKeys
     */
    setOpenKeys(keys) {

        this.getBodyContainer().clearOpenItems();
        this.getColumnLevel().setOpenKeys(keys);
        this.rebuild();

    }

    /**
     * For nested/grouped hierarchical datagrids, used to select records.
     * Iterates through the data provider, matching each object, and if matches, adds the object
     * to the selectedObjects for the level
     *
     * Please see the documentation of setSelectedKeys for instructions on maintaining grid selection
     * post a data provider refresh.
     * @method setSelectedObjects
     */
    setSelectedObjects(objects, openItems) {
        if (typeof openItems == "undefined") openItems = true;

        this.getColumnLevel().setSelectedObjects(objects, openItems);

    }

    /**
     * For nested/grouped hierarchical datagrids, used to select records.
     * Iterates through the data provider, matching each object, and if matches, adds the object
     * to the selectedObjects for the level. Ensure that the selectedKeyField is set at the level.
     *
     * When you reset the dataprovider via server call, the original objects that we were tracking with
     * selected objects are gone, so the grid no longer has  a handle to know which items to retain selected. To combat
     * this, you may use the following snippet:
     *
     * <p>
     * var selectedKeys:Array=grid.getSelectedKeys(); <br/>
     * grid.dataProvider=yourNewDataProvider;<br/>
     * grid.setSelectedKeys(selectedKeys);<br/>
     * </p>
     *
     * Please note, these API calls rely on the selectedKeyField being defined at each level, as well as the key values being unique.
     * @method setSelectedKeys
     */
    setSelectedKeys(objects, openItems) {
        if (typeof openItems == "undefined") openItems = true;

        this.getColumnLevel().setSelectedKeys(objects, openItems);

    }

    /**
     * For nested datagrids, used to get all records at all levels.
     * Please see the documentation of setSelectedKeys for instructions on maintaining grid selection
     * post a data provider refresh.
     * @method getSelectedKeys
     */
    getSelectedKeys() {

        return this.getSelectedObjects(true);

    }

    /**
     * When enableSelectionExclusion, returns a list of items that the user explicitly unselected.
     * @method getUnSelectedKeys
     */
    getUnSelectedKeys() {

        return this.getSelectedObjects(true, true);

    }

    /**
     * Given a row index (less than the total number of rows, goes to the row in question).
     * Row index becomes the first visible row. Please note this is a 1 based index.
     * @method gotoRow
     */
    gotoRow(rowIndex) {

        this.getBodyContainer().gotoRow(rowIndex);
        this.synchronizeLockedVerticalScroll();

    }

    /**
     * Selects the provided text in the currently visible cells
     * that have the default item renderer, or if the item renderer
     * has the selection property
     * @method selectText
     */
    selectText(txt) {

        this.getBodyContainer().selectText(txt);

    }

    /**
     * Given a data item, scrolls to that item in the datagrid
     *
     * Flexicious by default will only build RowPositionInfo objects
     * for open items that the user can visually scroll to. So items that
     * are closed, or are on a different page, will not be built, and cannot be scrolled to.
     * This function will will inspect the data provider to find the item in question, and build the RowPositionInfo for it
     * if its not found in the currently built RowPositionInfo objects.
     * @method gotoItem
     */
    gotoItem(item, highlight, level) {
        if (typeof highlight == "undefined") highlight = true;
        if (typeof level == "undefined") level = null;

        this.getBodyContainer().gotoItem(item, highlight, false, level);
        this.synchronizeLockedVerticalScroll();

    }

    /**
     * Given a key, scrolls to the item that has the provided value for the selectedKeyField at that level
     *
     * Flexicious by default will only build RowPositionInfo objects
     * for open items that the user can visually scroll to. So items that
     * are closed, or are on a different page, will not be built, and cannot be scrolled to.
     * This function will will inspect the data provider to find the item in question, and build the RowPositionInfo for it
     * if its not found in the currently built RowPositionInfo objects.
     * @method gotoKey
     */
    gotoKey(key, highlight, level) {
        if (typeof highlight == "undefined") highlight = true;
        if (typeof level == "undefined") level = null;

        this.getBodyContainer().gotoItem(key, highlight, true, level);
        this.synchronizeLockedVerticalScroll();

    }

    /**
     * Iterates through the data provider to get a list of row positions
     * that match the text provided.
     * @method quickFind
     */
    quickFind(whatToFind) {

        return this.getBodyContainer().quickFind(whatToFind);

    }

    /**
     * Gets the cell that is currently being edited.
     * @method getCurrentEditCell
     */
    getCurrentEditCell() {

        return this._editCell;

    }

    /**
     * Gets the editor that is currently being edited.
     * @method getCurrentEditor
     */
    getCurrentEditor() {

        return this._editor;

    }

    /**
     * Synchronizes the vertical scroll positions of the three locked sections
     * @method synchronizeLockedVerticalScroll
     */
    synchronizeLockedVerticalScroll() {

        this.getLeftLockedContent().setVerticalScrollPosition(this.getBodyContainer().getVerticalScrollPosition());
        this.getRightLockedContent().setVerticalScrollPosition(this.getBodyContainer().getVerticalScrollPosition());
    }

    /**
     * Synchronizes the vertical scroll positions of the three locked sections
     * @method synchronizeHorizontalScroll
     */
    synchronizeHorizontalScroll() {

        this.getHeaderContainer().setHorizontalScrollPosition(this.getBodyContainer().getHorizontalScrollPosition());
        this.getFooterContainer().setHorizontalScrollPosition(this.getBodyContainer().getHorizontalScrollPosition());
        this.getFilterContainer().setHorizontalScrollPosition(this.getBodyContainer().getHorizontalScrollPosition());

    }

    /**
     * Returns the data provider, with filter, paging and sorting applied on basis
     * of the boolean flags specified. The passed in dictionary contains a map of each
     * item in the resulting collection to the level that it belongs to.
     * 
     * @param dictionary	Map of each item in the resulting collection to the level that it belongs to
     * @param applyFilter	Whether or not to apply the filter
     * @param applyPaging	Whether or not to apply paging
     * @param applySort		Whether or not to apply sort
     * @param pages			Which pages to get, only needed if you want a page range. specify null(default) if you want only the current page.
     * @return A flat array of all items that match the criteria generated on basis of the parameters above.
     *  
     * @method getFilteredPagedSortedData
     *
     */
    getFilteredPagedSortedData(dictionary, applyFilter, applyPaging, applySort, pages) {
        if (typeof applyFilter == "undefined") applyFilter = true;
        if (typeof applyPaging == "undefined") applyPaging = true;
        if (typeof applySort == "undefined") applySort = true;
        if (typeof pages == "undefined") pages = null;

        return this.getBodyContainer().getFilteredPagedSortedData(dictionary, applyFilter, applyPaging, applySort, pages)

    }

    /**
     *Returns the RowPosition Info object for the item at the given vertical scroll position
     * @method getItemAtPosition
     */
    getItemAtPosition(position) {

        return this.getBodyContainer().getItemAtPosition(position);

    }

    /**
     *Returns the container for the given cell
     * @method getParentContainer
     */
    getParentContainer(cell) {

        if (cell.parent == this.getBodyContainer || cell.parent == this.getLeftLockedContent || cell.parent == this.getRightLockedContent)
            return this.getBodyContainer();
        if (cell.rowInfo.getIsFilterRow() && cell.level == this.getColumnLevel())
            return this.getFilterContainer();
        if (cell.rowInfo.getIsHeaderRow() && cell.level == this.getColumnLevel())
            return this.getHeaderContainer();
        if (cell.rowInfo.getIsFooterRow() && cell.level == this.getColumnLevel())
            return this.getFooterContainer();
        return this.getBodyContainer();

    }

    /**
     * Calls getChildren, and if result is XML or XMLList, returns length() else returns length;
     * @method getChildrenLength
     */
    getChildrenLength(object, level, filter, page, sort) {
        if (typeof filter == "undefined") filter = false;
        if (typeof page == "undefined") page = false;
        if (typeof sort == "undefined") sort = false;

        const children = this.getChildren(object, level, filter, page, sort);
        return this.getLength(children);


    }

    /**
     * If arr is XML or XMLList, returns length() else returns length;
     * @method getLength
     */
    getLength(arr) {

        return UIUtils.getLength(arr);

    }

    /**
     * If the dataprovider is IHierarchicalCollectionView, calls the getChildren method on the incoming object.
     * If object is XMLList or XML, returns the result of its "children" method.
     * Else returns the value of the level.childrenField property on the object being passed in
     *
     * Prior to returning, applies filter, page or sort as specified by the parameters.
     * You can intercept calls to this function by defining a custom getChildrenFunction
     * @method getChildren
     */
    getChildren(object, level, filter, page, sort) {
        if (typeof filter == "undefined") filter = false;
        if (typeof page == "undefined") page = false;
        if (typeof sort == "undefined") sort = false;

        let result;
        if (this.getChildrenFunction != null) {
            result = this.getChildrenFunction(object, level);
        }

        else {
            if (level.childrenField == null || level.childrenField == "") return [];
            result = object.hasOwnProperty(level.childrenField) ? object[level.childrenField] : [];
        }
        if (result == null) return [];
        if (filter || page || sort) {
            return this.getBodyContainer().filterPageSort(result, level.nextLevel ? level.nextLevel : level
                , object, filter, page, sort);
        }
        else {
            return result;
        }

    }

    /**
     * Returns the parent object for the passed in object.
     * Please note, if your data provider is xml or hierarchical collection view,
     * grid will use the getParent method or getParentItem method on such data providers
     * respectively. If you have specified a parentField, which is a pointer
     * on the object that points back to the parent, the grid will use that.
     * If none of the above is true, the grid will use its built in map of
     * hierarchical data, but this has a limitation of only being able to return
     * parents of items that are on the current page of data.
     * @method getParent
     * */
    getParent(object, level) {

        if (this.enableVirtualScroll) {
            return this.getVirtualBodyContainer().getParentOpenItemFromObject(object);
        }
        let result;
        if (level.parentField == null || level.parentField == "") {
            result = this.getBodyContainer().parentMap[level.getItemKey(object)];
        }
        else {
            result = object[level.parentField];
        }
        return result;


    }

    /**
     * Called by PrintController and ExportController to get the data on basis of PrintOptions and ExportOptions
     * @param {PrintOptions} [printOptions]
     * @method getDataForPrintExport
     */
    getDataForPrintExport(printOptions) {

        if (printOptions.printExportOption == flexiciousNmsp.PrintExportOptions.PRINT_EXPORT_CURRENT_PAGE) {
            if (this.getIsClientFilterPageSortMode())
                return this.getFilteredPagedSortedData({}, true, true, true);
            else
                return this.getDataProvider();//just use same dp as main grid in server mode.
        } else if (printOptions.printExportOption == flexiciousNmsp.PrintExportOptions.PRINT_EXPORT_SELECTED_RECORDS) {
            return this.getSelectedObjectsTopLevel();
        } else {
            //all or selected pages, in server mode, dispatch event. in client mode, do page math.
            if (this.getIsClientFilterPageSortMode()) {
                if (printOptions.printExportOption == flexiciousNmsp.PrintExportOptions.PRINT_EXPORT_SELECTED_PAGES)
                    return this.getFilteredPagedSortedData({}, true, true, true, [printOptions.pageFrom, printOptions.pageTo]);
                else
                    return this.getFilteredPagedSortedData({}, true, false, true, null);// all pages
            }
            else {
                return this._printExportData;
            }
        }
    }

    /**
     * Sets the visible flag on all columns except the ones speicified in the list to false.
     * @method showColumns
     */
    showColumns(colsToShow) {

        this.getColumnLevel().showColumns(colsToShow);

    }

    /**
     * Sets the visible flag on all columns except the ones where excludeFromPrint=true.
     * @method showPrintableColumns
     */
    showPrintableColumns() {

        this.getColumnLevel().showPrintableColumns();

    }

    /**
     *Returns the filter at the top level.
     * @method getFilterArguments
     */
    getFilterArguments() {

        return this.getFilterContainer().getFilterArguments();

    }

    /**
     *Gets the filter at the root level
     * @method getRootFilter
     */
    getRootFilter() {

        if (!this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER)) {
            this.itemFilters.addItem(Constants.TOP_LEVEL_FILTER, new flexiciousNmsp.AdvancedFilter());
            this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER).pageIndex = 0;
        }
        return this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER);

    }

    /**
     * Used to set the initial value of the filter at the top level for the specified field.
     * @param col		The column to set filter for
     * @param val			The value to set
     * @param triggerEvent	Whether or not to fire the filterPageSortChange event. Defaults to true.
     * @method setFilterValue
     */
    setFilterValue(col, val, triggerEvent) {
        if (typeof triggerEvent == "undefined") triggerEvent = true;

        const gridCol = this.getColumnLevel().getColumnByDataField(col, 'searchField');
        const rootFilter = this.getRootFilter();
        rootFilter.addOperatorCriteria(gridCol.getSearchField(), gridCol.filterOperation, val);
        if (this.getFilterContainer().rows.length == 0) {
            this.rebuildFilter();
        }
        this.getFilterContainer().setFilterValue(col, val);
        if (triggerEvent)
            this.processFilter();

    }

    /**
     * Sets the filter at the top level.
     *
     * @param fld    The string to match the searchField property of the filter control with.
     * @return         True if focus was set, false if otherwise.<br/>
     * Focus may not be set if the given search field does not exist, <br/>
     * or if the filter control for the given search field does not  <br/>
     * implement IFocusManagerComponent.
     * @method setFilterFocus
     */
    setFilterFocus(fld) {

        return this.getFilterContainer().setFilterFocus(fld);

    }
    /**
     * Used to set the initial value of the filter at the top level for the specified field.
     * @param col		The column to set filter for
     * @method getFilterValue
	 * @return {*}
     */
    getFilterValue(col) {

        const rootFilter = this.getRootFilter();
        return rootFilter.getFilterValue(col);

    }

    /**
     * Used by state persistence to load sort settings that were
     * persisted previously.
     * @param sorts
     * @method processSort
     *
     */
    processSort(sorts) {
        this.getColumnLevel().removeAllSorts();

        for (const sort of sorts) {
            this.getColumnLevel().addSort(sort);
        }

        this.rebuildBody();
        this.rebuildHeader();
    }

    /**
     * Clears out all the columns of the grid
     * If the parameter to rebuild is true, the grid will be rebuilt.
     * Otherwise, just the columns will be cleared, and the consumer code
     * should rebuild the grid.
     * @method clearColumns
     */
    clearColumns(rebuild) {
        if (typeof rebuild == "undefined") rebuild = true;

        this.getColumnLevel().clearColumns();

    }

    /**
     * Adds the column to the collection of columns at the root level.
     * @method addColumn
     */
    addColumn(col) {

        this.getColumnLevel().addColumn(col);

    }

    /**
     * Removes the column from the collection of columns at this level.
     * @method removeColumn
     */
    removeColumn(col) {

        this.getColumnLevel().removeColumn(col);

    }

    /**
     *Returns the column with the specified datafield, only at the root level
     * @method getColumnByDataField
     */
    getColumnByDataField(fld) {

        return this.getColumnLevel().getColumnByDataField(fld);

    }

    /**
     *Returns the column with the specified UniqueIdentifier, only at the root level
     * @method getColumnByUniqueIdentifier
     */
    getColumnByUniqueIdentifier(fld) {

        return this.getColumnLevel().getColumnByUniqueIdentifier(fld);

    }

    /**
     * Modifies the columns so the width is distributed equally.
     * Columns that are fixedWidth are not updated.
     * @method distributeColumnWidthsEqually
     */
    distributeColumnWidthsEqually() {

        this.getColumnLevel().distributeColumnWidthsEqually();

    }

    /**
     * Returns FlexDataGridColumnLevel object at the specified depth
     * @method getLevel
     */
    getLevel(levelDepth) {

        let level = this.getColumnLevel();
        while (level != null) {
            if (level.getNestDepth() == levelDepth)
                return level;
            level = level.nextLevel;
        }
        return null;

    }

    /**
     * Returns the export controller instance
     */
    getExportController() {
        return flexiciousNmsp.ExtendedExportController.instance();
    }

    /**
     * Returns the print controller instance
     */
    getPrintController() {
        return flexiciousNmsp.ExtendedPrintController.instance();
    }

    /**
     * For nested datagrids, expands all items to the level specified.
     * @method expandToLevel
     */
    expandToLevel(level, maxItems) {

        if (this.enableVirtualScroll) throw new Error("This method is not supported when enableVirtualScroll=true");

        if (level < this.getMaxDepth() && level >= 0) {
            this._currentExpandLevel = level;
            const lvlObj = this.getLevelAtNestDepth(level);

            this.getBodyContainer().clearOpenItems();
            if (this._currentExpandLevel > 0) {
                const items = this.flatten(this._currentExpandLevel, true, true, false, true, -1);
                for (let i = 0; i < items.length; i++) {
                    const item = items[i];
                    if (maxItems && maxItems > i) {
                        return;
                    }
                    this.getBodyContainer().addOpenItem(item, null, false, lvlObj);
                }
            }
            this.dispatchEvent(new flexiciousNmsp.BaseEvent("expandChanged"));
            this.rebuildBody();
            //this.invalidateBackground();
        }

    }
    getLevelAtNestDepth(depth) {
        if (depth < 1)
            return this.getColumnLevel();
        let level = this.getColumnLevel();
        while (depth != level.getNestDepth())
            level = level.nextLevel;
        return level;
    }
    onTableContextMenuItemClick(event) {
        const options = flexiciousNmsp.ExportOptions.create(flexiciousNmsp.ExportOptions.TXT_EXPORT);
        options.showColumnPicker = false;
        options.copyToClipboard = true;
        options.printExportOption = flexiciousNmsp.PrintExportOptions.PRINT_EXPORT_ALL_PAGES;
        flexiciousNmsp.ExtendedExportController.instance().doexport(this, options);
        UIUtils.showMessage("Copied to clipboard.");
    }

    /**
     * A method that simply rebuilds the body as opposed to rebuilding the entire grid.
     * @method rebuildBody
     */
    rebuildBody(vupdateTotalRecords) {
        if (typeof vupdateTotalRecords == "undefined") vupdateTotalRecords = false;

        if (this.inRebuildBody) return;//what we call could end up calling us depending on what event handlers are wired up in the client code.
        UIComponent.statePaused = true;
        this.inRebuildBody = true;
        this.updateTotalRecords = vupdateTotalRecords;
        this.getBodyContainer().invalidateCalculatedHeight();
        this.currentPoint.reset();
        this.getBodyContainer().createComponents(this.getColumnLevel());
        this.updateTotalRecords = true;
        this.inRebuildBody = false;
        UIComponent.flushPendingUpdates();

    }

    /**
     * A method that simply rebuilds the header as opposed to rebuilding the entire grid.
     * @method rebuildHeader
     */
    rebuildHeader() {

        this.currentPoint.reset();
        this.getHeaderContainer().createComponents(this.getColumnLevel());

    }

    /**
     * A method that simply rebuilds the pager as opposed to rebuilding the entire grid.
     * @method rebuildPager
     */
    rebuildPager() {

        this.currentPoint.reset();
        this.getPagerContainer().createComponents(this.getColumnLevel());

    }

    /**
     * A method that simply rebuilds the footer as opposed to rebuilding the entire grid.
     * @method rebuildFooter
     */
    rebuildFooter() {

        this.currentPoint.reset();
        this.getFooterContainer().createComponents(this.getColumnLevel());

    }

    /**
     * A method that simply rebuilds the footer as opposed to rebuilding the entire grid.
     * @method rebuildFilter
     */
    rebuildFilter() {

        this.currentPoint.reset();
        this.getFilterContainer().createComponents(this.getColumnLevel());
        this.dispatchEvent(new flexiciousNmsp.BaseEvent('RebuildFilter'));

    }

    /**
     * A method that simply redraws the body as opposed to rebuilding the entire grid.
     * As opposed to rebuild, does not recalculate row positions and heights, just refreshes
     * the currently drawn rows.
     * @method redrawBody
     */
    redrawBody() {

        this.currentPoint.reset();
        this.getBodyContainer().createComponents(this.getColumnLevel());


    }

    /**
     *For nested datagrids, expands all items one level up
     * @method expandUp
     */
    expandUp() {

        this.expandToLevel(this._currentExpandLevel - 1);

    }

    /**
     * For nested datagrids, expands all items one level down
     * @method expandDown
     */
    expandDown() {

        this.expandToLevel(this._currentExpandLevel + 1);

    }

    /**
     * For grids with column groups, expands them all.
     * @method expandAllColumnGroups
     */
    expandAllColumnGroups(lvl) {
        if (typeof lvl == "undefined") lvl = 1;

        const items = this.getColumnLevel().getColumnGroupsAtLevel(lvl);

        for (const cg of items) {
            cg.openColumns();
        }
    }

    /**
     * For grids with column groups, expands them all.
     * @method collapseAllColumnGroups
     */
    collapseAllColumnGroups(lvl) {
        if (typeof lvl == "undefined") lvl = 1;
        const items = this.getColumnLevel().getColumnGroupsAtLevel(lvl);

        for (const cg of items) {
            cg.closeColumns();
        }
    }

    /**
     * For nested datagrids, expands all items one level down
     * @method expandAll
     */
    expandAll() {
        this.expandToLevel(this.getMaxDepth() - 1);

    }

    /**
     * For nested datagrids, expands all items one level down
     * @method collapseAll
     */
    collapseAll() {

        this.expandToLevel(0);

    }

    /**
     *Displays a tooltip for the control in question. The tooltip will disappear if the mouse
	 * moves over an area that is not the 'relativeTo' component or the tooltip component.. 
	 * @param relativeTo Which component to position the popup relative to
	 * @param tooltip The popup to display
	 * @param dataContext If the popup has a data property, it will be set to this value
	 * @param point If you specify this, the relativeTo is ignored, and the popup appears at the exact point you specify. Please ensure that the X and Y are relative to the Grid.
	 * @param leftOffset Whether to shift the popup left after calculating the positions, for customizing the actual position
	 * @param topOffset	Whether to shift the popup top after calculating the positions, for customizing the actual position
	 * @param offScreenMath	Whether or not to adjust the popup if it appears off screen
	 * @param where		One of three values, left, right or none. If left, positions to bottom left, if right, positions to bottom right, if none, positions right below the relativeTo component.
	 * @param container	The holder for the tooltip, defaults to UIUtils.getTopLevelApplication(). You may need to override in multi window Air apps.
	 * By default, the tooltip will go away once you hover the mouse out of the trigger cell or the tooltip and stayed that way for tooltipWatcherTimeout. You may also
	 * manually remove the tooltip by calling the hideToolTip() function. 
	 *
     * @method showTooltip
     */
    showTooltip(
        relativeTo,
        tooltip,
        dataContext,
        point,
        leftOffset,
        topOffset,
        offScreenMath,
        where,
        container) {

        if (typeof point == "undefined") point = null;
        if (typeof leftOffset == "undefined") leftOffset = 0;
        if (typeof topOffset == "undefined") topOffset = 0;
        if (typeof offScreenMath == "undefined") offScreenMath = true;
        if (typeof where == "undefined") where = "left";
        if (typeof container == "undefined") container = this;

        this.tooltipBehavior.showTooltip(relativeTo, tooltip, dataContext, point, leftOffset, topOffset, offScreenMath, where, container);


    }

    /**
     * Hides the current tooltip.
     * @method hideTooltip
     */
    hideTooltip() {

        this.tooltipBehavior.hideTooltip();

    }

    /**
     * @method dispatchEvent
     */
    dispatchEvent(e) {

        //trace("grid dispatching " + e.type)
        if ((e.implementsOrExtends('ExtendedFilterPageSortChangeEvent'))) {
            if (this.showSpinnerOnFilterPageSort && (this.getFilterPageSortMode() == "server" || e.type == "itemLoad")) {
                this.showSpinner();
            }
        }
        if (e.type == flexiciousNmsp.FlexDataGridEvent.CHANGE && this.enableDelayChange && !this.inUpdate && e.grid == this) {
            this._changePending = true;
            this.invalidateDisplayList();
            return false;
        }
        if (e.type == flexiciousNmsp.FlexDataGridEvent.CHANGE && e.grid == null) {
            return false;//this is an internal html control that dispatched a change that bubbled up to us.
        }
        return super.dispatchEvent(e);

    }

    /**
     * @method getItemFilter
     */
    getItemFilter(level, item) {

        return this.itemFilters.getValue(level.getNestDepth() == 1 ? Constants.TOP_LEVEL_FILTER : item);

    }

    /**
     * Handle for the auto refresh.
     * @param event
     * @method dispatchAutoRefreshEvent
     */
    dispatchAutoRefreshEvent(event) {

        this.lastAutoRefresh = new Date();
        if (this.enableAutoRefresh && this.autoRefreshTimer) {
            this.autoRefreshTimer.stop();
            this.autoRefreshTimer.start();
        }
        this.dispatchEvent(new flexiciousNmsp.FlexDataGridEvent(flexiciousNmsp.FlexDataGridEvent.AUTO_REFRESH, this, null, null, null, null, event));

    }

    /**
     *  If grid.getOpenItems().contains(getItemKey(cell.rowInfo.data)),
     *  return the value of expandTooltip else collapseTooltip
     * @method defaultExpandCollapseTooltipFunction
     */
    defaultExpandCollapseTooltipFunction(cell) {

        if (!this.allowInteractivity) return "";
        if (cell.level.isItemOpen(cell.rowInfo.getData())) {
            return this.collapseTooltip;
        } else {
            return this.expandTooltip;
        }

    }

    /**
     * Adds to toolbar actions, and refreshes the toolbar.
     * @method setToolbarActions
     */
    setToolbarActions(actions) {
        this.toolbarActions = [];

        for (const item of actions) {
            const tba = this.extractActionFromObject(item);
            this.toolbarActions.push(tba);
        }
    }

    /**
     * @method extractAction
     */

    extractAction(item) {

        let tba = item.implementsOrExtends("ToolbarAction") ? item : null;
        if (!tba) {
            tba = new flexiciousNmsp.ToolbarAction("");
            for (const prop in item) {
                if (item.hasOwnProperty(prop) && UIUtils.isPrimitive(item[prop])) {
                    tba[prop] = item[prop];
                }
            }
        }
        return tba;
    }

    /**
     */


    addToolbarAction(action, itemIndex) {
        if (typeof itemIndex == "undefined") itemIndex = -1;

        const tba = this.extractAction(action);
        if (itemIndex >= 0)
            this.toolbarActions.splice(itemIndex, 0, tba);
        else
            this.toolbarActions.push(tba);
        this.toolbarActions.refresh();

    }

    /**
     * @method removeToolbarAction
     */

    removeToolbarAction(code) {
        let tba;
        const items = this.toolbarActions;

        for (const item of items) {
            if (item.code == code) {
                tba = item;
                break;
            }
        }

        if (tba) {
            this.toolbarActions.splice(this.toolbarActions.indexOf(tba), 1);
            this.toolbarActions.refresh();
        }
    }

    /**
     * Runs the given toolbar action. Dispatches the toolbarActionExecuted event. If you call prevent default in this event,
     * the default handling code does not execute.
     * @method runToolbarAction
     */
    runToolbarAction(action, currentTarget, extendedPager) {

        if (this.toolbarActionExecutedFunction != null) {
            this.toolbarActionExecutedFunction(action, currentTarget, extendedPager);
        }
        const w = new flexiciousNmsp.WrapperEvent("toolbarActionExecuted", action);
        this.dispatchEvent(w);
        if (w.isDefaultPrevented()) return;
        let list;
        if (action) {
            if (action.code == "filter") {
                this.setPreservePager(true);
                this.setEnableFilters(!this.getEnableFilters());
            } else if (action.code == "sort") {
                //assumption.implementsOrExtends('that the multi column so')){
                this.multiColumnSortShowPopup();
            } else if (action.code == "addRow") {
                const obj = {};
                list = this.getRootFlat();
                if (list.implementsOrExtends('Array')) {
                    list.push(this.obj);
                } else if (list.hasOwnProperty("addItem")) {
                    list.push(this.obj);
                }
                this.trackChange(this.obj, flexiciousNmsp.ChangeInfo.CHANGE_TYPE_INSERT);
                this.rebuild();
            } else if (action.code == "delete") {
                const todelete = this.getSelectedItem();
                if (todelete) {
                    list = this.getRootFlat();
                    const lvl = this.getLevelForItem(todelete);
                    if (lvl && lvl.getNestDepth() > 1) {
                        const parent = this.getParent(todelete, lvl);
                        if (parent)
                            list = this.getChildren(parent, lvl);
                    }
                    if (list.implementsOrExtends('Array')) {
                        list.splice(todelete, 1);
                    }
                    this.clearSelection();
                    this.trackChange(todelete, flexiciousNmsp.ChangeInfo.CHANGE_TYPE_DELETE);
                    this.rebuild();
                }
            } else if (action.code == Constants.MOVE_UP ||
                action.code == Constants.MOVE_DOWN ||
                action.code == Constants.MOVE_TOP ||
                action.code == Constants.MOVE_BOTTOM) {
                const selectedObj = this.getSelectedObjects()[0];
                let selectedRowInfo;
                const items = this.getBodyContainer().rows;

                for (const rowInfo of items) {
                    if (rowInfo.getData() == selectedObj) {
                        selectedRowInfo = rowInfo;
                        break;
                    }
                }

                if (selectedRowInfo) {
                    const level = selectedRowInfo.rowPositionInfo.getLevel(this);
                    let flat;
                    if (this.level.getNestDepth() == 1) {
                        flat = this.getRootFlat();
                    } else {
                        const parent1 = this.getParent(selectedObj, this.level);
                        flat = this.getChildren(parent1, this.level.getParentLevel());
                    }


                    const itemIndex = flat.indexOf(selectedObj);
                    const newIndex = this.getNewIndex(flat, selectedObj, action.code);

                    flat.splice(itemIndex, 1);
                    flat.splice(newIndex, 1, selectedObj);
                    this.setPreservePager(true);
                    this.rebuild();
                }
            }
        }

    }

    /**
     * @method getNewIndex
     */
    getNewIndex(lcw, item, direction) {

        let idx = lcw.indexOf(item);

        if (direction == Constants.MOVE_UP) {
            if (idx == 0)
                return 0;
            else
                return --idx;
        }
        else {
            if (idx == (lcw.length - 1)) {
                return lcw.length - 1;
            }
            else {
                return ++idx;
            }
        }

    }

    /**
     * Creates a Toolbar Action
     * @param lbl            The label to apply to the action
     * @param code            The code to associate with the action
     * @param [requiresSelection]    Whether or not the action requires an item to be selected within the grid.
     * @param [requiresSingleSelection]    Whether or not the action requires a single item to be selected within the grid.
     * @method createBuiltinAction
     */
    createBuiltinAction(lbl, code, requiresSelection, requiresSingleSelection) {
        if (typeof requiresSelection == "undefined") requiresSelection = false;
        if (typeof requiresSingleSelection == "undefined") requiresSingleSelection = false;


        const tb = new flexiciousNmsp.ToolbarAction(lbl);
        tb.code = code ? code : lbl;

        const existingAction = this.getActionByCode(tb.code);
        if (existingAction) return existingAction;

        tb.iconUrl = this.getStyle(`toolbarAction${flexiciousNmsp.CellUtils.doCap(tb.code)}IconUrl`);
        tb.disabledIconUrl = this.getStyle(`toolbarAction${flexiciousNmsp.CellUtils.doCap(tb.code)}DisabledIconUrl`);
        tb.requiresSelection = requiresSelection;
        tb.requiresSingleSelection = requiresSingleSelection;
        tb.tooltip = lbl;
        return tb;

    }

    /**
     * Given a code, loops through the toolbarActions, and gets the toolbar action with the given code.
     * @param code
     * @return
     * @method getActionByCode
     */
    getActionByCode(code) {
        const items = this.toolbarActions;

        for (const tba of items) {
            if (tba.code == code)
                return tba;
        }

        return null;
    }

    /**
     * Adds to built in filters and refreshes the toolbar.
     * @method setPredefinedFilters
     */
    setPredefinedFilters(filters) {

        flexiciousNmsp.UIUtils.removeAll(this.predefinedFilters);
        for (let i = 0; i < filters.length; i++) {
            const item = filters[i]
            const f = new Filter();
            f.copyFrom(this.getItem);
            this.predefinedFilters.push(f);
        }
        this.predefinedFilters.refresh();

    }

    /**
     * On grids that allow for tracking errors, call this method to highlight the error
     * using the errorRowStyle, errorContainerRowStyle, and errorMessageStyle.
     *
     * Pass in the key of the object (that is matched using the selectedKeyField)
     * the dataField of the column that is supposed to show the error, and the
     * error message text.
     * @method setErrorByKey
     *
     */
    setErrorByKey(key, fld, errorMsg) {

        const obj = this.getColumnLevel().getItemFromKey(key);
        if (obj) {
            this.setErrorByObject(obj, fld, errorMsg);
        } else {
            throw new Error(`Item with key ${key} not found.`);
        }

    }

    /**
     * Similar to setErrorByKey, except takes the actual object that the key represents.
     * On grids that allow for tracking errors, call this method to highlight the error
     * using the errorRowStyle, errorContainerRowStyle, and errorMessageStyle.
     *
     * Pass in the key of the object (that is matched using the selectedKeyField)
     * the dataField of the column that is supposed to show the error, and the
     * error message text.
     * 
     * @method setErrorByObject
     */
    setErrorByObject(item, fld, errorMsg) {

        if (!this.errorMap.getValue(item))
            this.errorMap.addItem(item, {});
        this.errorMap.getValue(item)[fld] = errorMsg;
        this.hasErrors = true;
        const cell = this.getBodyContainer().getCellForRowColumn(item, null);
        if (this._editor) this._editor.setErrorString(errorMsg);

        if (cell)
            cell.rowInfo.invalidateCells();

    }

    /**
     * Clears the errors for the specified key
     * @method clearErrorByKey
     */
    clearErrorByKey(key, fld) {
        if (typeof fld == "undefined") fld = '';

        const obj = this.getColumnLevel().getItemFromKey(key);
        if (obj) {
            this.clearErrorByObject(obj, fld);
        } else {
            throw new Error(`Item with key ${key} not found.`);
        }
        this.hasErrors = this.getAllErrorString().length > 0;


    }

    /**
     * Clears out all the errors
     * @method clearAllErrors
     */
    clearAllErrors() {

        this.errorMap.clear();
        this.getBodyContainer().invalidateCells();

    }

    /**
     * Similar to clearErrorByKey, except takes the actual object that the key represents.
     * @method clearErrorByObject
     */
    clearErrorByObject(item, fld) {
        if (typeof fld == "undefined") fld = '';

        if (fld && this.errorMap.getValue(item)) {
            const itemToDelete = this.errorMap.getValue(item);
            delete itemToDelete[fld];
            const hasErrors = false;
            for (const prop in this.getValue(item)) {
                this.hasErrors = true;
            }
            if (!this.hasErrors) {
                this.errorMap.removeItem(item);
            }
        }
        else if (this.errorMap.getValue(item))
            this.errorMap.removeItem(item);
        const cell = this.getBodyContainer().getCellForRowColumn(item, null);
        if (cell)
            cell.rowInfo.invalidateCells();

    }

    /**
     * Returns an object that has the error information for the passed in object.
     * @method getError
     */
    getError(item) {

        return this.errorMap.getValue(item);

    }

    /**
     * Returns an object that has the error information for the passed in object.
     * @method getAllErrorString
     */
    getAllErrorString() {
        let result = "";

        for (const item of this.errorMap.keys) {
            const lvl = this.getLevelForItem(item);
            if (lvl) {
                const key = lvl.getItemKey(this.getItem);
                result += `Item with ID ${key} has the following errors\n`;
                const itemError = this.errorMap.getValue(item);
                for (const prop in itemError) {
                    result += `${prop}${itemError[prop]}\n`;
                }
            }
        }

        return result;
    }

    /**
     * Provided an item, loops through the data provider, and finds
     * the level associated with the provided item.
     * Let the level and flat be null.
     * @method getLevelForItem
     */
    getLevelForItem(itemToFind, flat, level) {
        if (typeof flat == "undefined") flat = null;
        if (typeof level == "undefined") level = null;

        if (!flat) flat = this.getRootFlat();
        if (!level) level = this.getColumnLevel();

        for (const item of flat) {
            if (level.areItemsEqual(item, itemToFind)) {
                return level;
            }
            if (level.nextLevel) {
                const result = this.getLevelForItem(itemToFind,
                    level.getChildren(item), level.nextLevel);
                if (result) {
                    return result;
                }
            }
        }

        return null;
    }

    /**
     * If variableRowHeight returns the minimum height required to display text of each column without clipping.
     * Please note, atleast one column needs to have the wordWrap flag set to true. If you use custom item rendereres, these are not accounted for in the height measurement
     * for performance reasons. In this case, you should override the getRowHeight method and provide your own implementation which is optimized for your situation.
     *
     * @param item        The item being displayed
     * @param level        The FlexDataGridColumnLevel object that the item belongs to
     * @param rowType    The type of the row, one of the RowPositionInfo.ROW_TYPE_XXXX constants
     * @return             Height of the row
     * @method calculateRowHeight
     *
     */
    calculateRowHeight(item, level, rowType) {
        let ht = level.getRowHeightFromType(rowType, item);

        if (this.getRowHeightFunction != null) {
            const rowHtFromFunction = this.getRowHeightFunction(item, level, rowType);
            if (rowHtFromFunction > 0) {
                return rowHtFromFunction;
            }
        }
        this.inExport = true;
        this.recordBeingExported = item;
        if (!this.variableRowHeight || (rowType != flexiciousNmsp.RowPositionInfo.ROW_TYPE_DATA)) return ht;


        const cols = level.getFlowColumns();
        if (!this.measurer) {
            this.measurer = document.createElement("div");
            this.measurer.style.position = "absolute";
            UIUtils.addChild(document.body, this.measurer);

        }

        for (const col of cols) {
            let paddingLeft = col.getStyleValue("paddingLeft");
            const paddingTop = col.getStyleValue("paddingTop");
            const paddingRight = col.getStyleValue("paddingRight");
            const paddingBottom = col.getStyleValue("paddingBottom");
            paddingLeft += col.enableHierarchicalNestIndent ? level.getMaxPaddingCellWidth() : 0;
            ht = this.measureCellHeight(col, paddingLeft, paddingRight, paddingTop, paddingBottom, col.itemRenderer, ht, col.itemToLabel(item), item, col);
        }


        document.body.removeChild(this.measurer);
        this.measurer = null;
        this.inExport = false;
        return ht;
    }

    /**
     * Given a column and padding values, calculate the height required to fully render the text
     * @param col            The column to render. The width of this column is used to calculate the height.
     * @param paddingLeft    The left padding to apply while calculating the height
     * @param paddingRight    The right padding to apply while calculating the height
     * @param paddingTop    The top padding to apply while calculating the height
     * @param paddingBottom    The bottom padding to apply while calculating the height
     * @param itemRenderer    The renderer to use - for data cells uses itemRenderer for header cells uses headerRenderer
     * @param ht            The previously calculated max height. The ht will return this value if the calculated height is less than the passed in ht.
     * @param txt            The text to render.
     * @param item            The item (or row data) object that will be applied to the data property of the renderer
     * @param styl             Apply style to the item
     * @param isHeader
     * @return                 If the calculated height is greater than ht parameter, returns the calculated height. Else returns the value of the ht parameter
     * @method measureCellHeight
     */
    measureCellHeight(
        col,
        paddingLeft,
        paddingRight,
        paddingTop,
        paddingBottom,
        itemRenderer,
        ht,
        txt,
        item,
        styl,
        isHeader) {

        if (this.variableRowHeightUseRendererForCalculation && itemRenderer) {
            let renderer = null;
            if (this.getBodyContainer().variableRowHeightRenderers.getValue(col)) {
                renderer = this.getBodyContainer().variableRowHeightRenderers.getValue(col);
            }
            if (!renderer) {
                renderer = itemRenderer.newInstance();
                this.getBodyContainer().variableRowHeightRenderers.addItem(col, renderer);
                this.addChild(renderer);
            }

            renderer.setWidth(col.getWidth());

            renderer.setText(txt);

            renderer.setData(item);

            renderer.validateNow();
            const componentHeight = renderer.getHeight() + paddingTop + paddingBottom + 2;
            ht = componentHeight > ht ? componentHeight : ht;

        } else {

            this.measurer.innerHTML = (txt);
            let w = this.measurer.offsetWidth;
            this.measurer.style.width = (col.getWidth() - paddingLeft - paddingRight - 4) + "px";
            this.measurer.style.height = "auto";
            this.measurer.style.whiteSpace = "normal";
            if (isHeader) {
                this.measurer.style.fontWeight = "bold";
            }
            this.measurer.innerHTML = (txt);
            w = this.measurer.offsetWidth;
            const newHt = this.measurer.offsetHeight;
            const calc = Math.ceil(this.measurer.offsetHeight) + paddingTop + paddingBottom + 2;
            ht = Math.max(ht, calc);
        }
        return ht;

    }

    /**
     *  Shows the given toaster message
     * 
     * @param message			The message to display in the toaster notification 
     * @param toasterPosition	The position for the toaster. One of the Toaster.POSITION_XXXX constants. Defaults to Toaster.POSITION_BOTTOM_RIGHT
	 * @param toasterRenderer	A classfactory for the actual renderer control. Defaults to DefaultToasterRenderer.
	 * @param animationDuration	Number of milli seconds to animate the move or the fade animation for the toaster to appear and disappear. Defaults to 1000
	 * @param visibleDuration	Number of milli seconds to keep the toaster visible. Defaults to 5000
	 * @param moveAnimate		Whether to use the move animation. 
     * @param fadeAnimate		Whether to use the fade animation. 
	 * 
     * @return The toaster instance used to show the toaster.
	 *
     * @method showToaster
     */
    showToaster(
        message,
        toasterPosition,
        toasterRenderer,
        animationDuration,
        visibleDuration,
        moveAnimate,
        fadeAnimate) {


        /** @namespace flexiciousNmsp.Toaster */
        flexiciousNmsp.Toaster.showToaster(message
            , toasterPosition
            , toasterRenderer
            , animationDuration
            , visibleDuration
            , moveAnimate
            , fadeAnimate);


    }

    /**
     * Adds the provided item to the selection of the top (root) level.
     * @param val
     * @method addSelectedItem
     */
    addSelectedItem(val) {

        this.getColumnLevel().addSelectedItem(val);

    }

    /**
     *  Opens or closes all the nodes of the navigation tree below the specified item.
     *  @param item An Object defining the branch node. This Object contains the
     *  data provider element for the branch node.
     *
     *  @param open Specify <code>true</code> to open the items,
     *  and <code>false</code> to close them.
     *
     *  @param level Level at which the item exists. If null is specified, defaults to the top level
     *  @method expandChildrenOf
     * */
    expandChildrenOf(item, open, level) {
        if (typeof level == "undefined") level = null;

        if (!level) level = this.getColumnLevel();
        this.addRemoveFromOpenItems(item, open, level);
        this.rebuildBody();
        this.validateNow();
        this.currentCell = this.getBodyContainer().getCellForRowColumn(item, null, true);
        if (this.currentCell)
            this.highlightRow(this.currentCell, this.currentCell.rowInfo, true);

    }

    /**
     */

    addRemoveFromOpenItems(item, open, level) {

        if (!level.nextLevel && !level.nextLevelRenderer) return;
        const children = this.getChildren(item, level);
        if (this.getLength(children) > 0) {
            if (open && !level.isItemOpen(item))
                this.getBodyContainer().addOpenItem(item);
            else if (!open && level.isItemOpen(item))
                this.getBodyContainer().removeOpenItem((item));
            if (level.nextLevel) {
                for (const child of children) {
                    this.addRemoveFromOpenItems(child, open, level.nextLevel)
                }
            }
        }

    }

    /**
     * Method to track a change, called by track change API to keep track of additions, deletions and modifications to the data provider.
     * @param changedItem    Item being changed
     * @param changeType    Type of the change
     * @param [changeLevel]    Nest Level of the level being changed
     * @param [changedProperty]    The property being changed
     * @param [previousValue]    The value prior to the change
     * @param [newValue]    The new value.
     * @method trackChange
     */
    trackChange(
        changedItem,
        changeType,
        changeLevel,
        changedProperty,
        previousValue,
        newValue) {
        if (typeof changeLevel == "undefined") changeLevel = null;
        if (typeof changedProperty == "undefined") changedProperty = null;
        if (typeof previousValue == "undefined") previousValue = null;
        if (typeof newValue == "undefined") newValue = null;

        if (!this.enableTrackChanges) return;
        const items = this.getChanges();
        for (var i = 0; i < items.length; i++) {
            var ci = items[i];
            if (ci.changedItem == changedItem && (ci.changeType == changeType) && (ci.changedProperty == changedProperty)) {
                if( ci.previousValue != newValue )
                    ci.newValue = newValue;
                else
                    items.splice(i, 1);
                this.dispatchEvent(new flexiciousNmsp.BaseEvent("rowChanged"));
                return;//we already have this change.
            }
        }
        var lvl = changeLevel ? changeLevel : this.getLevelForItem(changedItem);
        if(newValue !== previousValue) {
            this.getChanges().push(new flexiciousNmsp.ChangeInfo(changedItem, lvl ? lvl.getNestDepth() : 1, changedProperty, previousValue, newValue, changeType));
        }
        this.dispatchEvent(new flexiciousNmsp.BaseEvent("rowChanged"));
    }

    /**
     * Sets the open items on basis of the selectedField.
     * @param [rebuild] Flag to rebuild the grid. Set to true if calling from your code, unless rebuild is being called else where.
     * @param [openItems]
     * @method setSelectedItemsBasedOnSelectedField
     */
    setSelectedItemsBasedOnSelectedField(rebuild, openItems) {
        if (typeof rebuild == "undefined") rebuild = false;
        if (typeof openItems == "undefined") openItems = true;

        const result = this.getColumnLevel().setSelectedItemsBasedOnSelectedField(this.getRootFlat(), null, openItems);
        if (rebuild) {
            this.rebuildBody();
        }
        if (result) {
            const evt = new flexiciousNmsp.FlexDataGridEvent(flexiciousNmsp.FlexDataGridEvent.CHANGE,
                this, this.getColumnLevel(), null);
            this.dispatchEvent(evt);
        }


    }

    /**
     */

    addEventListener(type, listener, useCapture, priority, useWeakReference) {

        super.addEventListener(type, listener, useCapture, priority, useWeakReference);
        if (type == flexiciousNmsp.FlexDataGridEvent.CELL_RENDERED) {
            this.dispatchCellRenderered = true;
        } else if (type == flexiciousNmsp.FlexDataGridEvent.RENDERER_INITIALIZED) {
            this.dispatchRendererInitialized = true;
        } else if (type == flexiciousNmsp.FlexDataGridEvent.CELL_CREATED) {
            this.dispatchCellCreated = true;
        }
    }

    /**
     * Gets the column with the specified search field
     * @method getFilterColumn
     */
    getFilterColumn(searchField) {
        const items = this.getColumns();

        for (const col of items) {
            if (col.getSearchField() == searchField)
                return col;
        }

        return null
    }

    /**
     * Displays a message without the spinner label.
     * @param msg
     * @method showMessage
     */
    showMessage(msg) {

        this.spinnerBehavior.showMessage(msg);

    }

    /**
     * @method onGridResized
     */
    onGridResized(event) {


        if (this.noDataMessage && this.spinner && this.spinner.getVisible()) {
            this.checkNoDataMessage(true);
        }

    }

    /**
     * Default handler for the Word Export Button. Calls
     * ExtendedExportController.instance().doexport(this.grid,ExportOptions.create(ExportOptions.DOC_EXPORT))
     * @method defaultWordHandlerFunction
     */
    defaultWordHandlerFunction() {

        const eo = this.wordOptions;
        eo.exportOptionsRenderer = this.popupFactoryExportOptions;
        flexiciousNmsp.ExtendedExportController.instance().doexport(this, eo)

    }

    /**
     * Default handler for the Word Export Button. Calls
     * ExtendedExportController.instance().doexport(this.grid,ExportOptions.create())
     * @method defaultExcelHandlerFunction
     */
    defaultExcelHandlerFunction() {

        const eo = this.excelOptions;
        eo.exportOptionsRenderer = this.popupFactoryExportOptions;
        flexiciousNmsp.ExtendedExportController.instance().doexport(this, eo)

    }

    /**
     * Default handler for the Print Button. Calls
     * var po:PrintOptions=PrintOptions.create();
     * po.printOptionsViewrenderer = new ClassFactory(ExtendedPrintOptionsView);
     * ExtendedPrintController.instance().print(this.grid,po)
     * @method defaultPrintHandlerFunction
     */
    defaultPrintHandlerFunction() {

        //var eo = this.htmlOptions;
        //eo.exportOptionsRenderer = this.popupFactoryExportOptions;
        //flexiciousNmsp.ExtendedExportController.instance().doexport(this, eo)
        if (this.useEnhancedPrint) {
            const po = this.printOptions;
            po.asynch = true;
            po.printOptionsViewrenderer = this.popupFactoryPrintOptions;
            flexiciousNmsp.ExtendedPrintController.instance().print(this, po);

        } else {

            const eo = this.htmlOptions;
            eo.exportOptionsRenderer = this.popupFactoryExportOptions;
            flexiciousNmsp.ExtendedExportController.instance().doexport(this, eo)
        }


    }

    /**
     * Default handler for the Print Button. Calls
     * var po:PrintOptions=PrintOptions.create(true);
     * po.printOptionsViewrenderer = new ClassFactory(ExtendedPrintOptionsView);
     * ExtendedPrintController.instance().print(this.grid,po)
     * @method defaultPdfHandlerFunction
     */
    defaultPdfHandlerFunction() {
        if (this.useEnhancedPdf) {

            const po = this.pdfOptions;
            po.asynch = true;
            po.printOptionsViewrenderer = this.popupFactoryPrintOptions;
            flexiciousNmsp.ExtendedPrintController.instance().print(this, po);

        } else {

            const eo = this.pdfOptionsBasic;
            eo.exportOptionsRenderer = this.popupFactoryExportOptions;
            flexiciousNmsp.ExtendedExportController.instance().doexport(this, eo)
        }
    }

    /**
     * Gets the class responsible for handling the PrintUI should be a IPrintDataGrid
     * @return
     * @method createPrintComponentFactory
     */
    createPrintComponentFactory() {

        return this.printComponentFactory;

    }

    /**
     * Return true if enableStickyControlKeySelection  Or (Control Key is down AND (selectionMode is MultipleRows or MultipleCells))
     * @method isCtrlKeyDownOrSticky
     */
    isCtrlKeyDownOrSticky(event) {

        const ctrlKey = event.ctrlKey;
        return (ctrlKey && (this.getSelectionMode() == flexiciousNmsp.NdgBase.SELECTION_MODE_MULTIPLE_ROWS
            || this.getSelectionMode() == flexiciousNmsp.NdgBase.SELECTION_MODE_MULTIPLE_CELLS))
            || this.enableStickyControlKeySelection;

    }

    /**
     * @method getUserSettingsController
     */
    getUserSettingsController() {

        return flexiciousNmsp.UserSettingsController.instance();

    }

    /**
     * If you modify one or more column groups, calling this method is required so that
     * inter related column groups can update themselves.
     * @method alignColumnGroups
     */
    alignColumnGroups() {
        const items = this.getColumnLevel().columnGroups;

        for (const cg of items) {
            this.cascadeColumnGroups(cg);
        }

        this.getColumnLevel().setGroupedColumns(this.getColumnLevel().getGroupedColumns());
    }

    /**
     *
     * @method cascadeColumnGroups
     */
    cascadeColumnGroups(cg) {
        cg.setGroupedColumns(cg.getGroupedColumns());
        const items = cg.columnGroups;

        for (const ccg of items) {
            this.cascadeColumnGroups(ccg);
        }
    }

    /**
     * Given a cell, returns it row span based upon how many children are open
     * Recursively inspects the children to see if any of them are open as well.
     * @param cell
     * @return
     * @method getRowSpanBasedOnOpenItemCount
     */
    getRowSpanBasedOnOpenItemCount(cell) {

        return this.getOpenItemCount(cell);


    }

    /**
     * Given a cell if it is a datarow, and it is associated with a column
     * and the column is at the nest level of the cell, and the column is left locked
     * and the data item bound to the cell is open, then will return the recursive
     * count of all open items under this cell.
     * @param cell    The cell to check
     * @return     integer
     * @method getOpenItemCount
     */
    getOpenItemCount(cell) {

        if (cell.rowInfo.getIsDataRow() //its the data row, not the header or the footer row
            && !cell.rowInfo.getIsFillRow()//since the filler.implementsOrExtends('also considered a data r')){
            && cell.getColumn()
            && (cell.getColumn().getColIndex() == cell.level.getNestDepth() - 1)
            && cell.getColumn().getIsLeftLocked()
            && cell.level.isItemOpen(cell.rowInfo.getData())//item.implementsOrExtends('op')){
        ) {
            const children = this.getChildren(cell.rowInfo.getData(), cell.level);
            let childrenCount = this.getLength(children) + 1;
            if (cell.level.nextLevel) {
                childrenCount += this.getRecursiveOpenItemCount(children, cell.level.nextLevel);
            }
            return childrenCount;
        } else {
            return 1;
        }

    }

    /**
     * @method getRecursiveOpenItemCount
     */

    getRecursiveOpenItemCount(children, nextLevel) {
        let count = 0;

        for (const item of children) {
            if (nextLevel.isItemOpen(item)) {
                const nlchildren = this.getChildren(item, nextLevel);
                count += this.getLength(nlchildren);
                if (nextLevel.nextLevel) {
                    count += this.getRecursiveOpenItemCount(nlchildren, nextLevel.nextLevel);
                }
            }
        }

        return count;
    }

    /**
     * @method showSpinner
     */
    showSpinner(msg) {
        if (typeof msg == "undefined") msg = '';

        this.spinnerBehavior.showSpinner(msg);

    }

    /**
     * @method hideSpinner
     */
    hideSpinner() {
        this.spinnerBehavior.hideSpinner();
    }

    /**
     * Queues a call to drawFiller in the next validation cycle
     * @method invalidateFiller
     */
    invalidateFiller() {

        if (!this.enableFillerRows) return;
        this._fillerInvalidated = true;
        this.doInvalidate();

    }

    /**
     * When enableFillerRows=true, wipes out and recreates the filler rows. The grid automatically calls this method
     * when any column widths change, dataprovider changes, size changes, or when expand/collapse happen.
     * @method drawFiller
     */
    drawFiller() {
        const aic = this.getStyle("alternatingItemColors");
        this.getBodyContainer().setBackgroudFillerSize();
        this.getLeftLockedContent().setBackgroudFillerSize();
        this.getRightLockedContent().setBackgroudFillerSize();
        //return;
        const verticalGridLines = this.getStyle("verticalGridLines");
        const verticalGridLineThickness = this.getStyle("verticalGridLineThickness");
        const verticalGridLineColor = this.getStyle("verticalGridLineColor");

        const sepThickness = this.getStyle("lockedSeperatorThickness");

        const horizontalGridLines = this.getStyle("horizontalGridLines");
        const horizontalGridLineThickness = this.getStyle("horizontalGridLineThickness");
        const horizontalGridLineColor = this.getStyle("horizontalGridLineColor");

        const sections = [this.getLeftLockedContent(), this.getRightLockedContent(), this.getBodyContainer()];

        for (const section of sections) {
            const cols = (section == this.getLeftLockedContent()) ?
                this.getColumnLevel().getLeftLockedColumns() :
                (section == this.getRightLockedContent()) ? this.getColumnLevel().getRightLockedColumns() :
                    this.getColumnLevel().getUnLockedColumns();
            let sectionToDraw = section;

            sectionToDraw = section.backgroundForFillerRows;
            sectionToDraw.attachClass("fillerBackground");
            sectionToDraw.children = [];
            const comp = new UIComponent("div");
            comp.key = new Date().getTime();
            sectionToDraw.addChildNoState(comp);

            // sectionToDraw.setState({ timestamp: new Date().getTime() });
            const firstChild = new UIComponent({}, "div");
            firstChild.setStyleAttribute("position", "relative");
            sectionToDraw.addChildNoState(firstChild);

            let pointer = 0;
            let index = this.getBodyContainer().getItemVerticalPositions().length;
            let rowHt = this.getColumnLevel().getRowHeight();
            const colColors = {};
            const colisLastLocked = {};
            const colisInView = {};
            const sectionHorizontalScrollPosition = section.getHorizontalScrollPosition();
            //if(cols.length==0)continue;
            while (pointer < (sectionToDraw.getHeight())) {
                let done = false;
                if ((pointer + rowHt) > sectionToDraw.getHeight()) {
                    rowHt = sectionToDraw.getHeight() - pointer;
                    done = true;
                }

                let currx = 0;
                const odd = (index % 2 == 0);
                if (this.enableDefaultDisclosureIcon && (this.getColumnLevel().nextLevel || this.getColumnLevel().nextLevelRenderer) && ((section == this.getLeftLockedContent() && this.lockDisclosureCell) || (section == this.getBodyContainer() && !this.lockDisclosureCell))) {
                    currx = this.drawFillerCell(sectionToDraw, aic[odd ? 0 : 1], pointer, currx,
                        (cols.length == 0 ? sectionToDraw.getWidth() : this.getColumnLevel().getDeepNestIndent())
                        , verticalGridLines
                        , verticalGridLineThickness
                        , verticalGridLineColor
                        , horizontalGridLines
                        , horizontalGridLineThickness
                        , horizontalGridLineColor
                        , rowHt, true, true, 0, null);
                }

                for (const col of cols) {
                    const isColInView = colisInView[col.getUniqueIdentifier()] != null ? colisInView[col.getUniqueIdentifier()] :
                        (this.getBodyContainer().isInVisibleHorizontalRange(currx, col.getWidth()) || col.getIsLocked());
                    colisInView[col.getUniqueIdentifier()] = isColInView;


                    const lastIsLocked = colisLastLocked[col.getUniqueIdentifier()] != null ?
                        colisLastLocked[col.getUniqueIdentifier()] :
                        (((section == this.getLeftLockedContent()) && col.getIsLastLeftLocked())
                            || ((section == this.getRightLockedContent()) && col.getIsLastrightLocked())
                            || ((section == this.getBodyContainer()) && col.getIsLastUnLocked()));
                    colisLastLocked[col.getUniqueIdentifier()] = lastIsLocked;
                    let color = aic[odd ? 0 : 1];
                    if (colColors[col.getUniqueIdentifier()] == null) {
                        const cb = col.getStyle("backgroundColor");
                        if (col.isValidStyleValue(cb)) {
                            colColors[col.getUniqueIdentifier()] = cb;
                        } else {
                            colColors[col.getUniqueIdentifier()] = -1;
                        }
                    }
                    if (colColors[col.getUniqueIdentifier()] != -1) {
                        color = colColors[col.getUniqueIdentifier()];
                    }
                    currx = this.drawFillerCell(sectionToDraw, color, pointer, currx, col.getWidth()
                        , verticalGridLines && (!lastIsLocked)
                        , verticalGridLineThickness
                        , verticalGridLineColor
                        , horizontalGridLines
                        , horizontalGridLineThickness
                        , horizontalGridLineColor
                        , rowHt, false, isColInView, sectionHorizontalScrollPosition, col);
                }

                //                if (horizontalGridLines && !done) {
                ////                    var c = sectionToDraw.domElement.getContext("2d");
                ////                    c.lineWidth=(horizontalGridLineThickness);
                ////                    c.strokeStyle='#' + (horizontalGridLineColor.toString(16));
                ////                    c.moveTo(0, pointer + rowHt - 0.5 );
                ////                    c.lineTo(section.getWidth(), pointer + rowHt - 0.5 );
                ////                    c.stroke();
                //                }
                pointer += rowHt;
                index++;
                if (done) {
                    break;
                }
            }
            sectionToDraw.invalidateState();
        }
    }

    /**
     * @method drawFillerCell
     */

    drawFillerCell(
        section,
        color,
        pointer,
        currx,
        colWidth,
        verticalGridLines,
        verticalGridLineThickness,
        verticalGridLineColor,
        horizontalGridLines,
        horizontalGridLineThickness,
        horizontalGridLineColor,
        rowHt,
        draw,
        colIsInView,
        sectionHorizontalScrollPosition,
        col) {
        if (colIsInView) {
            const dv = new flexiciousNmsp.UIComponent({}, "div");
            dv.setAttribute("className", "flexDataGridCell fillerCell");
            dv.setWidth(colWidth);
            dv.setHeight(rowHt);
            dv.move(currx - sectionHorizontalScrollPosition, pointer);

            dv.setStyleAttribute("backgroundColor", UIUtils.decimalToColor(color));
            if (verticalGridLines) {
                dv.setStyleAttribute("borderRight", `solid ${verticalGridLineThickness}px ${UIUtils.decimalToColor(verticalGridLineColor)}`);
            }
            if (horizontalGridLines) {
                dv.setStyleAttribute("borderBottom", `solid ${horizontalGridLineThickness}px ${UIUtils.decimalToColor(horizontalGridLineColor)}`);
            }

            section.children[0].addChildNoState(dv);

            if( this.fillerCellCreatedFunction )
                this.fillerCellCreatedFunction(dv, col);

            //            var xCord=Math.ceil(currx+colWidth-verticalGridLineThickness- sectionHorizontalScrollPosition);
            //            if(xCord%2==0){
            //                xCord-=0.5;
            //            }else{
            //                xCord+=0.5;
            //            }
            //
            //            var c = section.domElement.getContext("2d");
            //            c.moveTo(currx,pointer);
            //            c.fillStyle = '#' + color.toString(16);
            //            c.fillRect(currx - sectionHorizontalScrollPosition,pointer,colWidth,rowHt);
            //            if(verticalGridLines){
            //                c.lineWidth=(verticalGridLineThickness)
            //                c.strokeStyle='#' + (verticalGridLineColor.toString(16));
            //                c.beginPath();
            //                c.moveTo(xCord ,pointer);
            //                c.lineTo(xCord ,pointer+rowHt);
            //                c.stroke();
            //            }
        }
        currx += colWidth;
        return currx;
    }

    /**
     * Pointer to the TOP level cellBorderFunction
     * A function that lets you control the border drawing mechanism for each cell.
	 * By default, each cell will draw a 1px wide line to its right and bottom ends. 
	 * 
	 * This function offers you the opportunity to hook into this mechanism, and draw 
	 * your own border using the graphics property of the FlexDataGridCell object,
	 * that is passed in as a parameter to this function. If this function returns false,
	 * the default border is not drawn.
     * @method getCellBorderFunction
     */
    getCellBorderFunction() {
        return this.getColumnLevel().cellBorderFunction;
    }

    /**
     *
     * @method setCellBorderFunction
     */
    setCellBorderFunction(value) {
        this.getColumnLevel().cellBorderFunction = value;
    }

    /**
     *Returns the columns where visible=true
     * @method getVisibleColumns
     */
    getVisibleColumns() {
        return this.getColumnLevel().getVisibleColumns();
    }

    /**
     * Returns true of this is a nested grid, and we have not expanded to the lowest level
     * @method getCanExpandDown
     */
    getCanExpandDown() {
        return this.getMaxDepth() > 1 && this._currentExpandLevel < this.getMaxDepth() - 1;
    }

    /**
     * Returns the built in moveDown Action
     * @return
     * @method getToolbarActionMoveDown
     */
    getToolbarActionMoveDown() {
        const act = this.createBuiltinAction("", FlexDataGrid.MOVE_DOWN, true, true);
        act.requiresSingleSelection = true;
        return act;
    }

    /**
     * Returns the columns where excludeFromSettings=false
     * @method getSettingsColumns
     */
    getSettingsColumns() {
        return this.getColumnLevel().getShowableColumns();
    }

    /**
     * Pointer to the TOP level expandCollapseHeaderCellRenderer
     * @method getExpandCollapseHeaderCellRenderer
     */
    getExpandCollapseHeaderCellRenderer() {
        return this.getColumnLevel().expandCollapseHeaderCellRenderer;
    }

    /**
     * @method setExpandCollapseHeaderCellRenderer
     */

    setExpandCollapseHeaderCellRenderer(val) {
        this.getColumnLevel().expandCollapseHeaderCellRenderer = val;
    }

    /**
     * Pointer to the TOP level filterFunction
     * @method getFilterFunction
     */
    getFilterFunction() {
        return this.getColumnLevel().filterFunction;
    }

    /**
     * @method setFilterFunction
     */

    setFilterFunction(value) {
        this.getColumnLevel().filterFunction = value;
    }

    /**
     * The container for the header cells. This is an instance of the FlexDataGridHeaderContainer class.
     * This class manages cell initialization, recycling, mouse events on each cell, etc. The rows collection
     * of this object will aways contain a single RowInfo object, which has a cells collection. This will
     * be a series of ComponentInfo objects, which has a component property that will be an instance of FlexDataGridHeaderCell
     * Although the parent property of each of the cells could be either the
     * leftLockedHeader, rightLockedHeader or the headerContainer, the rowInfo is the same, so the cells will
     * include left, right, and unlocked cells.
     * @method getHeaderContainer
     */
    getHeaderContainer() {
        return this._treeDataGridHeader;
    }

    /**
     * Pointer to the TOP level expandCollapseCellRenderer
     * @method getExpandCollapseCellRenderer
     */
    getExpandCollapseCellRenderer() {
        return this.getColumnLevel().expandCollapseCellRenderer;
    }

    /**
     *
     * @method setExpandCollapseCellRenderer
     */
    setExpandCollapseCellRenderer(val) {
        this.getColumnLevel().expandCollapseCellRenderer = val;
    }

    /**
     * Returns the sum of: <br/>
     * If enableFilters, then filterRowHeight else 0 plus<br/>
     * headerHeight
     * @return
     * @method getHeaderSectionHeight
     */
    getHeaderSectionHeight() {
        return ((this.getEnablePaging() || this.getForcePagerRow()) ? this.getColumnLevel().getPagerRowHeight() : 0) +
            (this.getEnableFilters() ? this.getColumnLevel().getFilterRowHeight() : 0) +
            ((this.getColumnLevel().getHeaderHeight()) * this.getColumnLevel().getMaxColumnGroupDepth());
    }

    /**
     * The container for the left locked footer cells.
     * This is an instance of the LockedContent class, which basically is an extended
     * UIComponent that manages the filter and footer cell visiblity, heights, and the y positions.
     *
     * To access all the footer cells, please use the rows collection of the footerContainer
     * This contains a single RowInfo object, which contains a cells collection.
     * The cells collection contains ComponentInfo objects, that has a component property, which is
     * an instance of one of the subclasses of FlexDataGridCell. The cell will have a renderer property
     * which is the actual UI control that is being displayed.
     * @method getLeftLockedFooter
     */
    getLeftLockedFooter() {
        return this._leftLockedFooter;
    }

    /**
     * Pointer to the TOP level cellCustomBackgroundDrawFunction
     *  A function that lets you control the background drawing mechanism for each cell.
	 * By default, each cell will draw a background on basis of the XXXXColors style property
	 * and XXXXRollOverColors style property, where XXXX= header,filter,pager,footer,renderer or blank.
     * 
     * This function offers you the opportunity to hook into this mechanism, and draw 
     * your own background using the graphics property of the FlexDataGridCell object,
     * that is passed in as a parameter to this function. If this function returns false,
     * the default background is not drawn.
     * @method getCellCustomBackgroundDrawFunction
     */
    getCellCustomBackgroundDrawFunction() {
        return this.getColumnLevel().cellCustomBackgroundDrawFunction;
    }

    /**
     * @method setCellCustomBackgroundDrawFunction
     */

    setCellCustomBackgroundDrawFunction(value) {
        this.getColumnLevel().cellCustomBackgroundDrawFunction = value;
    }

    /**
     * A list of selected objects from the data provider. This is the sdk equivalent of selectedItems.
     * We do not have selectedItems, but selectedObjects will almost always be the same as selectedItems.
     * The only exception is when you use server side paging. In this case, selectedObjects will contain all the items
     * selected, on all pages.
     *
     * When a row is selected in the grid, we store the  the selected object in the selectedObects array collection.
     * This allows for multiple pages of data that comes down from the server and not maintained in memory
     * to still keep track of the objects that were selected on other pages.
     *
     * Please note, for hierarchical grids, each level has its own collection of selected keys.
     * The grid.selectedObjects returns the selectedKeys at the top level. To access the selected keys
     * at a lower level, you may navigate to that level using grid.getColumnLevel().nextLevel...nextLevel.selectedKeys
     * You can also call grid.getSelectedObjects to get selected objects at all levels.
     * @method getSelectedObjectsTopLevel
     *
     *
     * */
    getSelectedObjectsTopLevel() {
        return this.getColumnLevel().getSelectedObjects();
    }

    /**
     * A list of ID values, based on the selectedKeyField property.
     * Returns the selected keys for the top column level. Please NOTE - this is a read only collection.
     * Adding to this does nothing. If you want to programatically modify the selection, use the selectedObjects instead.
     *
     * Please note, for hierarchical grids, each level has its own collection of selected keys.
     * The grid.selectedKeys returns the selectedKeys at the top level. To access the selected keys
     * at a lower level, you may navigate to that level using grid.getColumnLevel().nextLevel...nextLevel.selectedKeys
     *
     * @method getSelectedKeys
     * You can also call grid.getSelectedObjects to get selected objects at all levels. */

    getSelectedKeys() {
        return this.getSelectedObjects(true);
    }

    /**
     * The column that initiated the drag
     * @return
     * @method getDragColumn
     */
    getDragColumn() {

        return this._dragColumn;
    }

    /**
     * Pointer to the TOP level additionalFilterArgumentsFunction
     * In scenarios where there are detached filters, this function
	 * may be used to add on to the list of arguments before the filter is
	 * run. The function must take a column level as the only parameter, 
	 * and return an array collection of the filter expressions. 
     * @method getAdditionalFilterArgumentsFunction
     */
    getAdditionalFilterArgumentsFunction() {
        return this.getColumnLevel().additionalFilterArgumentsFunction;
    }

    /**
     * @method setAdditionalFilterArgumentsFunction
     */

    setAdditionalFilterArgumentsFunction(value) {
        this.getColumnLevel().additionalFilterArgumentsFunction = value;
    }

    /**
     * Returns true of this is a nested grid, and we have expanded to a level below 1.
     * @method getCanExpandUp
     */
    getCanExpandUp() {
        return this.getMaxDepth() > 1 && this._currentExpandLevel > 0;
    }

    /**
     * Returns true if the footer row is visible at the top level.
     * @method getFooterVisible
     */
    getFooterVisible() {
        return this.getColumnLevel().footerVisible;
    }

    /**
     * Sets the footer row to visible at the top level.
     * @method setFooterVisible
     */
    setFooterVisible(val) {
        this.getColumnLevel().footerVisible = val;
    }

    /**
     * A property on the object that identifies whether the object is disabled. 
     * @method getRowDisabledFunction
     */

    getRowDisabledFunction() {
        return this.getColumnLevel().rowDisabledFunction;
    }

    /**
     * @method setRowDisabledFunction
     */

    setRowDisabledFunction(value) {
        this.getColumnLevel().rowDisabledFunction = value;
    }

    /**
     * Returns the built in moveUp Action
     * @return
     * @method getToolbarActionSeparator
     */
    getToolbarActionSeparator() {
        return this.createBuiltinAction("separator", "separator", false);
    }

    /**
     * Returns the number of rows currently visible.
     * @method getRowCount
     */
    getRowCount() {
        return this.getBodyContainer().getOnScreenRows().length;
    }

    /**
     * Returns dataProvider.indexOf(selectedObjects(0))
     * @method getSelectedIndices
     */
    getSelectedIndices() {
        const results = [];
        const items = this.getSelectedObjectsTopLevel();

        for (const item of items) {
            results.push(this.getDataProvider().indexOf(item))
        }

        return results;
    }

    /**
     * The main scrollable area of the grid. This is an instance of the FlexDataGridBodyContainer class, which
     * derives from FlexDataGridContainerBase. The Body container manages renderer recycling, scrolling, expand
     * collapse, editing, etc. The bodyContainer contains a rows collection, which is a visual representation of
     * the current ViewPort, that is, it shows the currently visible cells based on the vertical and horizontal
     * scroll postions. You can iterate through the currently visible cells via looping through the rows property
     * and going through the cells collection of each RowInfo. Please note, this will only get you the currently
     * visible cells. If you wish to access each cell as it is being initialized (or revived from a recyclable state)
     * please wire up the rendererInitialized event on the grid.
     * 
     * Specialized getter when enableVirtualScroll=true
     * @method getVirtualBodyContainer
     */
    getVirtualBodyContainer() {
        return this.getBodyContainer();
    }

    /**
     * Whether to use addElement or addChild;
     * @method getUseElements
     */
    getUseElements() {
        return false;
    }

    /**
     * Returns true if the filter row is visible at the top level.
     * @method getFilterVisible
     */
    getFilterVisible() {
        return this.getColumnLevel().filterVisible;
    }

    /**
     * Sets the filter row to visible at the top level.
     * @method setFilterVisible
     */
    setFilterVisible(val) {
        if (val != this.getColumnLevel().filterVisible) {

        }
        this.getColumnLevel().filterVisible = val;
    }

    /**
     * The concept of selection in Flexicious Ultimate is much more powerful as compared to the basic SDK datagrids in the following ways:
     * <ul>
     * <li>First, It supports selection independant of dataprovider, so when a row is selected in the grid, we store the
     * the selected object in the selectedObects array collection. This allows for multiple pages of data that comes down from the server
     * and not maintained in memory to still keep track of the objects that were selected on other pages.
     * </li>
     * <li>Second, Flexicious Ultimate supports ID based selection (by using selectedKeyField). The selectedKeyField is used for object equality.
     * So for example, if the user selects a record with ID 1, and the grid's data provider is later refreshed with new data from the backend,
     * the grid will maintain the selection if you specify a selectedKeyField which points to the ID (usually the surrogate key) in the database. This is also
     * used to maintain collapse/expand state in hierarchical grids.</li>
     *
     * <li>Third, Flexicious Ultimate supports bubbling and cascading selection information. So in hierarchical datagrids, if you
     * set enableSelectionCascade=true, the grid will automatically select all children when a parent is selected. If you set
     * enableSelectionBubble, the grid will select the parent if all its children are selected.</li>
     * <li>Fourth, Flexicious Ultimate supports selection based on exclusion. This is applicable for virtual scroll, where there are large
     * amounts of data, (potentially millions of rows), and the user navigates through these large numbers of records. In this scenario where you
     * have lazy loaded grids, selection cascade and select all will simply set flags on the selectionInfo object.
     * The selectedObjects and selectedKeys no longer contain references to data that is selected
     * Instead, they contain the items that the user explicitly selected. unSelectedObjects will contain items that the user explicitly unselected.
     * This helps maintain selection across very large lazy loaded datasets. When you set the enableSelectionExclusion flag to true, use the selectionInfo object to
     * access the selection (or build a query on the server) to identify the objects user selected.
     * </li>
     * </ul>
     *
     * There are a number of properties and methods that help with manipulation and interaction with selection.
     * <ul>
     * <li>grid.selectedObjects and level.selectedObjects: A list of selected objects from the data provider. This is the sdk equivalent of selectedItems.
     * We do not have selectedItems, but selectedObjects will almost always be the same as selectedItems.
     * The only exception is when you use server side paging. In this case, selectedObjects will contain all the items
     * selected, on all pages. grid.selectedObjects implicity returns selectedObjects at the top level. level.selectedObjects
     * will return all the selected objects (regardless of parent) at the corresponding level.
     * </li>
     * <li>grid.selectedKeys and level.selectedKeys: A list of ID values, based on the selectedKeyField property.
     * Returns the selected keys for the top column level. Please NOTE - this is a read only collection.
     * Adding to this does nothing. If you want to programatically modify the selection, use the selectedObjects instead.
     * grid.selectedKeys implicity returns selectedKeys at the top level. level.selectedKeys
     * will return all the selected objects (regardless of parent) at the corresponding level.
     * </li>
     * <li>grid.getSelectedObjects: This method is similar to grid.selectedObjects, except it recursively iterates through all levels
     * gathering the selected objects at each level. This is used for nested datagrids, and used to get all items selected at all levels.
     * If you specify getKey=true, the method will reutrn an array containning the value of the selectedKeyField at each level.
     * </li>
     * <li>grid.getSelectedKeys: This method is similar to grid.selectedKeys, except it recursively iterates through all levels
     * gathering the selected keys at each level. This is used for nested datagrids, and used to get all keys selected at all levels.
     * This method will reutrn an array containning the value of the selectedKeyField at each level, assuming you have specified a selectedKeyField.
     * </li>
     * <li>grid.setSelectedObjects: This method used to select records programmatically. It takes an array and goes through the dataprovider
     * trying to match each item in this array to the dataprovider, recursively trying to add the matching items to the selectedObjects
     * collection at the corresponding level. A boolean flag for this method will optionally open the selected items parents in hierarchical
     * datagrids, so any selection you set using this method is automatically expanded so the user can visually see the selected rows.
     * </li>
     * <li>grid.setSelectedKeys: This method is similar to grid.setSelectedObjects, except it takes an array of keys. Another consideration
     * for this method is that the array of keys need to be globally unique across the entire dataprovider, so parents and children cannot
     * have the same keys. Also, it depends on the selectedKeyField property being set.
     * </li>
     * <li>grid.selectableField : This is a boolean flag on the dataprovider that notifies the grid whether or not the grid should allow
     * interactive selection on the corresponding record.
     * </li>
     * </ul>
     * @method getSelectedKeyField
     */
    getSelectedKeyField() {
        return this.getColumnLevel().selectedKeyField;
    }

    /**
     * @method setSelectedKeyField
     */

    setSelectedKeyField(val) {
        this.getColumnLevel().selectedKeyField = val;
    }

    /**
     * Takes an object that has a rowIndex and a columnIndex property. Finds the cell at that position,
     * and emulates a click event on that cell. This event, in turn will begin an edit session for editable
     * cells.
     * @method setEditedItemPosition
     */
    setEditedItemPosition(rowIndex, colIndex) {
        if (rowIndex >= this.getBodyContainer().itemVerticalPositions.length) {
            throw new Error(`Invalid Row index ${rowIndex}. Max row index ${this.getBodyContainer().itemVerticalPositions.length - 1}`);
        }

        const rowPos = this.getBodyContainer().itemVerticalPositions[rowIndex];
        const level = rowPos.getLevel(this);
        const cols = level.getVisibleColumns();
        if (columnIndex >= cols.length) {
            throw new Error(`Invalid Column index ${columnIndex}. Max col index ${cols.length - 1}`);
        }
        const cell = this.getBodyContainer().getCellForRowColumn(rowPos.rowData, cols[columnIndex]);
        if (!cell) {
            throw new Error(`Cell at Column index ${columnIndex}, RowIndex ${rowIndex} not found`);
        }
        this.getBodyContainer().emulateClick(cell);
    }

    /**
     * Returns the top level pager
     * @method getPager
     */
    getPager() {
        return this.getPagerContainer().getPager();
    }

    /**
     * Gets the pager row height at the top level.
     * @method getPagerRowHeight
     */
    getPagerRowHeight() {
        return this.getColumnLevel().getPagerRowHeight();
    }

    /**
     * Sets the pager row height at the top level.
     * @method setPagerRowHeight
     */
    setPagerRowHeight(val) {
        this.getColumnLevel().setPagerRowHeight(val);
    }

    /**
     * Pointer to the TOP level nextLevelRenderer
     * @method getNextLevelRenderer
     */
    getNextLevelRenderer() {
        return this.getColumnLevel().nextLevelRenderer;
    }

    /**
     * @method setNextLevelRenderer
     */

    setNextLevelRenderer(val) {

        this.getColumnLevel().setNextLevelRenderer(val);
    }

    /**
     * returns true if any of the levels have a filter function
     * @return
     * @method getHasFilterFunction
     *
     */
    getHasFilterFunction() {
        return this.getColumnLevel().getHasFilterFunction();
    }

    /**
     * Added for Persistence support
     * @return
     * @method getHasGroupedColumns
     */
    getHasGroupedColumns() {
        return this.getColumnLevel().hasGroupedColumns;
    }

    /**
     * If rowSpanFunction!=null or colSpanFunction!=null
     * @method getHasRowSpanOrColSpan
     */
    getHasRowSpanOrColSpan() {
        return this._hasRowSpanOrColSpan;
    }

    /**
     * Pointer to the TOP level itemLoadMode
     * @method getItemLoadMode
     */
    getItemLoadMode() {
        return this.getColumnLevel().itemLoadMode;
    }

    /**
     * @method setItemLoadMode
     */

    setItemLoadMode(val) {
        this.getColumnLevel().itemLoadMode = val;
    }

    /**
     * Gets the value of the headerSortSeparatorRight property
     * @method getHeaderSortSeparatorRight
     */
    getHeaderSortSeparatorRight() {
        return this.getStyle("headerSortSeparatorRight") !== undefined
            ? this.getStyle("headerSortSeparatorRight") : 20;
    }
    
    /**
     * A list of items that the user has opened. Only applicable grids with nested column levels.
     * If you programatically modify this collection, call the rebuild method.
     * Please see the documentation of setOpenKeys for instructions on maintaining grid expand/collapse state
     * post a data provider refresh.
     * @method getOpenItems
     * @deprecated Please use the getOpenKeys and getOpenItems instead.
     *
     */
    getOpenItems() {
        return this.getBodyContainer().openItems;
    }

    /**
     * @method setOpenItems
     */

    setOpenItems(valCollection) {
        this.getBodyContainer().openItems = valCollection;
    }

    /**
     * Pointer to the TOP level childrenCountField
     * A property on the object that identifies if the object has children. Only needed in filterPageSortMode=server 
	 * 
	 * In lazy loaded (filterPageSortMode=server) hierarchical grids levels, the child 
	 * level items are loaded when the user actually expands this level for the first time.
	 * 
	 * In scenarios where it is known initially that there are children, set this property to
	 * the value of the object that identifies whether there are children. If this property is 
	 * set, the expand collapse icon will be drawn only when the value of this property on the object
	 * returns an integer greater than zero. Otherwise, the level will always draw the expand collapse icon. 
	 *
     * @method getChildrenCountField
     */
    getChildrenCountField() {
        return this.getColumnLevel()._childrenCountField;
    }

    /**
     * @method setChildrenCountField
     */

    setChildrenCountField(value) {
        this.getColumnLevel()._childrenCountField = value;
    }

    /**
     * @method setVerticalScrollPolicy
     */

    setVerticalScrollPolicy(value) {
        this.getBodyContainer().setVerticalScrollPolicy(value);
    }

    /**
     * @method setEnabled
     */

    setEnabled(value) {
        super.setEnabled();

        if (this.getBodyContainer())
            this.getBodyContainer().setEnabled(value);
        if (this.getFooterContainer())
            this.getFooterContainer().setEnabled(value);
        if (this.getFilterContainer())
            this.getFilterContainer().setEnabled(value);
        if (this.getFooterContainer())
            this.getFooterContainer().setEnabled(value);
        if (this.getPagerContainer())
            this.getPagerContainer().setEnabled(value);
        if (this.getHeaderContainer())
            this.getHeaderContainer().setEnabled(value);
        if (this.getLeftLockedContent())
            this.getLeftLockedContent().setEnabled(value);
        if (this.getRightLockedContent())
            this.getRightLockedContent().setEnabled(value);
        if (this.getLeftLockedHeader())
            this.getLeftLockedHeader().setEnabled(value);
        if (this.getLeftLockedFooter())
            this.getLeftLockedFooter().setEnabled(value);
        if (this.getRightLockedHeader())
            this.getRightLockedHeader().setEnabled(value);
        if (this.getRightLockedFooter())
            this.getRightLockedFooter().setEnabled(value);

    }

    /**
     * Returns the built in Edit Action
     * @return
     * @method getToolbarActionEdit
     */
    getToolbarActionEdit() {
        return this.createBuiltinAction("Edit", 'edit', true, true);
    }

    /**
     * When enableMultiColumnSort=true, setting this flag to on will enable AdvancedDataGrid like Split headers to enable multi column sort.
     * @method getEnableSplitHeader
     * @return {Boolean}
     */
    getEnableSplitHeader() {
        return this._enableSplitHeader && this.enableMultiColumnSort; //false;
    }

    /**
     * @method setEnableSplitHeader
     * @param value
     */

    setEnableSplitHeader(value) {
        this._enableSplitHeader = value;
    }

    /**
     * The container for the right locked footer cells.
     * This is an instance of the LockedContent class, which basically is an extended
     * UIComponent that manages the filter and footer cell visiblity, heights, and the y positions.
     *
     * To access all the footer cells, please use the rows collection of the footerContainer.
     * This contains a single RowInfo object, which contains a cells collection.
     * The cells collection contains ComponentInfo objects, that has a component property, which is
     * an instance of one of the subclasses of FlexDataGridCell. The cell will have a renderer property
     * which is the actual UI control that is being displayed.
     * @method getRightLockedFooter
     */
    getRightLockedFooter() {
        return this._rightLockedFooter;
    }

    /**
     * Pointer to the TOP level levelRendererHeight
     * Height to assign to the renderer for each level. If not specified, a new instance of the level renderer is created, and the height 
	 * is defaulted to the height of that one instance. The same height is then reused for subsequent renderers of the same type. 
     * @method getLevelRendererHeight
     */
    getLevelRendererHeight() {
        return this.getColumnLevel().levelRendererHeight;
    }

    /**
     * @method setLevelRendererHeight
     */

    setLevelRendererHeight(val) {
        this.getColumnLevel().levelRendererHeight = val;
    }

    /**
     *  Unused/Not Applicable. For legacy purposes only
     * @method getLockedColumnCount
     */
    getLockedColumnCount() {
        return -1;
    }

    /**
     * Return the FilterSort objects at the top level
     * @method getCurrentSorts
     */
    getCurrentSorts() {
        return this.getColumnLevel().currentSorts;
    }

    /**
     * If you set this to true, the next call to rebuild will not rebuild the pager control
     * Needed in cases where there is user interaction in the pager control that we do not want
     * to loose, but we want to rebuild the rest of the grid.
     * @method getPreservePager
     */
    getPreservePager() {
        return this._preservePager && (this.getPagerContainer().getPager() != null);
    }

    /**
     * @method setPreservePager
     */

    setPreservePager(value) {
        if (!this._componentsCreated) return;
        this._preservePager = value;
    }

    /**
     * The horizontal scrollbar associated with the this.getBodyContainer(). The body container is
     * the only section to have a scroll bar. The left and right locked containers scroll
     * along with it.
     * @method getHorizontalScrollBar
     */
    getHorizontalScrollBar() {
        return this.getBodyContainer().getHorizontalScrollBar();
    }

    /**
     * Returns true if the pager row is visible at the top level.
     * @method getPagerVisible
     */
    getPagerVisible() {
        return this.getColumnLevel().pagerVisible;
    }

    /**
     * Sets the pager row to visible at the top level.
     * @method setPagerVisible
     */
    setPagerVisible(val) {
        this.getColumnLevel().pagerVisible = val;
    }

    /**
     * Returns the list of groupedColumns at the root level.
     * The grid always has at least one column level. This is also referred to as the top level, or the root level.
     * In flat grids (non hierarchical), this is the only level. But in nested grids, you could have any number of nested levels.
     * The groupedColumns collection actually belongs to the columnLevel, and since there is one root level,
     * the groupedColumns collection of the grid basically points to the groupedColumns collection of this root level.
     * Note : If you set the columns or the grouped columns dynamically, ensure you call grid.getColumnLevel().initializeLevel(grid);
     * @method getGroupedColumns
     */
    getGroupedColumns() {
        return this.getColumnLevel()._groupedColumns.length == 0 ? this.getColumns() : this.getColumnLevel()._groupedColumns;
    }

    /**
     * @param val
     * @method setGroupedColumns
     */

    setGroupedColumns(val) {
        this.getColumnLevel().setGroupedColumns(val);
        if (this.enableEagerDraw)
            this.rebuild();
        this.dispatchEvent(new flexiciousNmsp.BaseEvent("columnsChanged"));

    }

    /**
     * Returns the pager control at the root level.
     * @method getPagerControl
     */
    getPagerControl() {
        return this.getPagerContainer().getPager();
    }

    /**
     * The page size of the top(root) level. To control page sizes at inner levels, set the pageSize property on the inner level.
     * @method getPageSize
     */
    getPageSize() {
        return this.getColumnLevel().pageSize;
    }

    /**
     * @method setPageSize
     */

    setPageSize(val) {
        if (this.getColumnLevel().pageSize != val) {
            this.dispatchEvent(new flexiciousNmsp.BaseEvent("pageSizeChanged"));
            if (!this.getIsClientFilterPageSortMode()) {
                this.getColumnLevel().pageSize = val;
                if (this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER)) {
                    this.itemFilters.getValue(Constants.TOP_LEVEL_FILTER).pageSize = val;
                }
                this.processRootFilter();

            }

            this.getColumnLevel().pageSize = val;
            this.setPageIndex(0);
            this.getRootFilter().pageIndex = 0;
        }

        if (this.enablePreferencePersistence && this._preferencesLoaded) {
            this.rebuild();
        }
    }

    /**
     * Sets the filter row height at the top level.
     * @method getFilterRowHeight
     */
    getFilterRowHeight() {
        return this.getColumnLevel().getFilterRowHeight();
    }

    /**
     * Sets the filter row height at the top level.
     * @method setFilterRowHeight
     */
    setFilterRowHeight(val) {
        this.getColumnLevel().setFilterRowHeight(val);
    }

    /**
     * The vertical scrollbar associated with the this.getBodyContainer(). The body container is
     * the only section to have a scroll bar. The left and right locked containers scroll
     * along with it.
     * @method getVerticalScrollBar
     */
    getVerticalScrollBar() {
        return this.getBodyContainer().getVerticalScrollBar();
    }

    /**
     *The vertical scroll position of the body container. The body container is
     * the only section to have a scroll bar. The left and right locked containers scroll
     * along with it.
     * @method getVerticalScrollPosition
     */
    getVerticalScrollPosition() {
        return this.getBodyContainer().getVerticalScrollPosition();
    }

    /**
     * @method setVerticalScrollPosition
     *
     */
    setVerticalScrollPosition(val) {
        this.getBodyContainer().gotoVerticalPosition(val);
    }

    /**
     * Returns the built in Delete Action
     * @return
     * @method getToolbarActionDelete
     */
    getToolbarActionDelete() {
        return this.createBuiltinAction("Delete", 'delete', true, true);
    }

    /**
     * An array of ChangeInfo objects that contains all the changes made to the data provider using the grid editing mechanism.
     * @method getChanges
     */
    getChanges() {
        return this._changes;
    }

    /**
     *The horizontal scroll position of the body container.
     * @method getHorizontalScrollPosition
     */
    getHorizontalScrollPosition() {
        return this.getBodyContainer().getHorizontalScrollPosition();
    }

    /**
     * @method setHorizontalScrollPosition
     */

    setHorizontalScrollPosition(val) {
        this.getBodyContainer().gotoHorizontalPosition(val);
    }

    /**
     * A function that can be used to control whether clicking on any cell in this level will select it.  
	 * If this function is null or returns false, clicking on the cell will not result in the row being selected.
	 * If this function returns true, clicking on the cell will result in the row being selected in row selection modes only.
	 * This function has two parameters: 
	 * 1) IFlexDataGridDataCell : Cell object which has a pointer to the row data (data) as well as other related information
	 * found in the documentation of the IFlexDataGridDataCell class. This parameter can be null, when the 
	 * function is called as a response to a higher level checkbox select. For example, when the user hits 
	 * select all. In this case, we do not always have a cell, and it will be passed in as null
	 * 2) The actual data object bound to the row. 
	 * This function should true or false.
	 * 
	 * For example:
	 * 
	 * private function rowSelectableFunction(cell:FlexDataGridCell,data:Object):Boolean{
	 * 		return data.enabled;
	 * }
	 * 
     * @method getRowSelectableFunction
     */
    getRowSelectableFunction() {
        return this.getColumnLevel().rowSelectableFunction;
    }

    /**
     * @method setRowSelectableFunction
     */

    setRowSelectableFunction(value) {
        this.getColumnLevel().rowSelectableFunction = value;
    }

    /**
     * The property of the parent level object, that identifies the children that should be displayed on the next level.
     * This is only required if the collection is not a hierarchical view.
     *
     * Please note, in server mode, this property is also the "storage" for the lazy loaded children.
     *
     * See the Partially and Lazy Loaded Server Grid examples for more details
     * @method getChildrenField
     */
    getChildrenField() {
        return this.getColumnLevel().childrenField;
    }

    /**
     * @method setChildrenField
     */

    setChildrenField(value) {
        this.getColumnLevel().childrenField = value;
    }

    /**
     * Returns the max depth possible for nested datagrids
     * @method getMaxDepth
     */
    getMaxDepth() {
        let level = this.getColumnLevel();
        while (level.nextLevel != null) {
            level = level.nextLevel;
        }
        return level.getNestDepth() + (level.nextLevelRenderer ? 1 : 0);
    }

    /**
     * Pointer to the TOP level pagerCellRenderer
     * Container for the footer renderer. Needs to inherit from FlexDataGridPagerCell.  
	 * Defaults to FlexDataGridPagerCell
     * 
     * @method getPagerCellRenderer
     */
    getPagerCellRenderer() {
        return this.getColumnLevel().pagerCellRenderer;
    }

    /**
     * @method setPagerCellRenderer
     */

    setPagerCellRenderer(val) {
        this.getColumnLevel().pagerCellRenderer = val;
    }

    /**
     * The container for the left locked data cells. This is an instance of the ElasticContainer class,
     * which basically attaches to the owner component (which is the bodyContainer) and scrolls vertically along with it.
     * The horizontal scroll of this component is set to off)
     *
     * To access all the data cells, please use the rows collection of the bodyContainer
     * This contains RowInfo objects, which contains a cells collection.
     * The cells collection contains ComponentInfo objects, that has a component property, which is
     * an instance of one of the subclasses of FlexDataGridCell. The cell will have a renderer property
     * which is the actual UI control that is being displayed.
     * @method getLeftLockedContent
     */
    getLeftLockedContent() {
        return this._leftLockedContent;
    }

    /**
     * Returns the columns where excludeFromExport=false
     * @method getExportableColumns
     */
    getExportableColumns() {
        return this.currentExportLevel ? this.currentExportLevel.getExportableColumns() :
            this.getColumnLevel().getExportableColumns();
    }

    /**
     * Returns all columns at all levels. 
     * @return 
     * 
     */
    getExportableColumnsAtAllLevel(exportOptions) {
        return this.getColumnLevel().getExportableColumns(null, true, exportOptions);
    }

    /**
     * Flag that indicates whether or not to show the footer
     * @method getEnableFooters
     */
    getEnableFooters() {
        return this.getColumnLevel().getEnableFooters();
    }

    /**
     * @method setEnableFooters
     */

    setEnableFooters(enabled) {
        this.getColumnLevel().setEnableFooters(enabled);
    }

    /**
     * Returns the top level columnCount
     * @method getColumnCount
     */
    getColumnCount() {
        return this.getVisibleColumns().length;
    }

    /**
     * Returns the built in Add Row Action
     * @return
     * @method getToolbarActionAddRow
     */
    getToolbarActionAddRow() {
        return this.createBuiltinAction("Add Row", "addRow");
    }

    /**
     * Returns (selectedObjects(0)).
     * @method getSelectedItem
     */
    getSelectedItem() {
        return this.getColumnLevel().getSelectedItem();
    }

    /**
     * @method setSelectedItem
     */

    setSelectedItem(val) {
        this.clearSelection();
        this.addSelectedItem(val);
    }

    /**
     *The container for the right locked filter and header cells.
     * This is an instance of the LockedContent class, which basically is an extended
     * UIComponent that manages the filter and footer cell visiblity, heights, and the y positions.
     *
     * To access all the filter/header cells, please use the rows collection of the headerContainer
     * or this.getFilterContainer(). This contains a single RowInfo object, which contains a cells collection.
     * The cells collection contains ComponentInfo objects, that has a component property, which is
     * an instance of one of the subclasses of FlexDataGridCell. The cell will have a renderer property
     * which is the actual UI control that is being displayed.
     * @method getRightLockedHeader
     */
    getRightLockedHeader() {
        return this._rightLockedHeader;
    }

    /**
     * Only applicable for flat grids. Selectd Index holds no meaning for hierarchical grids. 
     * This function will run a filter 
     * Returns dataProvider.indexOf(selectedObjects(0))
     * @method getSelectedIndex
     */
    getSelectedIndex() {
        if (this.getSelectedObjectsTopLevel().length > 0)
            return this.getDataProvider().indexOf(this.getSelectedObjects()[0]);
        return -1;
    }

    /**
     * @method setSelectedIndex
     */

    setSelectedIndex(val) {
        this.clearSelection();
        const itemToSelect = this.getDataProvider()[val];
        if (itemToSelect)
            this.addSelectedItem(itemToSelect);
    }

    /**
     * Returns an array of RowInfo objects in the filter row.
     * @method getFilterRows
     */
    getFilterRows() {
        return this.getFilterContainer().rows.slice();
    }

    /**
     * All elements of the spinner owner that should be blurred when the spinner is active.
	 * The alpha of this element will be set to the spinnerGridAlpha style or 0.3.
     * @method getElementsToBlur
     */
    getElementsToBlur() {
        return [this.getLeftLockedContent(), this.getRightLockedContent(), this.getBodyContainer(), this.getFilterContainer(), this.getHeaderContainer(), this.getLeftLockedHeader(), this.getRightLockedHeader()];
    }

    /**
     * Pointer to the TOP level headerSeparatorWidth
     * Width to show the resize indicator between columns. Defaults to 4
     * @method getHeaderSeperatorWidth
     */
    getHeaderSeperatorWidth() {
        return this.getColumnLevel().headerSeperatorWidth;
    }

    /**
     * @method setHeaderSeperatorWidth
     */

    setHeaderSeperatorWidth(val) {
        this.getColumnLevel().headerSeperatorWidth = val;
    }

    /**
     * The container for the pager cells. This is an instance of the FlexDataGridHeaderContainer class.
     * This will contain a rows collection, which will contain a single RowInfo object. The Single RowInfo
     * object has a cells Collection that will contain a single FlexDataGridPagerCell. The actual IPager
     * is the renderer property of the FlexDataGridPagerCell.
     * @method getPagerContainer
     */
    getPagerContainer() {
        return this._treeDataGridPager;
    }

    /**
     * Returns the top level column names
     * @method getColumnNames
     */
    getColumnNames() {
        return UIUtils.extractPropertyValues((this.getVisibleColumns()),
            "headerText").join("|");
    }

    /**
     * The container for the right locked data cells. This is an instance of the ElasticContainer class,
     * which basically attaches to the owner component (which is the bodyContainer) and scrolls vertically along with it.
     * The horizontal scroll of this component is set to off)
     *
     * To access all the data cells, please use the rows collection of the bodyContainer
     * This contains RowInfo objects, which contains a cells collection.
     * The cells collection contains ComponentInfo objects, that has a component property, which is
     * an instance of one of the subclasses of FlexDataGridCell. The cell will have a renderer property
     * which is the actual UI control that is being displayed.
     * @method getRightLockedContent
     */
    getRightLockedContent() {
        return this._rightLockedContent;
    }

    /*
     * By default, when you set the data provider, the grid clears out the open and selected items.
     * This is ok if you set the dataprovider for the first time, but if you are performing a data refresh,
     * you may wish to use this setter, which will basically store the current open and selected keys,
     * set the data provider, and set the open and selected keys back, irrespective of the fact that
     * the objects in the dataprovider after the refresh are different instances (albeit of the same backend record).
     *
     * var openKeys:Array = getOpenKeys();<br/>
     * var selectedKeys:Array = getSelectedKeys();<br/>
     * dataProvider=val;<br/>
     * setOpenKeys(openKeys);<br/>
     * setSelectedKeys(selectedKeys,false);<br/>
     *
     * Please note, the ability of setOpenKeys and setSelectedKeys to function depends on the selectedKeyField specified at each level,
     * and the value of the selectedKeyField property being unique at each level
     * @param val
     * @method
     *
     */
    /*FlexDataGrid.prototype.setDataProviderPreserveOpenAndSelectedRows = function(val:Object) {
     var openKeys = getOpenKeys();
     var selectedKeys = getSelectedKeys();
     dataProvider=val;
     setOpenKeys(openKeys);
     setSelectedKeys(selectedKeys,false);
    };
    */
    /**
    * Returns the built in moveUp Action
    * @return
    * @method getToolbarActionMoveUp
    */
    getToolbarActionMoveUp() {
        const act = this.createBuiltinAction("", FlexDataGrid.MOVE_UP, true, true);
        act.requiresSingleSelection = true;
        return act;
    }

    /**
     * Returns the list of columns at the root level.
     * The grid always has at least one column level. This is also referred to as the top level, or the root level.
     * In flat grids (non hierarchical), this is the only level. But in nested grids, you could have any number of nested levels.
     * The columns collection actually belongs to the columnLevel, and since there is one root level,
     * the columns collection of the grid basically points to the columns collection of this root level.
     *
     * Note : If you set the columns or the grouped columns dynamically, ensure you call grid.getColumnLevel().initializeLevel(grid);
     * @method getColumns
     */
    getColumns() {
        return this.getColumnLevel().getColumns();
    }

    /**
     * @param val
     * @method setColumns
     */

    setColumns(val) {
        this.getColumnLevel().setColumns(val);
        if (this.enableEagerDraw)
            this.rebuild();
        this.dispatchEvent(new flexiciousNmsp.BaseEvent("columnsChanged"));
    }

    /**
     * Page index at the top level.
     * @method getPageIndex
     */
    getPageIndex() {
        return this.getPagerContainer().getPager() ? this.getPagerContainer().getPager().getPageIndex() - 1 : null;
    }

    /**
     * Page index at the top level.
     * @method setPageIndex
     */
    setPageIndex(val) {
        if (this.getPagerContainer().getPager()) {
            this.getPagerContainer().getPager().setPageIndex(val);
        }
    }

    /**
     * Pointer to the TOP level nestIndent
     * The indentation to apply to each progressive nest level.
	 * @default 15
     * @method getNestIndent
     */
    getNestIndent() {
        return this.getColumnLevel().nestIndent;
    }

    /**
     * @method setNestIndent
     */

    setNestIndent(val) {
        this.getColumnLevel().nestIndent = val;
    }

    /**
     * @method getVerticalSpill
     */

    getVerticalSpill() {
        return this.getBodyContainer().verticalSpill;
    }

    /**
     * A comma seperated list of the following strings:
     * filter,header,body,footer,pager.
     *
     * Changes the order in which the grid displays the
     * filter,header,body,footer,pager
     * The order in which the various sections of the grid
     * are laid out.
     *
     * Defaults to pager,filter,body,footer
     * @method getDisplayOrder
     */
    getDisplayOrder() {
        return this.getColumnLevel().displayOrder;
    }

    /**
     * @param value
     * @method setDisplayOrder
     *
     */
    setDisplayOrder(value) {
        this.getColumnLevel().displayOrder = value;
    }

    /**
     * Returns the list of columns groups at the root level.
     * The grid always has at least one column level. This is also referred to as the top level, or the root level.
     * In flat grids (non hierarchical), this is the only level. But in nested grids, you could have any number of nested levels.
     * The column groups collection actually belongs to the columnLevel, and since there is one root level,
     * the column groups collection of the grid basically points to the column groups collection of this root level.
     * @method getColumnGroups
     */
    getColumnGroups() {
        return this.getColumnLevel().columnGroups;
    }

    /**
     * Pointer to the TOP level nestIndentPaddingCellRenderer
     * Container for the nest indent padding cell. Needs to inherit from FlexDataGridExpandCollapseHeaderCell.  
	 * Defaults to FlexDataGridExpandCollapseCell
     *  
     * @method getNestIndentPaddingCellRenderer
     */
    getNestIndentPaddingCellRenderer() {
        return this.getColumnLevel().nestIndentPaddingCellRenderer;
    }

    /**
     * @method setNestIndentPaddingCellRenderer
     */

    setNestIndentPaddingCellRenderer(val) {
        this.getColumnLevel().nestIndentPaddingCellRenderer = val;
    }

    /**
     * Pointer to the TOP level headerHeight
     * Height of the header for this level. Defaults to 25 
     * @method getHeaderRowHeight
     */
    getHeaderRowHeight() {
        return this.getColumnLevel().getHeaderHeight();
    }

    /**
     * @method setHeaderRowHeight
     */

    setHeaderRowHeight(val) {
        this.getColumnLevel().setHeaderHeight(val);
    }

    /**
     * A Class that is responsible for the multi column sort view. Defaults to MultiColumnSortRenderer. You
     * can provide your own implementation by specifying a custom MultiColumnSortRenderer.
     * @method getMultiSortRenderer
     */
    getMultiSortRenderer() {
        if (this._multiSortRenderer == null) {
            this._multiSortRenderer = new flexiciousNmsp.ClassFactory(flexiciousNmsp.MultiColumnSortPopup);
        }
        return this._multiSortRenderer;
    }

    /**
     * @private 
     * @param value
     * @method setMultiSortRenderer
     */
    setMultiSortRenderer(value) {
        this._multiSortRenderer = value;
    }

    /**
     * Flag that indicates whether or not to show the filter
     * @method getEnableFilters
     */
    getEnableFilters() {
        return this.getColumnLevel().getEnableFilters();
    }

    /**
     * @method setEnableFilters
     */

    setEnableFilters(enabled) {
        this.getColumnLevel().setEnableFilters(enabled);
    }

    /**
     * The property of the object on this level that should be used in the default sort at the root level. In nested levels, this property can be set on inner levels as well.
     * @method getInitialSortField
     */
    getInitialSortField() {
        return this.getColumnLevel().initialSortField;
    }

    /**
     * @method setInitialSortField
     */

    setInitialSortField(value) {
        this.getColumnLevel().initialSortField = value;
    }

    /**
     * Returns true if the header row is visible at the top level.
     * @method getHeaderVisible
     */
    getHeaderVisible() {
        return this.getColumnLevel().headerVisible;
    }

    /**
     * Sets the filter row to visible at the top level.
     * @method setHeaderVisible
     */
    setHeaderVisible(val) {
        this.getColumnLevel().headerVisible = val;
    }

    /**
     * Returns the built in Filter Action
     * @method getToolbarActionFilter
     * @return
     */
    getToolbarActionFilter() {
        return this.createBuiltinAction("Filter", "filter");
    }

    /**
     * Returns the built in Edit Action
     * @method getToolbarActionSort
     * @return
     */
    getToolbarActionSort() {
        return this.createBuiltinAction("Sort", 'sort', false, false);
    }

    /**
     * Returns the top level selectedObjects
     * @method getSelectedItems
     */
    getSelectedItems() {
        return this.getSelectedObjects().slice();
    }

    /**
     * The Filter/Page/Sort Mode. Can be either "server" or "client".
     * In client mode, the grid will take care of paging, sorting and
     * filtering once the dataprovider is set.
     * In server mode, the grid will fire a com.flexicious.grids.events.FilterPageSortChangeEvent
     * named filterPageSortChange
     * that should be used to construct an appropriate query to be sent to the
     * backend.
     *
     * @defaultValue "client"
     * @see com.flexicious.grids.events.FilterPageSortChangeEvent
     * @method getFilterPageSortMode
     */
    getFilterPageSortMode() {
        return this.getColumnLevel().filterPageSortMode;
    }

    /**
     * @method setFilterPageSortMode
     */

    setFilterPageSortMode(val) {
        this.getColumnLevel().filterPageSortMode = val;
    }

    /**
     * Returns the maximum width of right locked columns. If there are multiple levels, goes through each of the levels and gets the maximum
     * @method getRightLockedWidth
     */
    getRightLockedWidth() {
        return this.getColumnLevel().getWidestRightLockedWidth();
    }

    /**
     * If true, initial sort direction for this level is ascending. Defaults to true.
     * @method getInitialSortAscending
     */
    getInitialSortAscending() {
        return this.getColumnLevel().initialSortAscending;
    }

    /**
     * @method setInitialSortAscending
     */

    setInitialSortAscending(value) {
        this.getColumnLevel().initialSortAscending = value;
    }

    /**
     * The container for the footer cells. This is an instance of the FlexDataGridHeaderContainer class.
     * This class manages cell initialization, recycling, mouse events on each cell, etc. The rows collection
     * of this object will aways contain a single RowInfo object, which has a cells collection. This will
     * be a series of ComponentInfo objects, which has a component property that will be an instance of FlexDataGridFooterCell
     * Although the parent property of each of the cells could be either the
     * leftLockedFooter, rightLockedFooteror the footerContainer, the rowInfo is the same, so the cells will
     * include left, right, and unlocked cells.
     * @method getFooterContainer
     */
    getFooterContainer() {
        return this._treeDataGridFooter;
    }

    /**
     * The container for the left locked filter and header cells.
     * This is an instance of the LockedContent class, which basically is an extended
     * UIComponent that manages the filter and footer cell visiblity, heights, and the y positions.
     *
     * To access all the filter/header cells, please use the rows collection of the headerContainer
     * or filterContainer. This contains a single RowInfo object, which contains a cells collection.
     * The cells collection contains ComponentInfo objects, that has a component property, which is
     * an instance of one of the subclasses of FlexDataGridCell. The cell will have a renderer property
     * which is the actual UI control that is being displayed.
     * @method getLeftLockedHeader
     */
    getLeftLockedHeader() {
        return this._leftLockedHeader;
    }

    /**
     * Flag to force appearance of the pager row even with enablePaging=false.
     *
     * Use this flag to show the pager control even if the
     * enablePaging is set to false. This is used in a scenario
     * where you wish to show buttons other than the paging buttons
     * in the pager bar.
     * @return
     * @method getForcePagerRow
     */
    getForcePagerRow() {
        return this.getColumnLevel().forcePagerRow;
    }

    /**
     * @method setForcePagerRow
     */

    setForcePagerRow(val) {
        this.getColumnLevel().forcePagerRow = val;
    }

    /**
     * Whether or not to show the horizontal scroll bar.
     *
     * Please note, this behavior also controls the behavior when a column is resized.
     * If <code>horizontalScrollPolicy</code> is <code>"none"</code>,
     * increasing the size of a column reduces the size of other columns
     * in the grid. Decreasing the size does the opposite. This makes the grid have
     * a predictable width, and eliminates the need for a horizontal scroll bar.
     *
     * Default is "off", but if you specify any column as left or right locked, it becomes
     * auto.
     * @method getHorizontalScrollPolicy
     */
    getHorizontalScrollPolicy() {
        return this.getBodyContainer().getHorizontalScrollPolicy();
    }

    /**
     *
     * @method setHorizontalScrollPolicy
     */
    setHorizontalScrollPolicy(value) {
        this.getBodyContainer().setHorizontalScrollPolicy(value);
    }

    /**
     * Returns true if the top column level filterPageSortMode is client.
     * @return
     * @method getIsClientFilterPageSortMode
     *
     */
    getIsClientFilterPageSortMode() {
        return this.getColumnLevel().filterPageSortMode == "client";
    }

    /**
     * The current tooltip object trigger.
     * @method getCurrentTooltipTrigger
     */
    getCurrentTooltipTrigger() {
        return this.tooltipBehavior.currentTooltipTrigger;
    }

    /**
     * Returns an array of RowInfo objects in the footer row.
     * @method getFooterRows
     */
    getFooterRows() {
        return this.getFooterContainer().rows.slice();
    }

    /**
     * The max horizontal scroll position of the bodyContainer
     * @return
     * @method getMaxHorizontalScrollPosition
     */
    getMaxHorizontalScrollPosition() {
        return this.getBodyContainer().getMaxHorizontalScrollPosition();
    }

    /**
     * The main scrollable area of the grid. This is an instance of the FlexDataGridBodyContainer class, which
     * derives from FlexDataGridContainerBase. The Body container manages renderer recycling, scrolling, expand
     * collapse, editing, etc. The bodyContainer contains a rows collection, which is a visual representation of
     * the current ViewPort, that is, it shows the currently visible cells based on the vertical and horizontal
     * scroll postions. You can iterate through the currently visible cells via looping through the rows property
     * and going through the cells collection of each RowInfo. Please note, this will only get you the currently
     * visible cells. If you wish to access each cell as it is being initialized (or revived from a recyclable state)
     * please wire up the rendererInitialized event on the grid.
     * @method getBodyContainer
     */
    getBodyContainer() {
        return this._treeDataGridContainer;
    }

    /**
     * A Class that implements com.flexicious.controls.interfaces.IPager.
	 * Defaults to a built in implementation
     * @see com.flexicious.grids.columns.footers.PagerControl.
	 * @see implements com.flexicious.controls.interfaces.IPager.
     * @method getPagerRenderer
     */
    getPagerRenderer() {
        return this.getColumnLevel().getPagerRenderer();
    }

    /**
     *
     * @method setPagerRenderer
     */
    setPagerRenderer(val) {
        this.getColumnLevel().setPagerRenderer(val);
    }

    /**
     * Returns the built in Move to Action
     * @return
     * @method getToolbarActionMoveTo
     */
    getToolbarActionMoveTo() {
        const act = this.createBuiltinAction("Move to", 'moveTo', true, true);
        act.requiresSingleSelection = true;
        return act;
    }

    /**
     * A property on the object that identifies whether the object is disabled.
     * @method getDisabledField
     */
    getDisabledField() {
        return this.getColumnLevel().disabledField;
    }

    /**
     *
     * @method setDisabledField
     */
    setDisabledField(val) {
        this.getColumnLevel().disabledField = val;
    }

    /**
     * Unused/Not Applicable. For legacy purposes only. For flexicious Ultimate, the columnLockMode is set on the
     * FlexDataGridColumn object itself.
     * @method getLockedColumnWidth
     */
    getLockedColumnWidth() {
        return -1;
    }

    /**
     *  The element of the owner that should be used to center the spinner.
     * @method getElementToCenter
     */
    getElementToCenter() {
        return this;
    }

    /**
     * Returns the columns where excludeFromExport=false
     * @method getSortableColumns
     */
    getSortableColumns() {
        return this.getColumnLevel().getSortableColumns();
    }

    /**
     * Support for selection based on exclusion. In scenarios where you have lazy loaded grids, selection cascade and select all will
     * simply set flags on the selectionInfo object. The selectedObjects and selectedKeys no longer contain references to data that is selected
     * Instead, they contain the items that the user explicitly selected. unSelectedObjects will contain items that the user explicitly unselected.
     * This helps maintain selection across very large lazy loaded datasets. When you set the enableSelectionExclusion flag to true, use the selectionInfo object to
     * access the selection (or build a query on the server) to identify the objects user selected. Selection
     * 
     * @method getSelectionInfo
     */
    getSelectionInfo() {
        const selectionInfo = new flexiciousNmsp.SelectionInfo();
        selectionInfo.isSelectAll = this.getSelectAllState() == flexiciousNmsp.TriStateCheckBox.STATE_CHECKED;
        let lvl = this.getColumnLevel();
        while (lvl) {
            const lvlSelectionInfo = new flexiciousNmsp.LevelSelectionInfo();
            lvlSelectionInfo.levelNestDepth = lvl.getNestDepth();
            lvlSelectionInfo.selectedObjects = lvl._selectedObjects;
            lvlSelectionInfo.excludedObjects = lvl._unSelectedObjects;
            selectionInfo.levelSelections.push(lvlSelectionInfo);
            lvl = lvl.nextLevel;
        }
        return selectionInfo;
    }

    /**
     * Returns the sum of: <br/>
     * If enableFooters, then footerRowHeight else 0
     * @return
     * @method getFooterRowHeight
     */
    getFooterRowHeight() {
        return this.getColumnLevel().getFooterRowHeight();
    }

    /**
     * Sets the footer row height at the top level.
     * @method setFooterRowHeight
     */
    setFooterRowHeight(val) {
        this.getColumnLevel().setFooterRowHeight(val);
    }

    /**
     * The parent to add the spinner to.
     * @method getSpinnerParent
     */
    getSpinnerParent() {
        return this;
    }

    /**
     * @method getIsScrolling
     */

    getIsScrolling() {
        return this._isScrolling;
    }

    /**
     * Flag to indicate whether or not to enable paging functionality
     * @return
     * @method getEnablePaging
     */
    getEnablePaging() {
        return this.getColumnLevel().enablePaging;
    }

    /**
     * @method setEnablePaging
     */


    setEnablePaging(enabled) {
        this.getColumnLevel().enablePaging = enabled;
    }

    /**
     * If all items from the top level are selected, returns TriStateCheckBox.STATE_CHECKED.
     * If none are selected, returns TriStateCheckBox.STATE_UNCHECKED
     * else returns TriStateCheckBox.STATE_MIDDLE
     * @method getSelectAllState
     */
    getSelectAllState() {
        return this.enableSelectionExclusion ? this._selectAllState : this.getColumnLevel().getSelectedKeysState(this.getDataProvider());
    }

    /**
     * Sets the selected keys for the top level.
     * If you pass in TriStateCheckBox.STATE_CHECKED, all items are selected.
     * If you pass in TriStateCheckBox.STATE_UNCHECKED, all items are unselected.
     * TriStateCheckBox.STATE_MIDDLE is not valid parameter for this function.
     * @method setSelectAllState
     */
    setSelectAllState(val) {
        this._useSelectedSelectAllState = val;
        if (this.enableSelectionExclusion) {
            this.clearSelection();
            this._selectAllState = val;
            const evt = new flexiciousNmsp.FlexDataGridEvent(flexiciousNmsp.FlexDataGridEvent.CHANGE,
                this, this.getColumnLevel(), null);
            this.dispatchEvent(evt);
        } else {
            this.getColumnLevel().setSelectedKeysState(val);
        }
        this.invalidateSelection()
    }

    /**
     * This is a boolean flag on the dataprovider that notifies the grid whether or not the grid should allow
     * interactive selection on the corresponding record.
     * @method getSelectableField
     */
    getSelectableField() {
        return this.getColumnLevel().selectableField;
    }

    /**
     * @method setSelectableField
     */
    setSelectableField(val) {
        this.getColumnLevel().selectableField = val;
    }

    /**
     *  Delay in milliseconds before "virtualScroll" event is dispatched.
     * @method getVirtualScrollDelay
     */
    getVirtualScrollDelay() {
        return this.getVirtualBodyContainer().virtualScrollDelay;
    }

    /**
     * @method setVirtualScrollDelay
     */
    setVirtualScrollDelay(value) {
        this.getVirtualBodyContainer().virtualScrollDelay = (value);
    }

    /**
     * Returns the TOP level data without any filters.
     * @method getDataProviderNoFilters
     */
    getDataProviderNoFilters() {
        return this.getRootFlat();
    }

    /**
     * @method getTraceRows
     */
    getTraceRows() {
        let str = "";
        const cols = this.getColumns();

        for (const col of cols) {
            str += `${col.width}`;
        }

        return str;
    }

    /**
     * The Root Column Level. This is a property of type "FlexDataGridColumnLevel".
     * This grid always has at least one column level. This is also referred to as the top level, or the root level.
     * In flat grids (non hierarchical), this is the only level. But in nested grids, you could have any number of nested levels.
     * The columns collection actually belongs to the columnLevel, and since there is one root level, the columns collection
     * of the grid basically points to the columns collection of this root level.
     *
     * The FlexDataGridColumnLevel class has a "nextLevel" property, which is a pointer to another instance of the same class,
     * or a "nextLevelRenderer" property, which is a reference to a ClassFactory the next level.
     * Please note, currently, if you specify nextLevelRenderer, the nextLevel is ignored.
     * This means, at the same level, you cannot have both a nested subgrid as well as a level renderer.
     * @method getColumnLevel
     */
    getColumnLevel() {
        if (!this._columnLevel) {
            this.setColumnLevel(new flexiciousNmsp.FlexDataGridColumnLevel(this));
        }
        return this._columnLevel;
    }

    /**
     * @method setColumnLevel
     */
    setColumnLevel(value) {
        if (this._columnLevel && (this._columnLevel != value)) {
            //this means we got initialized by some boolean flags that were set before the level was initialized
            value.transferProps(this._columnLevel, value, true);
            value.grid = this;
        }
        this._columnLevel = value;
        value.initializeLevel(this);
        if (this.enableEagerDraw)
            this.rebuild();
    }

    /**
     * Returns the TOP level data without any paging, but with filters.
     * @method getDataProviderNoPaging
     */
    getDataProviderNoPaging() {
        return UIUtils.filterArray(this.getRootFlat(), this.getRootFilter(), this, this.getColumnLevel(), false);
    }

    /**
     * A field on the dataprovider that indicates that this item should be selected
     * @method getSelectedField
     */
    getSelectedField() {
        return this.getColumnLevel().selectedField;
    }

    /**
     * @method setSelectedField
     */
    setSelectedField(val) {
        this.getColumnLevel().selectedField = val;
    }

    /**
     * The current tooltip object.
     * @method getCurrentTooltip
     */
    getCurrentTooltip() {
        return this.tooltipBehavior.getCurrentTooltip();
    }

    /**
     * Flag to embed a column that shows row numbers
     * @method getEnableRowNumbers
     */
    getEnableRowNumbers() {
        return this.getColumnLevel().enableRowNumbers;
    }

    /**
     * @method setEnableRowNumbers
     */
    setEnableRowNumbers(value) {
        this.getColumnLevel().enableRowNumbers = value;
    }

    /**
     * The data provider for the grid. Needs to be an Array. We provide examples in the sample project to
     * convert XML to Json. See flexiciousNmsp.xml2json
     * <p>
     * Please note, for hierarchical data, hierarchy is setup in the Grid itself, so
     * HTMLTreeGrid was designed with multi Level Heterogeneous and
     * Homogeneous Hierarchical Data in mind, so we do not have the need to implement a customized data
     * structure to morph object graphs into nested data. We are able to consume flat
     * Array, and display a hierarchical UI. We provide numerous examples of this concept in our sample project.
     * </p>
     * <p>
     * The Grid provides the concept of "columnLevels". In fact, a non-hierarchical
     * Flexicious Ultimate Grid is simply a grid with just one column level. Please
     * refer to the documentation of the FlexDataGridColumnLevel class.
     * </p>
     * <p>
     * When you have multiple levels of data (i.e. multiple Column Levels),
     * you can just assign a flat collection to the top level, and within the flat collection
     * specify which property contains the next level of data, via the childrenField property.
     * </p>
     * @method getDataProvider
     */
    getDataProvider() {
        return this._dataProvider;
    }

    /**
     *
     * @method setDataProvider
     */
    setDataProvider(value) {
        if (value == null) {
            return;
        }
        if (value == this._dataProvider) {
            return;
        }
        if (value instanceof Array) {
            value = (value);
            if (this.showSpinnerOnFilterPageSort) {
                this.hideSpinner();
            }
        }
        else {
            const arr = [];
            if (value != null) {
                arr.push(value);
            }
            value = (arr);
        }
        if (this._dataProvider != value) {
            this._dataProvider = value;

            if (this.rebuildGridOnDataProviderChange || !this._dataProviderSet)
                this.rebuild();
            else
                this.rebuildBody();
            this.clearAllCollections();
        }
        if ((this.getFilterPageSortMode() == "server")) {
            //we are in server mode
            if (this.enableSelectAllOnPageChange && this._useSelectedSelectAllState == flexiciousNmsp.TriStateCheckBox.STATE_CHECKED) {
                //user has checked all....
                const items = this._dataProvider;

                for (const item of items) {
                    if (!this.getColumnLevel().isItemSelected(item))
                        this.getColumnLevel().selectRow(item, true);
                }
            }
            if (this.showSpinnerOnFilterPageSort) {
                this.hideSpinner();
            }

            this.checkNoDataMessage();
            this.dispatchEvent(new flexiciousNmsp.FlexDataGridEvent(flexiciousNmsp.FlexDataGridEvent.DATA_PROVIDER_CHANGE, this));

            if (this.getHasRowSpanOrColSpan() && (this.getVerticalScrollPosition() > 0) && this._dataProviderSet) {
                //this means the data provider changed
                const vsp = this.getVerticalScrollPosition();
                this.gotoVerticalPosition(0);
                this.validateNow();
                //if you want to maintain vsp
                while (this.getVerticalScrollPosition() < vsp) {
                    this.gotoVerticalPosition(this.getVerticalScrollPosition() + this.getBodyContainer().getHeight());
                    this.validateNow();
                }
            }

        } else {
            this.dispatchEvent(new flexiciousNmsp.FlexDataGridEvent(flexiciousNmsp.FlexDataGridEvent.DATA_PROVIDER_CHANGE, this));
        }
        this._dataProviderSet = true;
    }

    /**
     * Not used.
     * @method getVerticalScrollBarOffset
     */
    getVerticalScrollBarOffset() {
        return this.getVerticalScrollBar() ? this.getVerticalScrollBar().width : 0;
    }

    /**
     * @method getPeristenceKey
     */

    /**
     * String value that uniquely identifies this grid across the application.
     * If you have multiple grids' with enablePreferencePersistence, and they
     * happen to share the same value for the id field, e.g. id="grid1" they
     * might overwrite each others' preferences. To combat this situation, we
     * provide a property, which defaults to the id of the grid, but you can
     * override to provide a globally unique key.
     * @return {*}
     * @method getPeristenceKey
     */
    getPeristenceKey() {

        return this.getPreferencePersistenceKey();

    }

    /**
     * @method clearPreferences
     */
    clearPreferences() {

        this._preferencesSet = false;
        this.getUserSettingsController().clearPreferences(this.userSettingsOptionsFunction());

    }

    /**
     * Persists the preferences as Shared Objects when  preferencePersistenceMode=client
     * or dispatches an event with the preference information when preferencePersistenceMode=server
     * @method persistPreferences
     */
    persistPreferences(name, isDefault) {
        if (typeof name == "undefined") name = 'Default';
        if (typeof isDefault == "undefined") isDefault = false;

        this.getUserSettingsController().persistPreferences(this.userSettingsOptionsFunction(), name, isDefault);

    }

    /**
     * Loads preference values from the Shared object, called automatically in
     * preferencePersistenceMode=client. In server mode, you can directly set
     * the preferences property to the string XML value persisted earlier.
     * @method loadPreferences
     */
    loadPreferences() {

        this._preferencesLoaded = true;
        this.getUserSettingsController().loadPreferences(this.userSettingsOptionsFunction());

    }

    /**
     * Takes an array collection of preferences and applies them to the grid.
     * @method setPreferencesFromSettings
     */
    setPreferencesFromSettings(arrayCollection) {

        this._preferencesSet = true;
        this._triggerEvent = false;
        let filterPersisted = false;
        const uso = this.userSettingsOptionsFunction();
        this.getUserSettingsController().setPreferences(uso, arrayCollection);
        if (uso.grid != null) {
            for (const item of arrayCollection) {
                if (item.key == Constants.PERSIST_COLUMN_WIDTH) {
                    this._userPersistedColumnWidths = true;//this means the user explicitly previously set column widths, so dont change with them
                }
                else if (item.key == Constants.PERSIST_FILTER) {
                    filterPersisted = true;
                }
            }
        }
        this._triggerEvent = true;
        if (filterPersisted) {
            this._filterDirty = true;
            this.doInvalidate();
        }

    }

    /**
     * returns UserSettingsOptions.create(this);
     * @method defaultUseSettingsOptionsFunction
     */
    defaultUseSettingsOptionsFunction() {

        return flexiciousNmsp.UserSettingsOptions.create(this);

    }

    /**
     * When enableMultiplePreferences = true, this represents a list of all preferences saved for this
     * grid.
     * @method getGridPreferencesInfo
     */
    getGridPreferencesInfo() {

        return this._gridPreferencesInfo;

    }

    /**
     * Sets the multiple preferences array. On basis of the applyPreferences parameter, loops
     * through the preferences and sets the preferences value to the first preference where
     * isDefault=true.
     * @method setGridPreferencesInfo
     **/
    setGridPreferencesInfo(val, applyPreferences) {
        if (typeof applyPreferences == "undefined") applyPreferences = true;

        this._gridPreferencesInfo = val;
        const prefArr = val ? val.savedPreferences : [];
        if (prefArr && prefArr.length > 0 && applyPreferences) {
            let defaultPref = prefArr[0];

            for (const pref of prefArr) {
                if (pref.name == val.defaultPreferenceName) {
                    defaultPref = pref;
                    break;
                }
            }

            this.setPreferences(defaultPref.preferences);
        }

    }

    /**
     * When enableMultiplePreferences = true, this represents the currently applied preference
     * @method getCurrentPreferenceInfo
     */
    getCurrentPreferenceInfo() {

        return this._currentPreference;

    }

    /**
     * When enableMultiplePreferences = true, applies the given preference as the current
     * preference.
     * @method setCurrentPreferenceInfo
     **/
    setCurrentPreferenceInfo(val, applyPreferences) {
        if (typeof applyPreferences == "undefined") applyPreferences = true;

        this._currentPreference = val;
        if (val && applyPreferences) {
            this.setPreferences(val.preferences)
        }
        this.dispatchEvent(new flexiciousNmsp.BaseEvent('gridPreferencesChanged'));

    }

    /**
     * By default, when the grid's creation complete event is dispatched, the grid will go
     * in and load the saved preference. This works well in most cases, but in some cases, where
     * the data needed to build selection comboboxes (for filters) is built from the dataprovider,
     * it makes sense to wait until the dataprovider is loaded to parse and set the preferences, otherwise
     * the grid will end up ignoring saved preferences for filters that have dropdown based UI. In this case
     * set autoLoadPreferences to true, and manually call loadPreferences when the data is received from
     * the server and the dataprovider is set.<br/>
     *
     * grid:FlexDataGrid autoLoadPreferences=”false” <br/>
     * And then, when you set the dataprovider: <br/>
     * dgReport.dataProvider=dp;<br/>
     * if(!dgReport.getPreferencesLoaded()){<br/>
     *         dgReport.loadPreferences();<br/>
     * }<br/>
     * 
     * @method getAutoLoadPreferences
     */
    getAutoLoadPreferences() {

        return this.autoLoadPreferences;

    }

    /**
     * Returns an XML representation of the preferences specified in
     * the  preferencesToPersist property and values being the actual
     * values. When
     * @return
     * @method getPreferences
     */
    getPreferences() {
        return this.getUserSettingsController().getPreferencesString(this.userSettingsOptionsFunction());
    }

    /**
     * @method setPreferences
     */

    setPreferences(val) {
        this.setPreferencesFromSettings(this.getUserSettingsController().parsePreferences(this.userSettingsOptionsFunction(), val));
    }

    /**
     * Returns true if the load preferences has been called.
     * @method getPreferencesLoaded
     */
    getPreferencesLoaded() {
        return this._preferencesLoaded;
    }

    /**
     * String value that uniquely identifies this grid across the application.
     * If you have multiple grids' with enablePreferencePersistence, and they
     * happen to share the same value for the id field, e.g. id="grid1" they
     * might overwrite each others' preferences. To combat this situation, we
     * provide a property, which defaults to the id of the grid, but you can
     * override to provide a globally unique key.
     * @return
     * @method getPreferencePersistenceKey
     */
    getPreferencePersistenceKey() {
        return this._preferencePersistenceKey.length > 0 ? this._preferencePersistenceKey : this.id;
    }

    /**
     *  * String value that uniquely identifies this grid across the application.
     * If you have multiple grids' with enablePreferencePersistence, and they
     * happen to share the same value for the id field, e.g. id="grid1" they
     * might overwrite each others' preferences. To combat this situation, we
     * provide a property, which defaults to the id of the grid, but you can
     * override to provide a globally unique key.
     * @return {*}
     * @method setPreferencePersistenceKey
     */

    setPreferencePersistenceKey(val) {
        this._preferencePersistenceKey = val;
    }

    /**
     * IE does not know localName, it knows baseName.
     * @param node
     * @return {*|String|*}

     * @method getLocalName
     */
    getLocalName(node) {
        return node.localName || node.baseName;
    }

    /**
     * Dumps the configuration information
     */
    dumpConfig() {
        alert(this.configuration);
        alert(JSON.stringify(this.getDataProvider()));
    }

    /**
     * The main method that parses the configuration XML and builds the FlexDataGrid
     * @method buildFromXml
     * @param strXml
     */

    buildFromXml(strXml) {
        this.parse(strXml, this);
        this.configuration = strXml;
    }

    /**
     * used by the buildFromXml method to parse the XML to build the grid
     * @method parse
     */
    parse(strXml, grid) {
        strXml = strXml.replace(new RegExp("\"", "g"), "'");
        const xml = UIUtils.parseXML(strXml);
        const items = xml.childNodes;

        for (const gridItem of items) {
            if (!this.getLocalName(gridItem)) continue;
            const items2 = gridItem.attributes;

            for (const attr of items2) {
                this.applyAttribute(grid, attr, gridItem);
            }

            const items3 = gridItem.childNodes;

            for (const gridChildNode of items3) {
                if (!this.getLocalName(gridChildNode)) continue;
                if (this.getLocalName(gridChildNode) == 'level') {
                    this.extractLevel(gridChildNode, grid.getColumnLevel());
                }
                else if (this.getLocalName(gridChildNode) == 'filters') {
                    this.extractFilters(gridChildNode, grid);
                }
                else if (this.getLocalName(gridChildNode) == 'actions') {
                    this.extractActions(gridChildNode, grid);
                }
                else if (this.getLocalName(gridChildNode) == 'columns') {
                    this.extractColumns(gridChildNode, grid.getColumnLevel());
                }
            }
        }

        grid.getColumnLevel().initializeLevel(grid);
        grid.rebuild();
    }

    executeFunctionByName(functionName, context /*, args */) {
        const args = Array.prototype.slice.call(arguments, 2);
        const namespaces = functionName.split(".");
        const func = namespaces.pop();
        for (let i = 0; i < namespaces.length; i++) {
            context = context[namespaces[i]];
        }
        return context[func](...args);
    }

    /**
     * Applies the given attribute to the target. Has built in logic to check to
     * see if the property is a getter or a setter or a public field, or an event listener,
     * or a factory, or a renderer. If there is a factory or a renderer, we try to evaluate
     * the actual function on basis of the string passed in.
     * @method applyAttribute
     * @param target The target to apply the property to
     * @param attr  The attribute on the target
     * @param node  The value to apply
     * @param direct
     */
    applyAttribute(target, attr, node, direct) {
        let targetEvents = flexiciousNmsp[target.typeName].ALL_EVENTS;
        if (!targetEvents) {
            flexiciousNmsp[target.typeName].ALL_EVENTS = [];
            for (const prop in flexiciousNmsp[target.typeName]) {
                if (prop.indexOf("EVENT_") == 0) {
                    flexiciousNmsp[target.typeName].ALL_EVENTS.push(flexiciousNmsp[target.typeName][prop]);
                }
            }
            targetEvents = flexiciousNmsp[target.typeName].ALL_EVENTS;
        }
        //try
        {
            let attrName = direct ? attr : attr.name;
            let val = direct ? node : node.attributes.getNamedItem(attrName).value;

            if (this.delegate && val && val["length"] && val[0] == "{" && val[val.length - 1] == "}") {
                val = val.replace(/{/, "").replace(/}/, "");
                val = val.replace(/\(/, ",").replace(/\)/, "");
                val = val.split(",");
                val = this.executeFunctionByName(val.shift(), this.delegate, val);
            }
            //in here, values could be class factories or functions, which
            //need additional processing before we can apply them.
            if (attrName.indexOf('Function') > 0 || attrName.indexOf('Renderer') > 0 || attrName.indexOf('Editor') > 0
                || attrName.includes('spinnerFactory')
                || attrName.includes('filterDateRangeOptions') || attrName.indexOf("Formatter") > 0
                || attrName.indexOf("on") == 0 || targetEvents.includes(attrName)) {

                if (this.delegate != null && this.delegate[val] != undefined) {
                    val = this.delegate[val];
                }
                else {
                    val = eval(val);
                }

                if (attrName.indexOf("on") == 0 || targetEvents.includes(attrName)) {
                    //this is an event
                    if (attrName.indexOf("on") == 0) {
                        const charAt2 = attrName[2];
                        if (attrName[2] == attrName[2].toUpperCase()) {
                            attrName = attrName.substring(3);
                            attrName = charAt2.toLowerCase() + attrName;
                        }
                    }
                    target.addEventListener(this, attrName.indexOf("on") == 0 ? attrName.substring(2) : attrName, val);
                } else if (attrName == ('filterRenderer') ||
                    attrName == ('footerRenderer') ||
                    attrName == ('headerRenderer') ||
                    attrName == ('pagerRenderer') ||
                    attrName == ('itemRenderer') ||
                    attrName == ('nextLevelRenderer') ||
                    attrName == ('iconTooltipRenderer') ||
                    attrName == ('spinnerFactory') ||
                    attrName == ('itemEditor') ||
                    attrName == ('popupFactoryExportOptions') ||
                    attrName == ('popupFactoryContextMenuPopup') ||
                    attrName == ('popupFactorySaveSettingsPopup') ||
                    attrName == ('popupFactorySettingsPopup')
                ) {
                    if (!val.implementsOrExtends || !val.implementsOrExtends('ClassFactory')) {
                        val = new flexiciousNmsp.ClassFactory(val);
                    }
                }
            }
            else if (val.toString() == {}.toString()) {

            }
            else if (typeof val == "string") {
                if (val.toLowerCase() == "false") {
                    val = false;
                }
                else if (val.toLowerCase() == "true") {
                    val = true;
                }
                else if (val.indexOf("[") == 0) {
                    val = val.substring(1, val.length - 1).split(",");
                    for (let i = 0; i < val.length; i++) {
                        if (val[i].indexOf("0x") == 0) {
                            val[i] = parseInt(val[i], 16);
                        }
                    }
                }
                else if (val.indexOf("0x") == 0) {
                    val = parseInt(val, 16)
                }
                else if ((val.indexOf("eval__") == 0)) {
                    val = eval(val.split("eval__")[1])
                }
                else if (UIUtils.isStringNumeric(val)) {
                    val = parseFloat(val)
                }
            }
            this.checkSetterAndApply(target, attrName, val);

        }

    }

    /**
     * Method to extract action. Unused
     * @method extractActionFromObject
     */
    extractActionFromObject(item) {
        let tba = item;
        if (!tba) {
            tba = new flexiciousNmsp.ToolbarAction("");
            for (const prop in item) {
                if (UIUtils.isPrimitive(item[prop])) {
                    tba[prop] = item[prop];
                }
            }
        }
        return tba;
    }

    /**
     * Checks to see if there is a setter by the name provided, and if so use that, else apply as a property
     * @method checkSetterAndApply
     */
    checkSetterAndApply(target, attrName, val) {
        UIUtils.checkSetterAndApply(target, attrName, val);
    }

    /**
     * Checks to see if there is a getter with the specified name, and if so, return the value of that getter
     * other wise return the value of the field with this name,
     * @method checkGetterAndRetrieve
     */
    checkGetterAndRetrieve(target, attrName) {
        return UIUtils.checkGetterAndRetrieve(target, attrName);
    }

    /**
     * @unused
     * @method extractActions
     */
    extractActions(actionsNode, grid) {
        const actions = [];
        const items = actionsNode.childNodes;

        for (const actionNode of items) {
            if (!this.getLocalName(actionNode)) continue;
            actions.push(
                grid.hasOwnProperty(`toolbarAction${flexiciousNmsp.CellUtils.doCap(actionNode.attributes.getNamedItem('code').value)}`) ?
                    this.extractAction(actionNode, grid[`toolbarAction${flexiciousNmsp.CellUtils.doCap(actionNode.attributes.getNamedItem('code').value)}`]) :
                    this.extractAction(actionNode)
            );
        }

        grid.setToolbarActions(actions);
    }

    /**
     * @unused
     * @method extractAction
     */
    extractAction(actionNode, action) {
        if (!action)
            action = new flexiciousNmsp.ToolbarAction(actionNode.attributes.getNamedItem('code').value);
        const items = actionNode.attributes;

        for (const actionAttr of items) {
            this.applyAttribute(action, actionAttr, actionNode);
        }

        return action;
    }

    /**
     * Code to extract filters. Has logic to extract date ranges, etc
     * @method extractFilters
     */
    extractFilters(filtersNode, grid) {
        const filters = [];
        const items = filtersNode.childNodes;

        for (const filterNode of items) {
            if (!this.getLocalName(filterNode)) continue;
            if (filterNode.attributes.getNamedItem('type').value == "date") {
                filters.push(UIUtils.createDateFilter(
                    filterNode.attributes.getNamedItem('description').value, filterNode.attributes.getNamedItem('fld').value,
                    filterNode.attributes.getNamedItem('dateRange').value,
                    filterNode.attributes.getNamedItem('dateRange').value == flexiciousNmsp.DateRange.DATE_RANGE_CUSTOM ? new Date(filterNode.attributes.getNamedItem('start').value) : null,
                    filterNode.attributes.getNamedItem('dateRange').value == flexiciousNmsp.DateRange.DATE_RANGE_CUSTOM ? new Date(filterNode.attributes.getNamedItem('end').value) : null
                ));
            } else if (filterNode.attributes.getNamedItem('type').value == "list") {
                filters.push(UIUtils.createListFilter(
                    filterNode.attributes.getNamedItem('description').value, filterNode.attributes.getNamedItem('fld').value,
                    filterNode.attributes.getNamedItem('values').value.split(",")
                ));
            } else {
                const filter = new flexiciousNmsp.Filter();
                filter.filterDescrption = filterNode.attributes.getNamedItem('description');
                filters.push(filter);
            }
        }

        grid.setPredefinedFilters(filters);
    }

    /**
     * Method to extact column information from XML
     * @method extractColumns
     */
    extractColumns(levelNodeChild, lvl) {
        const cols = [];
        let hasColumnGroups = false;
        for (var j = 0; j < levelNodeChild.childNodes.length; j++) {
            var colNode = levelNodeChild.childNodes[j];
            if (!this.getLocalName(colNode)) continue;
            if (this.getLocalName(colNode) == "columnGroup") {
                hasColumnGroups = true;
                cols.push(this.extractColGroup(colNode));
            }
            else
                cols.push(this.extractCol(colNode));
        }
        if (hasColumnGroups)
            lvl.setGroupedColumns(cols);
        else
            lvl.setColumns(cols);
        return { cols, hasColumnGroups, j, colNode };
    }

    /**
     * Method to extract level information from xml
     * @method extractLevel
     */

    extractLevel(levelNode, lvl) {
        const items = levelNode.attributes;

        for (const levelAttr of items) {
            this.applyAttribute(lvl, levelAttr, levelNode);
        }

        const items2 = levelNode.childNodes;

        for (const levelNodeChild of items2) {
            if (!this.getLocalName(levelNodeChild)) continue;
            if (this.getLocalName(levelNodeChild) == 'nextLevel') {
                lvl.nextLevel = new flexiciousNmsp.FlexDataGridColumnLevel(lvl.grid);
                let realChild;
                const items3 = levelNodeChild.childNodes;
                for (let k = 0; k < items3.length; k++) {
                    const colNode = items3[k];
                    realChild = k;
                    if (this.getLocalName(colNode)) break;
                }
                this.extractLevel(levelNodeChild.childNodes[realChild], lvl.nextLevel);
            }
            else if (this.getLocalName(levelNodeChild) == 'columns') {
                this.extractColumns(levelNodeChild, lvl);

            }
        }
    }

    /**
     * @method extractColGroup
     */
    extractColGroup(cgNode) {
        const cg = new flexiciousNmsp.FlexDataGridColumnGroup();
        const items = cgNode.attributes;

        for (const colAttr of items) {
            this.applyAttribute(cg, colAttr, cgNode);
        }

        const cols = [];
        let hasColumnGroups = false;
        let realChild = 0;
        const items2 = cgNode.childNodes;
        for (let j = 0; j < items2.length; j++) {
            var colNode = items2[j];
            realChild = j;
            if (this.getLocalName(colNode)) break;
        }
        const items3 = cgNode.childNodes[realChild].childNodes;
        for (let k = 0; k < items3.length; k++) {
            var colNode = items3[k];
            if (!this.getLocalName(colNode)) continue;
            if (this.getLocalName(colNode) == "columnGroup") {
                hasColumnGroups = true;
                cols.push(this.extractColGroup(colNode));
            }
            else
                cols.push(this.extractCol(colNode));
        }
        if (hasColumnGroups)
            cg.columnGroups = (cols);
        else
            cg.setColumns(cols);
        return cg;
    }

    /**
     * @method extractCol
     */
    extractCol(colNode) {
        let col = new flexiciousNmsp.FlexDataGridColumn();
        if (colNode.attributes.getNamedItem('type') && colNode.attributes.getNamedItem('type').value == "checkbox")
            col = new flexiciousNmsp.FlexDataGridCheckBoxColumn();

        const items = colNode.attributes;

        for (const colAttr of items) {
            if (this.getLocalName(colAttr) != "type")
                this.applyAttribute(col, colAttr, colNode);
        }

        return col;
    }

    /**
     *
     * @private
     * @param val
     * @method setTotalRecords
     */
    setTotalRecords(val) {

        this._totalRecords = val;
        if (this.getEnablePaging()) {
            const pager = this.getPagerContainer().getPager();
            if (pager) {
                if (pager.getTotalRecords() != val)
                    pager.setTotalRecords(val);
            }
        }

    }

    /**
     * The total number of records at the root level (needs to be set only in server mode,
     * because there is no way for the grid to know how many records on
     * the server match the filter criteria)
     * In client mode, the count of the data provider is used instead.
     * @return
     * @method getTotalRecords
     */
    getTotalRecords() {
        return this._totalRecords;
    }

    /**
     * Height of the row for this level. Defaults to 25
     * @method getRowHeight
     */
    getRowHeight() {
        return this.getColumnLevel().getRowHeight();
    }

    /**
     * @method setRowHeight
     *
     */
    setRowHeight(o) {
        this.getColumnLevel().setRowHeight(o);
    }

    /**
     * This is not used.
     * @return
     * @method getprintExportData
     */
    getprintExportData() {

        return this._printExportData;

    }

    /**
     * @private
     * @method setPrintExportData
     */
    setPrintExportData(value) {
        this._printExportData = value;
        //once we have the data from the server, we continue as usuual...
        this.dispatchEvent(new flexiciousNmsp.BaseEvent("printExportDataReceived"));
    }

    /**
     * A function that takes in a data object, and a column, and returns a
     * number. -1 indicates that the row should span the entire height of the
     * grid. Please note, rowspans and col spans are only supported for data
     * rows.
     * @method getRowSpanFunction
     */

    getRowSpanFunction() {
        return this.rowSpanFunction;
    }

    /**
     * A function that takes in a data object, and a column, and returns a
     * number. -1 indicates that the row should span the entire height of the
     * grid. Please note, rowspans and col spans are only supported for data
     * rows.
     * @method setRowSpanFunction
     */
    setRowSpanFunction(value) {
        this.rowSpanFunction = value;
        this._hasRowSpanOrColSpan = (value != null);
    }

    /**
     * A function that takes in a data object, and a column, and returns a
     * number. -1 indicates that the row should span the entire width of the
     * grid. Please note, rowspans and col spans are only supported for data
     * rows.
     *
     * Since this function is defined on the grid, it will get a
     * IFlexDataGridCell object that you should use to return a rowSpan or
     * colSpan.
     *
     * @method getColSpanFunction
     */

    getColSpanFunction() {
        return this.colSpanFunction;
    }

    /**
     * A function that takes in a data object, and a column, and returns a
     * number. -1 indicates that the row should span the entire width of the
     * grid. Please note, rowspans and col spans are only supported for data
     * rows.
     *
     * Since this function is defined on the grid, it will get a
     * IFlexDataGridCell object that you should use to return a rowSpan or
     * colSpan.
     *
     * @method setColSpanFunction
     */
    setColSpanFunction(value) {
        this.colSpanFunction = value;
        this._hasRowSpanOrColSpan = (value != null);
    }

    /**
     * Cleanup method
     * @method kill
     */
    kill() {
        delete flexiciousNmsp.registry[this.__id];
        this.getBodyContainer().kill();
        this.getHeaderContainer().kill();
        this.getFooterContainer().kill();
        this.getPagerContainer().kill();
        this.getFilterContainer().kill();
        this.getLeftLockedHeader().kill();
        this.getLeftLockedFooter().kill();
        this.getLeftLockedContent().kill();
        this.getRightLockedHeader().kill();
        this.getRightLockedFooter().kill();
        this.getRightLockedContent().kill();
        this.rendererCache.kill();
        this.getColumnLevel().kill();
        if (this.resizeTimer)
            this.resizeTimer.kill();
        this.tooltipBehavior.kill();
        this.spinnerBehavior.kill();
        flexiciousNmsp.UIComponent.prototype.kill.apply(this);

    }

    /**
     * Check for changes to the div that holds us. HTML does not have a resize event, so we have to periodically inspect
     * the dom element to see if there were any changes to the container size.
     * @method checkResize
     */

    checkResize() {
        if (this.getBodyContainer()._inEdit)
            return;
        if (this.resizeListenerPaused) {
            return false;
        }
        if (!this.domElement) {
            this.resizeTimer.kill();
            return;
        }
        if (!this.domElement.style.width.includes("%") && !this.domElement.style.height.includes("%")) {
            this.resizeTimer.kill();
        }
        if (!this.placedHeight || !this.placedWidth) return;
        if (this.domElement.style.width.indexOf("%") > 0) {
            //this means we are percent based.
            if ((this.domElement.offsetWidth != this.placedWidth) && (this.domElement.offsetWidth > 0)) {
                this.invalidateWidth();
            }
        }
        if (this.domElement.style.height.indexOf("%") > 0) {
            //this means we are percent based.
            if ((this.domElement.offsetHeight != this.placedHeight) && (this.domElement.offsetHeight > 0)) {
                this.invalidateHeight();
            }
        }
    }

    /**
     * Rebuilds the grid based on the current theme
     * @method applyTheme
     */
    applyTheme(themeID) {
        this.themeID = themeID;

        for (const o of flexiciousNmsp.themes) {
            if (o.id == themeID) {
                UIUtils.mergeObjects(this, o);
                this.rebuild();
                return;
            }
        }
    }

    /**
     * Based upon the current theme id, returns the theme icons folder.
     * @method getThemeToolbarIconFolder
     */
    getThemeToolbarIconFolder() {
        return this.imagesRoot;
    }

    /**
     * @param {String} whatToFind 
     * @param {Object} flat 
     * @param {FlexDataGridColumnLevel} level 
     * @param {Array} result 
     * @param {Array} searchCols 
     * @param {Boolean} breakAfterFind 
     * @param {Boolean} captureCols 
     * @param {Number} flatIndex 
     */
    itemsQuickFind(
        whatToFind,
        flat,
        level,
        result,
        searchCols,
        breakAfterFind,
        captureCols,
        flatIndex) {
        if (!whatToFind) return [];
        if (!flat) flat = this.getRootFlat();
        if (!level) level = this.getColumnLevel();
        if (!result) result = [];
        if (!searchCols || searchCols.length == 0) searchCols = level.getVisibleColumns();
        const itemIndex = 0;

        for (const item of flat) {
            for (const col of searchCols) {
                if (col.excludeFromQuickFind) continue;
                const txt = col.itemToLabel(item);
                if (txt && txt.toLowerCase().includes(whatToFind.toLowerCase())) {
                    if (captureCols) {
                        result.push({ "item": item, "col": col, "flatIndex": flatIndex, "value": txt });
                    } else {
                        result.push(item);
                    }
                    if (breakAfterFind)
                        break;
                }
            }

            if (level.nextLevel && level.nextLevel.getNestDepth() <= 3 && !level.nextLevel.excludeFromQuickFind) {
                const nextFlat = this.getBodyContainer().filterPageSort(level.getChildren(item), level, item, true, false, true);
                flatIndex++;
                this.itemsQuickFind(whatToFind, nextFlat, level.nextLevel, result, level.nextLevel.reusePreviousLevelColumns ? searchCols : null, breakAfterFind, captureCols, flatIndex);
            }
        }

        return result;
    }

    /**
     * A global filter function that matches against gloalSearchString
     * @param item Item to match
     * @return 	Whether or not the item exists in the dataprovider.
     *
     */
    globalFilterFunction(item) {

        if (this.getGlobalFilterString()) {
            const colsToMatch = (this.getGlobalFilterColumns().length == 0) ? this.getColumns() : this.getGlobalFilterColumns();

            for (const col of colsToMatch) {
                const str = col.itemToLabel(item);
                if (str && (str.toLocaleLowerCase().includes(this.getGlobalFilterString().toLocaleLowerCase()))) {
                    return true;
                }
            }
        } else {
            return true;
        }
        return false;

    }

    /**
     * Handler for the next highlight
     * @param backwards
     * @method gotoNextHighlight
     */
    gotoNextHighlight(backwards) {
        if (typeof backwards == "undefined") backwards = false;

        if (backwards) {
            if (this._currentMatch > 1)
                this._currentMatch--;
        }
        else if (this._currentMatch <= this.matchedObjects.length) {
            this._currentMatch++;
        }
        if (this._currentMatch > this.matchedObjects.length || this._currentMatch < 0) {
            this._currentMatch = 1;
        }
        if (this._currentMatch <= this.matchedObjects.length && this._currentMatch > 0) {
            const currentMatchedObject = this.matchedObjects[this._currentMatch - 1];
            this.gotoItem(currentMatchedObject.item, false);
            this.getBodyContainer().gotoVerticalPosition(Math.max(this.getBodyContainer().getVerticalScrollPosition() - (this.getRowHeight() * 4), 0));
            if (!this.isInVisibleHorizontalRange(currentMatchedObject.col.getX(), currentMatchedObject.col.getWidth())) {
                this.gotoHorizontalPosition(currentMatchedObject.col.getX());
            }
            this.validateNow();
            this.getBodyContainer().validateNow();
            const fCell = this.getCellForRowColumn(currentMatchedObject.item, currentMatchedObject.col);
            const cell = fCell;
            if (cell) {
                for (const row of this.getBodyContainer().rows) {
                    for (const cellComp of row.cells) {
                        const tdgc = cellComp.component;
                        if (tdgc) {
                            try {
                                tdgc.removeHighlight();
                            } catch (error) { }
                        }
                    }
                }

                this.highlightedCellInfo = new flexiciousNmsp.CellInfo(currentMatchedObject.item, currentMatchedObject.col);
                //callLater(cell.highlight,[true]);
                //cell.highlight(true);
                const that = this;
                setTimeout(() => {
                    for (const row of that.getBodyContainer().rows) {
                        for (const cellComp of row.cells) {
                            const tdgc = cellComp.component;
                            if (tdgc.getRowInfo().getData() == that.highlightedCellInfo.rowData &&
                                tdgc.getColumn() == that.highlightedCellInfo.column) {
                                tdgc.highlight(true);
                            }
                        }
                    }
                }, 100);
            }
        }

    }

    /**
     * Returns true if the passed in cordinates are in the visible ViewPort
     * @param x
     * @param wwidth
     * @method isInVisibleHorizontalRange
     * 
     * @return {Boolean}
     */
    isInVisibleHorizontalRange(x, wwidth) {

        const controlXBegin = x;
        const controlXEnd = x + wwidth;
        const range = [this.getHorizontalScrollPosition(), this.getHorizontalScrollPosition() + this.getWidth()];
        return (range.length == 0 || (

            ((controlXBegin > range[0]) && (controlXEnd < range[1]))

        ));

    }

    /**
     * @method clearCurrentHighlight
     * @param currentMatchedObject  
     */
    clearCurrentHighlight(currentMatchedObject) {

        if (!this.currentMatchedObject)
            return;
        const fCell = getCellForRowColumn(currentMatchedObject.item, currentMatchedObject.col);
        const cell = fCell;
        if (cell) {
            cell.removeHighlight();
            this.rebuildBody(true);
        }

    }

    /**
     * @method clearAllHighlight
     */
    clearAllHighlight() {
        for (const row of this.getBodyContainer().rows) {
            for (const cellComp of row.cells) {
                const tdgc = cellComp.component;
                if (tdgc) {
                    try {
                        tdgc.removeHighlight();
                    } catch (error) {

                    }
                }
            }
        }
    }

    /**
     * A String to highlight in the grid.
     * @method getGlobalHightlightString
     * @return {String}
     */
    getGlobalHightlightString() {
        return this._globalHightlightString;
    }

    /**
     * @private
     */
    setGlobalHightlightString(value) {
        if (this._globalHightlightString != value) {
            this.clearAllHighlight();
            this._globalHightlightString = value;
            this._globalFilterOrHighLightDirty = true;
            this.matchedObjects = [];
            if (value) {
                for (var i = 0; i < this.itemsQuickFind(value, null, null, null, this.getGlobalHighlightColumns(), false, true).length; i++) {
                    const matchedObject = this.itemsQuickFind(value, null, null, null, this.getGlobalHighlightColumns(), false, true)[i];
                    let alreadyAdded = false;
                    for (var i = 0; i < this.matchedObjects.length; i++) {
                        const oldMO = this.matchedObjects[i];
                        if (oldMO.col == matchedObject.col && oldMO.item == matchedObject.item) {
                            alreadyAdded = true;
                        }

                    }
                    if (!alreadyAdded && !matchedObject.col.hideHeaderText) {
                        this.matchedObjects.push(matchedObject);
                    }
                }
            }
            //this.matchedObjects = this.matchedObjects.sortOn(["flatIndex", "value"],[Array.NUMERIC]);
            this.matchedObjects.sort((a, b) => {
                const textA = a.flatIndex;
                const textB = b.flatIndex;
                return (textA < textB) ? -1 : (textA > textB) ? 1 : 0;
            });
            this._currentMatch = 0;
            this.invalidateDisplayList();

        }
    }

    /**
     * A Boolean variable that tells us whether to highlight just the first occurence or all occurences
     * @method getGlobalHightlightAll
     * @return {Array}
     */
    getGlobalHightlightAll() {
        return this._globalHightlightAll;
    }

    /**
     * @method getMatchedObjects
     * @return {Array}
     */
    getMatchedObjects() {
        return this.matchedObjects;
    }

    /**
     * @private
     */
    setGlobalHightlightAll(value) {
        if (this._globalHightlightAll != value) {
            this._globalHightlightAll = value;
            this._globalFilterOrHighLightDirty = true;
            this.invalidateDisplayList();
        }

    }

    /**
     * @method getGlobalFilterString
     * @return {String}
     */
    getGlobalFilterString() {
        return this._globalFilterString;
    }

    /**
     * @private
     */
    setGlobalFilterString(value) {
        if (this._globalFilterString != value) {
            this._globalFilterString = value;
            this._globalFilterOrHighLightDirty = true;
            this.invalidateDisplayList();
        }
    }

    /**
     * Array to search for when highlighting a term in specific columns
     * @method getGlobalHighlightColumns
     * @return {Array}
     */
    getGlobalHighlightColumns() {
        return this._globalHighlightColumns;
    }

    /**
     * @private
     */
    setGlobalHighlightColumns(value) {
        this._globalHighlightColumns = value;
        this._globalFilterOrHighLightDirty = true;
        this.invalidateDisplayList();
    }

    /**
     * The index of the currently matched object
     * @method getCurrentMatch
     * @return {Number}
     */
    getCurrentMatch() {

        return this._currentMatch;
    }

    /**
     * A list of columns that the global search uses to search. If no columns are defined, all columns are searched.
     * @method getGlobalFilterColumns
     * @return {Array}
     */
    getGlobalFilterColumns() {
        return this._globalFilterColumns;
    }

    /**
     * @private
     */
    setGlobalFilterColumns(value) {
        this._globalFilterColumns = value;
        this._globalFilterOrHighLightDirty = true;
        this.invalidateDisplayList();
    }

    /**
     * @method commitProperties
     */
    commitProperties() {


        if (this._globalFilterOrHighLightDirty) {
            this._globalFilterOrHighLightDirty = false;
            this.rebuildBody(true);
        }

    }

    /**
     * @method setDragDropCompleteFunction
     * @param val 
     */
    setDragDropCompleteFunction(val) {
        this.dragDropCompleteFunction = val;
    }

    /**
     *  Responsive mode for this grid. There are there modes.
     *
     *  <b><i> scrollBarMode </i></b> - The base HTMLTreeGrid will be extended to provide a
     *  Bootstrap-like API to show or hide the scroll bar on basis of the screen width.
     *  Below a certain pre-configured screen width, a scroll bar shall appear,
     *  and allow the user to scroll through all the columns. Above this screen width,
     *  there shall be no scrollbar.
     *
     *  <b><i> columnPriorityMode </i></b> -  The base HTMLTreeGrid will be extended to expose and
     *  API for a priority model, where each column can be assigned a priority and the columns shall
     *  appear or be hidden on basis of screen width.
     *
     *  <b><i> transposedColumnMode </i></b> - A new column type, TransposedColumn will be added to
     *  accommodate smaller screens, below a certain pre-configured width, all the columns in the grid
     *  shall be replaced by the Transposed Column which shall contain, within a single cell,
     *  all the information that was held in the previous cells in a transposed manner

     * @type {string}
     * @default scrollBarMode
     */
    setResponsiveBehaviorMode(mode) {
        if (this.responsiveBehavior && this.responsiveBehavior.responsiveBehaviorMode != mode) {
            this.responsiveBehavior.enabled = true;
            this.responsiveBehavior.setResponsiveBehaviorMode(mode);
        }
    }

    /**
     * @override
     */
    componentWillUnmount() {
        //console.log("unmounting");
        this.kill();
    }

    /**
     * @method createColumn
     * @param isCheckBox 
     * @return {*}
     */
    createColumn(isCheckBox) {
        return isCheckBox ? new FlexDataGridCheckBoxColumn() : new FlexDataGridColumn();
    }

    /**
     * @method createColumnLevel
     * @return {flexiciousNmsp.FlexDataGridColumnLevel}
     */
    createColumnLevel() {
        return new FlexDataGridColumnLevel(this);
    }

    /**
     * @method createColumnGroup
     * @return {flexiciousNmsp.FlexDataGridColumnGroup}
     */
    createColumnGroup() {
        return new FlexDataGridColumnGroup(this);
    }


    /**
     *  Gets the height of this component
     * @method getWidth
     * @return {Number}
     */
    getWidth() {
        return this.width || (this.domElement ? this.domElement.offsetWidth : this.propertyBag.style.width);
    };
    /**
     *  Sets the width of this component
     * @method setWidth
     * @param val
     */
    setWidth(val) {
        flexiciousNmsp.NdgBase.prototype.setWidth.apply(this, [val]);
        if (val.toString().indexOf("%") > 0) {
            if (this.domElement) {
                this.domElement.style.width = val;
            } else {
                this._percentWidthPending = val;
            }
            this.width = 0;
        } else {
            if (val < 0 || isNaN(val)) return val;
            this.width = val;
            if (this.domElement) {
                this.domElement.style.width = val + "px";
            }
        }
        return val;
    };
    /**
     *  Gets the height of this component
     * @method getHeight
     * @return {Number}
     */
    getHeight() {
        return this.height || (this.domElement ? this.domElement.offsetHeight : this.propertyBag.style.height);
    };
    /**
     *  Sets the height of this component
     * @method setHeight
     * @param {Number} val
     */
    setHeight(val) {
        flexiciousNmsp.NdgBase.prototype.setHeight.apply(this, [val]);
        if (val.toString().indexOf("%") > 0) {
            if (this.domElement) {
                this.domElement.style.height = val;
            } else {
                this._percentHeightPending = val;
            }
            this.height = 0;

        } else {
            if (val < 0 || isNaN(val)) return val;
            this.height = val;
            if (this.domElement) {
                this.domElement.style.height = val + "px";
            }
        }
        return val;
    };

    /**
     * @method setEnablePrint
     * @param enabled 
     */
    setEnablePrint(enabled) {
        //print and pdf are not implemented
    }

    /**
     * @method setEnablePdf
     * @param enabled 
     */
    setEnablePdf(enabled) {
        //print and pdf are not implemented        
    }

    /**
     * @method onScrollTimerComplete 
     * @param event 
     */
    onScrollTimerComplete(event) {
        if (this.scrollTimer) {
            this.scrollTimer.stop();
            this.scrollTimer = null;
            this._isScrolling = false;
            ReactDataGridCellContainer.isScrolling = false;
            UIComponent.statePaused = false;
            UIComponent.clearPendingUpdates()
            this.invalidateCells();
            this.refreshCells();
        }
        this.dispatchEvent(new flexiciousNmsp.FlexDataGridEvent(FlexDataGrid.EVENT_SCROLLCOMPLETE, this,
            this.getColumnLevel()));


        if (!this.getForceColumnsToFitVisibleArea()) {
            this.getBodyContainer().recycleH();
            this.synchronizeHorizontalScroll();
        }
    };
}

flexiciousNmsp.FlexDataGrid = FlexDataGrid; //add to name space
FlexDataGrid.prototype.typeName = FlexDataGrid.typeName = 'FlexDataGrid';//for quick inspection
FlexDataGrid.MOVE_TOP = "moveTop";
FlexDataGrid.MOVE_UP = "moveUp";
FlexDataGrid.MOVE_DOWN = "moveDown";
FlexDataGrid.MOVE_BOTTOM = "moveBottom";
FlexDataGrid.CELL_POSITION_ABOVE = "above";
FlexDataGrid.CELL_POSITION_BELOW = "below";
FlexDataGrid.CELL_POSITION_BELOW_FIRST = "belowFirst";
FlexDataGrid.CELL_POSITION_ABOVE_LAST = "aboveFirst";
FlexDataGrid.CELL_POSITION_LEFT = "left";
FlexDataGrid.CELL_POSITION_RIGHT = "right";


//events block
/**
 * Dispatched whenthe user stops scrolling
 * @event scrollComplete
 */
FlexDataGrid.EVENT_SCROLLCOMPLETE = 'scrollComplete';

/**
 * Dispatched when all the cells snap to the calculated column widths.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event componentsCreated
 */

FlexDataGrid.EVENT_COMPONENTSCREATED = 'componentsCreated';
/**
 * Dispatched only in server mode, when the grid needs to print or export more data than is currently
 * loaded in memory.
 * Event Type:com.flexicious.grids.events.PrintExportDataRequestEvent
 * @event printExportDataRequest
 */

FlexDataGrid.EVENT_PRINTEXPORTDATAREQUEST = 'printExportDataRequest';
/**
 * Fired In preferencePersistenceMode=server , when the grid needs to load its preferences.
 * Fired In preferencePersistenceMode=client , when the grid has successfully loaded preferences.
 * Event Type:com.flexicious.grids.events.PreferencePersistenceEvent
 * @event loadPreferences
 */

FlexDataGrid.EVENT_LOADPREFERENCES = 'loadPreferencesEvent';
/**
 * Fired right before preferences are being loaded and applied.
 * Event Type:com.flexicious.grids.events.PreferencePersistenceEvent
 * @event preferencesLoading
 */

FlexDataGrid.EVENT_PREFERENCESLOADING = 'preferencesLoading';
/**
 * Fired when the grid needs to persist its preferences.
 * Event Type:com.flexicious.grids.events.PreferencePersistenceEvent
 * @event persistPreferences
 */

FlexDataGrid.EVENT_PERSISTPREFERENCES = 'persistPreferencesEvent';
/**
 * Fired when the grid needs to clear its preferences.
 * Event Type:com.flexicious.grids.events.PreferencePersistenceEvent
 * @event clearPreferences
 */

FlexDataGrid.EVENT_CLEARPREFERENCES = 'clearPreferencesEvent';
/**
 * Dispatched when the use clicks on the disclosure icon to collapse a previously opened item.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event itemClose
 */

FlexDataGrid.EVENT_ITEMCLOSE = 'itemClose';
/**
 * Dispatched when the user clicks on the disclosure icon to expand a previously collapsed item.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event itemOpen
 */

FlexDataGrid.EVENT_ITEMOPEN = 'itemOpen';
/**
 * Dispatched when an item is about to open. If you call preventDefault() on the event, the item will not open
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event itemOpening
 */

FlexDataGrid.EVENT_ITEMOPENING = 'itemOpening';
/**
 * Dispatched when an item is about to close. If you call preventDefault() on the event, the item will not close
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event itemClosing
 */

FlexDataGrid.EVENT_ITEMCLOSING = 'itemClosing';
/**
 * Dispatched only in server mode, when an item opens for the first time.
 * Used to wire up an event handler to load the next level of data in lazy loaded grids.
 *
 * Event Type:com.flexicious.nestedtreedatagrid.events.ExtendedFilterPageSortChangeEvent
 * @event itemLoad
 */

FlexDataGrid.EVENT_ITEMLOAD = 'itemLoad';
/**
 * Dispatched when the grid's page, sort or filter state changes. Also Dispatched when
 * an item, that was not previously opened is opened. Used in lazy loaded (filterPageSortMode=server)
 * grids, to load a specific page of data from the backend.
 * Event Type:com.flexicious.nestedtreedatagrid.events.ExtendedFilterPageSortChangeEvent
 * @event filterPageSortChange
 */

FlexDataGrid.EVENT_FILTERPAGESORTCHANGE = 'filterPageSortChange';
/**
 * Dispatched when any header cell is clicked
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event headerClicked
 */

FlexDataGrid.EVENT_HEADERCLICKED = 'headerClicked';
/**
 * Dispatched when columns are dragged and dropped to change their position
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event columnsShift
 */

FlexDataGrid.EVENT_COLUMNSSHIFT = 'columnsShift';
/**
 * Dispatched when the columns at this level are resized
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event columnsResized
 */

FlexDataGrid.EVENT_COLUMNSRESIZED = 'columnsResized';
/**
 *  Dispatched when the user attempts to edit an item. If you call preventDefault on this event, the edit session will not begin.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridItemEditEvent
 * @event itemEditBeginning
 */

FlexDataGrid.EVENT_ITEMEDITBEGINNING = 'itemEditBeginning';
/**
 *  Dispatched when the editor is instantiated.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridItemEditEvent
 * @event itemEditBegin
 */

FlexDataGrid.EVENT_ITEMEDITBEGIN = 'itemEditBegin';
/**
 *  Dispatched when the edit session ends.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridItemEditEvent
 * @event itemEditEnd
 */

FlexDataGrid.EVENT_ITEMEDITEND = 'itemEditEnd';
/**
 *  Dispatched when the item editor receives focus.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridItemEditEvent
 * @event itemFocusIn
 */

FlexDataGrid.EVENT_ITEMFOCUSIN = 'itemFocusIn';
/**
 *  Dispatched when the edit session is cancelled.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridItemEditEvent
 * @event itemEditCancel
 */

FlexDataGrid.EVENT_ITEMEDITCANCEL = 'itemEditCancel';
/**
 * Dispatched just before committing the value of the editorDataField property of the editor
 * to the property specified by the datafield property of the column of the item being edited.
 * If you call preventDefault on the event, the value will not be committed.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridItemEditEvent
 * @event itemEditValueCommit
 */

FlexDataGrid.EVENT_ITEMEDITVALUECOMMIT = 'itemEditValueCommit';
/**
 *  Dispatched when row selection or cell selection changes.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event change
 */

FlexDataGrid.EVENT_CHANGE = 'change';
/**
 *  Dispatched when user rolls over a row in row selection mode or cell in cell selection mode (only if rollover on a different item)
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event itemRollOver
 */

FlexDataGrid.EVENT_ITEMROLLOVER = 'itemRollOver';
/**
 *  Dispatched when user rolls out of a row in row selection mode or cell in cell selection mode (only if rollover on a different item)
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event itemRollOut
 */

FlexDataGrid.EVENT_ITEMROLLOUT = 'itemRollOut';
/**
 *  Dispatched when user clicks on a row in row selection mode or cell in cell selection mode
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event itemClick
 */

FlexDataGrid.EVENT_ITEMCLICK = 'itemClick';
/**
 *  Dispatched when user double clicks on a row in row selection mode or cell in cell selection mode
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event itemDoubleClick
 */

FlexDataGrid.EVENT_ITEMDOUBLECLICK = 'itemDoubleClick';
/**
 * Dispatched when the renderer is initialized.
 *
 * Please note, any changes you made to the renderer stay in place when the renderer
 * is recycled. So if you make any changes, please ensure that the changes are
 * rolled back in the event handler first. For example, if you set the text to
 * bold if a condition is met, then you should first set it to normal, check for the
 * condition, and then set it to bold. This will ensure that if the renderer was
 * previously used to display something that match the condition, and the current item
 * does not, then we do not display bold text.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event rendererInitialized
 */

FlexDataGrid.EVENT_RENDERERINITIALIZED = 'rendererInitialized';
/**
 * Dispatched when the cell is rendered completely. That is, the background and borders are drawn, the renderers are placed
 * Use this event to perform post processing of the cell after the grid has applied all its formatting and positioning
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event cellRendered
 */

FlexDataGrid.EVENT_CELLRENDERED = 'cellRendered';
/**
 *  When enableDynamicLevels=true, this event is dispatched whenever a new level is created.
 *  This event can be used to initialize the newly created level.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event dynamicLevelCreated
 */

FlexDataGrid.EVENT_DYNAMICLEVELCREATED = 'dynamicLevelCreated';
/**
 *  When enableDynamicLevels=true, this event is dispatched whenever all the dynamic levels are created.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event dynamicAllLevelsCreated
 */

FlexDataGrid.EVENT_DYNAMICALLLEVELSCREATED = 'dynamicAllLevelsCreated';
/**
 *  Dispatched when the content is scrolled.
 * Event Type:mx.events.ScrollEvent
 * @event scroll
 */

FlexDataGrid.EVENT_SCROLL = 'scroll';
/**
 * Dispatched when the grid is about to be exported
 * Event Type:com.flexicious.export.ExportEvent
 * @event beforeExport
 */

FlexDataGrid.EVENT_BEFOREEXPORT = 'beforeExport';
/**
 * Dispatched when the grid is finished exporting. At this point, the
 * textWritten variable of the dispatched event is available to you, to
 * customize the generated text if you need to.
 * Event Type:com.flexicious.export.ExportEvent
 * @event afterExport
 */

FlexDataGrid.EVENT_AFTEREXPORT = 'afterExport';
/**
 * Dispatched when the grid is about to be generated for the print, or the preview.
 * The event has a handle to the grid that is being printed, as well as the PrintDataGrid instance.
 * This lets you perform custom logic on the PrintDataGrid before the print occurs.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridPrintEvent
 * @event beforePrint
 */

FlexDataGrid.EVENT_BEFOREPRINT = 'beforePrint';
/**
 * Dispatched before the beforePrint event, right prior to the data provider being set.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridPrintEvent
 * @event beforePrintProviderSet
 */

FlexDataGrid.EVENT_BEFOREPRINTPROVIDERSET = 'beforePrintProviderSet';
/**
 * Dispatched when the grid is sent to the printer.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridPrintEvent
 * @event printComplete
 */

FlexDataGrid.EVENT_PRINTCOMPLETE = 'printComplete';
/**
 * Dispatched when the autorefresh interval is hit.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event autoRefresh
 */

FlexDataGrid.EVENT_AUTOREFRESH = 'autoRefresh';
/**
 * Dispatched when any toolbarAction is executed. Wrapper events' data contains the action being executed.
 * If you call prevent default in this event, the default handling code does not execute
 ** Event Type:com.flexicious.grids.events.WrapperEvent
 * @event toolbarActionExecuted
 */

FlexDataGrid.EVENT_TOOLBARACTIONEXECUTED = 'toolbarActionExecuted';
/**
 * Dispatched when the top level select checkbox is changed
 ** Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event selectAllCheckBoxChanged
 */

FlexDataGrid.EVENT_SELECTALLCHECKBOXCHANGED = 'selectAllCheckBoxChanged';
/**
 * Dispatched when the user clicks the 'Generate PDF' button on the Print Preview.
 * In response to this user action, the grid simply prints it output to a byte array of
 * page images. This byte array can then be sent to any pdf generation library either
 * on the client or the server, for example Alive PDF. We provide integration code for
 * AlivePDF out of the box.
 * Event Type:com.flexicious.print.PrintPreviewEvent
 * @event pdfBytesReady
 */

FlexDataGrid.EVENT_PDFBYTESREADY = 'pdfBytesReady';
/**
 *  Dispatched by the grid when a prebuilt filter is run.
 * Event Type:com.flexicious.grids.events.WrapperEvent
 * @event prebuiltFilterRun
 */

FlexDataGrid.EVENT_PREBUILTFILTERRUN = 'prebuiltFilterRun';
/**
 * When grid.enableVirtualScroll=true, the grid dispatches a virtualScroll event when the grid scrolls.
 * This event contains a recordsToLoad array, which contains an series of VirtualScrollLoadInfo records.
 * This provides the application a list of record indexes to load, and which levels to load them at.
 *
 * In flat grids, the FlexDataGridVirtualScrollEvent.recordsToLoad will always contain a list of VirtualScrollLoadInfo records were level=1.
 * For nested grids, depending on where the user scrolls and which items are open, you could get a list of records from multiple levels,
 * for example. Records 1-3 from level 1, All children of record 3 from level 2, and then Record 4-10 from level 1.
 *
 * Setting enableVirtualScroll requires that you specify childrenCountField as well as selectedKeyField.
 * Additionally, enableVirtualScroll also requires that you set filterPageSortMode=server and
 * itemLoadMode=server. Finally, virtual scroll does not work with variableRowHeights.
 * @event virtualScroll
 */

FlexDataGrid.EVENT_VIRTUALSCROLL = 'virtualScroll';

FlexDataGrid.EVENT_CREATION_COMPLETE = 'creationComplete';
/**
 *  Dispatched when user clicks on an icon enabled via the enableIcon flag on a column
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event iconClick
 */

FlexDataGrid.EVENT_ICONCLICK = 'iconClick';
/**
 *  Dispatched when user mouseovers on an icon enabled via the enableIcon flag on a column
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event iconMouseOver
 */

FlexDataGrid.EVENT_ICONMOUSEOVER = 'iconMouseOver';
/**
 *  Dispatched when user mouse outs on an icon enabled via the enableIcon flag on a column
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event iconMouseOut
 */

FlexDataGrid.EVENT_ICONMOUSEOUT = 'iconMouseOut';
/**
 * When enableTrackChanges is set to true, this event is dispatched when any change (add,delete or update)
 * is made to the grid. Only the updates made via the grid editors are tracked.
 * @event rowChanged
 */

FlexDataGrid.EVENT_ROWCHANGED = 'rowChanged';
/**
 * Dispatched whenever the page size is changed.
 * @event pageSizeChanged
 */

FlexDataGrid.EVENT_PAGESIZECHANGED = 'pageSizeChanged';
/**
 * Dispatched prior to the widths, heights, x, and y of the various sections are calculated. By sections, we
 * mean the left locked,right locked and unlocked content, header, footer, and body sections.
 * Event Type:com.flexicious.nestedtreedatagrid.events.FlexDataGridEvent
 * @event placingSections+
 */

FlexDataGrid.EVENT_PLACINGSECTIONS = 'placingSections';
/*
 * Method to handle the click for the copy table menu item
 * Copies the entire dataprovider in tab delimited format into the clipboard
 * @param event
 * @method onTableContextMenuItemClick
 *
 */